<?php

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

namespace Folha\Logic\Comite;

/**
 * Description of Comite
 *
 * @author phillipesilva
 */

use Folha\Entities\GpeComiteparticipa;
use Folha\Entities\Gpetiporeuniao;
use Folha\Entities\Gpereuniao;
use Folha\Entities\Gpecomite;

class Comite {
    public static function validaInclusaoParticComite($nrParc, $nrComite) {
        $participante = GpeComiteparticipa::findOneByNrparcnegocioAndNrcomiteAndNrorg($nrParc, $nrComite, \Geral\Util\Ambiente::getNrorg());

        if (is_object($participante)) {
            return true;
        }

        return false;
    }

    public static function verificaTipoComite($nrTipoComite, $nrOrg)
    {
        $gpeComite = Gpecomite::findByNrtipocomiteAndNrorg($nrTipoComite, $nrOrg);
        $comite = $comiteAux = '';
        
        if(empty($gpeComite)) {
            return false;
        }
        
        foreach($gpeComite as $comite) {            
            if($comiteAux != $comite->getNmcomite()) {
                $comiteAux = $comite->getNmcomite();
                $comite .= ' "'.$comite->getNmcomite().'"'.',';
            }
        }
        
        return rtrim($comite, ',');
    }
    
    public static function verificaComite($nrComite, $nrOrg)
    {
        $gpeReuniao = Gpereuniao::findByNrcomiteAndNrorg($nrComite, $nrOrg);
        $reuniaoStr  = $reuniaoAux = '';
        
        if(empty($gpeReuniao)) {
            return false;
        }
        
        foreach($gpeReuniao as $reuniao) {
            $tipoReuniao = Gpetiporeuniao::findOneByNrtiporeuniaoAndNrorg($reuniao->getNrtiporeuniao(), $nrOrg);
            
            if($reuniaoAux != $tipoReuniao->getNmtiporeuniao()) {
                $reuniaoAux = $tipoReuniao->getNmtiporeuniao();
                $reuniaoStr.= ' "'.$tipoReuniao->getNmtiporeuniao().'"'.',';
            }
        }
        
        return rtrim($reuniaoStr, ',');
    }
    
    public static function deleteParticipantesComite($nrComite, $nrOrg)
    {
        $db = \Setforms2\Runtime\Connection::getInstance();
        $db->getConn()->beginTransaction();
        $mannager = \Setforms2\Shared\Registry::getEntityManager();
        $particComite = GpeComiteparticipa::findByNrcomiteAndNrorg($nrComite, $nrOrg);
        
        try {
            foreach($particComite as $particp) {
                if(is_object($particp)) {
                    $particp->delete();
                }
            }   
            $mannager->flush();
            $db->getConn()->commit();     
        }catch(\Exception $e){
            $db->getConn()->rollback();
            throw $e;
        }
    }
}