/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_TIPOCOMP                                                 */
/* Tabela : TIPOCOMP                                                          */
/*                                                                            */
/* Criao:                                                                   */
/* 21/04/2007 - Ronald Reis                                                   */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_TIPOCOMP
BEFORE INSERT OR UPDATE OR DELETE
ON TIPOCOMP FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUTCOM := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDTIPOCOMP,0) <> NVL(:NEW.CDTIPOCOMP,0)) OR
         (NVL(:OLD.NMTIPOCOMP,0) <> NVL(:NEW.NMTIPOCOMP,0)) THEN
         :NEW.DTULTATUTCOM := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('TIPOCOMP', '', 'CDTIPOCOMP='||:OLD.CDTIPOCOMP||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE TIPOCOMP MODIFY DTULTATUTCOM DEFAULT SYSDATE
/

-- VERSAO --
BEGIN ATUVEROBJ('DTULTATU_TIPOCOMP','4.11.134'); END;
/
