function Cdp05000_roteiro_producao_Controller (ZHPromise, Cdp05000_roteiro_producao_Service, templateManager, restEngine, General, ScreenService, cdp02200_grupo_de_equipamentoService){
  
    var CDFILIAL;
    var CDOPERADOR;
    var auxHora = 0;
    
    this.getFilial = function(){
        Cdp05000_roteiro_producao_Service.retornaFilial().then(function(filialLogada){
            CDFILIAL =  filialLogada[0].CDFILIAL;
        });
    };
    
    this.getOperador = function(){
        Cdp05000_roteiro_producao_Service.retornaOperadorLogado().then(function(operadorLogado){
            CDOPERADOR =  operadorLogado[0].CDOPERADOR;
        });
    };
    
    this.newProcesso = function(widget){
        widget.newRow();
        widget.currentRow.CDFILIAL =  CDFILIAL;
        widget.currentRow.CDOPERADOR  = CDOPERADOR;
        widget.currentRow.CDPRODUTO = widget.parent.currentRow.CDPRODUTO;
    };
    
    this.newEtapa = function(widget){
        widget.newRow();
        widget.currentRow.CDFILIAL = widget.parent.currentRow.CDFILIAL;
        widget.currentRow.CDPRODUTO = widget.parent.currentRow.CDPRODUTO;
        widget.currentRow.CDPROCFABRIC = widget.parent.currentRow.CDPROCFABRIC;
    };
    
    this.newInsumo = function(widget){
        widget.newRow();
        widget.currentRow.CDFILIAL = widget.parent.currentRow.CDFILIAL;
        widget.currentRow.CDPRODUTO = widget.parent.currentRow.CDPRODUTO;
        widget.currentRow.CDPROCFABRIC = widget.parent.currentRow.CDPROCFABRIC;
        widget.currentRow.CDETAPAPROD = widget.parent.currentRow.CDETAPAPROD;
        widget.currentRow.VRPRENINSETP = "100.00";
    };

    this.saveMateriaPrima = function(widget){
        this.verificaVRPRENINSETP();
        General.saveCrud(widget);
    };
    
    this.calcQntdLiq = function(){
        var widget = templateManager.container.getWidget('insumo_etapa');
        if((parseInt(widget.currentRow.QTINSUMETAPA) > 0) && (parseInt(widget.currentRow.VRPRENINSETP) > 0)){
            widget.currentRow.QTBRUTINSETP = (parseFloat(widget.currentRow.QTINSUMETAPA.replace(",","."))*parseFloat(widget.currentRow.VRPRENINSETP.toString().replace(",",".")))/100;
            widget.currentRow.QTBRUTINSETP = widget.currentRow.QTBRUTINSETP.toString();
        } else {
            widget.currentRow.QTBRUTINSETP = "";
        }
    };
    
    this.verificaVRPRENINSETP = function(){
        var widget = templateManager.container.getWidget('insumo_etapa');
        if(parseFloat(widget.currentRow.VRPRENINSETP.toString().replace(",",".")) >= 1000){
            ScreenService.showMessage("Rendimento deve ser menor que 1000%");
            widget.currentRow.VRPRENINSETP = "100.00";
        } else {
            this.calcQntdLiq();
        } 
    };
    
    this.deleteFilhos = function(widget){
        widget.currentRow.WIDGET_NAME = widget.name;
        ScreenService.confirmMessage(ScreenService.i18n('Delete Register?'), 'question', function (success) {
            Cdp05000_roteiro_producao_Service.deleteFilhos(widget.currentRow).then(function(sucess){
                ScreenService.showMessage('Deletado com sucesso.');
                ScreenService.closeSwipe();
                ScreenService.goBack();
                widget.reload();
            },function(error){
                ScreenService.showMessage(error.data.error);
            });
        });
    };
    
    this.trocaTipoRecurso = function(){
        var widget = templateManager.container.getWidget('recursos_atividade');
        
        if(widget.currentRow.IDRECURETAPA === "H"){
            
            widget.getField('NMHABILIDADE').readOnly = false;
            widget.getField('NMHABILIDADE').validations.required = true;
          
            widget.currentRow.CDEQUIPPRO = "";
            widget.getField('NMEQUIPPRO').readOnly = true;
            widget.currentRow.NMEQUIPPRO = "";
            widget.getField('NMEQUIPPRO').validations = {};
          
            widget.getField('QTRECURETAPA').readOnly = false;
          
            widget.getField('IDTEMPRECUR').readOnly = true;
            widget.currentRow.IDTEMPRECUR = "";
          
            widget.getField('QTPRODRECUR').readOnly = true;
            widget.currentRow.QTPRODRECUR = "";
            
        } else if(widget.currentRow.IDRECURETAPA === "E"){
            
            widget.currentRow.CDHABILIDADE = "";
            widget.getField('NMHABILIDADE').readOnly = true;
            widget.currentRow.NMHABILIDADE = "";
            widget.getField('NMHABILIDADE').validations = {};
            
            widget.getField('NMEQUIPPRO').readOnly = false;
            widget.getField('NMEQUIPPRO').validations.required = true;
            
            widget.getField('QTRECURETAPA').readOnly = true;
            widget.currentRow.QTRECURETAPA = "1";
            
            widget.getField('IDTEMPRECUR').readOnly = false;
            
            widget.getField('QTPRODRECUR').readOnly = false;
            
        }
    };
    
    this.editarRecursosAtividade = function(widget){
        this.trocaTipoRecurso();
        General.edit(widget);
    };
    
    this.consertaHora = function(widget){
        if(widget.name == "atividade_etapa"){
            widget.dataSource.data.forEach(function(element, index){
                if(element.QTHRINSPEXE){
                    var frac = Math.abs(Math.trunc(element.QTHRINSPEXE) - element.QTHRINSPEXE);
                    frac = (Math.round(frac*100))/100;
                    if((Math.trunc(element.QTHRINSPEXE) < 10) && ((Math.round(frac*60)) < 10)){
                        widget.dataSource.data[index].QTHRINSPEXE = "0"+(Math.trunc(element.QTHRINSPEXE)).toString()+":"+"0"+((Math.round(frac*60)).toString());
                    } 
                    else if(Math.trunc(element.QTHRINSPEXE) < 10){
                        widget.dataSource.data[index].QTHRINSPEXE = "0"+(Math.trunc(element.QTHRINSPEXE)).toString()+":"+((Math.round(frac*60)).toString());
                    } 
                    else if((Math.round(frac*60)) < 10){
                        widget.dataSource.data[index].QTHRINSPEXE = (Math.trunc(element.QTHRINSPEXE)).toString()+":"+"0"+((Math.round(frac*60)).toString());
                    } 
                    else {
                        widget.dataSource.data[index].QTHRINSPEXE = (Math.trunc(element.QTHRINSPEXE)).toString()+":"+((Math.round(frac*60)).toString());
                    }   
                }
            });
        } else if(widget.name == "recursos_atividade"){
            widget.dataSource.data.forEach(function(element, index){
                if(element.QTHRUTRECUR){
                    var frac = Math.abs(Math.trunc(element.QTHRUTRECUR) - element.QTHRUTRECUR);
                    frac = (Math.round(frac*100))/100;
                    if((Math.trunc(element.QTHRUTRECUR) < 10) && ((Math.round(frac*60)) < 10)){
                        widget.dataSource.data[index].QTHRUTRECUR = "0"+(Math.trunc(element.QTHRUTRECUR)).toString()+":"+"0"+((Math.round(frac*60)).toString());
                    } 
                    else if(Math.trunc(element.QTHRUTRECUR) < 10){
                        widget.dataSource.data[index].QTHRUTRECUR = "0"+(Math.trunc(element.QTHRUTRECUR)).toString()+":"+((Math.round(frac*60)).toString());
                    } 
                    else if((Math.round(frac*60)) < 10){
                        widget.dataSource.data[index].QTHRUTRECUR = (Math.trunc(element.QTHRUTRECUR)).toString()+":"+"0"+((Math.round(frac*60)).toString());
                    } 
                    else {
                        widget.dataSource.data[index].QTHRUTRECUR = (Math.trunc(element.QTHRUTRECUR)).toString()+":"+((Math.round(frac*60)).toString());
                    }   
                }
            });
        }
    };
    
    this.verificaHora = function(widget){
        var doisPontos = [];
        
        if(widget.name == "atividade_etapa"){
            auxHora = 0;
            doisPontos = widget.currentRow.QTHRINSPEXE.split(":");
            if(doisPontos.length == 1){
                widget.currentRow.QTHRINSPEXE = widget.currentRow.QTHRINSPEXE+":00";
            }
        }
        else if(widget.name == "recursos_atividade"){
            auxHora = 0;
            doisPontos = widget.currentRow.QTHRUTRECUR.split(":");
            if(doisPontos.length == 1){
                widget.currentRow.QTHRUTRECUR = widget.currentRow.QTHRUTRECUR+":00";
            }
        }
    };
    
    this.verificaHoraOnInput = function(widget){
        
        var doisPontos = [];
        var tamanho;
        
        String.prototype.isNumber = function(){
            return /^\d+$/.test(this);
        };
        
        if(widget.name == "atividade_etapa"){
            if(widget.currentRow.QTHRINSPEXE){    
                tamanho = widget.currentRow.QTHRINSPEXE.length;
                
                if(widget.currentRow.QTHRINSPEXE[(tamanho - 1)].isNumber() == false){
                    
                    if((widget.currentRow.QTHRINSPEXE[(tamanho - 1)]) == ":" && (auxHora == 0)){
                        auxHora = 1;
                    } else {
                        widget.currentRow.QTHRINSPEXE = widget.currentRow.QTHRINSPEXE.substring(0,(tamanho - 1));
                    }
                    
                } else if(widget.currentRow.QTHRINSPEXE[(tamanho - 1)].isNumber() == true){
                    
                    doisPontos = widget.currentRow.QTHRINSPEXE.split(":");
                    
                    if(doisPontos.length == 2){
                        if(doisPontos[1].length > 2){
                            widget.currentRow.QTHRINSPEXE = widget.currentRow.QTHRINSPEXE.substring(0,(tamanho - 1));
                        } else if(parseInt(doisPontos[1][0]) > 5){
                            widget.currentRow.QTHRINSPEXE = widget.currentRow.QTHRINSPEXE.substring(0,(tamanho - 1));
                        }
                    }
                }
            }
        }
        else if(widget.name == "recursos_atividade"){
            if(widget.currentRow.QTHRUTRECUR){    
                tamanho = widget.currentRow.QTHRUTRECUR.length;
                
                if(widget.currentRow.QTHRUTRECUR[(tamanho - 1)].isNumber() == false){
                    
                    if((widget.currentRow.QTHRUTRECUR[(tamanho - 1)]) == ":" && (auxHora == 0)){
                        auxHora = 1;
                    } else {
                        widget.currentRow.QTHRUTRECUR = widget.currentRow.QTHRUTRECUR.substring(0,(tamanho - 1));
                    }
                    
                } else if(widget.currentRow.QTHRUTRECUR[(tamanho - 1)].isNumber() == true){
                    
                    doisPontos = widget.currentRow.QTHRUTRECUR.split(":");
                    
                    if(doisPontos.length == 2){
                        if(doisPontos[1].length > 2){
                            widget.currentRow.QTHRUTRECUR = widget.currentRow.QTHRUTRECUR.substring(0,(tamanho - 1));
                        } else if(parseInt(doisPontos[1][0]) > 5){
                            widget.currentRow.QTHRUTRECUR = widget.currentRow.QTHRUTRECUR.substring(0,(tamanho - 1));
                        }
                    }
                }
            }
        }
    };
    
    this.saveAtividadeEtapa = function(widget){
        widget.currentRow.CDFILIAL = widget.parent.currentRow.CDFILIAL;
        widget.currentRow.CDPRODUTO = widget.parent.currentRow.CDPRODUTO;
        widget.currentRow.CDPROCFABRIC = widget.parent.currentRow.CDPROCFABRIC;
        widget.currentRow.CDETAPAPROD = widget.parent.currentRow.CDETAPAPROD;
        
        if((widget.currentRow.QTHRINSPEXE) && (widget.currentRow.QTHRINSPEXE != "")){
            var tempo = widget.currentRow.QTHRINSPEXE.split(":");
            widget.currentRow.QTHRINSPEXE = ((parseInt(tempo[0])*60+parseInt(tempo[1]))/60);
        }
        General.saveCrud(widget).then(function(aux){
            if(widget.mode == "view"){   
                this.consertaHora(widget);
            }
        }.bind(this));
    };
    
    this.saveRecursoAtividade = function(widget){
        widget.currentRow.CDFILIAL = widget.parent.currentRow.CDFILIAL;
        widget.currentRow.CDPRODUTO = widget.parent.currentRow.CDPRODUTO;
        widget.currentRow.CDPROCFABRIC = widget.parent.currentRow.CDPROCFABRIC;
        widget.currentRow.CDETAPAPROD = widget.parent.currentRow.CDETAPAPROD;
        widget.currentRow.CDINSPECAO = widget.parent.currentRow.CDINSPECAO;
        widget.currentRow.NRINSPETAPA = widget.parent.currentRow.NRINSPETAPA;
        
        if((widget.currentRow.QTHRUTRECUR) && (widget.currentRow.QTHRUTRECUR != "")){
            var tempo = widget.currentRow.QTHRUTRECUR.split(":");
            widget.currentRow.QTHRUTRECUR = ((parseInt(tempo[0])*60+parseInt(tempo[1]))/60);
        }
        General.saveCrud(widget).then(function(aux){
            if(widget.mode == "view"){   
                this.consertaHora(widget);
            }
        }.bind(this));
    };
    
}
Configuration(function(ContextRegister) {
    ContextRegister.register('Cdp05000_roteiro_producao_Controller', Cdp05000_roteiro_producao_Controller);
});
