function cdp00400_controles_producaoController (templateManager, restEngine, General, ScreenService, ZHPromise){
    
    this.atualizaData = function(field){
        field.setValue(moment().format('DD/MM/YYYY HH:mm:ss'));
    };
    
    this.widgetSave = function (widget) {
		var deferred = ZHPromise.defer();

		if (widget.isValid()) {
			widget.currentRow.changed = true;

			if (!widget.currentRow.__is_new)
				widget.currentRow.__is_new = false;
			else if (widget.paramsNewCode && widget.paramsNewCode.__is_new_code) {
				widget.currentRow.__using_unit = widget.paramsNewCode.__using_unit || false;
				widget.currentRow.__new_code_pk = widget.paramsNewCode.__new_code_pk;
				widget.currentRow.__table_pk = widget.paramsNewCode.__table_pk;
				widget.currentRow.__new_code_length = widget.paramsNewCode.__new_code_length || 5;
				widget.currentRow.__cast_number = widget.paramsNewCode.__cast_number || false;
			}

			widget.saveRow().then(function (response) {
				widget.currentRow.changed = false;
				delete widget.backupRow;

				if (General.formWidgetSwitchTemplate(widget) && widget.parent) {
					widget.view();

					var widgets = widget.parent.widgets;
					General.changeWidgetAcessibility(widgets.concat(widget.parent), true);
				} else {
					if (widget.currentRow.__is_new) {
						ScreenService.closeSwipe();
						widget.list();
					} else widget.view();

					General.changeWidgetAcessibility(widget.widgets, true);
				}

				if (widget.currentRow.__is_new) widget.currentRow.__is_new = false;
				else widget.reload();

				deferred.resolve(response);
				widget.reload();
			}.bind(this), function (error) {
				var errorMessage = 'Timeout';

				if (error.data) errorMessage = error.data.error;

				ScreenService.showMessage(errorMessage);
				deferred.reject(errorMessage);
			});
		} else deferred.reject("Preencha todos os campos corretamente!");

		return deferred;
	};
	
	this.deleteCrud = function (widget) {
		var deferred = ZHPromise.defer();
		ScreenService.confirmMessage(ScreenService.i18n('Delete Register?'), 'question', function (success) {
			widget.removeRow().then(function () {
				ScreenService.closeSwipe().then(function () {
					widget.activate();
					deferred.resolve();
					
					widget.getParent().dataSource.reload().then(function (data){
						var existe = false;
						data.dataset.equipamentoUtilizado_nome.forEach(function(data){
							if(widget.currentRow.CDEQUIPPRO === data.CDEQUIPPRO && widget.currentRow.CDTPCONTROLE === data.CDTPCONTROLE){
								existe = true;
							}
						});
						if(!existe){
							ScreenService.closeSwipe();
							widget.getParent().activate();	
							}
					});
				});
			}, function (error) {
				if (error.data && error.data.error.indexOf('ORA-02292') !== -1) {
					ScreenService.showMessage('Exclusão não permitida! O registro possui registros filhos.');
				} else {
					ScreenService.showMessage(error.data.error);
				}
				deferred.reject();
			});
		});
		return deferred.promise;
	};
	
	this.saveEquipamento = function (widget) {
		if(widget.currentRow.__is_new){
			var deferred = ZHPromise.defer();
	
			if (widget.isValid()) {
				widget.currentRow.changed = true;
	
				if (!widget.currentRow.__is_new)
					widget.currentRow.__is_new = false;
				else if (widget.paramsNewCode && widget.paramsNewCode.__is_new_code) {
					widget.currentRow.__using_unit = widget.paramsNewCode.__using_unit || false;
					widget.currentRow.__new_code_pk = widget.paramsNewCode.__new_code_pk;
					widget.currentRow.__table_pk = widget.paramsNewCode.__table_pk;
					widget.currentRow.__new_code_length = widget.paramsNewCode.__new_code_length || 5;
					widget.currentRow.__cast_number = widget.paramsNewCode.__cast_number || false;
				}
				widget.dataSource.name = "cdp_producao#/crud/equipamentoUtilizado_nome_save";
	
				widget.saveRow().then(function (response) {
					widget.dataSource.name = "cdp_producao#/crud/equipamentoUtilizado_nome";
					widget.currentRow.changed = false;
					delete widget.backupRow;
	
					if (General.formWidgetSwitchTemplate(widget) && widget.parent) {
						widget.view();
	
						var widgets = widget.parent.widgets;
						General.changeWidgetAcessibility(widgets.concat(widget.parent), true);
					} else {
						if (widget.currentRow.__is_new) {
							ScreenService.closeSwipe();
							widget.list();
						} else widget.view();
	
						General.changeWidgetAcessibility(widget.widgets, true);
					}
	
					if (widget.currentRow.__is_new) widget.currentRow.__is_new = false;
					else widget.reload();
	
					deferred.resolve(response);
					widget.reload();
				}.bind(this), function (error) {
					var errorMessage = 'Timeout';
	
					if (error.data) errorMessage = error.data.error;
	
					ScreenService.showMessage(errorMessage);
					deferred.reject(errorMessage);
				});
			} else deferred.reject("Preencha todos os campos corretamente!");
	
			return deferred;
		} else {
			this.widgetSave(widget);
		}
	};
	
	this.backOrCancel = function(args){
		General.backOrCancel(args);
		
		var widgetsToActivate = args.owner.widget.widgets;

				General.changeWidgetAcessibility(
					widgetsToActivate.filter(function (subwidget) {
						return subwidget.name != args.owner.widget.name;
					}).concat(args.owner.widget), //retorna um array com a widget parent e suas widgets filhas, exceto aquela que será editada
					true);
	};

}
Configuration(function(ContextRegister) {
    ContextRegister.register('cdp00400_controles_producaoController', cdp00400_controles_producaoController);
});