function cdp01500_parametros_mrp_Controller(templateManager, restEngine, General, ScreenService, cdp01500_parametros_mrp_Service){
    
    this.editar = function(widget){
        var filial = widget.currentRow.CDFILIAL;
        
        if(filial == null) {
        	widget.currentRow.__is_new = true;
        	widget.currentRow.CDFILIAL = widget.__filterPopup.getField('CDFILIAL').value();
        }
        
        General.edit(widget);
    };
    
    this.achaMaxNivelProduto = function(widget){
        var maxNivel;
        
        cdp01500_parametros_mrp_Service.achaMaxNivelProduto().then(function(nv){
            maxNivel = nv.dataset.maxNvProduto[0].MAXNVPROD;
            widget.__filterPopup.getField('NMPRODUTO').dataSourceFilter[0].value = maxNivel;
        });
    };
    
    this.salvaParamMrp = function(widget){
    	var msg;
    	
    	if(widget.isValid()){
    		if(widget.currentRow.HRENTRPROD != null){
    			widget.currentRow.HRENTRPROD = widget.currentRow.HRENTRPROD.replace(/[^0-9]+/g, '');
    		}
    		widget.saveRow().then(
    			function success(success) {
    				widget.reload().then(function(){
	    				ScreenService.closeSwipe();
						ScreenService.successNotification(ScreenService.i18n('Item salvo com sucesso'));
    				});
				},
				function error(error) {
					if (error.data) {
						msg = ScreenService.i18n(error.data.error);
						ScreenService.showMessage(msg);
					} else {
						msg = ScreenService.i18n("Verifique sua conexão e tente novamente");
						ScreenService.showMessage(msg);
					}
				}
    		);
    	}
    };
    
    this.salvaMaisParams = function(widget){
    	var widgetPrincipal = templateManager.container.getWidget('ParametrosMrpWidget');
    	var contS = 0, contF = 0;
    	var msg = 'Deseja modificar os itens selecionados?', linhasSelecionadas = [];
    	var inicial = widget.currentRow.INICIAL-1, final = widget.currentRow.FINAL;
    	var backToMain = this.voltaAoPrincipal;
    	
    	for(var i = inicial; i < final ; i++){
    		linhasSelecionadas.push(widgetPrincipal.dataSource.data[i]);
    	}
    	
    	if(widget.isValid()){
    		ScreenService.confirmMessage(msg, 'INFORMATION', function(){
	    		linhasSelecionadas.forEach(function(linha){
	    			if(linha.CDFILIAL == null) linha.__is_new = true;
	    			
	    			if(widget.currentRow.HRENTRPROD != null){
	    				linha.HRENTRPROD = widget.currentRow.HRENTRPROD.replace(/[^0-9]+/g, '');
	    			}else{
	    				linha.HRENTRPROD = widget.currentRow.HRENTRPROD;
	    			}
	    			linha.CDFILIAL = widget.currentRow.CDFILIAL;
	    			linha.CDPERIPRODU = widget.currentRow.CDPERIPRODU;
	    			linha.QTHRSEGPROD = widget.currentRow.QTHRSEGPROD;
	    			linha.IDAPLICHRSEG = widget.currentRow.IDAPLICHRSEG;
	    			linha.IDGERAOPCONF = widget.currentRow.IDGERAOPCONF;
	    			cdp01500_parametros_mrp_Service.salvaParametroMrp(linha).then(
	    				function success(success){
	    					contS++;
	    					if((contS + contF) == linhasSelecionadas.length){
	    						ScreenService.successNotification(ScreenService.i18n(contS + ' item(s) modificado(s) com sucesso'));
	    						backToMain();
	    					}
	    				},
	    			    function error(error){
	    			    	contF++;
							if (error.data) {
								msg = ScreenService.i18n(error.data.error);
								ScreenService.showMessage(msg);
							} else {
								msg = ScreenService.i18n("Verifique sua conexão e tente novamente");
								ScreenService.showMessage(msg);
							}
	    			    }
	    			);
	    		});
    		});
    	}
    	
    };
    
    this.editaMais = function(widget){
    	templateManager.container.getWidget('MultiParametrosWidget').isVisible = true;
    	this.currentRowConstructor(widget);
    	ScreenService.openPopup(widget.widgets[0]);
    };
    
    this.currentRowConstructor = function(widgetPrincipal){
    	var multiParametros = templateManager.container.getWidget('MultiParametrosWidget');
    	
    	multiParametros.currentRow.CDFILIAL = widgetPrincipal.__filterPopup.getField('CDFILIAL').value();
    	multiParametros.currentRow.CDPERIPRODU = null;
    	multiParametros.currentRow.HRENTRPROD = null;
    	multiParametros.currentRow.QTHRSEGPROD = null;
    	multiParametros.currentRow.IDAPLICHRSEG = null;
    	multiParametros.currentRow.IDGERAOPCONF = null;
    };
    
    this.excluiParam = function(widget){
        var msg1 = 'Deseja remover este item?';
        var msg2 = 'Deseja remover os itens selecionados?'; 
        var itensRemovidos = 0;
        
        if(widget.getCheckedRows().length == 0){
            ScreenService.confirmMessage(msg1, 'question', function () {
				
				if(widget.currentRow.CDFILIAL == null){
					return ScreenService.showMessage('Não foi possível realizar a remoção, item selecionado não está registrado nos parâmetros para MRP.');
				}else{
					widget.removeRow().then(
						function success(argument) {
							ScreenService.closeSwipe().then(function(){
								widget.reload(); 	
							});
							return ScreenService.successNotification(ScreenService.i18n('Item excluído com sucesso'));
						},
						function error(error) {
							var msg;
							if (error.data && error.data.error.indexOf('ORA-02292') !== -1) {
								msg = ScreenService.i18n('Exclusão não permitida. As informações da tabela são utilizadas em outras tabelas!');
								ScreenService.showMessage(msg);
							} else if (error.data) {
								msg = ScreenService.i18n(error.data.error);
								ScreenService.showMessage(msg);
							} else {
								msg = ScreenService.i18n("Verifique sua conexão e tente novamente");
								ScreenService.showMessage(msg);
							}
						}
					);	
				}
				
			});
			
        }else{//por enquanto inutil
            var linhasSelecionadas = widget.getCheckedRows();
            
            linhasSelecionadas.forEach(function(linha){
            	if(linha.CDFILIAL != null) itensRemovidos++;
            });
            
            ScreenService.confirmMessage(msg2, 'question', function () {
				widget.removeCheckedRows().then(
					function success(argument) {
						ScreenService.closeSwipe().then(function(){
							widget.reload(); 	
						});
						return ScreenService.successNotification(ScreenService.i18n(itensRemovidos + ' itens excluídos com sucesso'));
					},
					function error(error) {
						var msg;
						if (error.data && error.data.error.indexOf('ORA-02292') !== -1) {
							msg = ScreenService.i18n('Exclusão não permitida. As informações da tabela são utilizadas em outras tabelas!');
							ScreenService.showMessage(msg);
						} else if (error.data) {
							msg = ScreenService.i18n(error.data.error);
							ScreenService.showMessage(msg);
						} else {
							msg = ScreenService.i18n("Verifique sua conexão e tente novamente");
							ScreenService.showMessage(msg);
						}
					}
				);
			});
			
        }
    };
    
    this.voltaAoPrincipal = function(){
    	templateManager.container.getWidget('MultiParametrosWidget').currentRow = [];
    	templateManager.container.getWidget('MultiParametrosWidget').getField('CDARVPRODFIN').readOnly = true;
    	ScreenService.closePopup();
		templateManager.container.getWidget('ParametrosMrpWidget').reload();
		templateManager.container.getWidget('ParametrosMrpWidget').unSelectAll();
    	templateManager.container.getWidget('MultiParametrosWidget').isVisible = false;
    };
    
	this.filtroChanger = function(widget){
		//revela cadastramento automatico depois de aplicar filtro	
		templateManager.container.getWidget('ParametrosMrpWidget').actions[4].isVisible = true;
		
    	templateManager.container.getWidget('ParametrosMrpWidget').dataSourceFilter = 
			[
				{
                    "name": "P_CDFILIAL",
                    "operator": "=",
                    "value": widget.getField('CDFILIAL').value()
                }
			];
			
		widget.fields.forEach(function(field){
			if(field.value() != undefined && field.value() != "" && field.value() != null && field.name != 'CDFILIAL' && field.name != 'SEARCHLIST__ALL'){
				templateManager.container.getWidget('ParametrosMrpWidget').dataSourceFilter.push(
					{
						"name": field.name,
	                    "operator": "=",
                    	"value": widget.getField(field.name).value()
					}
				);
			}	
		});
	};
	
	this.validaProdutoAte = function(widget){
		var produtoFinal = widget.getField('CDARVPRODFIN');
		var produtoInicial_isSelected = !!widget.currentRow.CDARVPRODINI;
		
		if(produtoInicial_isSelected){
			produtoFinal.validations.required = true;
		}else{
			delete(produtoFinal.validations.required);
			widget.getField('NMPRODFIN').setValue('');
		}
		
		produtoFinal.readOnly = !produtoInicial_isSelected;
		produtoFinal.setValue(null);
		produtoFinal.needReload = true;
	};
	
	this.prodFinal = function(widget){
		var limite = widget.currentRow.INICIAL;
		var arrayProdFinal = widget.getField('CDARVPRODFIN').dataSource.data;

		arrayProdFinal.splice(0, limite-1);//pegar o produto inicial(incluso) em diante
	};
}

Configuration(function(ContextRegister) {
    ContextRegister.register('cdp01500_parametros_mrp_Controller', cdp01500_parametros_mrp_Controller);
});