function cdp01600_LoteDeMateriaPrimaInsumos_Controller(ZHPromise, templateManager, restEngine, General, ScreenService)
{
    /**
     * Essa função valida o ReadOnly do field 'Lote__Até', sendo que esse campo 
     * só deve ser editado quando no field 'Lote__De' tiver algum vlr preenchido.
     * Também reseta qualquer valor previamente preenchido e copia dataSource de 
     * 'NRLOTEESTQ_DE' para 'NRLOTEESTQ_ATE'.
     */
    this.valida_LoteAte = function(widget) {
        var popup = widget.__filterPopup;
        // Variável booleana que é setada como true caso alguma empresa tenha sido selecionada.
        var lote__De_IsSelected = !!popup.currentRow.NRLOTEESTQ_DE;
        var loteAteField = popup.getField('NRLOTEESTQ_ATE');
        // Altera as propriedades do field 'Lote__Ate' e reseta seu valor.
        if(lote__De_IsSelected)
            loteAteField.validations.required = lote__De_IsSelected;
        else
            delete(loteAteField.validations.required);
        loteAteField.readOnly = !lote__De_IsSelected;
        loteAteField.setValue(null);
        loteAteField.needReload = true;
        limitaIntervalo(popup, 'NRLOTEESTQ');
    };

    /**
     * Essa função valida o ReadOnly do field 'Lote__Até', sendo que esse campo 
     * só deve ser editado quando no field 'Lote__De' tiver algum vlr preenchido.
     * Também reseta qualquer valor previamente preenchido e copia dataSource de 
     * 'NRLOTEESTQ_DE' para 'NRLOTEESTQ_ATE'.
     */
    this.valida_ProdutoAte = function(widget) {
        var popup = widget.__filterPopup;
        // Variável booleana que é setada como true caso alguma empresa tenha sido selecionada.
        var produto__De_IsSelected = !!popup.currentRow.CDARVPROD_DE;
        
        var produtoAteField = popup.getField('CDARVPROD_ATE');

        // Altera as propriedades do field 'Lote__Ate' e reseta seu valor.
        if(produto__De_IsSelected)
            produtoAteField.validations.required = produto__De_IsSelected;
        else
            delete(produtoAteField.validations.required);
        produtoAteField.readOnly = !produto__De_IsSelected;
        produtoAteField.setValue(null);
        produtoAteField.needReload = true;
        limitaIntervalo(popup, 'CDARVPROD' );
    };    

    /**
     * Função auxiliar que valida o limite de valores do field 'Lote__Até'. Esse limite é o
     * num. de lote do field 'Lote__De'.
     */
    var limitaIntervalo = function(popup, field){
        var limite;
        if(field == 'NRLOTEESTQ'){
            var nrloteestq_de = popup.getField('NRLOTEESTQ_DE');
            var nrloteestq_ate = popup.getField('NRLOTEESTQ_ATE');
            // Para economizar uma requisição, o dataSource do field 'NRLOTEESTQ_DE' é
            // atribuído para o field 'NRLOTEESTQ_ATE'
            angular.copy(nrloteestq_de.dataSource.data, nrloteestq_ate.dataSource.data);
            nrloteestq_ate.dataSource.data.forEach(function(obj){
                if(obj.NRLOTEESTQ == popup.currentRow.NRLOTEESTQ_DE){
                    // é atribuído à 'cont' o índice do .data do valor referente ao 'NRLOTEESTQ_DE'
                    // escolhido
                    limite = obj.ROWNUM;
                }
            });
            // É usado o splice, para retirar todos os elementos do .data do field 
            // 'NRLOTEESTQ_ATE' cujos índices é menor ou igual que o escolhido para o 
            // 'NRLOTEESTQ_DE'
            nrloteestq_ate.dataSource.data.splice(0, (limite));
        }else{
            // Abaixo é feita a mesma validação de quando a condição é verdadeira
            var cdarvprod_de = popup.getField('CDARVPROD_DE');
            var cdarvprod_ate = popup.getField('CDARVPROD_ATE');
            angular.copy(cdarvprod_de.dataSource.data, cdarvprod_ate.dataSource.data);
            cdarvprod_ate.dataSource.data.forEach(function(obj){
                if(obj.CDARVPROD == popup.currentRow.CDARVPROD_DE){
                    limite = obj.ROWNUM;
                }
            });
            cdarvprod_ate.dataSource.data.splice(0, (limite));
        }
    };
    /**
     * Função, disparada depois do filtro ser aplicado, que monta o dataSourceFilter
     * com os intervalos de 'NRLOTEESTQ' e 'CDARVPROD'
     */
    this.validaFiltro = function(widget){
        var popup = widget.__filterPopup;
        var dataSourceFilter = widget.dataSourceFilter;
        // Variáveis para NRLOTEESTQ
        var dadosFieldLoteAte = popup.getField('NRLOTEESTQ_ATE').dataSource.data;
        var dadosFieldProdutoAte = popup.getField('CDARVPROD_ATE').dataSource.data;
        // Variáveis para CDARVPROD
        var nrloteestq_ate = popup.currentRow.NRLOTEESTQ_ATE;
        var cdarvprod_ate = popup.currentRow.CDARVPROD_ATE;
        // Se existir na currentRow valor de 'NRLOTEESTQ_ATE' e/ou 'CDARVPROD_ATE', 
        // significa que se deve montar o filtro, caso o contrário, não se deve montar
        if(nrloteestq_ate)
            montaFiltroLote(dadosFieldLoteAte, nrloteestq_ate, dataSourceFilter);
        if(cdarvprod_ate)
            montaFiltroProduto(dadosFieldProdutoAte, cdarvprod_ate, dataSourceFilter);
    };
    
    /**
     * Função auxiliar, invocada para montar o filtro de Lote
     */
    var montaFiltroLote = function(dadosFieldLoteAte, nrloteestq_ate, dataSourceFilter){
        var logico = true, cont = 0, destrutor;
        var nrloteestq = [];
        // É percorrido o dataSource, e preenchido o intervalo selecionado 
        // à variável nrloteestq
        dadosFieldLoteAte.forEach(function(obj){
            if((obj.NRLOTEESTQ != nrloteestq_ate) && logico)
                nrloteestq.push(obj.NRLOTEESTQ);
            if(obj.NRLOTEESTQ == nrloteestq_ate){
                logico = false;
            }
        });
        // É adicionado à variável 'nrloteestq' o vlr escolhido no field 'NRLOTEESTQ_ATE'
        nrloteestq.push(nrloteestq_ate);
        // É percorrido o array dataSourceFilter, para excluir o índice referente a
        // 'NRLOTEESTQ_DE', e alterado o 'NRLOTEESTOQUE_ATE', afim de que se 
        // tome o formato de cláusula IN
        dataSourceFilter.forEach(function(obj){
            if(obj.name == 'NRLOTEESTQ_DE'){
                destrutor = cont;
            }
            if(obj.name == 'NRLOTEESTQ_ATE'){
                obj.name = 'NRLOTEESTQ';
                obj.operator = 'IN';
                obj.value = nrloteestq;
            }
            cont++;
        });
        dataSourceFilter.splice(destrutor, 1);
    };
    
    /**
     * Função auxiliar, invocada para montar o filtro de Produto. Dispensa comentários
     * no escopo, porque realiza o mesmo que 'montaFiltroLote', com excessão que é para
     * produto
     */
    var montaFiltroProduto = function(dadosFieldProdutoAte, cdarvprod_ate, dataSourceFilter){
        var logico = true, cont = 0, destrutor;
        var cdarvprod = [];
        dadosFieldProdutoAte.forEach(function(obj){
            if((obj.CDARVPROD != cdarvprod_ate) && logico)
                cdarvprod.push(obj.CDARVPROD);
            if(obj.CDARVPROD == cdarvprod_ate){
                logico = false;
            }
        });
        cdarvprod.push(cdarvprod_ate);
        dataSourceFilter.forEach(function(obj){
            if(obj.name == 'CDARVPROD_DE'){
                destrutor = cont;
            }
            if(obj.name == 'CDARVPROD_ATE'){
                obj.name = 'CDARVPROD';
                obj.operator = 'IN';
                obj.value = cdarvprod;
            }
            cont++;
        });
        dataSourceFilter.splice(destrutor, 1);
    };    
    
    /**
     * Função responsável por definir ReadOnly dos campos de intervalos, cujos 
     * componentes não existem, após a aplicação do filtro
     */
    this.validaReadOnly = function(widget){
        // Aparentemente, duas variáveis para o mesmo Field. Entretanto, isso se deve 
        // porque apenas no field da widget é possível alterar a propriedade ReadOnly,
        // e apenas no field do __filterPopup, é possível alterar o validations
        var nrloteestq_ate = widget.getField('NRLOTEESTQ_ATE');
        var cdarvprod_ate = widget.getField('CDARVPROD_ATE');
        var nrloteestq_ate_filter = widget.__filterPopup.getField('NRLOTEESTQ_ATE');
        var cdarvprod_ate_filter = widget.__filterPopup.getField('CDARVPROD_ATE');
        var dataSourceFilter = widget.dataSourceFilter, presencaLote = false, presencaProduto = false;
        // Percore o vetor de dataSource, a fim de procurar se existe para o campo
        // 'NRLOTEESTQ', e validar a partir disso
        dataSourceFilter.forEach(function(obj){
            if(obj.name == 'NRLOTEESTQ')
                presencaLote = true;
            if(obj.name == 'CDARVPROD')
                presencaProduto = true;
        });
        // Valida dataSourceFilter para field 'NRLOTEESTQ'
        if(presencaLote){
            nrloteestq_ate.readOnly = false;
        }else{
            nrloteestq_ate.readOnly = true;
            delete(nrloteestq_ate_filter.validations.required);
        }
        // Valida dataSourceFilter para field 'CDARVPROD'
        if(presencaProduto){
            cdarvprod_ate.readOnly = false;
        }else{
            cdarvprod_ate.readOnly = true;
            delete(cdarvprod_ate_filter.validations.required);
        }        
    };
}
Configuration(function(ContextRegister){
    ContextRegister.register('cdp01600_LoteDeMateriaPrimaInsumos_Controller', cdp01600_LoteDeMateriaPrimaInsumos_Controller);
});