function cdp04000_agenda_de_tarefas_Controller (cdp04000_agenda_de_tarefas_Service, ZHPromise, templateManager, restEngine, General, ScreenService){
    
    this.backupRow = {};
    this.CDSETOR = {};
    
    this.newAgenda = function(widget){
        widget.newRow();
        
        widget.widgets[0].enabled = false;
        
        cdp04000_agenda_de_tarefas_Service.retornaFilial().then(function(filialLogada){
            widget.currentRow.CDFILIAL =  filialLogada[0].CDFILIAL;
        });
        
        widget.currentRow.CDSETOR = this.CDSETOR;
        
    };
    
    this.showAdd = function(widget){
        widget.container.getWidget('agenda_de_tarefas').getAction('adicionar').isVisible = true;
    };
    
    this.setFilter = function (widget){
        widget.container.getWidget('agenda_de_tarefas').dataSourceFilter[1].value = widget.currentRow.CDSETOR;
        this.CDSETOR = widget.currentRow.CDSETOR; 
    };
    
    this.saveAgenda = function(widget){
        if (widget.isValid()){
            widget.currentRow.HRAGENTARE = widget.currentRow.HORAAGEN.replace(/[^0-9]+/g, ''); 
            
            /*Crio uma campo para backup para poder compara o campo do tipo atual com o anterior,
            de forma que só é impedido de salvar se já existir uma linha com os mesmos valores*/
            
            var widget_anterior = (widget.currentRow.__is_new == false) ? this.backupRow.IDORIGAGTARE : widget.currentRow.IDORIGAGTARE;
            widget.currentRow.BACKUP = widget_anterior;  
            
            cdp04000_agenda_de_tarefas_Service.salvarAgenda(widget.currentRow).then(
                function(Success) {
                        ScreenService.closeSwipe().then(function () {
                            widget.activate();
                        });
                        widget.reload();
                    },
                    function(callback){
                        if(callback.data){
                            ScreenService.showMessage(callback.data.error);
                        }
                    }
                );
            
            widget.widgets[0].enabled = true;
        }
    };
    
    this.editAgenda = function(widget){
        widget.widgets[0].enabled = false;
        this.backupRow = Util.clone(widget.currentRow); 
        General.edit(widget);
    };
    
    this.CancelAgenda = function(widget){
        widget.widgets[0].enabled = true;
    };
    
    this.deleteAgenda = function(widget){
        
       ScreenService.confirmMessage(ScreenService.i18n('Delete Register?'), 'question', function (success) {
    
            cdp04000_agenda_de_tarefas_Service.deletarAgenda(widget.currentRow).then(
                function(Success) {
                    ScreenService.closeSwipe().then(function () {
                        widget.activate();
                    });
                    widget.reload();
                },
                function(error){
                    if (error.data && error.data.error.indexOf('ORA-02292') !== -1) {
                        ScreenService.showMessage('Exclusão não permitida! O registro possui registros filhos.');
                    } else {
                        ScreenService.showMessage(error.message);
                    }
                }
            );
        });
    };
    
    this.verificaInspecaoVazia = function(args){
        var widget = args.owner.owner.widget;
       cdp04000_agenda_de_tarefas_Service.verificaInspecao(widget.currentRow).then(
            function(Success) {},
                function(callback){
                    if(callback.data){
                        ScreenService.showMessage(callback.data.error);
                        //ScreenService.closeSwipe();
                        ScreenService.closePopup();
                        backOrCancel(args);
                    }
                }
            ); 
        
    };
    
    this.newInspecao = function(widget){
    
        widget.newRow();

        widget.currentRow.NRORG =  widget.parent.currentRow.NRORG;
        widget.currentRow.CDFILIAL =  widget.parent.currentRow.CDFILIAL;
        widget.currentRow.CDSETOR = widget.parent.currentRow.CDSETOR;
        widget.currentRow.CDPERIENTR = widget.parent.currentRow.CDPERIENTR;
        widget.currentRow.HRAGENTARE = widget.parent.currentRow.HRAGENTARE;
        widget.currentRow.IDORIGAGTARE = widget.parent.currentRow.IDORIGAGTARE;
        
    };
    
    function backOrCancel(args) {
		var deferred = ZHPromise.defer();
		if (args.row.__is_new) {
			args.owner.owner.widget.list(true);
			args.owner.owner.widget.dataSource.data.pop();
			args.owner.owner.widget.currentRow = {};
			deferred.resolve();
		} else if (args.owner.owner.widget.mode === 'edit') {
			args.owner.owner.widget.view();
			for (var i in args.owner.owner.widget.backupRow) {
				args.owner.owner.widget.currentRow[i] = args.owner.owner.widget.backupRow[i];
			}
			deferred.resolve();
			return deferred.promise;
		}
		ScreenService.goBack();
		return deferred.promise;
	}
    
}
Configuration(function(ContextRegister) {
    ContextRegister.register('cdp04000_agenda_de_tarefas_Controller', cdp04000_agenda_de_tarefas_Controller);
});
