function ger02500_nutrienteController(ScreenService, ger02500_nutrienteService, localStorageEngine, templateManager, General, ZHPromise) {

	var self = this;

	this.abreDetalhesNutriente = function (nutrienteWidget, tabbedWidget, detalhesNutrienteWidget) {
		ScreenService.openSwipe(tabbedWidget);
		for (var i in nutrienteWidget.currentRow) {
			detalhesNutrienteWidget.currentRow[i] = nutrienteWidget.currentRow[i];
		}
	};

	this.editaNutriente = function (nutrienteWidget, tabbedWidget, detalhesNutrienteWidget) {
		self.abreDetalhesNutriente(nutrienteWidget, tabbedWidget, detalhesNutrienteWidget);
		detalhesNutrienteWidget.formTemplate = 'widget/form.html';
		detalhesNutrienteWidget.template = 'widget/form.html';
		detalhesNutrienteWidget.mode = 'edit';
		General.edit(detalhesNutrienteWidget);
	};

	this.cancelaEdicao = function (detalhesNutrienteWidget) {
		self.voltaModoView(detalhesNutrienteWidget);
		self.copiaRow(detalhesNutrienteWidget.backupRow, detalhesNutrienteWidget.currentRow);
	};

	this.salvaEdicao = function (nutrienteWidget, detalhesNutrienteWidget) {
		if (detalhesNutrienteWidget.isValid() && self.validaSigla(detalhesNutrienteWidget)) {
			detalhesNutrienteWidget.currentRow.__is_new = false;
			detalhesNutrienteWidget.currentRow.changed = true;
			detalhesNutrienteWidget.currentRow.DTULTATU = moment().format('L');
			detalhesNutrienteWidget.currentRow.NRORGULTATU = getLocalVar('NRORGTRAB');
			detalhesNutrienteWidget.currentRow.CDOPERULTATU = getLocalVar('CDOPERADOR');
			detalhesNutrienteWidget.dataSource.data = [];
			detalhesNutrienteWidget.saveRow().then(
				function success(success) {
					self.voltaModoView(detalhesNutrienteWidget);
					ScreenService.successNotification(ScreenService.i18n('Nutriente alterado com sucesso'));
					self.copiaRow(detalhesNutrienteWidget.currentRow, nutrienteWidget.currentRow);
				},
				function error(error) {
					var msg;
					if (error.data) {
						msg = ScreenService.i18n(error.data.error);
						ScreenService.showMessage(msg);
					} else {
						msg = ScreenService.i18n("Verifique sua conexão e tente novamente");
						ScreenService.showMessage(msg);
					}
				}
			);
		}
	};

	this.adicionaNutriente = function (nutrienteWidget) {
		newRowGeral(nutrienteWidget);
		ScreenService.openSwipe(nutrienteWidget);
		nutrienteWidget.currentRow.__is_new = true;
	};

	this.cancelaAdicao = function (nutrienteWidget) {
		nutrienteWidget.list(true);
		nutrienteWidget.dataSource.data.pop();
		nutrienteWidget.currentRow = {};
		ScreenService.closeSwipe();
		templateManager.updateTemplate();
	};

	this.validaAdicaoNutriente = function (nutrienteWidget) {
		if (nutrienteWidget.isValid()) {
			if (self.validaCodigoNutri(nutrienteWidget) && self.validaSigla(nutrienteWidget)) {
				var novoCdnutriente = nutrienteWidget.currentRow.CDNUTRIENTE;
				ger02500_nutrienteService.retornaNutriente().then(
					function success(success) {
						var nutriExistente = success.dataset.nutriente.filter(function (i) {
							return novoCdnutriente == i.CDNUTRIENTE;
						});
						if (nutriExistente.length) {
							var msg = ScreenService.i18n("Nutriente") + " '" + nutriExistente[0].CDNUTRIENTE + "' " + ScreenService.i18n("já cadastrado");
							ScreenService.showMessage(msg);
						} else {
							nutrienteWidget.currentRow.IDTIPONUTR = 'N';
							self.salvaAdicao(nutrienteWidget);
						}
					},
					function error(error) {
						var msg;
						if (error.data) {
							msg = ScreenService.i18n(error.data);
							ScreenService.showMessage(msg);
						} else {
							msg = ScreenService.i18n("Verifique sua conexão e tente novamente");
							ScreenService.showMessage(msg);
						}
					}
				);
			}
		}
	};

	this.salvaAdicao = function (nutrienteWidget) {
		$('CDNUTRIENTE').blur();
		return ger02500_nutrienteService.salvaNutriente(nutrienteWidget.currentRow).then(
			function success() {
				nutrienteWidget.list(true);
				nutrienteWidget.currentRow = {};
				ScreenService.closeSwipe();
				return nutrienteWidget.reload().then(function () {
					return ScreenService.successNotification(ScreenService.i18n('Nutriente adicionado com sucesso'));
				});
			},
			function error(error) {
				var msg;
				if (error.data) {
					msg = ScreenService.i18n(error.data);
					ScreenService.showMessage(msg);
				} else {
					msg = ScreenService.i18n("Verifique sua conexão e tente novamente");
					ScreenService.showMessage(msg);
				}
			}
		);
	};

	this.validaCodigoNutri = function (nutrienteWidget) {
		var validado = true;
		if (isNaN(parseFloat(nutrienteWidget.currentRow.CDNUTRIENTE))) {
			var msg = ScreenService.i18n("Código Inválido");
			ScreenService.showMessage(msg);
			validado = false;
		} else if (nutrienteWidget.currentRow.CDNUTRIENTE.length < 3) {
			var num = 3 - nutrienteWidget.currentRow.CDNUTRIENTE.length;
			for (num; num > 0; num--) {
				nutrienteWidget.currentRow.CDNUTRIENTE = '0' + nutrienteWidget.currentRow.CDNUTRIENTE;
			}
		} else if (nutrienteWidget.currentRow.CDNUTRIENTE.length > 3) {
			nutrienteWidget.currentRow.CDNUTRIENTE = nutrienteWidget.currentRow.CDNUTRIENTE.substr(0, 3);
		}
		return validado;
	};

	this.validaSigla = function (nutrienteWidget) {
		var validado = true;
		nutrienteWidget.currentRow.NMREDUZIDO = nutrienteWidget.currentRow.NMREDUZIDO.toUpperCase();
		if (nutrienteWidget.currentRow.NMREDUZIDO.length > 4) {
			nutrienteWidget.currentRow.NMREDUZIDO = nutrienteWidget.currentRow.NMREDUZIDO.substr(0, 4);
		}
		return validado;
	};

	this.excluiNutriente = function (nutrienteWidget) {
		var msg;
		
		if (nutrienteWidget.getCheckedRows().length == 0){
			msg = "Deseja excluir o nutriente " + nutrienteWidget.currentRow.NMNUTRIENTE + "?";
		}
		else if (nutrienteWidget.getCheckedRows().length > 1) {
			msg = "Deseja excluir o " + nutrienteWidget.getCheckedRows().length + " nutrientes selecionados?";
		} else {
			msg = "Deseja excluir o nutriente " + nutrienteWidget.getCheckedRows()[0].NMNUTRIENTE + "?";
		}
		
		if (nutrienteWidget.getCheckedRows().length > 0){
			ScreenService.confirmMessage(msg, 'question', function () {
				ger02500_nutrienteService.excluiNutriente(nutrienteWidget.getCheckedRows()).then(
					function success(argument) {
						nutrienteWidget.reload();
						nutrienteWidget.unSelectAll();
						templateManager.updateTemplate();
						return ScreenService.successNotification(ScreenService.i18n('Nutriente(s) excluído(s) com sucesso'));
					},
					function error(error) {
						var msg;
						if (error.data && error.data.error.indexOf('ORA-02292') !== -1) {
							msg = ScreenService.i18n('Exclusão não permitida. As informações da tabela NUTRIENTE são utilizadas na tabela NUTRPROD');
							ScreenService.showMessage(msg);
						} else if (error.data) {
							msg = ScreenService.i18n(error.data.error);
							ScreenService.showMessage(msg);
						} else {
							msg = ScreenService.i18n("Verifique sua conexão e tente novamente");
							ScreenService.showMessage(msg);
						}
					}
				);
			}, function(){
				nutrienteWidget.unSelectAll();
				templateManager.updateTemplate();
			});
		} else {
			ScreenService.confirmMessage(msg, 'question', function () {
				nutrienteWidget.removeRow().then(
					function success(argument) {
						ScreenService.closeSwipe().then(function(){
							nutrienteWidget.reload(); 	
						});
						return ScreenService.successNotification(ScreenService.i18n('Nutriente excluído com sucesso'));
					},
					function error(error) {
						var msg;
						if (error.data && error.data.error.indexOf('ORA-02292') !== -1) {
							msg = ScreenService.i18n('Exclusão não permitida. As informações da tabela NUTRIENTE são utilizadas na tabela NUTRPROD');
							ScreenService.showMessage(msg);
						} else if (error.data) {
							msg = ScreenService.i18n(error.data.error);
							ScreenService.showMessage(msg);
						} else {
							msg = ScreenService.i18n("Verifique sua conexão e tente novamente");
							ScreenService.showMessage(msg);
						}
					}
				);
			});
		}
	};

	this.voltaModoView = function (widget) {
		ScreenService.closeSwipe();
		widget.view();
		widget.template = "widget/form-view.html";
		templateManager.updateTemplate();
	};

	this.copiaRow = function (rowFonte, rowDestino) {
		for (var i in rowFonte) {
			rowDestino[i] = rowFonte[i];
		}
	};

	var newRowGeral = function (widget) {
		widget.newRow = function () {
			var event;
			if (this.beforeNewRow) {
				event = this.beforeNewRow();
			}
			if (!event || !event.isDefaultPrevented()) {

				var _oldValuesToRepeat = this.getRepeatOnNewValues();
				var row = {};
				if (this.dataSource) {
					this.dataSource.newRow();
					row = this.dataSource.data[this.dataSource.data.length - 1];
				}
				this.currentRow = row;
				this.applyDefaultValue();
				Util.extend(this.currentRow, _oldValuesToRepeat);
				this.edit();
				this.formTemplate = this.templateToForm;
				if (this.onNewRow) {
					this.onNewRow();
				}
			}
		};
		widget.newRow();
	};

}

Configuration(function (ContextRegister) {
	ContextRegister.register('ger02500_nutrienteController', ger02500_nutrienteController);
});