function ger15600_setorController (ScreenService, templateManager, General){
	
	this.reload = function(){
		var widgetSetor = templateManager.container.getWidget('widgetSetor');
		widgetSetor.reload();
	};
	
	this.createSetor = function(widget) {
        widget.reload();
        widget.newRow();
        widget.currentRow.__is_new = true;
    };
    
    this.edit = function(widget){
        widget.backupRow = Util.clone(widget.currentRow);
        widget.edit();
    };
    
    this.cancel = function(widget){
        if(widget.currentRow.__is_new === true){
            widget.dataSource.data.pop();
            ScreenService.closeSwipe();
        } else {
            Util.extend(widget.currentRow, widget.backupRow);
            widget.view();
        }
        this.reload();
    };
    
    this.verificaCodigo = function(){
        var codigo = templateManager.container.getWidget('widgetSetor').getField('CDSETOR').value();
        if(isNaN(codigo)){
            ScreenService.showMessage("O campo 'Setor' deve conter apenas números");
            templateManager.container.getWidget('widgetSetor').getField('CDSETOR').setValue('');
        }
    };
    
    this.salvar = function(widget){
        var codigo = templateManager.container.getWidget('widgetSetor').getField('CDSETOR').value();
        if(isNaN(codigo)){
            ScreenService.showMessage("O campo 'Setor' deve conter apenas números");
            templateManager.container.getWidget('widgetSetor').getField('CDSETOR').setValue('');
        }else{
            if(widget.isValid() == true){
                if(widget.currentRow.__is_new === false) widget.currentRow.oldSigla = widget.backupRow.SGSETOR;
                General.callRestEngine('cdp_producao#/setor_departamento_centcust/save', 'Row', widget.currentRow).then(function(callback){
                    if (widget.currentRow.__is_new) {
    					widget.list(true);
    					ScreenService.goBack();
    					widget.reload();
    				} else {
    					widget.computeDescriptionOrder();
    					widget.view();
    				}
    				ScreenService.showMessage("Salvo com sucesso.");
                }).catch(function(callback){
                    if(callback.data.error.length > 0){
                        ScreenService.showMessage(callback.data.error);
                    }else{
                        ScreenService.showMessage("Sigla já cadastrada.");
                    }
                });
            }
        }
    };
      
}
Configuration(function(ContextRegister) {
    ContextRegister.register('ger15600_setorController', ger15600_setorController);
});