function ger24000_habilidadeController (templateManager, restEngine, General, ScreenService, ZHPromise, ger24000_habilidadeService){
	
	var self = this;
	
	this.backOrCancel = function(args){
	    General.backOrCancel(args).then (function (){
	        if (args.owner.widget.name === 'grid_habilidade'){
	           General.changeWidgetAcessibility(args.owner.widget.widgets, true);
	        } 
	        if (args.owner.widget.name === 'grid_operador'){
	            args.owner.widget.getField('NMOPERADOR').readOnly = false;
	        }
	    });
	};
	
	this.activateTabs = function(args){
	    General.formWidgetSwitchTemplate(args.owner.widget);
	        var widgetsToActivate = args.owner.widget.widgets;

			General.changeWidgetAcessibility(
				widgetsToActivate.filter(function (subwidget) {
					return subwidget.name != args.owner.widget.name;
				}).concat(args.owner.widget), //retorna um array com a widget parent e suas widgets filhas, exceto aquela que será editada
				true);
				args.owner.widget.view();
	};
    
    this.validateFilterPopup = function(widget){
        var popup = widget.__filterPopup;
        var IDSITUACAOHABIL = popup.currentRow.IDSITUACAOHABIL;
        
        var IDGRUPHABILIDAD = popup.currentRow.IDGRUPHABILIDAD;

        if(!(IDSITUACAOHABIL)){
            widget.dataSourceFilter[1].value = 'T';
        }
        else{
            widget.dataSourceFilter[1].value = IDSITUACAOHABIL;
        }
        if(!(IDSITUACAOHABIL && IDGRUPHABILIDAD)){
            widget.dataSourceFilter[0].value = 'T';
        }
        else{
            widget.dataSourceFilter[0].value = IDGRUPHABILIDAD;
        }
            
    };
    
    this.saveCrud = function(widget){
        if(widget.currentRow.__is_new)
            General.saveCrud(widget).then(function(){
                General.changeWidgetAcessibility(widget.widgets, true);
            });
        else
            General.widgetSave(widget);
        if (widget.name === 'grid_operador'){
	        widget.getField('NMOPERADOR').readOnly = false;
	    }    
        
    };
    
    this.validateCusto = function(field){
        var VRCUSHRHABIL = field.value();
        
        if(VRCUSHRHABIL){
            if(parseFloat(VRCUSHRHABIL) > 999999999999999999999999999999999999999999999999999999999999999999999999999999999999999999999999999999999999999999999999999999 || parseFloat(VRCUSHRHABIL) < 0){
                ScreenService.errorNotification("Custo/Hora deve ter até 3 digitos e ser positivo");
                field.setValue('');
            }
        }
            
    };
    
    this.widgetEdit = function(widget){
        widget.getField('NMOPERADOR').readOnly = true;
        General.widgetEdit(widget);
    };
    
    this.saveCustohab = function(widget){
        
        var deferred = ZHPromise.defer();
        
        ScreenService.confirmMessage(ScreenService.i18n('Custo/Hora será alterado.\n Deseja Continuar?'), 'question', function (success) {
    		if (widget.isValid()) {
    			widget.currentRow.changed = true;
    
    			if (!widget.currentRow.__is_new)
    				widget.currentRow.__is_new = false;
    			else if (widget.paramsNewCode && widget.paramsNewCode.__is_new_code) {
    				widget.currentRow.__using_unit = widget.paramsNewCode.__using_unit || false;
    				widget.currentRow.__new_code_pk = widget.paramsNewCode.__new_code_pk;
    				widget.currentRow.__table_pk = widget.paramsNewCode.__table_pk;
    				widget.currentRow.__new_code_length = widget.paramsNewCode.__new_code_length || 5;
    				widget.currentRow.__cast_number = widget.paramsNewCode.__cast_number || false;
    			}
        
                var oldVRCUSHRHAB = Util.clone(widget.parent.currentRow.VRCUSHRHABIL);
                updateVRCUSHRHABIL(widget);
                var dataset = [];
                dataset.push(widget.currentRow, widget.parent.currentRow);
                ger24000_habilidadeService.saveCustohab(dataset).then(function (response) {
    				widget.currentRow.changed = false;
    				delete widget.backupRow;
    
    				if (General.formWidgetSwitchTemplate(widget) && widget.parent) {
    					widget.view();
    
    					var widgets = widget.parent.widgets;
    					General.changeWidgetAcessibility(widgets.concat(widget.parent), true);
    				} else {
    					if (widget.currentRow.__is_new) {
    						ScreenService.closeSwipe();
    						widget.list();
    						widget.reload();
    					} else widget.view();
    
    					General.changeWidgetAcessibility(widget.widgets, true);
    				}
    
    				if (widget.currentRow.__is_new) widget.currentRow.__is_new = false;
    				else widget.reload();
    
    				deferred.resolve(response);
    			}, function (error) {
    			    oldVRCUSHRHAB = widget.parent.currentRow.VRCUSHRHABIL;
    			    
    				var errorMessage = 'Timeout';
    
    				if (error.data) errorMessage = error.data.error;
    
    				ScreenService.showMessage(errorMessage);
    				deferred.reject(errorMessage);
    			});
    		} else deferred.reject("Preencha todos os campos corretamente!");
        });


		return deferred;
    };
    
    function updateVRCUSHRHABIL(widget){
        var deferred = ZHPromise.defer();
        var VRCUSHRHABIL = 0;
        widget.dataSource.data.forEach(function(data){
            VRCUSHRHABIL = parseFloat(VRCUSHRHABIL) + parseFloat(data.VRCUSTOHAB);
        });
        widget.parent.currentRow.VRCUSHRHABIL = VRCUSHRHABIL;
        return deferred.promise;
    }
    
}
Configuration(function(ContextRegister) {
    ContextRegister.register('ger24000_habilidadeController', ger24000_habilidadeController);
});