function QPR01000_Parametros_Qualidade_Producao_Controller (QPR01000_Parametros_Qualidade_Producao_Service, templateManager, restEngine, General, ScreenService,ZHPromise){

	this.setDefaultFilial = function(widget) {
        var filter = [
            {
                "name": "CDOPERADOR",
                "operator": "=",
                "value": "OPERADOR_LOGADO"
            }
        ];

        General.callRestEngine('cdp#/crud/operador', 'FilterData', filter).then(function(response) {
            widget.currentRow.CDFILIAL = response.dataset.operador[0].CDFILIALSELECIONADA;
            widget.currentRow.NMFILIAL = response.dataset.operador[0].CDFILIALSELECIONADA;
            this.filtroParametrosFilial(widget.getField('NMFILIAL'));
            this.setFilial(widget.getField('NMFILIAL'));
        }.bind(this));
    };

    this.widgetEdit = function (widget) {
    	if(!Util.isEmptyOrBlank(widget.dataSource.data)){
			if (!widget.editing) {
				//Trata a edição de uma widget filha do tipo form
				if (General.formWidgetSwitchTemplate(widget) && widget.parent) {
				    
				    this.changeBarAcessibility(widget.parent, false);
					
				} else //trata a edição dos demais casos
					General.changeWidgetAcessibility(widget.widgets, false);
	
				//propriedades a serem ignoradas na criação do backup
				var ignoredKeys = ["__rightActions", "__leftActions", "_children", "_parent", "__groupHeaders", "__index", "__isSelected", "__notSelectable", "$$hashKey"];
	
				//faz backup da currentRow para permitir a recuperação dos dados
				widget.backupRow = Util.clone(widget.currentRow, ignoredKeys);
				widget.edit();
				return true;
			} else return false;
    	} else{
    		this.NewRow(widget);
    	}
	};
    
    this.backOrCancel = function (args) {
		
		General.formWidgetSwitchTemplate(args.owner.widget);
		
		this.changeBarAcessibility(args.owner.widget.parent ,true);
		
		if (args.row.__is_new) {
			args.owner.widget.list(true);
			args.owner.widget.dataSource.data.pop();
			args.owner.widget.currentRow = {};
		} else if (args.owner.widget.mode === 'edit') {
			args.owner.widget.list();
			for (var i in args.owner.widget.backupRow) {
				args.owner.widget.currentRow[i] = args.owner.widget.backupRow[i];
			}
		}
		ScreenService.goBack();
	};
	
	this.filtroParametrosFilial =  function(field){
    	var filial = field.getParent().fields[1].value();
    	var allTabbeds =field.getParent().getParent().widgets; 
       	allTabbeds.forEach(function(widget){
       		this.activateAction(widget, !filial);
       	}.bind(this));
    };
    
    this.activateAction = function(widget, state){
    	widget.widgets.forEach(function(widget){
    		widget.actions.forEach(function(action){
    			action.readOnly = state;
    		});
    	});
    };
    
    this.recarregarField = function(nomeWidget,nomeField){
        var field =  templateManager.container.getWidget(nomeWidget).getField(nomeField);
        field.reload();
    };
    
    this.WidgetOnEnter = function(args){
        args.owner.currentRow = args.owner.dataSource.data[0];
    };
    
    this.changeBarAcessibility = function(widget, status){
        var widgetsToChange = widget.parent.widgets;

		General.changeWidgetAcessibility(
			widgetsToChange.filter(function (subwidget) {
				return subwidget.name != widget.name;
			}).concat(widget.parent), //retorna um array com a widget parent e suas widgets filhas, exceto aquela que será editada
		status);
    };
    
    this.changeLocalEstoqAcessibility = function (grid){
        var gridParametrosControleQualidade =  templateManager.container.getWidget(grid);
        if (gridParametrosControleQualidade.currentRow === undefined){
        	gridParametrosControleQualidade.currentRow = {};
        }
        var almoxarifado = gridParametrosControleQualidade.getField('CDALMOXARIFE').value();
        if(almoxarifado){
            gridParametrosControleQualidade.getField('DSLOCALESTOQ').readOnly = false;
        }else{
            gridParametrosControleQualidade.getField('DSLOCALESTOQ').readOnly = true;}
            gridParametrosControleQualidade.getField('DSLOCALESTOQ').reload();
    };
    
    
    this.getProxConsulta = function (args){
    
    QPR01000_Parametros_Qualidade_Producao_Service.findProxConsulta(args.owner).then(function(success) {
        var gridReanalise = templateManager.container.getWidget('grid_reanalise');
        if(success.dataset.parametroqpr_param_qualidade_prox_consulta[0] || (success.dataset.parametroqpr_param_qualidade_prox_consulta[1])){
            if(success.dataset.parametroqpr_param_qualidade_prox_consulta[0]){
	            gridReanalise.getField('DTHRPROXIMACONSULTA').setValue(success.dataset.parametroqpr_param_qualidade_prox_consulta[0].DTHRPROXIMACONSULTA);
            }
            if(success.dataset.parametroqpr_param_qualidade_prox_consulta[1]){
            	gridReanalise.getField('DTHRULTIMACONSULTA').setValue(success.dataset.parametroqpr_param_qualidade_prox_consulta[1].DTULTCONSULTA);
            }
            gridReanalise.getField('SITUACAOCONSUL').setValue('ATIVO');
        } else {
            gridReanalise.getField('SITUACAOCONSUL').setValue('INATIVO');
        }
        
    });  
    };
    
    this.widgetSave = function (widget, afterValid) {
		
		var deferred = ZHPromise.defer();

		if (widget.isValid()) {
			widget.currentRow.changed = true;

			if (!widget.currentRow.__is_new)
				widget.currentRow.__is_new = false;
			else if (widget.paramsNewCode && widget.paramsNewCode.__is_new_code) {
				widget.currentRow.__using_unit = widget.paramsNewCode.__using_unit || false;
				widget.currentRow.__new_code_pk = widget.paramsNewCode.__new_code_pk;
				widget.currentRow.__table_pk = widget.paramsNewCode.__table_pk;
				widget.currentRow.__new_code_length = widget.paramsNewCode.__new_code_length || 5;
				widget.currentRow.__cast_number = widget.paramsNewCode.__cast_number || false;
			}

			widget.saveRow().then(function (response) {
				widget.currentRow.changed = false;
				delete widget.backupRow;

				if (General.formWidgetSwitchTemplate(widget) && widget.parent) {
					widget.list();

					var widgets = widget.parent.widgets;
					General.changeWidgetAcessibility(widgets.concat(widget.parent), true);
					this.changeBarAcessibility(widget.parent ,true);
				} else {
					if (widget.currentRow.__is_new) {
						ScreenService.closeSwipe();
						widget.list();
					} else widget.list();

					General.changeWidgetAcessibility(widget.widgets, true);
				}

				if (widget.currentRow.__is_new) widget.currentRow.__is_new = false;
				else widget.reload();

				deferred.resolve(response);
			}.bind(this), function (error) {
				var errorMessage = 'Timeout';

				if (error.data) errorMessage = error.data.error;

				ScreenService.showMessage(errorMessage);
				deferred.reject(errorMessage);
			});
		} else deferred.reject("Preencha todos os campos corretamente!");

		return deferred;	
	};
	
	this.setFilial = function(field){
		var gridMain = templateManager.container.getWidget('tabbed_main');
            gridMain.widgets[0].getField('CDFILIAL').setValue(field.getParent().fields[1].value());
            gridMain.widgets[0].getField('NMFILIAL').setValue(field.value());
            gridMain.widgets[1].getField('CDFILIAL').setValue(field.getParent().fields[1].value());
            gridMain.widgets[1].getField('NMFILIAL').setValue(field.value());
            gridMain.widgets[2].getField('CDFILIAL').setValue(field.getParent().fields[1].value());
            gridMain.widgets[2].getField('NMFILIAL').setValue(field.value());
            gridMain.widgets[0].widgets[0].reload();
            gridMain.widgets[1].widgets[0].reload();
            gridMain.widgets[2].widgets[0].reload();
	};
	
	this.NewRow = function(widget){
		this.changeBarAcessibility(widget.parent, false);
		General.formWidgetSwitchTemplate(widget);
		templateManager.container.getWidget(widget.name).setCurrentRow({});
		widget.newRow();
		widget.currentRow.CDFILIAL = widget.parent.fields[1].value();
	};
	
	this.setFieldsOnAutorizacaoReadOnly = function(widget, state){
		widget.getField('IDAUTGRUPOP').readOnly = state;
		widget.getField('DSGRUPOPER').readOnly = state;
	};
    
}

Configuration(function(ContextRegister) {
    ContextRegister.register('QPR01000_Parametros_Qualidade_Producao_Controller', QPR01000_Parametros_Qualidade_Producao_Controller);
});