var Lib00206_InfComplProduto_Controller = function(MessageService, ScreenService, ZHPromise, templateManager,metaDataFactory,Lib00206_InfComplProduto_Service,eventEngine) {

    var infoComplEvents = {
        "InfoComplBeforeConfirm":"beforeConfirmInfoCompl",
        "InfoComplAfterConfirm":"afterConfirmInfoCompl",
        "InfoComplBeforeCancel":"beforeCancelInfoCompl",
        "InfoComplAfterCancel":"afterCancelInfoCompl",
        "InfoComplOnOpenPopup":"infoComplOpenPopup"
    };

    Object.keys(infoComplEvents).forEach(function(eventName) {
        if (!eventEngine.hasEvent(eventName)) {
            eventEngine.registerEvent(eventName, infoComplEvents[eventName]);
        }
    });
    var rowParent;

    this.infComplementares = function(widget,rowItem){
        var defaultParams = {
            ShowLote : true,
            ShowEntr : false,
            Ajuste : false,
            AtuEstoq : true,
            VerQtEst : true,
            DocuDevo : false,
            AfPiloto : false,
            IsEntrada : true
        };

        rowParent = rowItem;
        defaultParams.ShowLote = rowItem.__is_new;

        Util.extend(defaultParams,widget.paramInfoCompl);  
        
        if(!rowParent.IDCNTRESTOQ)   // IDCNTRESTOQ = null ou inexistente produto controlara estoque
            rowParent.IDCNTRESTOQ = 'S';
            
        if(!(rowParent.CDFILIAL && rowParent.CDFILIMOVI && rowParent.CDPRODESTO && rowParent.CDPRODUTO && rowParent.CDARVPROD && rowParent.NMPRODUTO)){
            console.error('Row do Item incompleta');
        } else if (rowParent.IDCNTRESTOQ != 'N') { // IDCNTRESTOQ = null produto controlara estoque
            Lib00206_InfComplProduto_Service.getParamFilial(rowParent.CDFILIMOVI).then(function(paramfilial){
                paramfilial = paramfilial.dataset.paramfilial[0];
                // IDCTRLESTQ = null filial controlara estoque
                if(paramfilial.IDCTRLESTQ != 'N' && (paramfilial.IDUTILLOTE == 'S' || paramfilial.IDUTILALMOX == 'S')){
                    if(paramfilial.IDUTILLOTE == 'S' && widget.container.name == 'dfe11000_lancamento_entrada')
                        defaultParams.ShowEntr = true;
                    this.openInfCompl(widget,defaultParams, paramfilial);
                } else {
                    notOpenPopup(widget);
                }
            }.bind(this));
        } else {
            notOpenPopup(widget);
        }

    };

    this.limpaCamposInfCompl = function(widget){
        widget.fields.forEach(function(field){
            field.value(null);
        });
    };

    this.openInfCompl = function(parentWidget,params, paramfilial){
        var popupWidget = createInfComplProdutoPopup(parentWidget);
        delete(rowParent.$error);
        Util.extend(popupWidget.currentRow,rowParent);
        //this.limpaCamposInfCompl(popupWidget);

        Lib00206_InfComplProduto_Service.getDtprocessa().then(function(success){
            var dtprocessa = success.dataset.paramestoque_processamento[0].DTPROCESSA;

            if(!rowParent.DTLANCMOVI)
                rowParent.DTLANCMOVI = dtprocessa;

            popupWidget.getField('DTVALILOTE').minDate = dtprocessa;

            var filialFilter = {
                "name":"CDFILIAL",
                "operator":"=",
                "value":rowParent.CDFILIMOVI
            };

            ['CDALMOXARIFE', 'CDLOCALESTOQ'].forEach(function(fieldName) {
                var fieldFilter = popupWidget.getField(fieldName).dataSourceFilter;
                var filterIndex = fieldFilter.findIndex(function(element) {return element.name == "CDFILIAL";});

                if(filterIndex == -1)
                    fieldFilter.push(filialFilter);
                else
                    fieldFilter[filterIndex] = filialFilter;

                if(['CDLOCALESTOQ'].includes(fieldName)) {
                    filterIndex = fieldFilter.findIndex(function(element) {return element.name == "CDALMOXARIFE";});

                    if(filterIndex == -1) {
                        var almoxariFilter = {
                            "name":"CDALMOXARIFE",
                            "operator":"=",
                            "value":"@Lib00206_InfComplProduto_Controller.getInfComplFieldVal('"+parentWidget.name+"','CDALMOXARIFE')@"
                        };

                        fieldFilter.push(almoxariFilter);
                    }
                }
            });

            this.setFieldLote(popupWidget,parentWidget,params);

            if(!params.AtuEstoq){
                popupWidget.getField('CDALMOXARIFE').setValue(' ');
                popupWidget.getField('CDLOCALESTOQ').setValue(' ');
                popupWidget.getField('NRSUBLOTE').setValue(' ');
                popupWidget.getField('NRLOTEESTQ').setValue(' ');
            }

            popupWidget.params = params;
            popupWidget.getField('IDNOVOLOTE').value(params.ShowEntr);
            popupWidget.getField('IDNOVOLOTE').defaultValue = params.ShowEntr;
            popupWidget.getField('IDNOVOLOTE').readOnly = !params.ShowEntr;
            this.setReadOnlyField(popupWidget,params).then(function(paramfilial){
                Lib00206_InfComplProduto_Service.getProdFili(rowParent.CDPRODUTO,rowParent.CDFILIMOVI).then(function(prodfili){
                    prodfili = prodfili.dataset.prodfili[0];

                    var almoxField = popupWidget.getField('CDALMOXARIFE'),
                        localField = popupWidget.getField('CDLOCALESTOQ'),
                        selectLote = popupWidget.getField('IDNOVOLOTE'),
                        loteField = popupWidget.getField('NRLOTEESTQ'),
                        subloteField = popupWidget.getField('NRSUBLOTE');

                    loteField.validations.required = true;
                    subloteField.setValue(' ');

                    if(prodfili.IDUTCTRLLOTE != 'S' && paramfilial.IDUTILLOTE != 'S') {
                        delete loteField.validations.required;
                        loteField.readOnly = true;
                        loteField.setValue(' ');
                        selectLote.readOnly = true;
                        popupWidget.getField('IDNOVOLOTE').isVisible = false;
                        popupWidget.getField('NRLOTEESTQ').isVisible = false;
                        popupWidget.getField('NRSUBLOTE').isVisible = false;
                    } else{
                        popupWidget.getField('IDNOVOLOTE').isVisible = true;
                        popupWidget.getField('NRLOTEESTQ').isVisible = true;
                        popupWidget.getField('NRSUBLOTE').isVisible = true;
                        
                        if(!parentWidget.currentRow.NRLOTEESTQ) {
                            loteField.value(null);

                            if(prodfili && params.ShowLote) {
                                Lib00206_InfComplProduto_Service.getProximoLote(rowParent.CDFILIMOVI, rowParent.CDPRODESTO).then(function(success){
                                    loteField.value(success.dataset.prox_lote.NRLOTEESTQ);
                                });
                            }
                        }
                    }

                    if(prodfili.IDCNTRESTOQ !== 'S'){
                        loteField.readOnly = true;
                        loteField.setValue(' ');
                        subloteField.readOnly = true;
                        subloteField.setValue(' ');
                        almoxField.readOnly = true;
                        almoxField.setValue(' ');
                        delete almoxField.validations.required;
                        localField.readOnly = true;
                        localField.setValue(' ');
                        delete localField.validations.required;
                    }

                    //popupWidget.currentRow.CDALMOXARIFE = !almoxField.readOnly ? parentWidget.currentRow.CDALMOXARIFE||prodfili.CDALMOXARIFE||paramfilial.CDALMOXARIFE||null:' ';
                    //popupWidget.currentRow.CDLOCALESTOQ = !localField.readOnly ? parentWidget.currentRow.CDLOCALESTOQ||prodfili.CDLOCALESTOQ||paramfilial.CDLOCALESTOQ||null:' ';
					if(!almoxField.readOnly){
                        if(parentWidget.currentRow.CDALMOXARIFE){
                            popupWidget.currentRow.CDALMOXARIFE = parentWidget.currentRow.CDALMOXARIFE;
                        }else if(prodfili.CDALMOXARIFE){
                            popupWidget.currentRow.CDALMOXARIFE = prodfili.CDALMOXARIFE;
                        }else if(paramfilial.CDALMOXARIFE){
                            popupWidget.currentRow.CDALMOXARIFE = paramfilial.CDALMOXARIFE;
                        }else{
                            popupWidget.currentRow.CDALMOXARIFE = null;
                        }
                    }else{
                        popupWidget.currentRow.CDALMOXARIFE = ' ';
                    }
                    
                    if(!localField.readOnly){
                        if(parentWidget.currentRow.CDLOCALESTOQ){
                            popupWidget.currentRow.CDLOCALESTOQ = parentWidget.currentRow.CDLOCALESTOQ;
                        }else if(prodfili.CDLOCALESTOQ){
                            popupWidget.currentRow.CDLOCALESTOQ = prodfili.CDLOCALESTOQ;
                        }else if(paramfilial.CDLOCALESTOQ){
                            popupWidget.currentRow.CDLOCALESTOQ = paramfilial.CDLOCALESTOQ;
                        }else{
                            popupWidget.currentRow.CDLOCALESTOQ = null;
                        }
                    }else{
                        popupWidget.currentRow.CDLOCALESTOQ = ' ';
                    }
                });
            });
            ScreenService.openPopup(popupWidget).then(function(){
                if(parentWidget.infoComplOpenPopup)
                    parentWidget.infoComplOpenPopup();
            }.bind(this));
            
        }.bind(this));
    };

    this.setFieldLote = function(popupWidget,parentWidget,params){
        var fieldLote = popupWidget.getField('NRLOTEESTQ');
        fieldLote.dataSourceFilter=[
                {
                    "name":"P_CDFILIAL",
                    "operator":"=",
                    "value":rowParent.CDFILIMOVI
                },{
                    "name":"P_CDPRODUTO",
                    "operator":"=",
                    "value":rowParent.CDPRODESTO
                },{
                    "name":"P_NRLOTEESTQ",
                    "operator":"=",
                    "value":" "
                },{
                    "name":"P_NRSUBLOTE",
                    "operator":"=",
                    "value":" "
                },{
                    "name":"P_DTPOSICAO",
                    "operator":"=",
                    "value":rowParent.DTLANCMOVI
                }
            ];
        if(!params.ShowEntr || !params.Ajuste ){
            fieldLote.dataSource.name = 'peblib#/lote_infCompl_almox';
            fieldLote.dataSourceFilter = fieldLote.dataSourceFilter.concat([
                {
                    "name":"P_CDALMOXARIFE",
                    "operator":"=",
                    "value":"@Lib00206_InfComplProduto_Controller.getInfComplFieldVal('"+parentWidget.name+"','CDALMOXARIFE')|| ' '@"
                },{
                    "name":"P_CDLOCALESTOQ",
                    "operator":"=",
                    "value":"@Lib00206_InfComplProduto_Controller.getInfComplFieldVal('"+parentWidget.name+"','CDLOCALESTOQ')|| ' '@"
                },{
                    "name":"P_IDQUANTID",
                    "operator":"=",
                    "value":"S"
                }
            ]);
        }else{
            if(params.VerQtEst){
                fieldLote.dataSource.name = 'peblib#/lote_infCompl_almox';
                fieldLote.dataSourceFilter = fieldLote.dataSourceFilter.concat([
                    {
                        "name":"P_CDALMOXARIFE",
                        "operator":"=",
                    "value":"@Lib00206_InfComplProduto_Controller.getInfComplFieldVal('"+parentWidget.name+"','CDALMOXARIFE')|| ' '@"
                    },{
                        "name":"P_CDLOCALESTOQ",
                        "operator":"=",
                    "value":"@Lib00206_InfComplProduto_Controller.getInfComplFieldVal('"+parentWidget.name+"','CDLOCALESTOQ')|| ' '@"
                    },{
                        "name":"P_IDQUANTID",
                        "operator":"=",
                        "value":"N"
                    }
                ]);
            }else{
                fieldLote.dataSource.name = 'peblib#/lote_infCompl_semAlmox';
            }
        }
    };

    function notOpenPopup(widget) {
        ZHPromise.when(widget.beforeConfirmInfoCompl && widget.AlwaysCallsBeforeEvent !== false ? widget.beforeConfirmInfoCompl() : undefined).then(function(){
            if(widget.afterConfirmInfoCompl && widget.AlwaysCallsAfterEvents !== false)
                widget.afterConfirmInfoCompl();
        });
    }
    
    var setCurrentRowWithOutData = function(currentRow, valuesToSetOnCurrentRow, outDataValue) {
        for (var key in outDataValue) {
            currentRow[outDataValue[key]] = valuesToSetOnCurrentRow[key];
        }
    };
    
    var locaisValidos = function(widget){
        var almoxarifado = widget.getField('CDALMOXARIFE');
        var local = widget.getField('CDLOCALESTOQ');
        var nlote = widget.getField('NRLOTEESTQ');
        var utAlmoxarifado = !almoxarifado.readOnly;
        var utLocal = !local.readOnly;
        var utLote = !nlote.readOnly;
        var almoxarifadoValido = false; 
        var localValido = false;
        var loteValido = false;
        var locaisValidos = false;
        
        if(utAlmoxarifado && almoxarifado.value() !== ' ')
            almoxarifadoValido = true;
        else
        if(!utAlmoxarifado && almoxarifado.value() === ' ')
            almoxarifadoValido = true;
                
        if(utLocal && local.value() !== ' ')
            localValido = true;
        else
        if(!utLocal && local.value() === ' ')
            localValido = true;
                
        if(utLote && nlote.value() !== ' ')
            loteValido = true;
        else
        if(!utLote && nlote.value() === ' ')
            loteValido = true;
                
        if(almoxarifadoValido && localValido && loteValido)
            locaisValidos = true;
            
        return locaisValidos;
    };
    
    this.saveLote = function(widget){
        if(widget.isValid() && locaisValidos(widget)){
            var row  = widget.currentRow;
            if(row.DTVALILOTE && row.DTFABRPROD && moment(row.DTFABRPROD,'DD/MM/YYYY').isAfter(moment(row.DTVALILOTE,'DD/MM/YYYY')) && widget.params.IsEntrada){
                MessageService.showMessageByCode("DTFABRICACAO_MENOR_OU_IGUAL_DTVALIDADE");
            }else if(row.DTVALILOTE && moment(row.DTVALILOTE,'DD/MM/YYYY').isBefore(moment(widget.getField('DTVALILOTE').minDate,'DD/MM/YYYY')) && widget.params.IsEntrada){
                MessageService.showMessageByCode("DTVALIDADE_MAIOR_DTPROCESSAMENTO");
            }else{
                var parent = widget.getParent();
                
                //atualiza currentrow com posição de estoque
                var lote =    widget.getField('NRLOTEESTQ');
                var subLote = widget.getField('NRSUBLOTE');
                var loteOutData = lote.outData;
                
                lote.dataSourceFilter.forEach(function(params){
                    if(params.name == "P_NRSUBLOTE")
                        params.value = subLote.value();
                	if(params.name == "P_NRLOTEESTQ")
                	    params.value = lote.value();
                }.bind(this));
                
                ZHPromise.when(parent.beforeConfirmInfoCompl?parent.beforeConfirmInfoCompl():undefined).then(function(){
                    Lib00206_InfComplProduto_Service.saveLote(row).then(
                        function(){
                            rowParent.CDALMOXARIFE = row.CDALMOXARIFE;
                            rowParent.CDLOCALESTOQ = row.CDLOCALESTOQ;
                            rowParent.NRLOTEESTQ = row.NRLOTEESTQ;
                            rowParent.NRSUBLOTE = row.NRSUBLOTE;
                            rowParent.QTESTOQDIA = (row.QTESTOQDIA) ? row.QTESTOQDIA : 0;
                            ScreenService.closePopup();
                            parent.activate();
                            lote.reload().then(function(posEst){
                                if(posEst.dataset.lote_infCompl_almox.length > 0){
                                    var valuesToSet = posEst.dataset.lote_infCompl_almox[0];
                                    setCurrentRowWithOutData(row, valuesToSet, loteOutData);
                                }else{
                                    var emptyRow = {};
                                    emptyRow.QTESTOQDIA = 0;
                                    emptyRow.VRESTOQDIA = 0;
                                    setCurrentRowWithOutData(row, emptyRow, loteOutData);
                                }
                                if(parent.afterConfirmInfoCompl)
                                    parent.afterConfirmInfoCompl();
                            }.bind(this));
                            
                        },
                        function(error){
                            ScreenService.showMessage(error.data.error);
                        }
                    );
                });
            

            }
        }
    };

    var createInfComplProdutoPopup = function(parentWidget) {
        var widget = parentWidget.InfoCompl;
        if(!widget){
            widget = getPopUpObject();
            widget.container = parentWidget.container;
            widget = metaDataFactory.widgetFactory(widget, parentWidget);
            parentWidget.InfoCompl = widget;
            widget.parent = parentWidget;
            return widget;
        }else {
            return widget;
        }
    };

    this.getInfComplFieldVal= function(parentName, fieldName){
        return templateManager.container.getWidget(parentName).InfoCompl.getField(fieldName).value();
    };

    this.setReadOnlyField = function(popupWidget,params){
        return Lib00206_InfComplProduto_Service.getParamFilial(popupWidget.currentRow.CDFILIMOVI).then(function(paramfilial){
            paramfilial = paramfilial.dataset.paramfilial[0];
            var idnovolote = popupWidget.getField('IDNOVOLOTE').value();
            popupWidget.getField('CDALMOXARIFE').readOnly = paramfilial.IDUTILALMOX !== 'S' || !params.AtuEstoq ;
            popupWidget.getField('CDLOCALESTOQ').readOnly = paramfilial.IDUTILLCESTQ !== 'S' || !params.AtuEstoq ;
            popupWidget.getField('DTVALILOTE').readOnly   = paramfilial.IDUTILLOTE !== 'S' || !params.ShowEntr || params.DocuDevo || !idnovolote;
            popupWidget.getField('NRLOTEESTQ').readOnly   = paramfilial.IDUTILLOTE !== 'S' || !params.AtuEstoq || params.DocuDevo || (paramfilial.IDENTRAUTLOTE === 'S' && params.ShowEntr);

            popupWidget.getField('NRSUBLOTE').readOnly    = popupWidget.getField('NRLOTEESTQ').readOnly || !idnovolote;
            popupWidget.getField('DTFABRPROD').readOnly   = (paramfilial.IDUTILLOTE !== 'S') || !params.ShowEntr || params.DocuDevo || !idnovolote;

            if(paramfilial.IDUTILLOTE ==='S' && idnovolote){
                if(!popupWidget.getField('DTVALILOTE').validations.hasOwnProperty('required'))
                    popupWidget.getField('DTVALILOTE').validations = {"required": {"message": "Campo Obrigatorio"}};
            }else{
                delete popupWidget.getField('DTVALILOTE').validations.required;
            }

            if(!popupWidget.getField('CDALMOXARIFE').readOnly){
                if(!popupWidget.getField('CDALMOXARIFE').validations.hasOwnProperty('required'))
                    popupWidget.getField('NRLOTEESTQ').validations = {"required": {"message": "Campo Obrigatorio"}};
            }else{
                delete popupWidget.getField('CDALMOXARIFE').validations.required;
            }

            if(!popupWidget.getField('CDLOCALESTOQ').readOnly){
                if(!popupWidget.getField('CDLOCALESTOQ').validations.hasOwnProperty('required'))
                    popupWidget.getField('NRLOTEESTQ').validations = {"required": {"message": "Campo Obrigatorio"}};
            }else{
                delete popupWidget.getField('CDLOCALESTOQ').validations.required;
            }

            if(!popupWidget.getField('NRLOTEESTQ').readOnly){
                if(!popupWidget.getField('NRLOTEESTQ').validations.hasOwnProperty('required'))
                    popupWidget.getField('NRLOTEESTQ').validations = {"required": {"message": "Campo Obrigatorio"}};
            }else{
                delete popupWidget.getField('NRLOTEESTQ').validations.required;
                
            }


            if(idnovolote){
                popupWidget.getField('NRLOTEESTQ').template = 'field/text-edit.html';
                popupWidget.getField('NRLOTEESTQ').dataSourceFilter[2].value = ' ';
                popupWidget.getField('NRLOTEESTQ').dataSourceFilter[3].value = ' ';
            }else{
                popupWidget.getField('NRLOTEESTQ').template = 'zh-select-autocomplete#field/select-autocomplete.html';
                popupWidget.getField('NRLOTEESTQ').dataSourceFilter[2].value = 'TD';
                popupWidget.getField('NRLOTEESTQ').dataSourceFilter[3].value = 'TD';
            }
            
            popupWidget.reload();

            return paramfilial;
        });
    };

    this.idNovoLoteChange = function(widget){
        this.setReadOnlyField(widget,widget.params);

        widget.getField('NRLOTEESTQ').value(null);
        widget.getField('NRSUBLOTE').value(null);

        if(widget.getField('IDNOVOLOTE').value())
            widget.getField('NRSUBLOTE').setValue(' ');

        widget.getField('DTVALILOTE').value(null);
        widget.getField('DTFABRPROD').value(null);
    };
    
    this.loteOnChange =function(widget){
        var novoLote = widget.getField('IDNOVOLOTE').value();
        
        if(novoLote){
            var nrLote = widget.getField('NRLOTEESTQ');
            nrLote.dataSourceFilter[2].value = nrLote.value();
        }

    };

    this.cancelaLancamento = function(widget){
        var parent = widget.getParent();
        
        Lib00206_InfComplProduto_Service.getParamFilial(rowParent.CDFILIMOVI).then(function(paramfilial){
            paramfilial = paramfilial.dataset.paramfilial[0];
                ZHPromise.when(parent.beforeCancelInfoCompl?parent.beforeCancelInfoCompl():undefined).then(function(){
                    ScreenService.closePopup();
                    if(parent.afterCancelInfoCompl)
                        parent.afterCancelInfoCompl();
                });
            
        });
    };
    
    this.almoxarifeChange = function(args){
        var fieldLocalEstoq = args.owner.field.widget.getField('CDLOCALESTOQ');
        var fieldLote = args.owner.field.widget.getField('NRLOTEESTQ');
        var fieldSubLote = args.owner.field.widget.getField('NRSUBLOTE');
        
        if(fieldLocalEstoq.readOnly || fieldLocalEstoq.readOnlyOnEdit)
            fieldLocalEstoq.setValue(' ');
        else
            fieldLocalEstoq.setValue('');
            
        fieldLocalEstoq.reload();
        
        if(fieldLote.readOnly || fieldLote.readOnlyOnEdit)
            fieldLote.setValue(' ');
        else
            fieldLote.setValue('');
            
        fieldLote.reload();
        
        if(fieldSubLote.readOnly || fieldSubLote.readOnlyOnEdit)
            fieldSubLote.setValue(' ');
        else
            fieldSubLote.setValue('');
            
    };
	this.localChange = function(args){
        
        var fieldLote = args.owner.field.widget.getField('NRLOTEESTQ');
        var fieldSubLote = args.owner.field.widget.getField('NRSUBLOTE');
        
        if(fieldLote.readOnly || fieldLote.readOnlyOnEdit)
            fieldLote.setValue(' ');
        else
            fieldLote.setValue('');
            
        fieldLote.reload();
        
        if(fieldSubLote.readOnly || fieldSubLote.readOnlyOnEdit)
            fieldSubLote.setValue(' ');
        else
            fieldSubLote.setValue('');
    };

    var getPopUpObject = function() {
        return {
            "id": "000",
            "isVisible": true,
            "name": "infComplProduto",
            "label": "Informações Complementares do Produto",
            "template": "widget/form.html",
            "currentRow": {},
            "showAsTab": false,
            "actions": [
                {
                    "id": 1,
                    "name": "cancelAction",
                    "label": "Cancelar",
                    "showAsAction": "back",
                    "isVisible": true,
                    "events": [
                        {
                            "id": 1,
                            "name": "ActionEvent",
                            "code": "Lib00206_InfComplProduto_Controller.cancelaLancamento(args.owner.widget)"
                        }
                    ]
                },
                {
                    "id": 4,
                    "name": "confirmAction",
                    "label": "Confirmar",
                    "showAsAction": "never",
                    "isVisible": true,
                    "events": [
                        {
                            "id": 1,
                            "name": "ActionEvent",
                            "code": "Lib00206_InfComplProduto_Controller.saveLote(args.owner.widget)"
                        }
                    ]
                }
            ],
            "fields": [
                {
                    "name": "NMPRODUTO",
                    "label": "Produto",
                    "isVisible": true,
                    "readOnly": true,
                    "readOnlyOnEdit": true,
                    "class": "6",
                    "showOnForm": true,
                    "showOnList": true,
                    "showOnView": true,
                    "defaultValue": null,
                    "descriptionOrder": 1,
                    "template": "field/text-edit.html"
                },
                {
                    "name": "CDARVPROD",
                    "label": "Cod. Produto",
                    "isVisible": true,
                    "readOnly": true,
                    "readOnlyOnEdit": true,
                    "class": "6",
                    "showOnForm": true,
                    "showOnList": true,
                    "showOnView": true,
                    "defaultValue": null,
                    "descriptionOrder": 1,
                    "template": "field/text-edit.html"
                },
                {
                    "id": 0,
                    "name": "CDALMOXARIFE",
                    "label": "Almoxarifado",
                    "isVisible": true,
                    "showOnForm": true,
                    "showOnList": true,
                    "showOnView": true,
                    "class": 6,
                    "order": "CDALMOXARIFE",
                    "template": "zh-select-autocomplete#field/select-autocomplete.html",
                    "searchableFields": [
                        "CDALMOXARIFE",
                        "DSALMOXARIFE"
                    ],
                    "displayedFields": [
                        "CDALMOXARIFE",
                        "DSALMOXARIFE"
                    ],
                    "showSelectAs": "grid",
                    "dataSource": {
                        "rest": true,
                        "lazyLoad": true,
                        "name": "peblib#/crud/almoxarifado"
                    },
                    "dataSourceFilter": [
                        {
                            "name": "CDALMOXARIFE",
                            "operator": "<>",
                            "value": " "
                        }
                    ],
                    "descriptionField": "DSALMOXARIFE",
                    "valueField": "CDALMOXARIFE",
                    "outData": {
                        "CDALMOXARIFE": "CDALMOXARIFE",
                        "DSALMOXARIFE": "DSALMOXARIFE"
                    },
                    "fields": [
                        {
                            "label": "Código",
                            "name": "CDALMOXARIFE",
                            "showOnList": true,
							"template": "field/text-edit.html",
                            "isVisible": true
                        },
                        {
                            "label": "Almoxarifado",
                            "name": "DSALMOXARIFE",
                            "showOnList": true,
							"isVisible": true
                        }
                    ],
                    "events": [
                        {
                            "name": "FieldBeforeSelectOpen",
                            "code": "args.owner.field.initializeField();"
                        },
                        {
                            "name": "FieldOnChange",
                            "code": "Lib00206_InfComplProduto_Controller.almoxarifeChange(args);"
                        }
                    ],
                    "validations": {
                        "required": {
                            "message": "Campo obrigatório"
                        }
                    }
                },
                {
                    "id": 0,
                    "name": "CDLOCALESTOQ",
                    "label": "Localização",
                    "isVisible": true,
                    "showOnForm": true,
                    "showOnList": true,
                    "class": 6,
                    "order": "CDLOCALESTOQ",
                    "template": "zh-select-autocomplete#field/select-autocomplete.html",
                    "searchableFields": [
                        "CDLOCALESTOQ",
                        "DSLOCALESTOQ"
                    ],
                    "displayedFields": [
                        "CDLOCALESTOQ",
                        "DSLOCALESTOQ"
                    ],
                    "showSelectAs": "grid",
                    "dataSource": {
                        "rest": true,
                        "lazyLoad": true,
                        "name": "peblib#/crud/localestoque"
                    },
                    "dataSourceFilter": [
                        {
                            "name": "CDLOCALESTOQ",
                            "operator": "<>",
                            "value": " "
                        }
                    ],
                    "descriptionField": "DSLOCALESTOQ",
                    "valueField": "CDLOCALESTOQ",
                    "outData": {
                        "CDLOCALESTOQ" : "CDLOCALESTOQ",
                        "DSLOCALESTOQ" : "DSLOCALESTOQ"
                    },
                    "fields": [
                        {
                            "label": "Código",
                            "name": "CDLOCALESTOQ",
                            "showOnList": true
                        },
                        {
                            "label": "Descrição",
                            "name": "DSLOCALESTOQ",
                            "showOnList": true
                        }
                    ],
                    "events": [
                        {
                            "name": "FieldBeforeSelectOpen",
                            "code": "args.owner.field.initializeField();"
                        },
						{
                            "name": "FieldOnChange",
                            "code": "Lib00206_InfComplProduto_Controller.localChange(args);"
                        }
                    ],
                    "validations": {
                        "required": {
                            "message": "Campo obrigatório"
                        }
                    }
                },
                {
                    "id": 3,
                    "name": "IDNOVOLOTE",
                    "label": "Lote",
                    "isVisible": true,
                    "readOnly": false,
                    "filterProperties": {
                        "isVisible": false,
                        "class": 0,
                        "newLine": false
                    },
                    "dataSource": {
                        "data": [
                            {
                                "IDNOVOLOTE": false,
                                "DSNOVOLOTE": "Lote Existente"
                            },
                            {
                                "IDNOVOLOTE": true,
                                "DSNOVOLOTE": "Novo Lote"
                            }
                        ]
                    },
                    "valueField": "IDNOVOLOTE",
                    "descriptionField": "DSNOVOLOTE",
                    "hideEmptyValue": true,
                    "template": "field/select-native.html",
                    "class": 2,
                    "showOnForm": true,
                    "showOnList": true,
                    "newLine": true,
                    "placeholder": null,
                    "events": [
                        {
                            "name": "FieldOnChange",
                            "code": "Lib00206_InfComplProduto_Controller.idNovoLoteChange(args.owner.field.widget)"
                        },
                        {
                            "name": "FieldBeforeSelectOpen",
                            "code": "args.owner.field.reload()"
                        }
                    ]
                },
                {
                    "id": 0,
                    "name": "NRLOTEESTQ",
                    "label": "Lote",
                    "isVisible": true,
                    "showOnForm": true,
                    "showOnList": true,
                    "class": 5,
                    "order": "NRLOTEESTQ",
                    "template": "zh-select-autocomplete#field/select-autocomplete.html",
                    "searchableFields": [
                        "NRLOTEESTQ",
                        "DTVALILOTE"
                    ],
                    "displayedFields": [
                        "NRLOTEESTQ",
                        "DTVALILOTE"
                    ],
                    "showSelectAs": "grid",
                    "maxlength": 20,
                    "dataSource": {
                        "rest": true,
                        "lazyLoad": true,
                        "name": "peblib#/lote_infCompl_semAlmox"
                    },
                    "dataSourceFilter": [],
                    "descriptionField": "NRLOTEESTQ",
                    "valueField": "NRLOTEESTQ",
                    "outData": {
                        "NRLOTEESTQ": "NRLOTEESTQ",
                        "NRSUBLOTE": "NRSUBLOTE",
                        "DTVALILOTE": "DTVALILOTE",
                        "QTESTOQDIA": "QTESTOQDIA",
                        "VRESTOQDIA": "VRESTOQDIA",
                        "CDFABRIC": "CDFABRIC"
                    },
                    "fields": [
                        {
                            "label": "Lote",
                            "name": "NRLOTEESTQ",
                            "showOnList": true
                        },
                        {
                            "label": "Sublote",
                            "name": "NRSUBLOTE",
                            "showOnList": true
                        },
                        {
                            "label": "Validade",
                            "name": "DTVALILOTE",
                            "showOnList": true,
                            "displayFormat": "DD/MM/YYYY"
                        },
                        {
                            "label": "Almoxarifado",
                            "name": "CDALMOXARIFE",
                            "showOnList": true
                        },
                        {
                            "label": "Localização",
                            "name": "CDLOCALESTOQ",
                            "showOnList": true
                        },
                        {
                            "label": "Quantidade",
                            "name": "QTESTOQDIA",
                            "showOnList": true,
                            "mask": {
                                "type": "viewFloat",
                                "params": {
                                    "precision": 2,
                                    "showSymbol": false
                                }
                            }
                        },
                        {
                            "label": "Valor Total",
                            "name": "VRESTOQDIA",
                            "showOnList": true,
                            "mask": {
                                "type": "viewFloat",
                                "params": {
                                    "precision": "2"
                                }
                            }
                        }
                    ],
                    "events": [
                        {
                            "name": "FieldBeforeSelectOpen",
                            "code": "args.owner.field.initializeField();"
                        },
                        {
                            "name": "FieldOnChange",
                            "code": "Lib00206_InfComplProduto_Controller.loteOnChange(args.owner.field.widget)"
                        }
                    ],
                    "validations": {
                         "required": {
                            "message": "Campo obrigatório"
                        }
                    }
                },
                {
                    "id": 3,
                    "name": "NRSUBLOTE",
                    "label": "Sublote",
                    "isVisible": true,
                    "sequenceInForm": 100,
                    "readOnly": false,
                    "defaultValue": null,
                    "maxlength": 4,
                    "order": "NRSUBLOTE",
                    "filterProperties": {
                        "isVisible": false,
                        "class": 0,
                        "newLine": false
                    },
                    "template": "field/text-edit.html",
                    "class": 5,
                    "showOnForm": true,
                    "showOnList": true,
                    "newLine": true,
                    "dataSource": {},
                    "placeholder": null,
                    "events": [],
                    "validations": {}
                },
                {
                    "id": 7,
                    "name": "DTVALILOTE",
                    "label": "Data de Validade",
                    "isVisible": true, 
                    "sequenceInForm": 80,
                    "readOnly": true,
                    "defaultValue": null,
                    "filterProperties": {
                        "template": "field/interval.html",
                        "readOnly": false
                    },
                    "template": "field/calendar.html",
                    "dateFormat": "DD/MM/YYYY",
                    "class": 6,
                    "showOnForm": true,
                    "showOnList": true,
                    "newLine": true,
                    "dataSource": {},
                    "placeholder": null,
                    "validations": {
                        "required": {
                            "message": "Campo obrigatório"
                        }
                    },
                    "events": [
                        {
                            "name": "FieldOnChange",
                            "code": "args.owner.field.widget.activate();"
                        }
                    ]
                },
                {
                    "id": 7,
                    "name": "DTFABRPROD",
                    "label": "Data de Fabricação",
                    "isVisible": true,
                    "sequenceInForm": 90,
                    "readOnly": false,
                    "defaultValue": null,
                    "filterProperties": {
                        "template": "field/interval.html"
                    },
                    "template": "field/calendar.html",
                    "dateFormat": "DD/MM/YYYY",
                    "class": 6,
                    "descriptionOrder": 4,
                    "showOnForm": true,
                    "showOnList": true,
                    "newLine": true,
                    "dataSource": {},
                    "placeholder": null,
                    "events": []
                }
            ],
            "events": [
                {
                    "name": "WidgetOnEnter",
                    "code": "args.owner.getField('CDALMOXARIFE').reload();"
                }
            ]
        };
    };
};

Configuration(function(ContextRegister) {
    ContextRegister.register('Lib00206_InfComplProduto_Controller', Lib00206_InfComplProduto_Controller);
});