// FILE: ./assets/modules/producao/assets/js/repositories/Cdp01100_tarefa_Repository.js
var Cdp01100_tarefa_Repository = function (restEngine) {

    this.updateDesc = function(row) {
        return restEngine.post('cdp_producao#/UpdateTarefaDesc', {
            "requestType": "Row",
            "row": row
        });
    };
};

Configuration(function(ContextRegister){
    ContextRegister.register('Cdp01100_tarefa_Repository', Cdp01100_tarefa_Repository);
});

// FILE: ./assets/modules/producao/assets/js/repositories/Cdp05000_roteiro_producao_Repository.js
var Cdp05000_roteiro_producao_Repository = function (restEngine) {

    this.deleteFilhos = function(row) {
        return restEngine.post('cdp_producao#/RoteiroDeleteFilhos', {
            "requestType": "Row",
            "row": row
        });
    };
};

Configuration(function(ContextRegister){
    ContextRegister.register('Cdp05000_roteiro_producao_Repository', Cdp05000_roteiro_producao_Repository);
});

// FILE: ./assets/modules/producao/assets/js/repositories/Ger11800_inspecao_Repository.js
var Ger11800_inspecao_Repository = function (restEngine, localStorageEngine) {
    
    this.updateDesc = function(row) {
        return restEngine.post('cdp_producao#/UpdateDesc', {
            "requestType": "Row",
            "row": row
        });
    };
    
    this.geraNRSEQINSPRO = function(row) {
        return restEngine.post('cdp_producao#/GeraNRSEQINSPRO', {
            "requestType": "Row",
            "row": row
        });
    };
};

Configuration(function(ContextRegister){
    ContextRegister.register('Ger11800_inspecao_Repository', Ger11800_inspecao_Repository);
});

// FILE: ./assets/modules/producao/assets/js/repositories/cdp00100_parametros_controle_producaoRepository.js
var cdp00100_parametros_controle_producaoRepository = function (restEngine) {

    this.saveObspadordpro = function(row) {
        return restEngine.post('cdp_producao#/SaveObspadordpro', {
            "requestType": "Row",
            "row": row
        });
    };
    
    this.selectObspadordpro = function(filter) {
        return restEngine.post('cdp_producao#/SelectObspadordpro', {
            "requestType": "FilterData",
            "filter": filter
        });
    };
    
};

Configuration(function(ContextRegister){
    ContextRegister.register('cdp00100_parametros_controle_producaoRepository', cdp00100_parametros_controle_producaoRepository);
});

// FILE: ./assets/modules/producao/assets/js/repositories/cdp00500_etapa_de_producao_Repository.js
var cdp00500_etapa_de_producao_Repository = function (restEngine) {

    this.save = function(row) {
        return restEngine.post('cdp_producao#/saveEtapa', {
            "requestType": "Row",
            "row": row
        });
    };
};

Configuration(function(ContextRegister){
    ContextRegister.register('cdp00500_etapa_de_producao_Repository', cdp00500_etapa_de_producao_Repository);
});

// FILE: ./assets/modules/producao/assets/js/repositories/cdp01000_lote_de_producao_Repository.js
var cdp01000_lote_de_producao_Repository = function (restEngine, localStorageEngine) {
    
    this.retornaUnidadeLogada = function() {
        var filter = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": "FILIAL_LOGADA"
            }
        ];
        return localStorageEngine.download("cdp#/crud/filial", filter);
    };

    this.retornaOperadorLogado = function() {
        var filter = [
            {
                "name": "CDOPERADOR",
                "operator": "=",
                "value": "OPERADOR_LOGADO"
            }
        ];
        return localStorageEngine.download("cdp#/crud/operador", filter);
    };
    
    this.confirmaLiberaLote = function(row) {
        return restEngine.post('cdp_producao#/LiberaLote', {
            "requestType": "Row",
            "row": row
        });
    };
};

Configuration(function(ContextRegister){
    ContextRegister.register('cdp01000_lote_de_producao_Repository', cdp01000_lote_de_producao_Repository);
});

// FILE: ./assets/modules/producao/assets/js/repositories/cdp01300_ocorrencia_da_producaoRepository.js
var cdp01300_ocorrencia_da_producaoRepository = function (restEngine) {

    this.deletarGrupo = function(row) {
        return restEngine.post('cdp_producao#/DeletarGrupoOcorrencia', {
            "requestType": "Row",
            "row": row
        });
    };
};

Configuration(function(ContextRegister){
    ContextRegister.register('cdp01300_ocorrencia_da_producaoRepository', cdp01300_ocorrencia_da_producaoRepository);
});

// FILE: ./assets/modules/producao/assets/js/repositories/cdp01500_parametros_mrp_Repository.js
var cdp01500_parametros_mrp_Repository = function(restEngine){
    this.achaMaxNivelProduto = function(){
        return restEngine.post('cdp_producao#/achaMaxNivelProduto', {
            "requestType": "FilterData",
            "filter": []
        });
    };
    
    this.salvaParametroMrp = function(linha){
        return restEngine.post('cdp_producao#/salvaParametroMrp',{
            "requestType": "Row",
            "row": linha
        });
    };
};

Configuration(function(ContextRegister){
    ContextRegister.register('cdp01500_parametros_mrp_Repository', cdp01500_parametros_mrp_Repository);
});

// FILE: ./assets/modules/producao/assets/js/repositories/cdp02200_grupo_de_equipamento_Repository.js
var cdp02200_grupo_de_equipamento_Repository = function (restEngine, localStorageEngine) {

    this.retornaUnidadeLogada = function() {
        var filter = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": "FILIAL_LOGADA"
            }
        ];
        return localStorageEngine.download("ger#/crud/filial", filter);
    };

    this.retornaOperadorLogado = function() {
        var filter = [
            {
                "name": "CDOPERADOR",
                "operator": "=",
                "value": "OPERADOR_LOGADO"
            }
        ];
        return localStorageEngine.download("ger#/crud/operador", filter);
    };

    this.deletarGrupo = function(row) {
        return restEngine.post('cdp_producao#/DeletarGrupo', {
            "requestType": "Row",
            "row": row
        });
    };
};

Configuration(function(ContextRegister){
    ContextRegister.register('cdp02200_grupo_de_equipamento_Repository', cdp02200_grupo_de_equipamento_Repository);
});

// FILE: ./assets/modules/producao/assets/js/repositories/cdp04000_agenda_de_tarefas_Repository.js
var cdp04000_agenda_de_tarefas_Repository = function (restEngine, localStorageEngine) {

    this.retornaUnidadeLogada = function() {
        var filter = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": "FILIAL_LOGADA"
            }
        ];
        return localStorageEngine.download("cdp#/crud/filial", filter);
    };

    this.deleteAgenda = function(row) {
        return restEngine.post('cdp_producao#/DeletarAgenda', {
            "requestType": "Row",
            "row": row
        });
    };
    
    this.saveAgenda = function(row) {
        return restEngine.post('cdp_producao#/SaveAgenda', {
            "requestType": "Row",
            "row": row
        });
    };
    
    this.verificaInspec = function(row) {
        return restEngine.post('cdp_producao#/VerificaInspecao', {
            "requestType": "Row",
            "row": row
        });
    };
    
};

Configuration(function(ContextRegister){
    ContextRegister.register('cdp04000_agenda_de_tarefas_Repository', cdp04000_agenda_de_tarefas_Repository);
});

// FILE: ./assets/modules/producao/assets/js/repositories/cdp06100_tarefas_da_producao_Repository.js
var cdp06100_tarefas_da_producao_Repository = function (restEngine) {

    this.salvarDescinsaudit = function(row) {
        return restEngine.post('cdp_producao#/SaveDescinsaudit', {
            "requestType": "Row",
            "row": row
        });
    };
    
    this.saveObservacaoAndDados = function (dataSet){
        return restEngine.post('cdp_producao#/saveObservacaoAndDados', {
           'requestType': 'DataSet', 
           'dataset': dataSet
        });
    };
    
    this.saveLiberacaoAndDados = function (dataSet){
        return restEngine.post('cdp_producao#/saveLiberacaoAndDados', {
           'requestType': 'DataSet', 
           'dataset': dataSet
        });
    };
    
    this.saveOcorrenciaAndDados = function (dataSet){
        return restEngine.post('cdp_producao#/saveOcorrenciaAndDados', {
           'requestType': 'DataSet', 
           'dataset': dataSet
        });
    };
    
};

Configuration(function(ContextRegister){
    ContextRegister.register('cdp06100_tarefas_da_producao_Repository', cdp06100_tarefas_da_producao_Repository);
});

// FILE: ./assets/modules/producao/assets/js/repositories/cdp06400_pontos_criticosRepository.js
var cdp06400_pontos_criticosRepository = function (restEngine) {

    this.incrementarCodigo = function(row) {
        return restEngine.post('cdp_producao#/IncrementarCodigo', {
            "requestType": "Row",
            "row": row
        });
    };
};

Configuration(function(ContextRegister){
    ContextRegister.register('cdp06400_pontos_criticosRepository', cdp06400_pontos_criticosRepository);
});

// FILE: ./assets/modules/producao/assets/js/repositories/cdp07700_calendario_de_producao_Repository.js
var cdp07700_calendario_de_producao_Repository = function (restEngine) {

    this.deletarCalendario = function(row) {
        return restEngine.post('cdp_producao#/DeletarCalendarioProducao', {
            "requestType": "Row",
            "row": row
        });
    };
    
    this.deletarCalendarioMes = function(row) {
        return restEngine.post('cdp_producao#/DeletarCalendarioProducaoMes', {
            "requestType": "Row",
            "row": row
        });
    };
    
    this.calculoProdAnual = function(row) {
        return restEngine.post('cdp_producao#/CalcularProducaoAnual', {
            "requestType": "Row",
            "row": row
        });
    };
};

Configuration(function(ContextRegister){
    ContextRegister.register('cdp07700_calendario_de_producao_Repository', cdp07700_calendario_de_producao_Repository);
});

// FILE: ./assets/modules/producao/assets/js/repositories/cdp26000_controle_prioridade_producaoRepository.js
var cdp26000_controle_prioridade_producaoRepository = function (restEngine) {

    this.checkNewRowPrioriproducao = function(row) {
        return restEngine.post('cdp_producao#/checkNewRowPrioriproducao', {
            "requestType": "Row",
            "row": row
        });
    };
};

Configuration(function(ContextRegister){
    ContextRegister.register('cdp26000_controle_prioridade_producaoRepository', cdp26000_controle_prioridade_producaoRepository);
});

// FILE: ./assets/modules/producao/assets/js/repositories/ger24000_habilidadeRepository.js
var ger24000_habilidadeRepository = function (restEngine) {

    this.saveCustohab = function(dataset) {
        return restEngine.post('cdp_producao#/saveCustohab', {
            "requestType": "Row",
            "row": dataset
        });
    };
};

Configuration(function(ContextRegister){
    ContextRegister.register('ger24000_habilidadeRepository', ger24000_habilidadeRepository);
});

// FILE: ./assets/modules/producao/assets/js/repositories/ger55000_informacoes_adicionais_Repository.js
function ger55000_informacoes_adicionais_Repository (templateManager, restEngine, General, ScreenService, ZHPromise){
	
	this.saveInfo = function(row){
	    return restEngine.post('cdp_producao#/saveInfo', {
            "requestType": "Row",
            "row": row
        });
	};
	
	this.saveDCB = function(row){
	     return restEngine.post('cdp_producao#/saveDCB', {
            "requestType": "Row",
            "row": row
        });
	};
	
	this.saveDCI = function(row){
	     return restEngine.post('cdp_producao#/saveDCI', {
            "requestType": "Row",
            "row": row
        });
	};
	
	this.saveCAS = function(row){
	     return restEngine.post('cdp_producao#/saveCAS', {
            "requestType": "Row",
            "row": row
        });
	};
	
	this.saveINCI = function(row){
	     return restEngine.post('cdp_producao#/saveINCI', {
            "requestType": "Row",
            "row": row
        });
	};
      
}
Configuration(function(ContextRegister) {
    ContextRegister.register('ger55000_informacoes_adicionais_Repository', ger55000_informacoes_adicionais_Repository);
});

// FILE: ./assets/modules/producao/assets/js/repositories/ger04800_equipamento_Repostitory.js
var ger04800_equipamento_Repository = function(restEngine) {
    this.newCdEquip = function(){
        return restEngine.post('cdp_producao#/novoCdEquip', {
           "requestType": "FilterData",
           "filter": []
        });
    };
};

Configuration(function(ContextRegister) {
    ContextRegister.register('ger04800_equipamento_Repository', ger04800_equipamento_Repository);
});

// FILE: ./assets/modules/qualidade/assets/js/repositories/QPR01000_Parametros_Qualidade_Producao_Repository.js
var QPR01000_Parametros_Qualidade_Producao_Repository = function(restEngine) {
  
  this.findProxConsulta = function(filter) {
      
    return restEngine.post('cdp#/findProxConsulta', {
           'requestType': 'DataSet', 
           'dataset': [filter.currentRow]
    });
      
      
  };
  
    
};

Configuration(function(ContextRegister) {
    ContextRegister.register('QPR01000_Parametros_Qualidade_Producao_Repository', QPR01000_Parametros_Qualidade_Producao_Repository);
});

// FILE: ./assets/modules/qualidade/assets/js/repositories/QPR01900_Inspecao_Digital_Repository.js
var QPR01900_Inspecao_Digital_Repository = function(restEngine) {

    this.changeQuestion = function(row){
        return restEngine.post('cdp#/InspecaoDigital/changeQuestion', {
            "requestType": "Row",
            "row": row
        });
    };
    
    this.searchTarefaQuestao = function(row){
        return restEngine.post('cdp#/InspecaoDigital/searchTarefaQuestao', {
            "requestType": "Row",
            "row": row
        });
    };
    
    this.sendChanges = function(row){
        return restEngine.post('cdp#/InspecaoDigital/sendChanges', {
            "requestType": "Row",
            "row": row
        });
    };
    
};

Configuration(function(ContextRegister){
    ContextRegister.register('QPR01900_Inspecao_Digital_Repository', QPR01900_Inspecao_Digital_Repository);
});

// FILE: ./assets/modules/producao/assets/js/services/Cdp01100_tarefa_Service.js
var Cdp01100_tarefa_Service = function(localStorageEngine, Cdp01100_tarefa_Repository){

	this.retornaFilial = function(){
        var filter = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": "FILIAL_LOGADA"
            }
        ];
        return localStorageEngine.download("cdp#/crud/filial", filter);
	};
    
    this.updateDesc = function(row){
        return Cdp01100_tarefa_Repository.updateDesc(row);
    };
    
};

 Configuration(function (ContextRegister){
    ContextRegister.register('Cdp01100_tarefa_Service', Cdp01100_tarefa_Service);
});

// FILE: ./assets/modules/producao/assets/js/services/Cdp05000_roteiro_producao_Service.js
var Cdp05000_roteiro_producao_Service = function(localStorageEngine, Cdp05000_roteiro_producao_Repository){

	this.retornaFilial = function(){
        var filter = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": "FILIAL_LOGADA"
            }
        ];
        return localStorageEngine.download("cdp#/crud/filial", filter);
	};
	
	this.retornaOperadorLogado = function() {
        var filter = [
            {
                "name": "CDOPERADOR",
                "operator": "=",
                "value": "OPERADOR_LOGADO"
            }
        ];
        return localStorageEngine.download("cdp#/crud/operador", filter);
    };
	
	this.deleteFilhos = function(row){
        return Cdp05000_roteiro_producao_Repository.deleteFilhos(row);
    };
	
};

 Configuration(function (ContextRegister){
    ContextRegister.register('Cdp05000_roteiro_producao_Service', Cdp05000_roteiro_producao_Service);
});

// FILE: ./assets/modules/producao/assets/js/services/Ger11800_inspecao_Service.js
var Ger11800_inspecao_Service = function(localStorageEngine, Ger11800_inspecao_Repository){

	this.retornaFilial = function(){
        var filter = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": "FILIAL_LOGADA"
            }
        ];
        return localStorageEngine.download("cdp#/crud/filial", filter);
	};
    
    this.retornaOperadorLogado = function() {
        var filter = [
            {
                "name": "CDOPERADOR",
                "operator": "=",
                "value": "OPERADOR_LOGADO"
            }
        ];
        return localStorageEngine.download("cdp#/crud/operador", filter);
    };
    
    this.updateDesc = function(row){
        return Ger11800_inspecao_Repository.updateDesc(row);
    };
    
    this.geraNRSEQINSPRO = function(row){
        return Ger11800_inspecao_Repository.geraNRSEQINSPRO(row);
    };
    
};

 Configuration(function (ContextRegister){
    ContextRegister.register('Ger11800_inspecao_Service', Ger11800_inspecao_Service);
});

// FILE: ./assets/modules/producao/assets/js/services/cdp00100_parametros_controle_producaoService.js
var cdp00100_parametros_controle_producaoService = function(cdp00100_parametros_controle_producaoRepository){
	
    
    this.salvarObspadordpro = function(row){
        return cdp00100_parametros_controle_producaoRepository.saveObspadordpro(row);
    };
    
    this.selectObspadordpro = function(filter){
        return cdp00100_parametros_controle_producaoRepository.selectObspadordpro(filter);
    };
    
};

 Configuration(function (ContextRegister){
    ContextRegister.register('cdp00100_parametros_controle_producaoService', cdp00100_parametros_controle_producaoService);
});

// FILE: ./assets/modules/producao/assets/js/services/cdp00500_etapa_de_producao_Service.js
var cdp00500_etapa_de_producao_Service = function(cdp00500_etapa_de_producao_Repository){

  this.salvarEtapa = function(row){
   return cdp00500_etapa_de_producao_Repository.save(row);
  };
  
 
};

 Configuration(function (ContextRegister){
    ContextRegister.register('cdp00500_etapa_de_producao_Service', cdp00500_etapa_de_producao_Service);
});



// FILE: ./assets/modules/producao/assets/js/services/cdp01000_lote_de_producao_Service.js
var cdp01000_lote_de_producao_Service = function(cdp01000_lote_de_producao_Repository){

	this.retornaFilial = function(){
		return cdp01000_lote_de_producao_Repository.retornaUnidadeLogada();
	};
	
	this.retornaOperadorLogado = function(){
		return cdp01000_lote_de_producao_Repository.retornaOperadorLogado();
	};
	
	this.liberaLote = function(row){
		return cdp01000_lote_de_producao_Repository.confirmaLiberaLote(row);
	};
    
};

 Configuration(function (ContextRegister){
    ContextRegister.register('cdp01000_lote_de_producao_Service', cdp01000_lote_de_producao_Service);
});

// FILE: ./assets/modules/producao/assets/js/services/cdp01300_ocorrencia_da_producaoService.js
var cdp01300_ocorrencia_da_producaoService = function(cdp01300_ocorrencia_da_producaoRepository){

	this.deletarGrupo = function(row){
        return cdp01300_ocorrencia_da_producaoRepository.deletarGrupo(row);
    };
};

 Configuration(function (ContextRegister){
    ContextRegister.register('cdp01300_ocorrencia_da_producaoService', cdp01300_ocorrencia_da_producaoService);
});

// FILE: ./assets/modules/producao/assets/js/services/cdp01500_parametros_mrp_Service.js
var cdp01500_parametros_mrp_Service = function(cdp01500_parametros_mrp_Repository){
  
    this.achaMaxNivelProduto = function(){
       return cdp01500_parametros_mrp_Repository.achaMaxNivelProduto();
    };
    
    this.salvaParametroMrp = function(linha){
      return cdp01500_parametros_mrp_Repository.salvaParametroMrp(linha); 
    };
};

Configuration(function (ContextRegister){
    ContextRegister.register('cdp01500_parametros_mrp_Service', cdp01500_parametros_mrp_Service);
});

// FILE: ./assets/modules/producao/assets/js/services/cdp02200_grupo_de_equipamentoService.js
var cdp02200_grupo_de_equipamentoService = function(cdp02200_grupo_de_equipamento_Repository){

	this.retornaFilial = function(){
		return cdp02200_grupo_de_equipamento_Repository.retornaUnidadeLogada();
	};
	
	this.retornaOperadorLogado = function(){
		return cdp02200_grupo_de_equipamento_Repository.retornaOperadorLogado();
	};
	
	this.deletarGrupo = function(row){
        return cdp02200_grupo_de_equipamento_Repository.deletarGrupo(row);
    };
};

 Configuration(function (ContextRegister){
    ContextRegister.register('cdp02200_grupo_de_equipamentoService', cdp02200_grupo_de_equipamentoService);
});

// FILE: ./assets/modules/producao/assets/js/services/cdp04000_agenda_de_tarefas_Service.js
var cdp04000_agenda_de_tarefas_Service = function(cdp04000_agenda_de_tarefas_Repository){

	this.retornaFilial = function(){
		return cdp04000_agenda_de_tarefas_Repository.retornaUnidadeLogada();
	};
	
	this.deletarAgenda = function(row){
        return cdp04000_agenda_de_tarefas_Repository.deleteAgenda(row);
    };
    
    this.salvarAgenda = function(row){
        return cdp04000_agenda_de_tarefas_Repository.saveAgenda(row);
    };
    
    this.verificaInspecao = function(row){
        return cdp04000_agenda_de_tarefas_Repository.verificaInspec(row);
    };
    
};

 Configuration(function (ContextRegister){
    ContextRegister.register('cdp04000_agenda_de_tarefas_Service', cdp04000_agenda_de_tarefas_Service);
});

// FILE: ./assets/modules/producao/assets/js/services/cdp06100_tarefas_da_producao_Service.js
var cdp06100_tarefas_da_producao_Service = function(cdp06100_tarefas_da_producao_Repository){
	
    
    this.salvarDescinsaudit = function(row){
        return cdp06100_tarefas_da_producao_Repository.salvarDescinsaudit(row);
    };
    
    this.saveObservacaoAndDados = function (dataSet){
        return cdp06100_tarefas_da_producao_Repository.salvarDescinsaudit(dataSet);
    };
    
    this.saveLiberacaoAndDados = function (dataSet){
        return cdp06100_tarefas_da_producao_Repository.salvarDescinsaudit(dataSet);
    };
    
    this.saveOcorrenciaAndDados = function (dataSet){
        return cdp06100_tarefas_da_producao_Repository.salvarDescinsaudit(dataSet);
    };
    
};

 Configuration(function (ContextRegister){
    ContextRegister.register('cdp06100_tarefas_da_producao_Service', cdp06100_tarefas_da_producao_Service);
});

// FILE: ./assets/modules/producao/assets/js/services/cdp06400_pontos_criticosService.js
var cdp06400_pontos_criticosService = function(cdp06400_pontos_criticosRepository){

	this.incrementoCodigo = function(row){
        return cdp06400_pontos_criticosRepository.incrementarCodigo(row);
    };
};

 Configuration(function (ContextRegister){
    ContextRegister.register('cdp06400_pontos_criticosService', cdp06400_pontos_criticosService);
});

// FILE: ./assets/modules/producao/assets/js/services/cdp07700_calendario_de_producao_Service.js
var cdp07700_calendario_de_producao_Service = function(cdp07700_calendario_de_producao_Repository){

    this.deleteCalendario = function(row){
        return cdp07700_calendario_de_producao_Repository.deletarCalendario(row);
    };
    
    this.deleteCalendarioMes = function(row){
        return cdp07700_calendario_de_producao_Repository.deletarCalendarioMes(row);
    };
  
    this.calcularProdAnual = function(row) {
        return cdp07700_calendario_de_producao_Repository.calculoProdAnual(row);
    };
};

 Configuration(function (ContextRegister){
    ContextRegister.register('cdp07700_calendario_de_producao_Service', cdp07700_calendario_de_producao_Service);
});

// FILE: ./assets/modules/producao/assets/js/services/cdp26000_controle_prioridade_producaoService.js
var cdp26000_controle_prioridade_producaoService = function(cdp26000_controle_prioridade_producaoRepository){

	this.checkNewRowPrioriproducao = function(row){
        return cdp26000_controle_prioridade_producaoRepository.checkNewRowPrioriproducao(row);
    };
};

 Configuration(function (ContextRegister){
    ContextRegister.register('cdp26000_controle_prioridade_producaoService', cdp26000_controle_prioridade_producaoService);
});

// FILE: ./assets/modules/producao/assets/js/services/ger02500_nutrienteService.js
var ger02500_nutrienteService = function (restEngine, localStorageEngine) {

    this.retornaNutriente = function() {
        return restEngine.post('cdp#/crud/nutriente', {
            "requestType": "FilterData",
            "filter": [
                {"name": "NRORG", "operator": "=", "value": getLocalVar('NRORGTRAB')}
            ]
        });
    };

    this.salvaNutriente = function(row) {
        return restEngine.post('cdp#/nutriente/save', {
            "requestType": "Row",
            "row": row
        });
    };

    this.excluiNutriente = function(dataSet) { 
        return restEngine.post('cdp#/nutriente/remove', {
            "requestType": "DataSet",
            "dataset": dataSet
        });
    };

};
Configuration(function(ContextRegister) {
    ContextRegister.register('ger02500_nutrienteService', ger02500_nutrienteService);
});

// FILE: ./assets/modules/producao/assets/js/services/ger04800_equipamento_Service.js
var ger04800_equipamento_Service = function(ger04800_equipamento_Repository) {
    
    this.newCdEquip = function(){
        return ger04800_equipamento_Repository.newCdEquip();
    };
};

Configuration(function(ContextRegister) {
    ContextRegister.register('ger04800_equipamento_Service', ger04800_equipamento_Service);
});

// FILE: ./assets/modules/producao/assets/js/services/ger24000_habilidadeService.js
var ger24000_habilidadeService = function(ger24000_habilidadeRepository){

	this.saveCustohab = function(dataset){
        return ger24000_habilidadeRepository.saveCustohab(dataset);
    };
};

 Configuration(function (ContextRegister){
    ContextRegister.register('ger24000_habilidadeService', ger24000_habilidadeService);
});

// FILE: ./assets/modules/producao/assets/js/services/ger55000_informacoes_adicionais_Service.js
function ger55000_informacoes_adicionais_Service (templateManager, restEngine, General, ScreenService, ZHPromise, ger55000_informacoes_adicionais_Repository){
	
	this.saveInfo = function(widget){
	    return ger55000_informacoes_adicionais_Repository.saveInfo(widget.currentRow);
	};
	
	this.saveDCB = function(widget){
	    return ger55000_informacoes_adicionais_Repository.saveDCB(widget.currentRow);
	};
	
	this.saveDCI = function(widget){
	    return ger55000_informacoes_adicionais_Repository.saveDCI(widget.currentRow);
	};
	
	this.saveCAS = function(widget){
	    return ger55000_informacoes_adicionais_Repository.saveCAS(widget.currentRow);
	};
	
	this.saveINCI = function(widget){
	    return ger55000_informacoes_adicionais_Repository.saveINCI(widget.currentRow);
	};
      
}
Configuration(function(ContextRegister) {
    ContextRegister.register('ger55000_informacoes_adicionais_Service', ger55000_informacoes_adicionais_Service);
});

// FILE: ./assets/modules/qualidade/assets/js/services/QPR01000_Parametros_Qualidade_Producao_Service.js
var QPR01000_Parametros_Qualidade_Producao_Service = function(QPR01000_Parametros_Qualidade_Producao_Repository) {
    
    this.findProxConsulta = function(filter) {
        return QPR01000_Parametros_Qualidade_Producao_Repository.findProxConsulta(filter);
    };
    
};


Configuration(function(ContextRegister) {
    ContextRegister.register('QPR01000_Parametros_Qualidade_Producao_Service', QPR01000_Parametros_Qualidade_Producao_Service);
});

// FILE: ./assets/modules/qualidade/assets/js/services/QPR01900_Inspecao_Digital_Service.js
var QPR01900_Inspecao_Digital_Service = function(QPR01900_Inspecao_Digital_Repository) {
    
    this.changeQuestion = function(row) {
        return QPR01900_Inspecao_Digital_Repository.changeQuestion(row);
    };
    
    this.searchTarefaQuestao = function(row) {
        return QPR01900_Inspecao_Digital_Repository.searchTarefaQuestao(row);
    };
    
    this.sendChanges = function(row) {
        return QPR01900_Inspecao_Digital_Repository.sendChanges(row);
    };
    
};

Configuration(function(ContextRegister) {
    ContextRegister.register('QPR01900_Inspecao_Digital_Service', QPR01900_Inspecao_Digital_Service);
});

// FILE: ./assets/modules/producao/assets/js/controllers/Cdp01100_tarefa_Controller.js
function Cdp01100_tarefa_Controller (ZHPromise, Cdp01100_tarefa_Service, templateManager, restEngine, General, ScreenService, cdp02200_grupo_de_equipamentoService){
  
    var CDFILIAL;
    var CDPICTINSPEC;
    var mask = {
        "type": "fix",
        "params": {
            "mask": "@getLocalVar('CDP_CDPICTINSPEC')@"
        }
    };
    var nivel_array = [];
    var nivel_max;
    
    this.getMask = function(){
       Cdp01100_tarefa_Service.retornaFilial().then(function(operadorLogado){
            CDFILIAL =  operadorLogado[0].CDFILIAL;
            
            var filtro = [];
            
            General.callRestEngine("cdp#/crud/paramgeral","FilterData", filtro).then(function(sucess){
                if(sucess.dataset.paramgeral.length > 0){
                    CDPICTINSPEC = sucess.dataset.paramgeral[0].CDPICTINSPEC;
                    setLocalVar('CDP_CDPICTINSPEC',CDPICTINSPEC);
                    nivel_array = CDPICTINSPEC.split('.');
                    nivel_max = nivel_array.length;
                    templateManager.container.getWidget('cdp01100_tarefa_tree').getField('CDARVINSPEC').maxlength =  CDPICTINSPEC.replace(/\./g, "").length;
                    templateManager.container.getWidget('cdp01100_tarefa_tree').getField('CDARVINSPEC').mask =  mask;
                    templateManager.container.getWidget('cdp01100_tarefa_tree').reload();
                } else {
                    ScreenService.showMessage("Base não possui parametrezição");
                }
            }, function(error){
                ScreenService.showMessage(error);
            });
            
        }, function(error){
            ScreenService.showMessage(error);
        });
            
    };
    
    this.verificaNivel = function(widget){
       
       if(widget.mode != "edit"){
           if(widget.currentRow.CDNVINSPECAO == nivel_max){
                widget.actions.forEach( function(element){
                   if((element.name == "ADD") && (element.showAsAction == "view")){
                       element.isVisible = false;
                       widget.widgets.forEach(function(elem){
                                elem.enabled = true;
                       });
                   }
               });
           } else {
                widget.actions.forEach( function(element){
                   if((element.name == "ADD") && (element.showAsAction == "view")){
                       element.isVisible = true;
                       widget.widgets.forEach(function(elem){
                            if( elem.name == "widgetDescInsp" ){
                                elem.enabled = true;
                            } else {
                                elem.enabled = false;
                            }
                       });
                    }
               });
           }
       }
       
    };

    this.openDescricao = function(widget){
        widget.dataSourceFilter = [];
        var filtro = [
            {
                "name": "CDINSPECAO",
                "operator": "=",
                "value": widget.parent.currentRow.CDINSPECAO
            }
        ];
       General.callRestEngine("cdp#/crud/descinspecao_tarefa","FilterData", filtro).then(function(sucess){
            if(widget.mode != "edit"){
                widget.currentRow = {};
                if(sucess.dataset.descinspecao_tarefa.length > 0){    
                    widget.currentRow = sucess.dataset.descinspecao_tarefa[0];
                    widget.view();
                } else if(Object.keys(widget.currentRow).length == 0){
                    ScreenService.showMessage('Descrição da Tarefa '+widget.parent.currentRow.NMINSPECAO+' não cadastrada');
                    widget.currentRow.CDINSPECAO = widget.parent.currentRow.CDINSPECAO;
                    widget.currentRow.CDARVINSPEC = widget.parent.currentRow.CDARVINSPEC;
                    widget.currentRow.NMINSPECAO = widget.parent.currentRow.NMINSPECAO;
                    widget.currentRow.__is_new = true;
                    widget.currentRow.TXDESCINSPEC_CLOB = "";
                    widget.view();
                }  else if(sucess.dataset.descinspecao_tarefa.length == 0){
                    widget.currentRow.TXDESCINSPEC_CLOB = "";
                }
            }
        });
    };

    this.newRow = function(widget){
        widget.newRow();
        widget.widgets.forEach(function(element){
            element.enabled = false;
        });
        widget.getField('CDARVINSPEC').mask = null;
        widget.getField('CDARVINSPEC').reload();
        widget.currentRow.IDTPRESPINSP = "NADA";  
        widget.currentRow.IDORIGINSPEC = "TAR";
        widget.currentRow.IDATEITEINSP = "F";
    };
    
    this.newRowView = function(widget){
        var CDARVINSPEC = widget.currentRow.CDARVINSPEC;  
        widget.newRow();
        widget.widgets.forEach(function(element){
            element.enabled = false;
        });
        widget.getField('CDARVINSPEC').mask = null;
        widget.getField('CDARVINSPEC').reload();
        widget.getField('CDARVINSPECANTE').isVisible = true;
        widget.getField('CDARVINSPECANTE').reload();
        //widget.currentRow.CDARVINSPEC = CDARVINSPEC;  
        widget.currentRow.CDARVINSPECANTE = CDARVINSPEC;  
        widget.currentRow.IDTPRESPINSP = "NADA";  
        widget.currentRow.IDORIGINSPEC = "TAR";
        widget.currentRow.IDATEITEINSP = "F";
    };
    
    this.verificaCdArvOnInput = function(widget){
        String.prototype.isNumber = function(){
            return /^\d+$/.test(this);
        };
        if(widget.currentRow.CDARVINSPEC){    
            var tamanho = widget.currentRow.CDARVINSPEC.length;
            var verficaCDPICTINSPEC = CDPICTINSPEC.replace(/\./g, "");
            if(verficaCDPICTINSPEC[(tamanho - 1)].isNumber() == false){
                if(widget.currentRow.CDARVINSPEC[(tamanho - 1)].match(/^[a-zA-Z-0-9]+$/) == null){
                    widget.currentRow.CDARVINSPEC = widget.currentRow.CDARVINSPEC.substring(0,(tamanho - 1));
                    ScreenService.alertNotification("A mascara do campo é "+CDPICTINSPEC+". Dígite um código semelhante, sem os pontos");
                }
            } else if(verficaCDPICTINSPEC[(tamanho - 1)].isNumber() == true){
                if(widget.currentRow.CDARVINSPEC[(tamanho - 1)].isNumber() == false){
                    widget.currentRow.CDARVINSPEC = widget.currentRow.CDARVINSPEC.substring(0,(tamanho - 1));
                    ScreenService.alertNotification("A mascara do campo é "+CDPICTINSPEC+". Dígite um código semelhante, sem os pontos");
                }
            }
        }
    };
    
    this.verificaCdArv = function(widget){
        String.prototype.isNumber = function(){
            return /^\d+$/.test(this);
        };
        
        var tamanho = 0;
        var i = 0;
        
        if(widget.currentRow.CDARVINSPEC.length <= CDPICTINSPEC.replace(/\./g, "").length){    
            while(widget.currentRow.CDARVINSPEC.length > tamanho){
                tamanho += nivel_array[i].length;
                i++;
            }
            if(tamanho > widget.currentRow.CDARVINSPEC.length){
                ScreenService.showMessage('Para preencher o código de nivel '+i+' é necessario que o campo código contenha '+tamanho+' números.');
                widget.currentRow.CDARVINSPEC = "";
                widget.getField('CDARVINSPEC').reload();
                widget.currentRow.CDARVINSPECANTE = "";
                widget.getField('CDARVINSPECANTE').reload();
                widget.currentRow.CDNVINSPECAO = "";
                widget.getField('CDNVINSPECAO').reload();
            } else if(tamanho == widget.currentRow.CDARVINSPEC.length){
                widget.currentRow.CDNVINSPECAO = i;
                if(widget.currentRow.CDNVINSPECAO == 1){
                    widget.currentRow.CDARVINSPECANTE = null;
                } else if(widget.currentRow.CDNVINSPECAO > 1){
                    var remove = - nivel_array[(widget.currentRow.CDNVINSPECAO - 1)].length;
                    widget.currentRow.CDARVINSPECANTE = widget.currentRow.CDARVINSPEC.slice(0, remove); 
                }
            }
        } else if(widget.currentRow.CDARVINSPEC.length > CDPICTINSPEC.replace(/\./g, "").length){
            ScreenService.showMessage('Tamanho maximo do código é '+CDPICTINSPEC.replace(/\./g, "").length);
            widget.currentRow.CDARVINSPEC = "";
            widget.getField('CDARVINSPEC').reload();
            widget.currentRow.CDARVINSPECANTE = "";
            widget.getField('CDARVINSPECANTE').reload();
            widget.currentRow.CDNVINSPECAO = "";
            widget.getField('CDNVINSPECAO').reload();
        }
    };
    
    this.saveArvoreInsp = function(widget){
        var row = widget.currentRow;
        if (widget.isValid()) {
            General.callRestEngine('cdp_producao#/tarefa_inspecao/save', "Row", row).then(function(sucess) {
				widget.activate();
				if (widget.currentRow.__is_new) {
    				if(widget.getField('CDARVINSPECANTE').isVisible == true){
        				widget.getField('CDARVINSPECANTE').isVisible = false;
                        widget.getField('CDARVINSPECANTE').reload();
    				}
    				widget.getField('CDARVINSPEC').mask =  mask;
                    widget.list();  
					ScreenService.goBack();
					widget.reload();
				} else {
					widget.view();
					widget.getField('CDARVINSPEC').mask =  mask;
            	}
				ScreenService.showMessage('Salvo com sucesso');
				this.verificaNivel(widget);
			}.bind(this), function(error){
			    ScreenService.showMessage(error.data.error);
			});
        }
    };
    
    this.deleteArvoreInsp = function(widget){
        ScreenService.confirmMessage(ScreenService.i18n('Delete Register?'), 'question', function (success) {
		    var row = widget.currentRow;
            General.callRestEngine('cdp_producao#/tarefa_inspecao/remove', "Row", row).then(function(sucess) {
        	    ScreenService.closeSwipe().then(function() {
                    widget.list();
                    widget.reload();
                });
        	    ScreenService.showMessage('Deletado com sucesso');
    		}.bind(this), function(error){
    		    ScreenService.showMessage(error.data.error);
    		});
        General.changeWidgetAcessibility(widget.widgets, true);
        });
    };
  
    this.backOrCancelArvoreInspec = function(args){
        if(args.owner.widget.currentRow.__is_new){    
            if(args.owner.widget.getField('CDARVINSPECANTE').isVisible == true){
				args.owner.widget.getField('CDARVINSPECANTE').isVisible = false;
                args.owner.widget.getField('CDARVINSPECANTE').reload();
			}
            General.backOrCancel(args);
            args.owner.widget.getField('CDARVINSPEC').mask =  mask;
        } else {
            General.backOrCancel(args);
        }
        this.verificaNivel(args.owner.widget);
    };
    
    this.newRowChecklist = function(widget){
        widget.newRow();
        widget.currentRow.CDINSPECAO = widget.parent.currentRow.CDINSPECAO;
        widget.currentRow.CDARVINSPEC = widget.parent.currentRow.CDARVINSPEC;
        widget.currentRow.NMINSPECAO = widget.parent.currentRow.NMINSPECAO;
        widget.currentRow.CDNVINSPECAO = widget.parent.currentRow.CDNVINSPECAO;
        widget.currentRow.IDSITINSPEC = widget.parent.currentRow.IDSITINSPEC;
        widget.currentRow.IDTPRESPINSP = widget.parent.currentRow.IDTPRESPINSP;
        widget.currentRow.DSLIMIRESP = widget.parent.currentRow.DSLIMIRESP;
        widget.currentRow.IDORIGINSPEC = widget.parent.currentRow.IDORIGINSPEC;
        widget.currentRow.IDATEITEINSP = widget.parent.currentRow.IDATEITEINSP;
    };
    
    this.editInspecTree = function(widget){
        General.changeWidgetAcessibility(widget.widgets, false);
        General.edit(widget);
    };
    
    this.editDesc = function(widget){
        widget.parent.enabled = false;
        widget.parent.widgets.forEach(function(element){
            if(element.name != widget.name){
                element.enabled = false;
            }
        });
        widget.template = widget.templateToForm;
        General.edit(widget);
    };
    
    this.cancelDesc = function(args){
        var widget = args.owner.widget;
        widget.template = widget.templateToView;
	    widget.view();
        widget.parent.enabled = true;
        widget.parent.widgets.forEach(function(element){
            if(element.name != widget.name){
                element.enabled = true;
            }
        });
        this.openDescricao(widget);
        this.verificaNivel(widget.parent);
    };
    
    this.deleteDesc = function(widget){
        ScreenService.confirmMessage(ScreenService.i18n('Delete Register?'), 'question', function (success) {
			widget.removeRow().then(function () {
                widget.template = widget.templateToView;
    		    widget.view();
                widget.parent.enabled = true;
                widget.parent.widgets.forEach(function(element){
                    if(element.name != widget.name){
                        element.enabled = true;
                    }
                });
                this.openDescricao(widget);
                this.verificaNivel(widget.parent);
            }.bind(this));
        }.bind(this));
    };
    
    this.saveDesc = function(widget){
        if(widget.currentRow.__is_new == true){
            widget.saveRow().then(function(sucess){
                widget.template = widget.templateToView;
                widget.view();
                widget.parent.enabled = true;
                this.verificaNivel(widget.parent);
            }.bind(this));
        } else if(widget.currentRow.__is_new == false){
            Cdp01100_tarefa_Service.updateDesc(widget.currentRow).then(function(sucess){
                widget.template = widget.templateToView;
                widget.view();
                widget.parent.enabled = true;
                this.verificaNivel(widget.parent);
            }.bind(this));
        }
    };
    
}
Configuration(function(ContextRegister) {
    ContextRegister.register('Cdp01100_tarefa_Controller', Cdp01100_tarefa_Controller);
});


// FILE: ./assets/modules/producao/assets/js/controllers/Cdp05000_roteiro_producao_Controller.js
function Cdp05000_roteiro_producao_Controller (ZHPromise, Cdp05000_roteiro_producao_Service, templateManager, restEngine, General, ScreenService, cdp02200_grupo_de_equipamentoService){
  
    var CDFILIAL;
    var CDOPERADOR;
    var auxHora = 0;
    
    this.getFilial = function(){
        Cdp05000_roteiro_producao_Service.retornaFilial().then(function(filialLogada){
            CDFILIAL =  filialLogada[0].CDFILIAL;
        });
    };
    
    this.getOperador = function(){
        Cdp05000_roteiro_producao_Service.retornaOperadorLogado().then(function(operadorLogado){
            CDOPERADOR =  operadorLogado[0].CDOPERADOR;
        });
    };
    
    this.newProcesso = function(widget){
        widget.newRow();
        widget.currentRow.CDFILIAL =  CDFILIAL;
        widget.currentRow.CDOPERADOR  = CDOPERADOR;
        widget.currentRow.CDPRODUTO = widget.parent.currentRow.CDPRODUTO;
    };
    
    this.newEtapa = function(widget){
        widget.newRow();
        widget.currentRow.CDFILIAL = widget.parent.currentRow.CDFILIAL;
        widget.currentRow.CDPRODUTO = widget.parent.currentRow.CDPRODUTO;
        widget.currentRow.CDPROCFABRIC = widget.parent.currentRow.CDPROCFABRIC;
    };
    
    this.newInsumo = function(widget){
        widget.newRow();
        widget.currentRow.CDFILIAL = widget.parent.currentRow.CDFILIAL;
        widget.currentRow.CDPRODUTO = widget.parent.currentRow.CDPRODUTO;
        widget.currentRow.CDPROCFABRIC = widget.parent.currentRow.CDPROCFABRIC;
        widget.currentRow.CDETAPAPROD = widget.parent.currentRow.CDETAPAPROD;
        widget.currentRow.VRPRENINSETP = "100.00";
    };

    this.saveMateriaPrima = function(widget){
        this.verificaVRPRENINSETP();
        General.saveCrud(widget);
    };
    
    this.calcQntdLiq = function(){
        var widget = templateManager.container.getWidget('insumo_etapa');
        if((parseInt(widget.currentRow.QTINSUMETAPA) > 0) && (parseInt(widget.currentRow.VRPRENINSETP) > 0)){
            widget.currentRow.QTBRUTINSETP = (parseFloat(widget.currentRow.QTINSUMETAPA.replace(",","."))*parseFloat(widget.currentRow.VRPRENINSETP.toString().replace(",",".")))/100;
            widget.currentRow.QTBRUTINSETP = widget.currentRow.QTBRUTINSETP.toString();
        } else {
            widget.currentRow.QTBRUTINSETP = "";
        }
    };
    
    this.verificaVRPRENINSETP = function(){
        var widget = templateManager.container.getWidget('insumo_etapa');
        if(parseFloat(widget.currentRow.VRPRENINSETP.toString().replace(",",".")) >= 1000){
            ScreenService.showMessage("Rendimento deve ser menor que 1000%");
            widget.currentRow.VRPRENINSETP = "100.00";
        } else {
            this.calcQntdLiq();
        } 
    };
    
    this.deleteFilhos = function(widget){
        widget.currentRow.WIDGET_NAME = widget.name;
        ScreenService.confirmMessage(ScreenService.i18n('Delete Register?'), 'question', function (success) {
            Cdp05000_roteiro_producao_Service.deleteFilhos(widget.currentRow).then(function(sucess){
                ScreenService.showMessage('Deletado com sucesso.');
                ScreenService.closeSwipe();
                ScreenService.goBack();
                widget.reload();
            },function(error){
                ScreenService.showMessage(error.data.error);
            });
        });
    };
    
    this.trocaTipoRecurso = function(){
        var widget = templateManager.container.getWidget('recursos_atividade');
        
        if(widget.currentRow.IDRECURETAPA === "H"){
            
            widget.getField('NMHABILIDADE').readOnly = false;
            widget.getField('NMHABILIDADE').validations.required = true;
          
            widget.currentRow.CDEQUIPPRO = "";
            widget.getField('NMEQUIPPRO').readOnly = true;
            widget.currentRow.NMEQUIPPRO = "";
            widget.getField('NMEQUIPPRO').validations = {};
          
            widget.getField('QTRECURETAPA').readOnly = false;
          
            widget.getField('IDTEMPRECUR').readOnly = true;
            widget.currentRow.IDTEMPRECUR = "";
          
            widget.getField('QTPRODRECUR').readOnly = true;
            widget.currentRow.QTPRODRECUR = "";
            
        } else if(widget.currentRow.IDRECURETAPA === "E"){
            
            widget.currentRow.CDHABILIDADE = "";
            widget.getField('NMHABILIDADE').readOnly = true;
            widget.currentRow.NMHABILIDADE = "";
            widget.getField('NMHABILIDADE').validations = {};
            
            widget.getField('NMEQUIPPRO').readOnly = false;
            widget.getField('NMEQUIPPRO').validations.required = true;
            
            widget.getField('QTRECURETAPA').readOnly = true;
            widget.currentRow.QTRECURETAPA = "1";
            
            widget.getField('IDTEMPRECUR').readOnly = false;
            
            widget.getField('QTPRODRECUR').readOnly = false;
            
        }
    };
    
    this.editarRecursosAtividade = function(widget){
        this.trocaTipoRecurso();
        General.edit(widget);
    };
    
    this.consertaHora = function(widget){
        if(widget.name == "atividade_etapa"){
            widget.dataSource.data.forEach(function(element, index){
                if(element.QTHRINSPEXE){
                    var frac = Math.abs(Math.trunc(element.QTHRINSPEXE) - element.QTHRINSPEXE);
                    frac = (Math.round(frac*100))/100;
                    if((Math.trunc(element.QTHRINSPEXE) < 10) && ((Math.round(frac*60)) < 10)){
                        widget.dataSource.data[index].QTHRINSPEXE = "0"+(Math.trunc(element.QTHRINSPEXE)).toString()+":"+"0"+((Math.round(frac*60)).toString());
                    } 
                    else if(Math.trunc(element.QTHRINSPEXE) < 10){
                        widget.dataSource.data[index].QTHRINSPEXE = "0"+(Math.trunc(element.QTHRINSPEXE)).toString()+":"+((Math.round(frac*60)).toString());
                    } 
                    else if((Math.round(frac*60)) < 10){
                        widget.dataSource.data[index].QTHRINSPEXE = (Math.trunc(element.QTHRINSPEXE)).toString()+":"+"0"+((Math.round(frac*60)).toString());
                    } 
                    else {
                        widget.dataSource.data[index].QTHRINSPEXE = (Math.trunc(element.QTHRINSPEXE)).toString()+":"+((Math.round(frac*60)).toString());
                    }   
                }
            });
        } else if(widget.name == "recursos_atividade"){
            widget.dataSource.data.forEach(function(element, index){
                if(element.QTHRUTRECUR){
                    var frac = Math.abs(Math.trunc(element.QTHRUTRECUR) - element.QTHRUTRECUR);
                    frac = (Math.round(frac*100))/100;
                    if((Math.trunc(element.QTHRUTRECUR) < 10) && ((Math.round(frac*60)) < 10)){
                        widget.dataSource.data[index].QTHRUTRECUR = "0"+(Math.trunc(element.QTHRUTRECUR)).toString()+":"+"0"+((Math.round(frac*60)).toString());
                    } 
                    else if(Math.trunc(element.QTHRUTRECUR) < 10){
                        widget.dataSource.data[index].QTHRUTRECUR = "0"+(Math.trunc(element.QTHRUTRECUR)).toString()+":"+((Math.round(frac*60)).toString());
                    } 
                    else if((Math.round(frac*60)) < 10){
                        widget.dataSource.data[index].QTHRUTRECUR = (Math.trunc(element.QTHRUTRECUR)).toString()+":"+"0"+((Math.round(frac*60)).toString());
                    } 
                    else {
                        widget.dataSource.data[index].QTHRUTRECUR = (Math.trunc(element.QTHRUTRECUR)).toString()+":"+((Math.round(frac*60)).toString());
                    }   
                }
            });
        }
    };
    
    this.verificaHora = function(widget){
        var doisPontos = [];
        
        if(widget.name == "atividade_etapa"){
            auxHora = 0;
            doisPontos = widget.currentRow.QTHRINSPEXE.split(":");
            if(doisPontos.length == 1){
                widget.currentRow.QTHRINSPEXE = widget.currentRow.QTHRINSPEXE+":00";
            }
        }
        else if(widget.name == "recursos_atividade"){
            auxHora = 0;
            doisPontos = widget.currentRow.QTHRUTRECUR.split(":");
            if(doisPontos.length == 1){
                widget.currentRow.QTHRUTRECUR = widget.currentRow.QTHRUTRECUR+":00";
            }
        }
    };
    
    this.verificaHoraOnInput = function(widget){
        
        var doisPontos = [];
        var tamanho;
        
        String.prototype.isNumber = function(){
            return /^\d+$/.test(this);
        };
        
        if(widget.name == "atividade_etapa"){
            if(widget.currentRow.QTHRINSPEXE){    
                tamanho = widget.currentRow.QTHRINSPEXE.length;
                
                if(widget.currentRow.QTHRINSPEXE[(tamanho - 1)].isNumber() == false){
                    
                    if((widget.currentRow.QTHRINSPEXE[(tamanho - 1)]) == ":" && (auxHora == 0)){
                        auxHora = 1;
                    } else {
                        widget.currentRow.QTHRINSPEXE = widget.currentRow.QTHRINSPEXE.substring(0,(tamanho - 1));
                    }
                    
                } else if(widget.currentRow.QTHRINSPEXE[(tamanho - 1)].isNumber() == true){
                    
                    doisPontos = widget.currentRow.QTHRINSPEXE.split(":");
                    
                    if(doisPontos.length == 2){
                        if(doisPontos[1].length > 2){
                            widget.currentRow.QTHRINSPEXE = widget.currentRow.QTHRINSPEXE.substring(0,(tamanho - 1));
                        } else if(parseInt(doisPontos[1][0]) > 5){
                            widget.currentRow.QTHRINSPEXE = widget.currentRow.QTHRINSPEXE.substring(0,(tamanho - 1));
                        }
                    }
                }
            }
        }
        else if(widget.name == "recursos_atividade"){
            if(widget.currentRow.QTHRUTRECUR){    
                tamanho = widget.currentRow.QTHRUTRECUR.length;
                
                if(widget.currentRow.QTHRUTRECUR[(tamanho - 1)].isNumber() == false){
                    
                    if((widget.currentRow.QTHRUTRECUR[(tamanho - 1)]) == ":" && (auxHora == 0)){
                        auxHora = 1;
                    } else {
                        widget.currentRow.QTHRUTRECUR = widget.currentRow.QTHRUTRECUR.substring(0,(tamanho - 1));
                    }
                    
                } else if(widget.currentRow.QTHRUTRECUR[(tamanho - 1)].isNumber() == true){
                    
                    doisPontos = widget.currentRow.QTHRUTRECUR.split(":");
                    
                    if(doisPontos.length == 2){
                        if(doisPontos[1].length > 2){
                            widget.currentRow.QTHRUTRECUR = widget.currentRow.QTHRUTRECUR.substring(0,(tamanho - 1));
                        } else if(parseInt(doisPontos[1][0]) > 5){
                            widget.currentRow.QTHRUTRECUR = widget.currentRow.QTHRUTRECUR.substring(0,(tamanho - 1));
                        }
                    }
                }
            }
        }
    };
    
    this.saveAtividadeEtapa = function(widget){
        widget.currentRow.CDFILIAL = widget.parent.currentRow.CDFILIAL;
        widget.currentRow.CDPRODUTO = widget.parent.currentRow.CDPRODUTO;
        widget.currentRow.CDPROCFABRIC = widget.parent.currentRow.CDPROCFABRIC;
        widget.currentRow.CDETAPAPROD = widget.parent.currentRow.CDETAPAPROD;
        
        if((widget.currentRow.QTHRINSPEXE) && (widget.currentRow.QTHRINSPEXE != "")){
            var tempo = widget.currentRow.QTHRINSPEXE.split(":");
            widget.currentRow.QTHRINSPEXE = ((parseInt(tempo[0])*60+parseInt(tempo[1]))/60);
        }
        General.saveCrud(widget).then(function(aux){
            if(widget.mode == "view"){   
                this.consertaHora(widget);
            }
        }.bind(this));
    };
    
    this.saveRecursoAtividade = function(widget){
        widget.currentRow.CDFILIAL = widget.parent.currentRow.CDFILIAL;
        widget.currentRow.CDPRODUTO = widget.parent.currentRow.CDPRODUTO;
        widget.currentRow.CDPROCFABRIC = widget.parent.currentRow.CDPROCFABRIC;
        widget.currentRow.CDETAPAPROD = widget.parent.currentRow.CDETAPAPROD;
        widget.currentRow.CDINSPECAO = widget.parent.currentRow.CDINSPECAO;
        widget.currentRow.NRINSPETAPA = widget.parent.currentRow.NRINSPETAPA;
        
        if((widget.currentRow.QTHRUTRECUR) && (widget.currentRow.QTHRUTRECUR != "")){
            var tempo = widget.currentRow.QTHRUTRECUR.split(":");
            widget.currentRow.QTHRUTRECUR = ((parseInt(tempo[0])*60+parseInt(tempo[1]))/60);
        }
        General.saveCrud(widget).then(function(aux){
            if(widget.mode == "view"){   
                this.consertaHora(widget);
            }
        }.bind(this));
    };
    
}
Configuration(function(ContextRegister) {
    ContextRegister.register('Cdp05000_roteiro_producao_Controller', Cdp05000_roteiro_producao_Controller);
});


// FILE: ./assets/modules/producao/assets/js/controllers/Cdp60000_acompanhamento_de_tarefas_Controller.js
function Cdp60000_acompanhamento_de_tarefas_Controller (templateManager, restEngine, General, ScreenService){
    
    this.atualizaWidget = function(widget){
        setTimeout(function(){
            widget.reload();
            ScreenService.alertNotification('Widget atualizada');
        }, 60000);
    };
    
}
Configuration(function(ContextRegister) {
    ContextRegister.register('Cdp60000_acompanhamento_de_tarefas_Controller', Cdp60000_acompanhamento_de_tarefas_Controller);
});

// FILE: ./assets/modules/producao/assets/js/controllers/Ger11800_inspecao_Controller.js
function Ger11800_inspecao_Controller (Ger11800_inspecao_Service, ZHPromise, templateManager, restEngine, General, ScreenService){
  
    var CDFILIAL;
    var CDPICTINSPEC;
    var CDPICTPROD;
    var mask = {
        "type": "fix",
        "params": {
            "mask": "@getLocalVar('CDP_CDPICTINSPEC')@"
        }
    };
    var nivel_array = [];
    var nivel_max;
    
    this.getMask = function(){
       Ger11800_inspecao_Service.retornaFilial().then(function(filialLogada){
            CDFILIAL =  filialLogada[0].CDFILIAL;
            
            var filtro = [
                {
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": CDFILIAL
                }
            ];
            
            General.callRestEngine("cdp#/crud/paramgeral","FilterData", filtro).then(function(sucess){
                CDPICTINSPEC = sucess.dataset.paramgeral[0].CDPICTINSPEC;
                CDPICTPROD = sucess.dataset.paramgeral[0].CDPICTPROD;
                setLocalVar('CDP_CDPICTINSPEC',CDPICTINSPEC);
                setLocalVar('CDP_CDPICTPROD',CDPICTPROD);
                nivel_array = CDPICTINSPEC.split('.');
                nivel_max = nivel_array.length;
                templateManager.container.getWidget('ger11800_inspecao_tree').getField('CDARVINSPEC').maxlength =  CDPICTINSPEC.replace(/\./g, "").length;
                templateManager.container.getWidget('ger11800_inspecao_tree').getField('CDARVINSPEC').mask =  mask;
                templateManager.container.getWidget('ger11800_inspecao_tree').reload();
            
            }, function(error){
                ScreenService.showMessage(error);
            });
            
        }, function(error){
            ScreenService.showMessage(error);
        });
            
    };
    
    this.verificaNivel = function(widget){
       var penNiv = nivel_max - 1;
       penNiv = penNiv.toString();
       
       if(widget.mode != "edit"){
           if(widget.currentRow.CDNVINSPECAO == nivel_max){
               widget.actions.forEach( function(element){
                   if((element.name == "ADD") && (element.showAsAction == "view")){
                       element.isVisible = false;
                       widget.widgets.forEach(function(elem){
                            if((elem.name == "widgetTipodeVistoInspec") || (elem.name == "widgetInspecaoporProdutoInspec")){
                                elem.enabled = false;
                            } else {
                                elem.enabled = true;
                            }
                       });
                   }
               });
           } else if(widget.currentRow.CDNVINSPECAO == penNiv){
               widget.actions.forEach( function(element){
                   if((element.name == "ADD") && (element.showAsAction == "view")){
                       element.isVisible = true;
                       widget.widgets.forEach(function(elem){
                            if((elem.name == "widgetDescInsp") || (elem.name == "widgetTipodeVistoInspec") || (elem.name == "widgetInspecaoporProdutoInspec")){
                                elem.enabled = true;
                            } else {
                                elem.enabled = false;
                            }
                       });
                    }
               });
           } else {
                widget.actions.forEach( function(element){
                   if((element.name == "ADD") && (element.showAsAction == "view")){
                       element.isVisible = true;
                       widget.widgets.forEach(function(elem){
                            if( elem.name == "widgetDescInsp" ){
                                elem.enabled = true;
                            } else {
                                elem.enabled = false;
                            }
                       });
                    }
               });
           }
       }
    };

    this.openDescricao = function(widget){
        widget.dataSource.data = [];
        widget.dataSourceFilter = [];
        var filtro = [
            {
                "name": "CDINSPECAO",
                "operator": "=",
                "value": widget.parent.currentRow.CDINSPECAO
            }
        ];
       General.callRestEngine("cdp#/crud/inspecao_descinspecao","FilterData", filtro).then(function(sucess){
            if(widget.mode != "edit"){
                widget.currentRow = {};
                if(sucess.dataset.inspecao_descinspecao.length > 0){    
                    widget.currentRow = sucess.dataset.inspecao_descinspecao[0];
                    if(widget.currentRow.TXDESCINSPEC_CLOB == null){
                        widget.currentRow.TXDESCINSPEC_CLOB = "";
                    }
                    widget.view();
                } else if(Object.keys(widget.currentRow).length == 0){
                    ScreenService.showMessage('Descrição da Inspeção '+widget.parent.currentRow.NMINSPECAO+' não cadastrada');
                    widget.currentRow.CDINSPECAO = widget.parent.currentRow.CDINSPECAO;
                    widget.currentRow.CDARVINSPEC = widget.parent.currentRow.CDARVINSPEC;
                    widget.currentRow.NMINSPECAO = widget.parent.currentRow.NMINSPECAO;
                    widget.currentRow.TXDESCINSPEC_CLOB = "";
                    widget.currentRow.__is_new = true;
                    widget.view();
                }  else if(sucess.dataset.inspecao_descinspecao.length == 0){
                    widget.currentRow.TXDESCINSPEC_CLOB = "";
                }
            }
        });
    };
    
    this.openAcaoCorretiva = function(widget){
        widget.dataSource.data = [];
        widget.dataSourceFilter = [];
        var filtro = [
            {
                "name": "CDINSPECAO",
                "operator": "=",
                "value": widget.parent.currentRow.CDINSPECAO
            }
        ];
       General.callRestEngine("cdp#/crud/inspecao_acao","FilterData", filtro).then(function(sucess){
            if(widget.mode != "edit"){
                widget.currentRow = {};
                if(sucess.dataset.inspecao_acao.length > 0){    
                    widget.currentRow = sucess.dataset.inspecao_acao[0];
                    if(widget.currentRow.TXACAOINSPEC_CLOB == null){
                        widget.currentRow.TXACAOINSPEC_CLOB = "";
                    } /*else {
                        widget.currentRow.TXACAOINSPEC_CLOB = this.openAcaoCorretivaComplete(widget.currentRow.TXACAOINSPEC_CLOB);
                    }*/
                    widget.view();
                } else if(Object.keys(widget.currentRow).length == 0){
                    ScreenService.showMessage('Descrição da Inspeção '+widget.parent.currentRow.NMINSPECAO+' não cadastrada');
                    widget.currentRow.CDINSPECAO = widget.parent.currentRow.CDINSPECAO;
                    widget.currentRow.CDARVINSPEC = widget.parent.currentRow.CDARVINSPEC;
                    widget.currentRow.NMINSPECAO = widget.parent.currentRow.NMINSPECAO;
                    widget.currentRow.TXACAOINSPEC_CLOB = "";
                    widget.currentRow.__is_new = true;
                    widget.view();
                }  else if(sucess.dataset.inspecao_acao.length == 0){
                    widget.currentRow.TXACAOINSPEC_CLOB = "";
                }
            }
        }.bind(this));
    };

    this.newRow = function(widget){
        General.changeWidgetAcessibility(widget.widgets, false);
        widget.newRow();
        widget.getField('CDARVINSPEC').mask = null;
        widget.getField('CDARVINSPEC').reload();  
        widget.currentRow.IDORIGINSPEC = "QUA";
    };
    
    this.newRowView = function(widget){
        var CDARVINSPEC = widget.currentRow.CDARVINSPEC;  
        General.changeWidgetAcessibility(widget.widgets, false);
        widget.newRow();
        widget.getField('CDARVINSPEC').mask = null;
        widget.getField('CDARVINSPEC').reload();
        widget.getField('CDARVINSPECANTE').isVisible = true;
        widget.getField('CDARVINSPECANTE').reload();
        //widget.currentRow.CDARVINSPEC = CDARVINSPEC;  
        widget.currentRow.CDARVINSPECANTE = CDARVINSPEC;  
        widget.currentRow.IDORIGINSPEC = "QUA";
    };
    
    this.newVisto = function(widget){
        widget.newRow();
        widget.currentRow.CDINSPECAO = widget.parent.currentRow.CDINSPECAO;
        widget.currentRow.CDARVINSPEC = widget.parent.currentRow.CDARVINSPEC;
        widget.currentRow.NMINSPECAO = widget.parent.currentRow.NMINSPECAO;
    };

    this.verificaCdArvOnInput = function(widget){
        String.prototype.isNumber = function(){
            return /^\d+$/.test(this);
        };
        if(widget.currentRow.CDARVINSPEC){    
            var tamanho = widget.currentRow.CDARVINSPEC.length;
            var verficaCDPICTINSPEC = CDPICTINSPEC.replace(/\./g, "");
            if(verficaCDPICTINSPEC[(tamanho - 1)].isNumber() == false){
                if(widget.currentRow.CDARVINSPEC[(tamanho - 1)].match(/^[a-zA-Z-0-9]+$/) == null){
                    widget.currentRow.CDARVINSPEC = widget.currentRow.CDARVINSPEC.substring(0,(tamanho - 1));
                    ScreenService.alertNotification("A mascara do campo é "+CDPICTINSPEC+". Dígite um código semelhante, sem os pontos");
                }
            } else if(verficaCDPICTINSPEC[(tamanho - 1)].isNumber() == true){
                if(widget.currentRow.CDARVINSPEC[(tamanho - 1)].isNumber() == false){
                    widget.currentRow.CDARVINSPEC = widget.currentRow.CDARVINSPEC.substring(0,(tamanho - 1));
                    ScreenService.alertNotification("A mascara do campo é "+CDPICTINSPEC+". Dígite um código semelhante, sem os pontos");
                }
            }
        }
    };  

    this.verificaCdArv = function(widget){
        String.prototype.isNumber = function(){
            return /^\d+$/.test(this);
        };
        
        var espace = false;
        var tamanho = widget.currentRow.CDARVINSPEC.length;
        var i = 0;
        
        for(var j = 0; j < tamanho; j++){
        	if(widget.currentRow.CDARVINSPEC[j] == " "){
        	 	ScreenService.showMessage("Favor inserir o código sem espaço");
        	 	widget.currentRow.CDARVINSPEC = "";
                widget.getField('CDARVINSPEC').reload();
                widget.currentRow.CDARVINSPECANTE = "";
                widget.getField('CDARVINSPECANTE').reload();
                widget.currentRow.CDNVINSPECAO = "";
                widget.getField('CDNVINSPECAO').reload();
                espace = true;
        	}
        }
         
        tamanho = 0; 
         
        if(espace == false){
            if(widget.currentRow.CDARVINSPEC.length <= CDPICTINSPEC.replace(/\./g, "").length){    
                while(widget.currentRow.CDARVINSPEC.length > tamanho){
                    tamanho += nivel_array[i].length;
                    i++;
                }
                if(tamanho > widget.currentRow.CDARVINSPEC.length){
                    ScreenService.showMessage('Para preencher o código de nivel '+i+' é necessario que o campo código contenha '+tamanho+' números.');
                    widget.currentRow.CDARVINSPEC = "";
                    widget.getField('CDARVINSPEC').reload();
                    widget.currentRow.CDARVINSPECANTE = "";
                    widget.getField('CDARVINSPECANTE').reload();
                    widget.currentRow.CDNVINSPECAO = "";
                    widget.getField('CDNVINSPECAO').reload();
                } else if(tamanho == widget.currentRow.CDARVINSPEC.length){
                    widget.currentRow.CDNVINSPECAO = i;
                    if(widget.currentRow.CDNVINSPECAO == 1){
                        widget.currentRow.CDARVINSPECANTE = null;
                    } else if(widget.currentRow.CDNVINSPECAO > 1){
                        var remove = - nivel_array[(widget.currentRow.CDNVINSPECAO - 1)].length;
                        widget.currentRow.CDARVINSPECANTE = widget.currentRow.CDARVINSPEC.slice(0, remove); 
                    }
                }
            } else if(widget.currentRow.CDARVINSPEC.length > CDPICTINSPEC.replace(/\./g, "").length){
                ScreenService.showMessage('Tamanho maximo do código é '+CDPICTINSPEC.replace(/\./g, "").length);
                widget.currentRow.CDARVINSPEC = "";
                widget.getField('CDARVINSPEC').reload();
                widget.currentRow.CDARVINSPECANTE = "";
                widget.getField('CDARVINSPECANTE').reload();
                widget.currentRow.CDNVINSPECAO = "";
                widget.getField('CDNVINSPECAO').reload();
            }
        }
    };
    
    this.saveArvoreInsp = function(widget){
        var row = widget.currentRow;
        if (widget.isValid()) {
            General.callRestEngine('cdp_producao#/inspecao_inspecao/save', "Row", row).then(function(sucess) {
				widget.activate();
				if (widget.currentRow.__is_new) {
    				if(widget.getField('CDARVINSPECANTE').isVisible == true){
        				widget.getField('CDARVINSPECANTE').isVisible = false;
                        widget.getField('CDARVINSPECANTE').reload();
    				}
    				widget.getField('CDARVINSPEC').mask =  mask;
                    widget.list();  
					ScreenService.goBack();
					widget.reload();
				} else {
					widget.view();
					widget.getField('CDARVINSPEC').mask =  mask;
            	}
				ScreenService.showMessage('Salvo com sucesso');
                this.verificaNivel(widget);
			}.bind(this), function(error){
			    ScreenService.showMessage(error.data.error);
			});
        }
    };
    
    this.saveInspecProd = function(widget){
        var row = widget.currentRow;
        if (widget.isValid()) {
            if(widget.currentRow.__is_new){
                Ger11800_inspecao_Service.geraNRSEQINSPRO(widget.currentRow).then(function(sucess){
                	row.NRSEQINSPRO = sucess.dataset.data[0].NRSEQINSPRO;
                	General.saveCrud(widget);
    			}.bind(this), function(error){
    			    ScreenService.showMessage(error.data.error);
    			});
            } else {
        	    General.saveCrud(widget);
            } 
        }
    };
    
    this.deleteArvoreInsp = function(widget){
        ScreenService.confirmMessage(ScreenService.i18n('Delete Register?'), 'question', function (success) {
		    var row = widget.currentRow;
            General.callRestEngine('cdp_producao#/inspecao_inspecao/remove', "Row", row).then(function(sucess) {
        	    ScreenService.closeSwipe().then(function() {
                    widget.list();
                    widget.reload();
                });
        	    ScreenService.showMessage('Deletado com sucesso');
    		}.bind(this), function(error){
    		    ScreenService.showMessage(error.data.error);
    		});
        General.changeWidgetAcessibility(widget.widgets, true);
        });
    };
  
    this.backOrCancelArvoreInspec = function(args){
        if(args.owner.widget.currentRow.__is_new){    
            if(args.owner.widget.getField('CDARVINSPECANTE').isVisible == true){
				args.owner.widget.getField('CDARVINSPECANTE').isVisible = false;
                args.owner.widget.getField('CDARVINSPECANTE').reload();
			}
            General.backOrCancel(args);
            args.owner.widget.getField('CDARVINSPEC').mask =  mask;
        } else {
            General.backOrCancel(args);
        }
        this.verificaNivel(args.owner.widget);
    };
    
    this.newRowChecklist = function(widget){
        widget.newRow();
        widget.currentRow.CDINSPECAO = widget.parent.currentRow.CDINSPECAO;
        widget.currentRow.CDARVINSPEC = widget.parent.currentRow.CDARVINSPEC;
        widget.currentRow.NMINSPECAO = widget.parent.currentRow.NMINSPECAO;
        widget.currentRow.CDNVINSPECAO = widget.parent.currentRow.CDNVINSPECAO;
        widget.currentRow.IDSITINSPEC = widget.parent.currentRow.IDSITINSPEC;
        widget.currentRow.IDTPRESPINSP = widget.parent.currentRow.IDTPRESPINSP;
        widget.currentRow.DSLIMIRESP = widget.parent.currentRow.DSLIMIRESP;
        widget.currentRow.IDORIGINSPEC = widget.parent.currentRow.IDORIGINSPEC;
        widget.currentRow.IDATEITEINSP = widget.parent.currentRow.IDATEITEINSP;
    };
    
    this.editInspecTree = function(widget){
        General.changeWidgetAcessibility(widget.widgets, false);
        General.edit(widget);
    };
    
    this.editDesc = function(widget){
        widget.parent.enabled = false;
        widget.parent.widgets.forEach(function(element){
            if(element.name != widget.name){
                element.enabled = false;
            }
        });
        widget.template = widget.templateToForm;
        General.edit(widget);
    };
    
    this.cancelDesc = function(args){
        var widget = args.owner.widget;
        widget.template = widget.templateToView;
	    widget.view();
        widget.parent.enabled = true;
        this.verificaNivel(widget.parent);
        this.openDescricao(widget);
    };
    
    this.deleteDesc = function(widget){
        ScreenService.confirmMessage(ScreenService.i18n('Delete Register?'), 'question', function (success) {
			widget.removeRow().then(function () {
                widget.template = widget.templateToView;
    		    widget.view();
                widget.parent.enabled = true;
                this.verificaNivel(widget.parent);
                this.openDescricao(widget);
            }.bind(this));
        }.bind(this));
    };
    
    this.saveDesc = function(widget){
        if(widget.currentRow.__is_new == true){
            widget.saveRow().then(function(sucess){
                widget.template = widget.templateToView;
                widget.view();
                widget.parent.enabled = true;
                this.verificaNivel(widget.parent);
            }.bind(this));
        } else if(widget.currentRow.__is_new == false){
            Ger11800_inspecao_Service.updateDesc(widget.currentRow).then(function(sucess){
                widget.template = widget.templateToView;
                widget.view();
                widget.parent.enabled = true;
                this.verificaNivel(widget.parent);
            }.bind(this));
        }
    };
    
    this.editAcaoCorretiva = function(widget){
        widget.parent.enabled = false;
        widget.parent.widgets.forEach(function(element){
            if(element.name != widget.name){
                element.enabled = false;
            }
        });
        widget.template = widget.templateToForm;
        General.edit(widget);
    };
    
    this.cancelAcaoCorretiva = function(args){
        var widget = args.owner.widget;
        widget.template = widget.templateToView;
	    widget.view();
        widget.parent.enabled = true;
        this.verificaNivel(widget.parent);
        this.openAcaoCorretiva(widget);
    };
    
    this.deleteAcaoCorretiva = function(widget){
        ScreenService.confirmMessage(ScreenService.i18n('Delete Register?'), 'question', function (success) {
			widget.removeRow().then(function () {
                widget.template = widget.templateToView;
    		    widget.view();
                widget.parent.enabled = true;
                this.verificaNivel(widget.parent);
                this.openAcaoCorretiva(widget);
            }.bind(this));
        }.bind(this));
    };
    
    this.ascii_to_hexa = function(str){
        var arr1 = [];
    	for (var n = 0, l = str.length; n < l; n ++) {
    	
    		if(Number(str.charCodeAt(n)) > 127){
    		    arr1.push("5c27");
    		    var hex_mf = Number(str.charCodeAt(n)).toString(16);
    		    for (var i = 0, t = hex_mf.length; i < t; i ++) {
    		        var hex_nf = Number(hex_mf.charCodeAt(i)).toString(16);
    		        arr1.push(hex_nf);
    		    }
    		} else {
        		var hex = Number(str.charCodeAt(n)).toString(16);
        		if(hex == "a"){
        		    hex = "0D";
        		}
        		arr1.push(hex);
        	}    
    	}
    	return arr1.join('');
    		
    };
    
    /**
     * 
     * Campo TXACAOINSPEC (Long Raw) estourando quando atinge 4000 caracteres;
     * 
     * Foi necessário criar um campo CLOB para ser possivvél que o campo tenha
     * a mesma funcionalidade do delphi, no mobile;
     * 
     * Basicamente o Mobile salva em HTML e o Delphi não reconhece o mesmo, 
     * exibindo para o usario além dos textos as tags;
     * 
     * Foi criado duas funções abaixo para identificar caracteres que não são
     * reconhecidos pelo zeedhi e exibilos corretamente.
     * 
     * Funções salvas e commitadas em comentario para uso posterior.
     * 
    */
    
    /*
    this.openAcaoCorretivaComplete = function(str){
        var arr1 = [];
    	for (var n = 0, l = str.length; n < l; n ++) {
    	
    		if((Number(str.charCodeAt(n)).toString(16) == "5c") && (Number(str.charCodeAt(n+1)).toString(16) == "27")){
    		    var hex_mf = this.hex_to_ascii(str.substring(n+2,n+4));
    		    arr1.push(hex_mf);
    		    n = n+3;
    		} else {
        		arr1.push(str[n]);
        	}    
    	}
    	return arr1.join('');
    		
    };
    
    this.hex_to_ascii = function(str1){
    	var hex  = str1.toString();
    	var str = '';
    	for (var n = 0; n < hex.length; n += 2) {
    		str += String.fromCharCode(parseInt(hex.substr(n, 2), 16));
    	}
    	return str;
    };
    */
    
    this.saveAcaoCorretiva = function(widget){
        widget.saveRow().then(function(sucess){
            widget.template = widget.templateToView;
            widget.view();
            widget.parent.enabled = true;
            this.verificaNivel(widget.parent);
        }.bind(this), function(error){
            console.log('Erro ao salvar Ação Corretiva');
        });
    };
    
    this.newRowOpcao = function(widget){
        widget.newRow();
        widget.currentRow.CDINSPECAO = widget.parent.currentRow.CDINSPECAO;
        widget.currentRow.CDARVINSPEC = widget.parent.currentRow.CDARVINSPEC;
        widget.currentRow.NMINSPECAO = widget.parent.currentRow.NMINSPECAO;
    };
    
    this.newRowInspecProd = function(widget){
        widget.newRow();
        widget.currentRow.CDINSPECAO = widget.parent.currentRow.CDINSPECAO;
        widget.currentRow.CDARVINSPEC = widget.parent.currentRow.CDARVINSPEC;
        widget.currentRow.NMINSPECAO = widget.parent.currentRow.NMINSPECAO;
        //widget.currentRow.IDIMPINSPRO = "2";
        //widget.currentRow.IDPROCPROD = "E";
    };
    
    this.verificaIDTPRESPINSP = function(widget){
        var IDTPRESPINSP = widget.parent.currentRow.IDTPRESPINSP;
        if(IDTPRESPINSP == "NADA"){
            widget.getField('VRPONTRESINS').isVisible = true;
            widget.getField('VRPONTRESINS').showOnList = true;
            widget.getField('VRPONTRESINS').reload();
        
            widget.getField('IDFAIXRESINS').isVisible = false;
            widget.getField('IDFAIXRESINS').reload();
            widget.getField('VRINIFAIXRES').isVisible = false;
            widget.getField('VRINIFAIXRES').reload();
            widget.getField('VRFINFAIXRES').isVisible = false;
            widget.getField('VRFINFAIXRES').reload();
            widget.getField('date_DTINIFAIXRES').isVisible = false;
            widget.getField('date_DTINIFAIXRES').reload();
            widget.getField('date_DTFINFAIXRES').isVisible = false;
            widget.getField('date_DTFINFAIXRES').reload();
            widget.getField('time_DTINIFAIXRES').isVisible = false;
            widget.getField('time_DTINIFAIXRES').reload();
            widget.getField('time_DTFINFAIXRES').isVisible = false;
            widget.getField('time_DTFINFAIXRES').reload();
            widget.getField('datetime_DTINIFAIXRES').isVisible = false;
            widget.getField('datetime_DTINIFAIXRES').reload();
            widget.getField('datetime_DTFINFAIXRES').isVisible = false;
            widget.getField('datetime_DTFINFAIXRES').reload();
        
        } else if(IDTPRESPINSP == "TEXT"){
            widget.getField('VRPONTRESINS').isVisible = true;
            widget.getField('VRPONTRESINS').showOnList = true;
            widget.getField('VRPONTRESINS').reload();
        
            widget.getField('IDFAIXRESINS').isVisible = false;
            widget.getField('IDFAIXRESINS').reload();
            widget.getField('VRINIFAIXRES').isVisible = false;
            widget.getField('VRINIFAIXRES').reload();
            widget.getField('VRFINFAIXRES').isVisible = false;
            widget.getField('VRFINFAIXRES').reload();
            widget.getField('date_DTINIFAIXRES').isVisible = false;
            widget.getField('date_DTINIFAIXRES').reload();
            widget.getField('date_DTFINFAIXRES').isVisible = false;
            widget.getField('date_DTFINFAIXRES').reload();
            widget.getField('time_DTINIFAIXRES').isVisible = false;
            widget.getField('time_DTINIFAIXRES').reload();
            widget.getField('time_DTFINFAIXRES').isVisible = false;
            widget.getField('time_DTFINFAIXRES').reload();
            widget.getField('datetime_DTINIFAIXRES').isVisible = false;
            widget.getField('datetime_DTINIFAIXRES').reload();
            widget.getField('datetime_DTFINFAIXRES').isVisible = false;
            widget.getField('datetime_DTFINFAIXRES').reload();
    
        } else if(IDTPRESPINSP == "VALR"){
            widget.getField('IDFAIXRESINS').isVisible = true;
            widget.getField('IDFAIXRESINS').showOnList = true;
            widget.getField('IDFAIXRESINS').reload();
            widget.getField('VRINIFAIXRES').isVisible = true;
            widget.getField('VRINIFAIXRES').showOnList = true;
            widget.getField('VRINIFAIXRES').reload();
            widget.getField('VRFINFAIXRES').isVisible = true;
            widget.getField('VRFINFAIXRES').showOnList = true;
            widget.getField('VRFINFAIXRES').reload();
            widget.getField('VRPONTRESINS').isVisible = true;
            widget.getField('VRPONTRESINS').showOnList = true;
            widget.getField('VRPONTRESINS').reload();
        
            widget.getField('date_DTINIFAIXRES').isVisible = false;
            widget.getField('date_DTINIFAIXRES').reload();
            widget.getField('date_DTFINFAIXRES').isVisible = false;
            widget.getField('date_DTFINFAIXRES').reload();
            widget.getField('time_DTINIFAIXRES').isVisible = false;
            widget.getField('time_DTINIFAIXRES').reload();
            widget.getField('time_DTFINFAIXRES').isVisible = false;
            widget.getField('time_DTFINFAIXRES').reload();
            widget.getField('datetime_DTINIFAIXRES').isVisible = false;
            widget.getField('datetime_DTINIFAIXRES').reload();
            widget.getField('datetime_DTFINFAIXRES').isVisible = false;
            widget.getField('datetime_DTFINFAIXRES').reload();
        
        } else if(IDTPRESPINSP == "DATA"){
            widget.getField('date_DTINIFAIXRES').isVisible = true;
            widget.getField('date_DTINIFAIXRES').showOnList = true;
            widget.getField('date_DTINIFAIXRES').reload();
            widget.getField('date_DTFINFAIXRES').isVisible = true;
            widget.getField('date_DTFINFAIXRES').showOnList = true;
            widget.getField('date_DTFINFAIXRES').reload();
            
            widget.getField('IDFAIXRESINS').isVisible = false;
            widget.getField('IDFAIXRESINS').reload();
            widget.getField('VRINIFAIXRES').isVisible = false;
            widget.getField('VRINIFAIXRES').reload();
            widget.getField('VRFINFAIXRES').isVisible = false;
            widget.getField('VRFINFAIXRES').reload();
            widget.getField('VRPONTRESINS').isVisible = false;
            widget.getField('VRPONTRESINS').reload();
            widget.getField('time_DTINIFAIXRES').isVisible = false;
            widget.getField('time_DTINIFAIXRES').reload();
            widget.getField('time_DTFINFAIXRES').isVisible = false;
            widget.getField('time_DTFINFAIXRES').reload();
            widget.getField('datetime_DTINIFAIXRES').isVisible = false;
            widget.getField('datetime_DTINIFAIXRES').reload();
            widget.getField('datetime_DTFINFAIXRES').isVisible = false;
            widget.getField('datetime_DTFINFAIXRES').reload();
        
        } else if(IDTPRESPINSP == "HORA"){
            widget.getField('time_DTINIFAIXRES').isVisible = true;
            widget.getField('time_DTINIFAIXRES').showOnList = true;
            widget.getField('time_DTINIFAIXRES').reload();
            widget.getField('time_DTFINFAIXRES').isVisible = true;
            widget.getField('time_DTFINFAIXRES').showOnList = true;
            widget.getField('time_DTFINFAIXRES').reload();
            
            widget.getField('IDFAIXRESINS').isVisible = false;
            widget.getField('IDFAIXRESINS').reload();
            widget.getField('VRINIFAIXRES').isVisible = false;
            widget.getField('VRINIFAIXRES').reload();
            widget.getField('VRFINFAIXRES').isVisible = false;
            widget.getField('VRFINFAIXRES').reload();
            widget.getField('VRPONTRESINS').isVisible = false;
            widget.getField('VRPONTRESINS').reload();
            widget.getField('date_DTINIFAIXRES').isVisible = false;
            widget.getField('date_DTINIFAIXRES').reload();
            widget.getField('date_DTFINFAIXRES').isVisible = false;
            widget.getField('date_DTFINFAIXRES').reload();
            widget.getField('datetime_DTINIFAIXRES').isVisible = false;
            widget.getField('datetime_DTINIFAIXRES').reload();
            widget.getField('datetime_DTFINFAIXRES').isVisible = false;
            widget.getField('datetime_DTFINFAIXRES').reload();
            
        } else if(IDTPRESPINSP == "DTHR"){
            widget.getField('datetime_DTINIFAIXRES').isVisible = true;
            widget.getField('datetime_DTINIFAIXRES').showOnList = true;
            widget.getField('datetime_DTINIFAIXRES').reload();
            widget.getField('datetime_DTFINFAIXRES').isVisible = true;
            widget.getField('datetime_DTFINFAIXRES').showOnList = true;
            widget.getField('datetime_DTFINFAIXRES').reload();
            
            widget.getField('IDFAIXRESINS').isVisible = false;
            widget.getField('IDFAIXRESINS').reload();
            widget.getField('VRINIFAIXRES').isVisible = false;
            widget.getField('VRINIFAIXRES').reload();
            widget.getField('VRFINFAIXRES').isVisible = false;
            widget.getField('VRFINFAIXRES').reload();
            widget.getField('VRPONTRESINS').isVisible = false;
            widget.getField('VRPONTRESINS').reload();
            widget.getField('time_DTINIFAIXRES').isVisible = false;
            widget.getField('time_DTINIFAIXRES').reload();
            widget.getField('time_DTFINFAIXRES').isVisible = false;
            widget.getField('time_DTFINFAIXRES').reload();
            widget.getField('date_DTINIFAIXRES').isVisible = false;
            widget.getField('date_DTINIFAIXRES').reload();
            widget.getField('date_DTFINFAIXRES').isVisible = false;
            widget.getField('date_DTFINFAIXRES').reload();
        
        }
    };
    
    this.saveOpcao = function(widget){
        if(widget.currentRow.date_DTINIFAIXRES || widget.currentRow.date_DTFINFAIXRES){
            widget.currentRow.DTINIFAIXRES = widget.currentRow.date_DTINIFAIXRES;
            widget.currentRow.DTFINFAIXRES = widget.currentRow.date_DTFINFAIXRES;
        } else if(widget.currentRow.time_DTINIFAIXRES || widget.currentRow.time_DTFINFAIXRES){
            widget.currentRow.DTINIFAIXRES = moment(moment().format("DD/MM/YYYY")+" "+widget.currentRow.time_DTINIFAIXRES, "DD/MM/YYYY HH:mm:ss").format("DD/MM/YYYY HH:mm:ss");
            widget.currentRow.DTFINFAIXRES = moment(moment().format("DD/MM/YYYY")+" "+widget.currentRow.time_DTFINFAIXRES, "DD/MM/YYYY HH:mm:ss").format("DD/MM/YYYY HH:mm:ss");
        } else if(widget.currentRow.datetime_DTINIFAIXRES || widget.currentRow.time_DTFINFAIXRES){
            widget.currentRow.DTINIFAIXRES = widget.currentRow.datetime_DTINIFAIXRES;
            widget.currentRow.DTFINFAIXRES = widget.currentRow.datetime_DTFINFAIXRES;
        }
        General.saveCrud(widget);
    };
    
    this.fieldHourAplly = function(widget){
        var IDTPRESPINSP = widget.parent.currentRow.IDTPRESPINSP;
        if(IDTPRESPINSP == "DATA"){
            widget.dataSource.data.forEach( function(element){
                if(element.DTINIFAIXRES){
                    element.date_DTINIFAIXRES = moment(element.DTINIFAIXRES).format("DD/MM/YYYY");
                }
                if(element.DTFINFAIXRES){
                    element.date_DTFINFAIXRES = moment(element.DTFINFAIXRES).format("DD/MM/YYYY");
                }
            });
            
        } else if(IDTPRESPINSP == "HORA"){
            widget.dataSource.data.forEach( function(element){
                if(element.DTINIFAIXRES){
                    element.time_DTINIFAIXRES = moment(element.DTINIFAIXRES, "DD/MM/YYYY HH:mm:ss" ).format("HH:mm");
                }
                if(element.DTFINFAIXRES){
                    element.time_DTFINFAIXRES = moment(element.DTFINFAIXRES, "DD/MM/YYYY HH:mm:ss" ).format("HH:mm");
                }
            });
      
        } else if(IDTPRESPINSP == "DTHR"){
           widget.dataSource.data.forEach( function(element){
                if(element.DTINIFAIXRES){
                    element.datetime_DTINIFAIXRES = element.DTINIFAIXRES;
                }
                if(element.DTFINFAIXRES){
                    element.datetime_DTFINFAIXRES = element.DTFINFAIXRES;
                }
            });
        
        }
        
    };
    
    
    
}
Configuration(function(ContextRegister) {
    ContextRegister.register('Ger11800_inspecao_Controller', Ger11800_inspecao_Controller);
});

// FILE: ./assets/modules/producao/assets/js/controllers/Ger13500_departamentoController.js
function Ger13500_departamentoController (templateManager, ScreenService, General){
    
    this.setCdfilial = function(){
        var cdfilial = templateManager.container.getWidget('widgetDepartamento').currentRow.CDFILIAL;
        var campocdfilial = templateManager.container.getWidget('widgetDepartamento').getField('CDFILIPEDORC');
        campocdfilial.setValue(cdfilial);
        campocdfilial.reload();
    };
    
    this.createDepart = function(widget) {
        widget.reload();
        widget.newRow();
        widget.currentRow.__is_new = true;
    };
	
	this.edit = function(widget){
        widget.backupRow = Util.clone(widget.currentRow);
        widget.edit();
    };
    
    this.cancel = function(args, widget){
        if(widget.currentRow.__is_new === true){
            widget.dataSource.data.pop();
            ScreenService.closeSwipe();
        } else {
            Util.extend(widget.currentRow, widget.backupRow);
            widget.view();
        }
        this.reload(args);
    };
    
    this.reload = function(args) {
        var widgetDepartamento = templateManager.container.getWidget("widgetDepartamento");
        widgetDepartamento.reload();
    };
    
    this.verificaCodigo = function(){
        var codigo = templateManager.container.getWidget('widgetDepartamento').getField('CDDEPTO').value();
        if(isNaN(codigo)){
            ScreenService.showMessage("O campo 'Departamento' deve conter apenas números");
            templateManager.container.getWidget('widgetDepartamento').getField('CDDEPTO').setValue('');
        }
    };
	
      
}
Configuration(function(ContextRegister) {
    ContextRegister.register('Ger13500_departamentoController', Ger13500_departamentoController);
});

// FILE: ./assets/modules/producao/assets/js/controllers/cdp-extrato-ordem-producao-Controller.js
function cdp_extrato_ordem_producao_Controller (templateManager, restEngine, General, ScreenService){
    
    this.geraPdf = function(widget){
        restEngine.post("cdp_producao#/geraRelatorio",{'requestType': 'DataSet', 'dataset': [widget.currentRow]})
        .then(function (data) {
            window.open("data:application/pdf;base64, " + data.dataset.base64pdf[0]);
            widget.reload();
        }).
        catch(function(e){
            ScreenService.showMessage(e.data.error);
            ScreenService.closeSwipe();
        });
    };
}
Configuration(function(ContextRegister) {
    ContextRegister.register('cdp_extrato_ordem_producao_Controller', cdp_extrato_ordem_producao_Controller);
});

// FILE: ./assets/modules/producao/assets/js/controllers/cdp00100_parametros_controle_producaoController.js
function cdp00100_parametros_controle_producaoController (templateManager, restEngine, General, ScreenService, cdp00100_parametros_controle_producaoService){
    
    var self = this;
    var VRPRODAGUA;
    var IDLIBLOTEEST;
    
    this.setFilter = function(widget){
        var filial = widget.currentRow.CDFILIAL;
        widget.widgets.forEach(function(widget){
            widget.dataSourceFilter[0].value = filial;
            if(filial)
                widget.getAction('editar').readOnly = false;
            else
                widget.getAction('editar').readOnly = true;
        });
        if (templateManager.container.getActiveWidget().name === "form_observacao")
            self.selectObspadordpro();
        else
            templateManager.container.getActiveWidget().reload();
    };
    
    this.moveToFirst = function(widget){
        if(widget.dataSource.data[0] === undefined){
            widget.currentRow = {};
            widget.currentRow.__is_new = true;
        }
        else {
            widget.moveToFirst();
        }
    };
    
    this.reload = function(widget){
        widget.reload();
    };
    
    this.chageIsVisibleDsunidmedida = function(){
        if (templateManager.container.getActiveWidget().getField("IDUNIDADEVRINT").value() === "S"){
            templateManager.container.getActiveWidget().getField("DSUNIDMEDIDA").isVisible = true;
            templateManager.container.getActiveWidget().getField("IDUNIDADEVRINT").class = 6;
        }
        else{
            templateManager.container.getActiveWidget().getField("DSUNIDMEDIDA").isVisible = false;
            templateManager.container.getActiveWidget().getField("IDUNIDADEVRINT").class = 12;
        }
    };
    
    this.chageIsVisibleIdlibloteest = function(){
        var data;
        if (templateManager.container.getActiveWidget().getField("IDUTSEGLIBLOTE").value() === "S"){
            data = [
                {
                    "label": "Conclusão de Análise",
                    "value": "1"
                },
                {
                    "label": "Lote de Produção",
                    "value": "2"
                }
            ];
            if(IDLIBLOTEEST === "1"){
                templateManager.container.getActiveWidget().currentRow.IDLIBLOTEEST = "1";
            }
            if(IDLIBLOTEEST === "2"){
                templateManager.container.getActiveWidget().currentRow.IDLIBLOTEEST = "2";
            }
            if(IDLIBLOTEEST === "3"){
                templateManager.container.getActiveWidget().currentRow.IDLIBLOTEEST = "1";
            }
        }
        else{
            data = [
                {
                    "label": "Não Utiliza",
                    "value": "3"
                }
            ];
            templateManager.container.getActiveWidget().currentRow.IDLIBLOTEEST = "3";
        }
        templateManager.container.getActiveWidget().redraw();
        templateManager.container.getActiveWidget().getField("IDLIBLOTEEST").dataSource.data = data;
    };
    
    this.selectObspadordpro = function(){
        templateManager.container.getWidget('form_observacao').currentRow.CDFILIAL = templateManager.container.getWidget("tabbed_filial").getField("CDFILIAL").value();
        if (templateManager.container.getWidget('form_observacao').currentRow.CDPARAMAN === undefined)
            templateManager.container.getWidget('form_observacao').getField('CDPARAMAN').setValue(templateManager.container.getWidget('form_observacao').getField('CDPARAMAN').defaultValue);
        
        var filter = [
                {
                    "name": "P_CDFILIAL",
                    "operator": "=",
                    "value": templateManager.container.getWidget('form_observacao').currentRow.CDFILIAL
                },
                {
                    "name": "P_CDPARAM",
                    "operator": "=",
                    "value": templateManager.container.getWidget('form_observacao').currentRow.CDPARAMAN
                }
            ];
            
        cdp00100_parametros_controle_producaoService.selectObspadordpro(filter).then(function (response){
            if(response.dataset.Obspadordpro_controleProducao_select_txt[0]){
                templateManager.container.getWidget('form_observacao').currentRow = response.dataset.Obspadordpro_controleProducao_select_txt[0];
                if (templateManager.container.getWidget('form_observacao').currentRow.TXOBSORDPRO){
                    var TXOBSORDPRO = response.dataset.Obspadordpro_controleProducao_select_txt[0].TXOBSORDPRO;
                    if ((TXOBSORDPRO.substr(TXOBSORDPRO.length - 9).split("}")[0]) === "\\par " ){
                        TXOBSORDPRO = response.dataset.Obspadordpro_controleProducao_select_txt[0].TXOBSORDPRO.split("}")[2];
                        TXOBSORDPRO = TXOBSORDPRO.substr(TXOBSORDPRO.indexOf(" "));
                        TXOBSORDPRO = TXOBSORDPRO.substr(0,TXOBSORDPRO.indexOf('\\par '));
                    }
                    templateManager.container.getWidget('form_observacao').currentRow.TXOBSORDPRO = TXOBSORDPRO;
                }
            }
            else{
                templateManager.container.getWidget('form_observacao').currentRow= {};
            }
        });
    };
    
    this.permissaoNewRow = function (widget){
        widget.getField('DSGRUPOPER').readOnly = false;
        widget.getField('IDAUTGRUPOP').readOnly = false;
        General.widgetNewRow(widget);
    };
    
    this.savePermissao = function(widget){
        General.saveCrud(widget).then(function(){
            widget.getField('DSGRUPOPER').readOnly = true;
            widget.getField('IDAUTGRUPOP').readOnly = true;
        });
    };
    
    this.cancelPermissao = function(args){
        General.backOrCancel(args).then(function(){
            args.owner.widget.getField('DSGRUPOPER').readOnly = true;
            args.owner.widget.getField('IDAUTGRUPOP').readOnly = true;
        });
    };
    
    this.editTabbedFilial = function(widget){
        var isNew = widget.currentRow.__is_new;
        if (widget.currentRow.__is_new === undefined){
            isNew = true;
        }
        widget.getParent().getField("NMFILIAL").readOnly = true;
        General.widgetEdit(widget);
        var widgetsToDeactivate = widget.parent.parent.widgets;

		General.changeWidgetAcessibility(
			widgetsToDeactivate.filter(function (subwidget) {
				return subwidget.name != widget.parent.name;
			}).concat(widget.parent.parent), //retorna um array com a widget parent e suas widgets filhas, exceto aquela que será editada
		false);
		
		var widgetsToActivate = widget.parent.parent.widgets;
		
		General.changeWidgetAcessibility(
			widgetsToActivate.filter(function (subwidget) {
				return subwidget.name === widget.parent.name;
			}).concat(widget.parent.parent), //retorna um array com a widget parent e suas widgets filhas, exceto aquela que será editada
		true);
		widget.currentRow.__is_new = isNew;

    };
    
    this.saveTabbedFilial = function(widget){
        if (!widget.currentRow.CDFILIAL){
            widget.currentRow.CDFILIAL = widget.getParent().getField('CDFILIAL').value();
        }
        if(widget.name === "form_observacao"){
            if (!widget.currentRow.CDPARAMAN){
                widget.currentRow.CDPARAMAN = General.getFieldValue('CDPARAMAN','form_observacao');
            }
            cdp00100_parametros_controle_producaoService.salvarObspadordpro(widget.currentRow).then(function(){
                if (General.formWidgetSwitchTemplate(widget) && widget.parent) {
                    var widgetsToActivate = widget.parent.parent.widgets;
        		
                	General.changeWidgetAcessibility(
                		widgetsToActivate.filter(function (subwidget) {
                			return subwidget.name != widget.parent.name;
                		}).concat(widget.parent.parent), //retorna um array com a widget parent e suas widgets filhas, exceto aquela que será editada
                	true);
                		
                	widgetsToActivate = widget.parent.widgets;
            		
                	General.changeWidgetAcessibility(
                		widgetsToActivate.filter(function (subwidget) {
                			return subwidget.name != widget.name;
                		}).concat(widget.parent), //retorna um array com a widget parent e suas widgets filhas, exceto aquela que será editada
                	true);
        			widget.list();
        			
                    widget.getParent().getField("NMFILIAL").readOnly = false;
                }
            }, function (error){
                if (error.data.error.indexOf('FKMAN00097PARAMAN') > 0){
                    ScreenService.errorNotification('Não há parâmetros cadastrados. Cadastre outra aba, antes de adicionar a descrição');
                } else if(error.data.errorCode === 0) {
                    ScreenService.showMessage(error.data.error);
                }else {
                    ScreenService.errorNotification('Ocorreu um Erro durante o salvamento.');
                }
            });
        }
        else{
            General.widgetSave(widget).then(function(){
    			var widgetsToActivate = widget.parent.parent.widgets;
    		
            	General.changeWidgetAcessibility(
            		widgetsToActivate.filter(function (subwidget) {
            			return subwidget.name != widget.parent.name;
            		}).concat(widget.parent.parent), //retorna um array com a widget parent e suas widgets filhas, exceto aquela que será editada
            	true);
            		
            	widgetsToActivate = widget.parent.widgets;
        		
            	General.changeWidgetAcessibility(
            		widgetsToActivate.filter(function (subwidget) {
            			return subwidget.name != widget.name;
            		}).concat(widget.parent), //retorna um array com a widget parent e suas widgets filhas, exceto aquela que será editada
            	true);
    			widget.list();
    			
                widget.getParent().getField("NMFILIAL").readOnly = false;
            });
        }
    };
    
    this.cancelTabbedFilial = function(args){
        General.backOrCancel(args).then(function (){
            var widget = args.owner.widget;
            if (General.formWidgetSwitchTemplate(widget) && widget.parent) {
            	var widgetsToActivate = widget.parent.parent.widgets;
		
        		General.changeWidgetAcessibility(
        			widgetsToActivate.filter(function (subwidget) {
        				return subwidget.name != widget.parent.name;
        			}).concat(widget.parent.parent), //retorna um array com a widget parent e suas widgets filhas, exceto aquela que será editada
        		true);
        		
        		widgetsToActivate = widget.parent.widgets;
    		
        		General.changeWidgetAcessibility(
        			widgetsToActivate.filter(function (subwidget) {
        				return subwidget.name != widget.name;
        			}).concat(widget.parent), //retorna um array com a widget parent e suas widgets filhas, exceto aquela que será editada
        		true);
			    widget.list();
            } else
				General.changeWidgetAcessibility(widget.widgets, true);
			
        widget.getParent().getField("NMFILIAL").readOnly = false;
        });
    };
    
    this.editTabbedMatPrima = function(widget){
        self.editTabbedFilial(widget);
        var DSUNIDMEDIDA;
        
        if (widget.currentRow.DSUNIDMEDIDA)
            DSUNIDMEDIDA = widget.currentRow.DSUNIDMEDIDA.split("_");
        
        widget.currentRow.DSUNIDMEDIDA = DSUNIDMEDIDA;
    };
    
    this.saveTabbedMatPrima = function(widget){
        var DSUNIDMEDIDA = ""; 
        if (widget.currentRow.DSUNIDMEDIDA){
            widget.currentRow.DSUNIDMEDIDA.forEach(function(data){
                if (data != ""){
                    DSUNIDMEDIDA = DSUNIDMEDIDA.concat("_");
                    DSUNIDMEDIDA = DSUNIDMEDIDA.concat(data);
                }
            });
        }
        if (VRPRODAGUA != widget.currentRow.VRPRODAGUA){
            widget.currentRow.VRULTPRODAGUA = VRPRODAGUA;
        }
        widget.currentRow.VRPRODAGUA = parseFloat(widget.currentRow.VRPRODAGUA);
        widget.currentRow.DSUNIDMEDIDA = DSUNIDMEDIDA;
        self.saveTabbedFilial(widget);
    };
    
    this.setVrprodagua = function(widget){
        VRPRODAGUA = widget.getField('VRPRODAGUA').value();
    };
    
    this.setIdlibloteest = function(widget){
        IDLIBLOTEEST = widget.getField('IDLIBLOTEEST').value();
    };
    
    this.startFiltering = function(widget){
        widget.getField('NMFILIAL').reload().then(function (){
            widget.getField('NMFILIAL').dataSource.data.forEach(function (data){
                if (data.CDFILIAL === getLocalVar('CDFILIAL')){
                    widget.getField('NMFILIAL').setValue(data.NMFILIAL);
                    widget.getField('CDFILIAL').setValue(getLocalVar('CDFILIAL'));
                }
            });
            self.setFilter(widget);
        });
    };
    
}
Configuration(function(ContextRegister) {
    ContextRegister.register('cdp00100_parametros_controle_producaoController', cdp00100_parametros_controle_producaoController);
});

// FILE: ./assets/modules/producao/assets/js/controllers/cdp00200_tipo_composicao_produto_Controller.js
function cdp00200_tipo_composicao_produto_Controller (templateManager, restEngine, General, ScreenService){
    
    this.atualizaData = function(field){
        field.setValue(moment().format('DD/MM/YYYY HH:mm:ss'));
    };
    
    this.reload = function(widget){
        widget.reload();
    };
}
Configuration(function(ContextRegister) {
    ContextRegister.register('cdp00200_tipo_composicao_produto_Controller', cdp00200_tipo_composicao_produto_Controller);
});

// FILE: ./assets/modules/producao/assets/js/controllers/cdp00400_controles_producaoController.js
function cdp00400_controles_producaoController (templateManager, restEngine, General, ScreenService, ZHPromise){
    
    this.atualizaData = function(field){
        field.setValue(moment().format('DD/MM/YYYY HH:mm:ss'));
    };
    
    this.widgetSave = function (widget) {
		var deferred = ZHPromise.defer();

		if (widget.isValid()) {
			widget.currentRow.changed = true;

			if (!widget.currentRow.__is_new)
				widget.currentRow.__is_new = false;
			else if (widget.paramsNewCode && widget.paramsNewCode.__is_new_code) {
				widget.currentRow.__using_unit = widget.paramsNewCode.__using_unit || false;
				widget.currentRow.__new_code_pk = widget.paramsNewCode.__new_code_pk;
				widget.currentRow.__table_pk = widget.paramsNewCode.__table_pk;
				widget.currentRow.__new_code_length = widget.paramsNewCode.__new_code_length || 5;
				widget.currentRow.__cast_number = widget.paramsNewCode.__cast_number || false;
			}

			widget.saveRow().then(function (response) {
				widget.currentRow.changed = false;
				delete widget.backupRow;

				if (General.formWidgetSwitchTemplate(widget) && widget.parent) {
					widget.view();

					var widgets = widget.parent.widgets;
					General.changeWidgetAcessibility(widgets.concat(widget.parent), true);
				} else {
					if (widget.currentRow.__is_new) {
						ScreenService.closeSwipe();
						widget.list();
					} else widget.view();

					General.changeWidgetAcessibility(widget.widgets, true);
				}

				if (widget.currentRow.__is_new) widget.currentRow.__is_new = false;
				else widget.reload();

				deferred.resolve(response);
				widget.reload();
			}.bind(this), function (error) {
				var errorMessage = 'Timeout';

				if (error.data) errorMessage = error.data.error;

				ScreenService.showMessage(errorMessage);
				deferred.reject(errorMessage);
			});
		} else deferred.reject("Preencha todos os campos corretamente!");

		return deferred;
	};
	
	this.deleteCrud = function (widget) {
		var deferred = ZHPromise.defer();
		ScreenService.confirmMessage(ScreenService.i18n('Delete Register?'), 'question', function (success) {
			widget.removeRow().then(function () {
				ScreenService.closeSwipe().then(function () {
					widget.activate();
					deferred.resolve();
					
					widget.getParent().dataSource.reload().then(function (data){
						var existe = false;
						data.dataset.equipamentoUtilizado_nome.forEach(function(data){
							if(widget.currentRow.CDEQUIPPRO === data.CDEQUIPPRO && widget.currentRow.CDTPCONTROLE === data.CDTPCONTROLE){
								existe = true;
							}
						});
						if(!existe){
							ScreenService.closeSwipe();
							widget.getParent().activate();	
							}
					});
				});
			}, function (error) {
				if (error.data && error.data.error.indexOf('ORA-02292') !== -1) {
					ScreenService.showMessage('Exclusão não permitida! O registro possui registros filhos.');
				} else {
					ScreenService.showMessage(error.data.error);
				}
				deferred.reject();
			});
		});
		return deferred.promise;
	};
	
	this.saveEquipamento = function (widget) {
		if(widget.currentRow.__is_new){
			var deferred = ZHPromise.defer();
	
			if (widget.isValid()) {
				widget.currentRow.changed = true;
	
				if (!widget.currentRow.__is_new)
					widget.currentRow.__is_new = false;
				else if (widget.paramsNewCode && widget.paramsNewCode.__is_new_code) {
					widget.currentRow.__using_unit = widget.paramsNewCode.__using_unit || false;
					widget.currentRow.__new_code_pk = widget.paramsNewCode.__new_code_pk;
					widget.currentRow.__table_pk = widget.paramsNewCode.__table_pk;
					widget.currentRow.__new_code_length = widget.paramsNewCode.__new_code_length || 5;
					widget.currentRow.__cast_number = widget.paramsNewCode.__cast_number || false;
				}
				widget.dataSource.name = "cdp_producao#/crud/equipamentoUtilizado_nome_save";
	
				widget.saveRow().then(function (response) {
					widget.dataSource.name = "cdp_producao#/crud/equipamentoUtilizado_nome";
					widget.currentRow.changed = false;
					delete widget.backupRow;
	
					if (General.formWidgetSwitchTemplate(widget) && widget.parent) {
						widget.view();
	
						var widgets = widget.parent.widgets;
						General.changeWidgetAcessibility(widgets.concat(widget.parent), true);
					} else {
						if (widget.currentRow.__is_new) {
							ScreenService.closeSwipe();
							widget.list();
						} else widget.view();
	
						General.changeWidgetAcessibility(widget.widgets, true);
					}
	
					if (widget.currentRow.__is_new) widget.currentRow.__is_new = false;
					else widget.reload();
	
					deferred.resolve(response);
					widget.reload();
				}.bind(this), function (error) {
					var errorMessage = 'Timeout';
	
					if (error.data) errorMessage = error.data.error;
	
					ScreenService.showMessage(errorMessage);
					deferred.reject(errorMessage);
				});
			} else deferred.reject("Preencha todos os campos corretamente!");
	
			return deferred;
		} else {
			this.widgetSave(widget);
		}
	};
	
	this.backOrCancel = function(args){
		General.backOrCancel(args);
		
		var widgetsToActivate = args.owner.widget.widgets;

				General.changeWidgetAcessibility(
					widgetsToActivate.filter(function (subwidget) {
						return subwidget.name != args.owner.widget.name;
					}).concat(args.owner.widget), //retorna um array com a widget parent e suas widgets filhas, exceto aquela que será editada
					true);
	};

}
Configuration(function(ContextRegister) {
    ContextRegister.register('cdp00400_controles_producaoController', cdp00400_controles_producaoController);
});

// FILE: ./assets/modules/producao/assets/js/controllers/cdp00500_etapa_de_producao_Controller.js
function cdp00500_etapa_de_producao_Controller (cdp00500_etapa_de_producao_Service, ZHPromise, templateManager, restEngine, General, ScreenService){
    
    this.saveEtapa = function(widget){
        if(widget.isValid()){
          	cdp00500_etapa_de_producao_Service.salvarEtapa(widget.currentRow).then(function(Success) {
            	if (widget.currentRow.__is_new) {
		            widget.reload().then(function() {
                   		widget.list(true);
                   		ScreenService.closeSwipe();
                    });
                }
                else {
                    widget.view();
                }
            }.bind(this),
            function(callback){
                if(callback.data){
                    ScreenService.showMessage(callback.data.error);
                }
            });
        }  
    };
    
}
Configuration(function(ContextRegister) {
    ContextRegister.register('cdp00500_etapa_de_producao_Controller', cdp00500_etapa_de_producao_Controller);
});

// FILE: ./assets/modules/producao/assets/js/controllers/cdp00600_TipoDeDocumento_Controller.js
function cdp00600_TipoDeDocumento_Controller(ZHPromise, templateManager, restEngine, General, ScreenService){
    /**
     * Função disparada após o filtro ser aplicado, que reseta os valores de 
     * aplicação, para q ao filtrar por nenhum valor, todos sejam carregados.
     */
    this.validaFiltro = function(widget){
        widget.filterApplied = [];
        widget.__filterPopup.currentRow = {};
        widget.reload();
    };
}
Configuration(function(ContextRegister){
    ContextRegister.register('cdp00600_TipoDeDocumento_Controller', cdp00600_TipoDeDocumento_Controller);
});

// FILE: ./assets/modules/producao/assets/js/controllers/cdp01000_lote_de_producao_Controller.js
function cdp01000_lote_de_producao_Controller(General, templateManager, ScreenService, cdp01000_lote_de_producao_Service) {
    
    var cdProdutoInicial = {};
    var cdProdutoFinal = {};
    var nrLoteInicial = {};
    var nrLoteFinal = {};
    
    this.verificaActions = function(widget){
        //Sitação Pendente
        if(widget.currentRow.IDSTPRODLOTE === "1" ){
            if(widget.currentRow.NMOPERLIB === ""){
                widget.actions[2].isVisible = false;
            }
            widget.actions[1].isVisible = false;
            widget.reload();
        }
        
        //Sitação Em Produção
        else if(widget.currentRow.IDSTPRODLOTE === "2" ){
            widget.actions[2].isVisible = false;
            templateManager.container.getWidget('RastreamentoLoteEmProducao').isVisible = true;
            templateManager.container.getWidget('RastreamentoLoteEmProducao').reload();
            templateManager.container.getWidget('RastreamentoLoteProduzido').isVisible = false;
            templateManager.container.getWidget('RastreamentoLoteProduzido').reload();
            widget.reload();
        }
        
        //Sitação Em Analise
        else if(widget.currentRow.IDSTPRODLOTE === "3" ){
            widget.actions[2].isVisible = false;
            widget.reload();
        }
        
        //Sitação Cancelado
        else if(widget.currentRow.IDSTPRODLOTE === "4" ){
            if(widget.currentRow.NMOPERLIB === ""){
                widget.actions[2].isVisible = false;
            }
            widget.actions[1].isVisible = false;
            widget.reload();
        }
        
        //Sitação Produzido
        else if(widget.currentRow.IDSTPRODLOTE === "5" ){
            widget.actions[2].isVisible = false;
            templateManager.container.getWidget('RastreamentoLoteProduzido').isVisible = true;
            templateManager.container.getWidget('RastreamentoLoteProduzido').reload();
            templateManager.container.getWidget('RastreamentoLoteEmProducao').isVisible = false;
            templateManager.container.getWidget('RastreamentoLoteEmProducao').reload();
            widget.reload();
        }
        
        //Sitação null
        else if(widget.currentRow.IDSTPRODLOTE === "" ){
            widget.actions[2].isVisible = false;
            widget.reload();
        }
    };
    
    this.filtroFix = function(widget){
        
        var filtro = templateManager.container.getWidget('lote_de_producao').dataSourceFilter;
        
        var indexToRemoveValiLote = filtro.findIndex(function(elemento){
            return elemento.name === "DTVALILOTE";
        });
        filtro.splice(indexToRemoveValiLote,1);
    
        var indexToRemoveLibeLote = filtro.findIndex(function(elemento){
            return elemento.name == "DTPRELIBLOTE";
        });
        filtro.splice(indexToRemoveLibeLote,1);

    };
    
    this.filtroDataValidade = function(widget){
         
        var dtInicial = templateManager.container.getWidget('lote_de_producao').dataSourceFilter.filter(function(data){
             return data.name == "P_DTINVAL";
        });
         
        var dtFinal = templateManager.container.getWidget('lote_de_producao').dataSourceFilter.filter(function(data){
             return data.name == "P_DTFIVAL";
        });
         
        var dtTotal = templateManager.container.getWidget('lote_de_producao').dataSourceFilter.filter(function(data){
             return data.name == "P_TDTVAL";
        });
             
        if(widget.owner.field.intervalWidget){
            
            dtInicial[0].value = widget.owner.field.intervalWidget.intervalData.start; 
            dtFinal[0].value = widget.owner.field.intervalWidget.intervalData.end;
            dtTotal[0].value ="";
            ScreenService.closePopup();
             
        } else{
             
             dtInicial[0].value = ""; 
             dtFinal[0].value = "";
             dtTotal[0].value ="T";
             templateManager.container.getWidget('lote_de_producao').reload();
        }
         
    };
    
    this.filtroDataPrevisao = function(widget){
         
        var dtInicial = templateManager.container.getWidget('lote_de_producao').dataSourceFilter.filter(function(data){
             return data.name == "P_DTINCON";
        });
         
        var dtFinal = templateManager.container.getWidget('lote_de_producao').dataSourceFilter.filter(function(data){
             return data.name == "P_DTFICON";
        });
         
        var dtTotal = templateManager.container.getWidget('lote_de_producao').dataSourceFilter.filter(function(data){
             return data.name == "P_TDTPRE";
        });
             
        if(widget.owner.field.intervalWidget){
            
            dtInicial[0].value = widget.owner.field.intervalWidget.intervalData.start; 
            dtFinal[0].value = widget.owner.field.intervalWidget.intervalData.end;
            dtTotal[0].value ="";
            ScreenService.closePopup();
             
        } else{
             
             dtInicial[0].value = ""; 
             dtFinal[0].value = "";
             dtTotal[0].value ="T";
             templateManager.container.getWidget('lote_de_producao').reload();
        }
         
    };
    
    this.prodIni = function(widget){
        
        cdProdutoInicial = widget.row.P_CDARVPRODDE;
        
        if((cdProdutoInicial) && (cdProdutoFinal)){

            if(cdProdutoInicial > cdProdutoFinal){
                ScreenService.showMessage("O codigo do produto inicial não pode ser maior que do final");
                widget.row.CDPRODUTOINI = "";
                widget.row.NMPRODUTOINI = "";
                widget.row.CDPRODUTOFIN = "";
                widget.row.NMPRODUTOFIN = "";
                return 0;
            }
        }
        
    };

    this.prodFin = function(widget){
    
        cdProdutoFinal = widget.row.P_CDARVPRODATE;
        
        if((cdProdutoInicial) && (cdProdutoFinal)){

            if(cdProdutoInicial > cdProdutoFinal){
                ScreenService.showMessage("O codigo do produto inicial não pode ser maior que do final");
                widget.row.P_CDARVPRODATE = "";
                widget.row.NMPRODUTOFIN = "";
                return 0;
            }
        } else if (cdProdutoInicial.length){
                widget.row.P_CDARVPRODATE = "";
                widget.row.NMPRODUTOFIN = "";
        }
    };

    this.loteIni = function(widget){
        
        nrLoteInicial = widget.row.P_LOTEINI;
        
        if((nrLoteInicial) && (nrLoteFinal)){

            if(nrLoteInicial > nrLoteFinal){
                ScreenService.showMessage("O codigo do lote inicial não pode ser maior que do final");
                widget.row.P_LOTEINI = "";
                widget.row.P_LOTEFIM = "";
                return 0;
            }
        }
        
    };
    
    this.loteFim = function(widget){
        
        nrLoteFinal = widget.row.P_LOTEFIM;
        
        if((nrLoteInicial) && (nrLoteFinal)){

            if(nrLoteInicial > nrLoteFinal){
                ScreenService.showMessage("O codigo do lote inicial não pode ser maior que do final");
                widget.row.P_LOTEFIM = "";
                return 0;
            }
        }
        
    };
    
    this.filtroRastreamento = function(widget){
         
        var cdFilialLote; 
        var cdFilialPrioridade;
        var nrLote;
         
        if(widget.currentRow.IDSTPRODLOTE === "2" ){
            
            cdFilialLote = templateManager.container.getWidget('RastreamentoLoteEmProducao').dataSourceFilter.filter(function(data){
                 return data.name == "P_CDFILIAL";
            });
             
            cdFilialPrioridade = templateManager.container.getWidget('PrioridadeWidgetEmProducao').dataSourceFilter.filter(function(data){
                 return data.name == "P_CDFILIAL";
            });
             
            nrLote = templateManager.container.getWidget('RastreamentoLoteEmProducao').dataSourceFilter.filter(function(data){
                 return data.name == "P_NRLOTEESTQ";
            });
             
            cdFilialLote[0].value = widget.currentRow.CDFILIAL; 
            cdFilialPrioridade[0].value = widget.currentRow.CDFILIAL; 
            nrLote[0].value = widget.currentRow.NRLOTEESTQ;
            
            templateManager.container.getWidget('RastreamentoLoteEmProducao').reload();
        
        } else if(widget.currentRow.IDSTPRODLOTE === "5" ){
            
            cdFilialLote = templateManager.container.getWidget('RastreamentoLoteProduzido').dataSourceFilter.filter(function(data){
                 return data.name == "P_CDFILIAL";
            });
             
            cdFilialPrioridade = templateManager.container.getWidget('PrioridadeWidgetProduzido').dataSourceFilter.filter(function(data){
                 return data.name == "P_CDFILIAL";
            });
            
            var cdFilialAnalise = templateManager.container.getWidget('ANALINSPEC').dataSourceFilter.filter(function(data){
                 return data.name == "P_CDFILIAL";
            });
            
            var cdFilialAnaliseAtiv = templateManager.container.getWidget('ANALINSPEC_ATIV').dataSourceFilter.filter(function(data){
                 return data.name == "P_CDFILIAL";
            });
            
            var cdFilialInfoMatPri = templateManager.container.getWidget('InfoMatPrimaInsu').dataSourceFilter.filter(function(data){
                 return data.name == "P_CDFILIAL";
            });
            
            var cdFilialInfoMatPriFilha = templateManager.container.getWidget('InfoMatPrimaInsuFilha').dataSourceFilter.filter(function(data){
                 return data.name == "P_CDFILIAL";
            });
            
            nrLote = templateManager.container.getWidget('RastreamentoLoteProduzido').dataSourceFilter.filter(function(data){
                 return data.name == "P_NRLOTEESTQ";
            });
            
            var nrLoteInfoMatPri = templateManager.container.getWidget('InfoMatPrimaInsu').dataSourceFilter.filter(function(data){
                 return data.name == "P_NRLOTEESTQ";
            });
            
            var nrSubLote = templateManager.container.getWidget('InfoMatPrimaInsu').dataSourceFilter.filter(function(data){
                 return data.name == "P_NRSUBLOTE";
            });
            
            var cdProdInfo = templateManager.container.getWidget('InfoMatPrimaInsu').dataSourceFilter.filter(function(data){
                 return data.name == "P_CDPRODUTO";
            });
             
            cdFilialLote[0].value = widget.currentRow.CDFILIAL; 
            cdFilialPrioridade[0].value = widget.currentRow.CDFILIAL; 
            cdFilialAnalise[0].value = widget.currentRow.CDFILIAL;
            cdFilialAnaliseAtiv[0].value = widget.currentRow.CDFILIAL;
            cdFilialInfoMatPri[0].value = widget.currentRow.CDFILIAL;
            cdFilialInfoMatPriFilha[0].value = widget.currentRow.CDFILIAL;
            nrLote[0].value = widget.currentRow.NRLOTEESTQ;
            nrLoteInfoMatPri[0].value = widget.currentRow.NRLOTEESTQ;
            nrSubLote[0].value = widget.currentRow.NRSUBLOTE;
            cdProdInfo[0].value = widget.currentRow.CDPRODUTO;
            
            templateManager.container.getWidget('RastreamentoLoteProduzido').reload();
        }

    };
    
    this.filtroRastreamentoPrioridade = function(widget){
        
        if(widget.parent.currentRow.IDSTPRODLOTE === "2" ){
            
            var nrOrdemProducao = templateManager.container.getWidget('PrioridadeWidgetEmProducao').dataSourceFilter.filter(function(data){
                 return data.name == "P_NRORDPROD";
            });
            
            var nrSubOrdemProduto = templateManager.container.getWidget('PrioridadeWidgetEmProducao').dataSourceFilter.filter(function(data){
                 return data.name == "P_NRSUBORDPROD";
            });
            
            
            nrOrdemProducao[0].value = widget.currentRow.NRORDPROD;
            nrSubOrdemProduto[0].value = widget.currentRow.NRSUBORDPROD;
            
            templateManager.container.getWidget('PrioridadeWidgetEmProducao').reload();

        } else if(widget.parent.currentRow.IDSTPRODLOTE === "5" ){
            
            var nrOrdemProducaoProduzido = templateManager.container.getWidget('PrioridadeWidgetProduzido').dataSourceFilter.filter(function(data){
                 return data.name == "P_NRORDPROD";
            });
            
            var nrSubOrdemProdutoProduzido = templateManager.container.getWidget('PrioridadeWidgetProduzido').dataSourceFilter.filter(function(data){
                 return data.name == "P_NRSUBORDPROD";
            });
            
            var nrOrdemProducaoEquip = templateManager.container.getWidget('InsumosEquip').dataSourceFilter.filter(function(data){
                 return data.name == "P_NRORDPROD";
            });
            
            var nrSubOrdemProdutoEquip = templateManager.container.getWidget('InsumosEquip').dataSourceFilter.filter(function(data){
                 return data.name == "P_NRSUBORDPROD";
            });
            
            var nrOrdemProducaoRecur = templateManager.container.getWidget('InsumosRecurso').dataSourceFilter.filter(function(data){
                 return data.name == "P_NRORDPROD";
            });
            
            var nrSubOrdemProdutoRecur = templateManager.container.getWidget('InsumosRecurso').dataSourceFilter.filter(function(data){
                 return data.name == "P_NRSUBORDPROD";
            });
            
            var nrOrdemProducaoAnalise = templateManager.container.getWidget('ANALINSPEC').dataSourceFilter.filter(function(data){
                 return data.name == "P_NRORDPROD";
            });
            
            var nrSubOrdemProdutoAnalise = templateManager.container.getWidget('ANALINSPEC').dataSourceFilter.filter(function(data){
                 return data.name == "P_NRSUBORDPROD";
            });
            
            var nrLoteProducaoOriginado = templateManager.container.getWidget('PRODORIGIN').dataSourceFilter.filter(function(data){
                 return data.name == "P_NRLOTEESTQ";
            });
            
            var cdProdutoOriginado = templateManager.container.getWidget('PRODORIGIN').dataSourceFilter.filter(function(data){
                 return data.name == "P_CDPRODUTO";
            });
            
            nrOrdemProducaoProduzido[0].value = widget.currentRow.NRORDPROD;
            nrSubOrdemProdutoProduzido[0].value = widget.currentRow.NRSUBORDPROD;
            nrOrdemProducaoEquip[0].value = widget.currentRow.NRORDPROD;
            nrSubOrdemProdutoEquip[0].value = widget.currentRow.NRSUBORDPROD;
            nrOrdemProducaoRecur[0].value = widget.currentRow.NRORDPROD;
            nrSubOrdemProdutoRecur[0].value = widget.currentRow.NRSUBORDPROD;
            nrOrdemProducaoAnalise[0].value = widget.currentRow.NRORDPROD;
            nrSubOrdemProdutoAnalise[0].value = widget.currentRow.NRSUBORDPROD;
            nrLoteProducaoOriginado[0].value = widget.currentRow.NRLOTEESTQ;
            cdProdutoOriginado[0].value = widget.currentRow.CDPRODUTO;
            
            templateManager.container.getWidget('PrioridadeWidgetProduzido').reload();
            templateManager.container.getWidget('InsumosEquip').reload();
            templateManager.container.getWidget('InsumosRecurso').reload();
            templateManager.container.getWidget('ANALINSPEC').reload();
            templateManager.container.getWidget('PRODORIGIN').reload();

        }
        
    };
    
    this.filtroRastreamentoAnalise = function(widget){
        
        var nrAuditoria = templateManager.container.getWidget('ANALINSPEC_ATIV').dataSourceFilter.filter(function(data){
             return data.name == "P_NRAUDITORIA";
        });
        
        var nrInspecAudi = templateManager.container.getWidget('ANALINSPEC_ATIV').dataSourceFilter.filter(function(data){
             return data.name == "P_NRINSPECAUDI";
        });
        
        nrAuditoria[0].value = widget.currentRow.NRAUDITORIA;
        nrInspecAudi[0].value = widget.currentRow.NRINSPECAUDI;
        
        templateManager.container.getWidget('ANALINSPEC_ATIV').reload();
        
    };
    
    this.filtroRastreamentoInfoMat = function(widget){
        
        var nrLancNotaFiscal = templateManager.container.getWidget('InfoMatPrimaInsuFilha').dataSourceFilter.filter(function(data){
             return data.name == "P_NRLANCTONF";
        });
        
        nrLancNotaFiscal[0].value = widget.currentRow.NRLANCTONF;
        
        templateManager.container.getWidget('InfoMatPrimaInsuFilha').reload();
        
    };
    
    this.gerarLote = function(){
        
    };
    
    this.liberarLote = function(widget){
        
        ScreenService.closePopup();
        
        cdp01000_lote_de_producao_Service.retornaOperadorLogado().then(function(operadorLogado){
            
            widget.widgets[2].currentRow.CDOPERADOR =  operadorLogado[0].CDOPERADOR;
            
            widget.widgets[2].currentRow.NMOPERADOR =  operadorLogado[0].NMOPERADOR;
            
            widget.widgets[2].currentRow.DTATUAL = moment().format("DD-MM-YYYY hh:mm:ss");
        
            widget.widgets[2].reload();
            
            ScreenService.openPopup(widget.widgets[2]);
        
        });
        
    };
    
    this.liberarLoteConfirma = function(widget){
        
        cdp01000_lote_de_producao_Service.liberaLote(widget.parent.currentRow).then(
            function(Success) {
                ScreenService.closeSwipe().then(function () {
                    widget.activate();
                });
                widget.reload();
            },
            function(error){
                if (error.data && error.data.error.indexOf('ORA-02292') !== -1) {
                    ScreenService.showMessage('Exclusão não permitida! O registro possui registros filhos.');
                } else {
                    ScreenService.showMessage(error.message);
                }
            }
        );
        
    };
    
    this.liberarLoteCancela = function(widget){
        ScreenService.closePopup();
        ScreenService.goBack();

    };
    
    this.cancelarLote = function(){
        
    };
    
}

Configuration(function(ContextRegister){
    ContextRegister.register('cdp01000_lote_de_producao_Controller', cdp01000_lote_de_producao_Controller);
});










// FILE: ./assets/modules/producao/assets/js/controllers/cdp01300_ocorrencia_da_producaoController.js
function cdp01300_ocorrencia_da_producaoController (ZHPromise, templateManager, restEngine, General, ScreenService, cdp01300_ocorrencia_da_producaoService){
    
    this.newGrupo = function(widget){
        widget.newRow();
        widget.widgets[0].enabled = false;
    };
    
    this.saveGrupo = function(widget){
        widget.widgets[0].enabled = true;
        General.saveCrud(widget);
    };
    
    this.editGrupo = function(widget){
        widget.widgets[0].enabled = false;
        General.edit(widget);
    };
    
    this.CancelGrupo = function(widget){
        widget.widgets[0].enabled = true;
    };
    
    this.deleteGrupo = function(widget){
        
       ScreenService.confirmMessage(ScreenService.i18n('Delete Register?'), 'question', function (success) {
    
            cdp01300_ocorrencia_da_producaoService.deletarGrupo(widget.currentRow).then(
                function(Success) {
                    ScreenService.closeSwipe().then(function () {
                        widget.activate();
                    });
                    widget.reload();
                },
                function(error){
                    if (error.data && error.data.error.indexOf('ORA-02292') !== -1) {
                        ScreenService.showMessage('Exclusão não permitida! O registro possui registros filhos.');
                    } else {
                        ScreenService.showMessage(error.message);
                    }
                }
            );
        });
    };
    
    this.saveComplete = function(widget){
        widget.currentRow.CDGRPOCOR = widget.parent.currentRow.CDGRPOCOR;
        General.saveCrud(widget);
    };
    
}
Configuration(function(ContextRegister) {
    ContextRegister.register('cdp01300_ocorrencia_da_producaoController', cdp01300_ocorrencia_da_producaoController);
});

// FILE: ./assets/modules/producao/assets/js/controllers/cdp01500_parametros_mrp_Controller.js
function cdp01500_parametros_mrp_Controller(templateManager, restEngine, General, ScreenService, cdp01500_parametros_mrp_Service){
    
    this.editar = function(widget){
        var filial = widget.currentRow.CDFILIAL;
        
        if(filial == null) {
        	widget.currentRow.__is_new = true;
        	widget.currentRow.CDFILIAL = widget.__filterPopup.getField('CDFILIAL').value();
        }
        
        General.edit(widget);
    };
    
    this.achaMaxNivelProduto = function(widget){
        var maxNivel;
        
        cdp01500_parametros_mrp_Service.achaMaxNivelProduto().then(function(nv){
            maxNivel = nv.dataset.maxNvProduto[0].MAXNVPROD;
            widget.__filterPopup.getField('NMPRODUTO').dataSourceFilter[0].value = maxNivel;
        });
    };
    
    this.salvaParamMrp = function(widget){
    	var msg;
    	
    	if(widget.isValid()){
    		if(widget.currentRow.HRENTRPROD != null){
    			widget.currentRow.HRENTRPROD = widget.currentRow.HRENTRPROD.replace(/[^0-9]+/g, '');
    		}
    		widget.saveRow().then(
    			function success(success) {
    				widget.reload().then(function(){
	    				ScreenService.closeSwipe();
						ScreenService.successNotification(ScreenService.i18n('Item salvo com sucesso'));
    				});
				},
				function error(error) {
					if (error.data) {
						msg = ScreenService.i18n(error.data.error);
						ScreenService.showMessage(msg);
					} else {
						msg = ScreenService.i18n("Verifique sua conexão e tente novamente");
						ScreenService.showMessage(msg);
					}
				}
    		);
    	}
    };
    
    this.salvaMaisParams = function(widget){
    	var widgetPrincipal = templateManager.container.getWidget('ParametrosMrpWidget');
    	var contS = 0, contF = 0;
    	var msg = 'Deseja modificar os itens selecionados?', linhasSelecionadas = [];
    	var inicial = widget.currentRow.INICIAL-1, final = widget.currentRow.FINAL;
    	var backToMain = this.voltaAoPrincipal;
    	
    	for(var i = inicial; i < final ; i++){
    		linhasSelecionadas.push(widgetPrincipal.dataSource.data[i]);
    	}
    	
    	if(widget.isValid()){
    		ScreenService.confirmMessage(msg, 'INFORMATION', function(){
	    		linhasSelecionadas.forEach(function(linha){
	    			if(linha.CDFILIAL == null) linha.__is_new = true;
	    			
	    			if(widget.currentRow.HRENTRPROD != null){
	    				linha.HRENTRPROD = widget.currentRow.HRENTRPROD.replace(/[^0-9]+/g, '');
	    			}else{
	    				linha.HRENTRPROD = widget.currentRow.HRENTRPROD;
	    			}
	    			linha.CDFILIAL = widget.currentRow.CDFILIAL;
	    			linha.CDPERIPRODU = widget.currentRow.CDPERIPRODU;
	    			linha.QTHRSEGPROD = widget.currentRow.QTHRSEGPROD;
	    			linha.IDAPLICHRSEG = widget.currentRow.IDAPLICHRSEG;
	    			linha.IDGERAOPCONF = widget.currentRow.IDGERAOPCONF;
	    			cdp01500_parametros_mrp_Service.salvaParametroMrp(linha).then(
	    				function success(success){
	    					contS++;
	    					if((contS + contF) == linhasSelecionadas.length){
	    						ScreenService.successNotification(ScreenService.i18n(contS + ' item(s) modificado(s) com sucesso'));
	    						backToMain();
	    					}
	    				},
	    			    function error(error){
	    			    	contF++;
							if (error.data) {
								msg = ScreenService.i18n(error.data.error);
								ScreenService.showMessage(msg);
							} else {
								msg = ScreenService.i18n("Verifique sua conexão e tente novamente");
								ScreenService.showMessage(msg);
							}
	    			    }
	    			);
	    		});
    		});
    	}
    	
    };
    
    this.editaMais = function(widget){
    	templateManager.container.getWidget('MultiParametrosWidget').isVisible = true;
    	this.currentRowConstructor(widget);
    	ScreenService.openPopup(widget.widgets[0]);
    };
    
    this.currentRowConstructor = function(widgetPrincipal){
    	var multiParametros = templateManager.container.getWidget('MultiParametrosWidget');
    	
    	multiParametros.currentRow.CDFILIAL = widgetPrincipal.__filterPopup.getField('CDFILIAL').value();
    	multiParametros.currentRow.CDPERIPRODU = null;
    	multiParametros.currentRow.HRENTRPROD = null;
    	multiParametros.currentRow.QTHRSEGPROD = null;
    	multiParametros.currentRow.IDAPLICHRSEG = null;
    	multiParametros.currentRow.IDGERAOPCONF = null;
    };
    
    this.excluiParam = function(widget){
        var msg1 = 'Deseja remover este item?';
        var msg2 = 'Deseja remover os itens selecionados?'; 
        var itensRemovidos = 0;
        
        if(widget.getCheckedRows().length == 0){
            ScreenService.confirmMessage(msg1, 'question', function () {
				
				if(widget.currentRow.CDFILIAL == null){
					return ScreenService.showMessage('Não foi possível realizar a remoção, item selecionado não está registrado nos parâmetros para MRP.');
				}else{
					widget.removeRow().then(
						function success(argument) {
							ScreenService.closeSwipe().then(function(){
								widget.reload(); 	
							});
							return ScreenService.successNotification(ScreenService.i18n('Item excluído com sucesso'));
						},
						function error(error) {
							var msg;
							if (error.data && error.data.error.indexOf('ORA-02292') !== -1) {
								msg = ScreenService.i18n('Exclusão não permitida. As informações da tabela são utilizadas em outras tabelas!');
								ScreenService.showMessage(msg);
							} else if (error.data) {
								msg = ScreenService.i18n(error.data.error);
								ScreenService.showMessage(msg);
							} else {
								msg = ScreenService.i18n("Verifique sua conexão e tente novamente");
								ScreenService.showMessage(msg);
							}
						}
					);	
				}
				
			});
			
        }else{//por enquanto inutil
            var linhasSelecionadas = widget.getCheckedRows();
            
            linhasSelecionadas.forEach(function(linha){
            	if(linha.CDFILIAL != null) itensRemovidos++;
            });
            
            ScreenService.confirmMessage(msg2, 'question', function () {
				widget.removeCheckedRows().then(
					function success(argument) {
						ScreenService.closeSwipe().then(function(){
							widget.reload(); 	
						});
						return ScreenService.successNotification(ScreenService.i18n(itensRemovidos + ' itens excluídos com sucesso'));
					},
					function error(error) {
						var msg;
						if (error.data && error.data.error.indexOf('ORA-02292') !== -1) {
							msg = ScreenService.i18n('Exclusão não permitida. As informações da tabela são utilizadas em outras tabelas!');
							ScreenService.showMessage(msg);
						} else if (error.data) {
							msg = ScreenService.i18n(error.data.error);
							ScreenService.showMessage(msg);
						} else {
							msg = ScreenService.i18n("Verifique sua conexão e tente novamente");
							ScreenService.showMessage(msg);
						}
					}
				);
			});
			
        }
    };
    
    this.voltaAoPrincipal = function(){
    	templateManager.container.getWidget('MultiParametrosWidget').currentRow = [];
    	templateManager.container.getWidget('MultiParametrosWidget').getField('CDARVPRODFIN').readOnly = true;
    	ScreenService.closePopup();
		templateManager.container.getWidget('ParametrosMrpWidget').reload();
		templateManager.container.getWidget('ParametrosMrpWidget').unSelectAll();
    	templateManager.container.getWidget('MultiParametrosWidget').isVisible = false;
    };
    
	this.filtroChanger = function(widget){
		//revela cadastramento automatico depois de aplicar filtro	
		templateManager.container.getWidget('ParametrosMrpWidget').actions[4].isVisible = true;
		
    	templateManager.container.getWidget('ParametrosMrpWidget').dataSourceFilter = 
			[
				{
                    "name": "P_CDFILIAL",
                    "operator": "=",
                    "value": widget.getField('CDFILIAL').value()
                }
			];
			
		widget.fields.forEach(function(field){
			if(field.value() != undefined && field.value() != "" && field.value() != null && field.name != 'CDFILIAL' && field.name != 'SEARCHLIST__ALL'){
				templateManager.container.getWidget('ParametrosMrpWidget').dataSourceFilter.push(
					{
						"name": field.name,
	                    "operator": "=",
                    	"value": widget.getField(field.name).value()
					}
				);
			}	
		});
	};
	
	this.validaProdutoAte = function(widget){
		var produtoFinal = widget.getField('CDARVPRODFIN');
		var produtoInicial_isSelected = !!widget.currentRow.CDARVPRODINI;
		
		if(produtoInicial_isSelected){
			produtoFinal.validations.required = true;
		}else{
			delete(produtoFinal.validations.required);
			widget.getField('NMPRODFIN').setValue('');
		}
		
		produtoFinal.readOnly = !produtoInicial_isSelected;
		produtoFinal.setValue(null);
		produtoFinal.needReload = true;
	};
	
	this.prodFinal = function(widget){
		var limite = widget.currentRow.INICIAL;
		var arrayProdFinal = widget.getField('CDARVPRODFIN').dataSource.data;

		arrayProdFinal.splice(0, limite-1);//pegar o produto inicial(incluso) em diante
	};
}

Configuration(function(ContextRegister) {
    ContextRegister.register('cdp01500_parametros_mrp_Controller', cdp01500_parametros_mrp_Controller);
});

// FILE: ./assets/modules/producao/assets/js/controllers/cdp01600_LoteDeMateriaPrimaInsumos_Controller.js
function cdp01600_LoteDeMateriaPrimaInsumos_Controller(ZHPromise, templateManager, restEngine, General, ScreenService)
{
    /**
     * Essa função valida o ReadOnly do field 'Lote__Até', sendo que esse campo 
     * só deve ser editado quando no field 'Lote__De' tiver algum vlr preenchido.
     * Também reseta qualquer valor previamente preenchido e copia dataSource de 
     * 'NRLOTEESTQ_DE' para 'NRLOTEESTQ_ATE'.
     */
    this.valida_LoteAte = function(widget) {
        var popup = widget.__filterPopup;
        // Variável booleana que é setada como true caso alguma empresa tenha sido selecionada.
        var lote__De_IsSelected = !!popup.currentRow.NRLOTEESTQ_DE;
        var loteAteField = popup.getField('NRLOTEESTQ_ATE');
        // Altera as propriedades do field 'Lote__Ate' e reseta seu valor.
        if(lote__De_IsSelected)
            loteAteField.validations.required = lote__De_IsSelected;
        else
            delete(loteAteField.validations.required);
        loteAteField.readOnly = !lote__De_IsSelected;
        loteAteField.setValue(null);
        loteAteField.needReload = true;
        limitaIntervalo(popup, 'NRLOTEESTQ');
    };

    /**
     * Essa função valida o ReadOnly do field 'Lote__Até', sendo que esse campo 
     * só deve ser editado quando no field 'Lote__De' tiver algum vlr preenchido.
     * Também reseta qualquer valor previamente preenchido e copia dataSource de 
     * 'NRLOTEESTQ_DE' para 'NRLOTEESTQ_ATE'.
     */
    this.valida_ProdutoAte = function(widget) {
        var popup = widget.__filterPopup;
        // Variável booleana que é setada como true caso alguma empresa tenha sido selecionada.
        var produto__De_IsSelected = !!popup.currentRow.CDARVPROD_DE;
        
        var produtoAteField = popup.getField('CDARVPROD_ATE');

        // Altera as propriedades do field 'Lote__Ate' e reseta seu valor.
        if(produto__De_IsSelected)
            produtoAteField.validations.required = produto__De_IsSelected;
        else
            delete(produtoAteField.validations.required);
        produtoAteField.readOnly = !produto__De_IsSelected;
        produtoAteField.setValue(null);
        produtoAteField.needReload = true;
        limitaIntervalo(popup, 'CDARVPROD' );
    };    

    /**
     * Função auxiliar que valida o limite de valores do field 'Lote__Até'. Esse limite é o
     * num. de lote do field 'Lote__De'.
     */
    var limitaIntervalo = function(popup, field){
        var limite;
        if(field == 'NRLOTEESTQ'){
            var nrloteestq_de = popup.getField('NRLOTEESTQ_DE');
            var nrloteestq_ate = popup.getField('NRLOTEESTQ_ATE');
            // Para economizar uma requisição, o dataSource do field 'NRLOTEESTQ_DE' é
            // atribuído para o field 'NRLOTEESTQ_ATE'
            angular.copy(nrloteestq_de.dataSource.data, nrloteestq_ate.dataSource.data);
            nrloteestq_ate.dataSource.data.forEach(function(obj){
                if(obj.NRLOTEESTQ == popup.currentRow.NRLOTEESTQ_DE){
                    // é atribuído à 'cont' o índice do .data do valor referente ao 'NRLOTEESTQ_DE'
                    // escolhido
                    limite = obj.ROWNUM;
                }
            });
            // É usado o splice, para retirar todos os elementos do .data do field 
            // 'NRLOTEESTQ_ATE' cujos índices é menor ou igual que o escolhido para o 
            // 'NRLOTEESTQ_DE'
            nrloteestq_ate.dataSource.data.splice(0, (limite));
        }else{
            // Abaixo é feita a mesma validação de quando a condição é verdadeira
            var cdarvprod_de = popup.getField('CDARVPROD_DE');
            var cdarvprod_ate = popup.getField('CDARVPROD_ATE');
            angular.copy(cdarvprod_de.dataSource.data, cdarvprod_ate.dataSource.data);
            cdarvprod_ate.dataSource.data.forEach(function(obj){
                if(obj.CDARVPROD == popup.currentRow.CDARVPROD_DE){
                    limite = obj.ROWNUM;
                }
            });
            cdarvprod_ate.dataSource.data.splice(0, (limite));
        }
    };
    /**
     * Função, disparada depois do filtro ser aplicado, que monta o dataSourceFilter
     * com os intervalos de 'NRLOTEESTQ' e 'CDARVPROD'
     */
    this.validaFiltro = function(widget){
        var popup = widget.__filterPopup;
        var dataSourceFilter = widget.dataSourceFilter;
        // Variáveis para NRLOTEESTQ
        var dadosFieldLoteAte = popup.getField('NRLOTEESTQ_ATE').dataSource.data;
        var dadosFieldProdutoAte = popup.getField('CDARVPROD_ATE').dataSource.data;
        // Variáveis para CDARVPROD
        var nrloteestq_ate = popup.currentRow.NRLOTEESTQ_ATE;
        var cdarvprod_ate = popup.currentRow.CDARVPROD_ATE;
        // Se existir na currentRow valor de 'NRLOTEESTQ_ATE' e/ou 'CDARVPROD_ATE', 
        // significa que se deve montar o filtro, caso o contrário, não se deve montar
        if(nrloteestq_ate)
            montaFiltroLote(dadosFieldLoteAte, nrloteestq_ate, dataSourceFilter);
        if(cdarvprod_ate)
            montaFiltroProduto(dadosFieldProdutoAte, cdarvprod_ate, dataSourceFilter);
    };
    
    /**
     * Função auxiliar, invocada para montar o filtro de Lote
     */
    var montaFiltroLote = function(dadosFieldLoteAte, nrloteestq_ate, dataSourceFilter){
        var logico = true, cont = 0, destrutor;
        var nrloteestq = [];
        // É percorrido o dataSource, e preenchido o intervalo selecionado 
        // à variável nrloteestq
        dadosFieldLoteAte.forEach(function(obj){
            if((obj.NRLOTEESTQ != nrloteestq_ate) && logico)
                nrloteestq.push(obj.NRLOTEESTQ);
            if(obj.NRLOTEESTQ == nrloteestq_ate){
                logico = false;
            }
        });
        // É adicionado à variável 'nrloteestq' o vlr escolhido no field 'NRLOTEESTQ_ATE'
        nrloteestq.push(nrloteestq_ate);
        // É percorrido o array dataSourceFilter, para excluir o índice referente a
        // 'NRLOTEESTQ_DE', e alterado o 'NRLOTEESTOQUE_ATE', afim de que se 
        // tome o formato de cláusula IN
        dataSourceFilter.forEach(function(obj){
            if(obj.name == 'NRLOTEESTQ_DE'){
                destrutor = cont;
            }
            if(obj.name == 'NRLOTEESTQ_ATE'){
                obj.name = 'NRLOTEESTQ';
                obj.operator = 'IN';
                obj.value = nrloteestq;
            }
            cont++;
        });
        dataSourceFilter.splice(destrutor, 1);
    };
    
    /**
     * Função auxiliar, invocada para montar o filtro de Produto. Dispensa comentários
     * no escopo, porque realiza o mesmo que 'montaFiltroLote', com excessão que é para
     * produto
     */
    var montaFiltroProduto = function(dadosFieldProdutoAte, cdarvprod_ate, dataSourceFilter){
        var logico = true, cont = 0, destrutor;
        var cdarvprod = [];
        dadosFieldProdutoAte.forEach(function(obj){
            if((obj.CDARVPROD != cdarvprod_ate) && logico)
                cdarvprod.push(obj.CDARVPROD);
            if(obj.CDARVPROD == cdarvprod_ate){
                logico = false;
            }
        });
        cdarvprod.push(cdarvprod_ate);
        dataSourceFilter.forEach(function(obj){
            if(obj.name == 'CDARVPROD_DE'){
                destrutor = cont;
            }
            if(obj.name == 'CDARVPROD_ATE'){
                obj.name = 'CDARVPROD';
                obj.operator = 'IN';
                obj.value = cdarvprod;
            }
            cont++;
        });
        dataSourceFilter.splice(destrutor, 1);
    };    
    
    /**
     * Função responsável por definir ReadOnly dos campos de intervalos, cujos 
     * componentes não existem, após a aplicação do filtro
     */
    this.validaReadOnly = function(widget){
        // Aparentemente, duas variáveis para o mesmo Field. Entretanto, isso se deve 
        // porque apenas no field da widget é possível alterar a propriedade ReadOnly,
        // e apenas no field do __filterPopup, é possível alterar o validations
        var nrloteestq_ate = widget.getField('NRLOTEESTQ_ATE');
        var cdarvprod_ate = widget.getField('CDARVPROD_ATE');
        var nrloteestq_ate_filter = widget.__filterPopup.getField('NRLOTEESTQ_ATE');
        var cdarvprod_ate_filter = widget.__filterPopup.getField('CDARVPROD_ATE');
        var dataSourceFilter = widget.dataSourceFilter, presencaLote = false, presencaProduto = false;
        // Percore o vetor de dataSource, a fim de procurar se existe para o campo
        // 'NRLOTEESTQ', e validar a partir disso
        dataSourceFilter.forEach(function(obj){
            if(obj.name == 'NRLOTEESTQ')
                presencaLote = true;
            if(obj.name == 'CDARVPROD')
                presencaProduto = true;
        });
        // Valida dataSourceFilter para field 'NRLOTEESTQ'
        if(presencaLote){
            nrloteestq_ate.readOnly = false;
        }else{
            nrloteestq_ate.readOnly = true;
            delete(nrloteestq_ate_filter.validations.required);
        }
        // Valida dataSourceFilter para field 'CDARVPROD'
        if(presencaProduto){
            cdarvprod_ate.readOnly = false;
        }else{
            cdarvprod_ate.readOnly = true;
            delete(cdarvprod_ate_filter.validations.required);
        }        
    };
}
Configuration(function(ContextRegister){
    ContextRegister.register('cdp01600_LoteDeMateriaPrimaInsumos_Controller', cdp01600_LoteDeMateriaPrimaInsumos_Controller);
});

// FILE: ./assets/modules/producao/assets/js/controllers/cdp01900_consulta_produto_por_materia_primaController.js
function cdp01900_consulta_produto_por_materia_primaController (ZHPromise, templateManager, restEngine, General, ScreenService){
    
    this.deleteConsulta = function(widget){
        var deferred = ZHPromise.defer();
        ScreenService.confirmMessage(ScreenService.i18n('Delete Register?'), 'question', function (success) {
            widget.currentRow.__is_new = false;
        	widget.currentRow.changed = true;
            widget.currentRow.IDMARCADO = "N";
            widget.currentRow.IDRATCUSPROD =  "N";
            widget.currentRow.VRPERCUSMAT = "0";
            General.saveCrud(widget).then(function () {
					widget.activate();
					widget.reload();
					deferred.resolve();
			});
		});
		return deferred.promise;
    };
    
    this.mudaRateio = function() {
        
        var widget = templateManager.container.getActiveWidget();
        
        if((widget.currentRow.IDRATCUSPROD != "N") || (widget.currentRow.VRPERCUSMAT != 0)){
            widget.getField('IDMARCADO').value("S");
        }
        if((widget.currentRow.IDMARCADO == "S") && (widget.currentRow.IDRATCUSPROD == "N") && (widget.currentRow.VRPERCUSMAT == 0)){
            widget.getField('VRPERCUSMAT').value("100");
        } else if((widget.currentRow.IDMARCADO == "S") && (widget.currentRow.IDRATCUSPROD == "S")){
            widget.getField('VRPERCUSMAT').value("0");
        }
        
    };
    
    this.mudaCusto = function() {
        var widget = templateManager.container.getActiveWidget();
        
        if((widget.currentRow.IDRATCUSPROD != "N") || (widget.currentRow.VRPERCUSMAT != 0) ){
            widget.getField('IDMARCADO').value("S");
        }
        if(widget.currentRow.VRPERCUSMAT != "0"){
                widget.getField('IDRATCUSPROD').value("N");
        }
    };
    
    this.saveConsulta = function (widget){
        
        var VRPERCUSMAT = widget.currentRow.VRPERCUSMAT;
        
        if((widget.currentRow.IDMARCADO == "S") && (widget.currentRow.IDRATCUSPROD == "N") && (VRPERCUSMAT == 0)){
            ScreenService.showMessage('Percentual do cálculo do custo do produto acabado em relação ao custo da matéria prima deve ser informado.');
        } else if((VRPERCUSMAT >= 0) && (VRPERCUSMAT <= 100)){
            General.saveCrud(widget);
        }else {
            ScreenService.showMessage('Percentual do cálculo do custo do produto acabado em relação ao custo da matéria prima deve estar entre 0 e 100%');
            widget.getField('VRPERCUSMAT').value("0");
        }
            
    };
    
}
Configuration(function(ContextRegister) {
    ContextRegister.register('cdp01900_consulta_produto_por_materia_primaController', cdp01900_consulta_produto_por_materia_primaController);
});


// FILE: ./assets/modules/producao/assets/js/controllers/cdp02200_grupo_de_equipamentoController.js
function cdp02200_grupo_de_equipamentoController (ZHPromise, templateManager, restEngine, General, ScreenService, cdp02200_grupo_de_equipamentoService){
    
    this.newGrupo = function(widget){
        widget.newRow();
        
        widget.widgets[0].enabled = false;
        widget.getField('CDGRUPOEQUIPA').readOnly= false;
    };
    
    this.saveGrupo = function(widget){
        widget.widgets[0].enabled = true;
        
        General.saveCrud(widget);
    };
    
    this.editGrupo = function(widget){
        widget.widgets[0].enabled = false;
        widget.getField('CDGRUPOEQUIPA').readOnly= true;
       
        General.edit(widget);
    };
    
    this.CancelGrupo = function(widget){
        widget.widgets[0].enabled = true;
    };
    
    this.deleteGrupo = function(widget){
        
       ScreenService.confirmMessage(ScreenService.i18n('Delete Register?'), 'question', function (success) {
    
            cdp02200_grupo_de_equipamentoService.deletarGrupo(widget.currentRow).then(
                function(Success) {
                    ScreenService.closeSwipe().then(function () {
                        widget.activate();
                    });
                    widget.reload();
                },
                function(error){
                    if (error.data && error.data.error.indexOf('ORA-02292') !== -1) {
                        ScreenService.showMessage('Exclusão não permitida! O registro possui registros filhos.');
                    } else {
                        ScreenService.showMessage(error.message);
                    }
                }
            );
        });
    };
    
    this.newEquipamento = function(widget){
        widget.newRow();
    };
    
    this.saveComplete = function(widget){
        widget.currentRow.__is_new = false;
    	widget.currentRow.changed = true;
        widget.currentRow.CDGRUPOEQUIPA = widget.parent.currentRow.CDGRUPOEQUIPA;
        
        cdp02200_grupo_de_equipamentoService.retornaFilial().then(function(filialLogada){
            widget.currentRow.CDFILIAL =  filialLogada[0].CDFILIAL;
        });
        General.saveCrud(widget);
    };
    
    this.editEquipamento = function(widget){
        widget.currentRow.CDGRUPOEQUIPA = null;
        widget.saveRow();
        
        General.edit(widget);
    };
    
    this.deleteEquipamento = function(widget){
        var deferred = ZHPromise.defer();
        ScreenService.confirmMessage(ScreenService.i18n('Delete Register?'), 'question', function (success) {
            widget.currentRow.__is_new = false;
        	widget.currentRow.changed = true;
            widget.currentRow.CDGRUPOEQUIPA = null;
            widget.currentRow.CDFILIAL =  null; 
            General.saveCrud(widget).then(function () {
                ScreenService.closeSwipe().then(function () {
					widget.activate();
					widget.reload();
					deferred.resolve();
				});
			});
		});
		return deferred.promise;
    };
    
}
Configuration(function(ContextRegister) {
    ContextRegister.register('cdp02200_grupo_de_equipamentoController', cdp02200_grupo_de_equipamentoController);
});


// FILE: ./assets/modules/producao/assets/js/controllers/cdp04000_agenda_de_tarefas_Controller.js
function cdp04000_agenda_de_tarefas_Controller (cdp04000_agenda_de_tarefas_Service, ZHPromise, templateManager, restEngine, General, ScreenService){
    
    this.backupRow = {};
    this.CDSETOR = {};
    
    this.newAgenda = function(widget){
        widget.newRow();
        
        widget.widgets[0].enabled = false;
        
        cdp04000_agenda_de_tarefas_Service.retornaFilial().then(function(filialLogada){
            widget.currentRow.CDFILIAL =  filialLogada[0].CDFILIAL;
        });
        
        widget.currentRow.CDSETOR = this.CDSETOR;
        
    };
    
    this.showAdd = function(widget){
        widget.container.getWidget('agenda_de_tarefas').getAction('adicionar').isVisible = true;
    };
    
    this.setFilter = function (widget){
        widget.container.getWidget('agenda_de_tarefas').dataSourceFilter[1].value = widget.currentRow.CDSETOR;
        this.CDSETOR = widget.currentRow.CDSETOR; 
    };
    
    this.saveAgenda = function(widget){
        if (widget.isValid()){
            widget.currentRow.HRAGENTARE = widget.currentRow.HORAAGEN.replace(/[^0-9]+/g, ''); 
            
            /*Crio uma campo para backup para poder compara o campo do tipo atual com o anterior,
            de forma que só é impedido de salvar se já existir uma linha com os mesmos valores*/
            
            var widget_anterior = (widget.currentRow.__is_new == false) ? this.backupRow.IDORIGAGTARE : widget.currentRow.IDORIGAGTARE;
            widget.currentRow.BACKUP = widget_anterior;  
            
            cdp04000_agenda_de_tarefas_Service.salvarAgenda(widget.currentRow).then(
                function(Success) {
                        ScreenService.closeSwipe().then(function () {
                            widget.activate();
                        });
                        widget.reload();
                    },
                    function(callback){
                        if(callback.data){
                            ScreenService.showMessage(callback.data.error);
                        }
                    }
                );
            
            widget.widgets[0].enabled = true;
        }
    };
    
    this.editAgenda = function(widget){
        widget.widgets[0].enabled = false;
        this.backupRow = Util.clone(widget.currentRow); 
        General.edit(widget);
    };
    
    this.CancelAgenda = function(widget){
        widget.widgets[0].enabled = true;
    };
    
    this.deleteAgenda = function(widget){
        
       ScreenService.confirmMessage(ScreenService.i18n('Delete Register?'), 'question', function (success) {
    
            cdp04000_agenda_de_tarefas_Service.deletarAgenda(widget.currentRow).then(
                function(Success) {
                    ScreenService.closeSwipe().then(function () {
                        widget.activate();
                    });
                    widget.reload();
                },
                function(error){
                    if (error.data && error.data.error.indexOf('ORA-02292') !== -1) {
                        ScreenService.showMessage('Exclusão não permitida! O registro possui registros filhos.');
                    } else {
                        ScreenService.showMessage(error.message);
                    }
                }
            );
        });
    };
    
    this.verificaInspecaoVazia = function(args){
        var widget = args.owner.owner.widget;
       cdp04000_agenda_de_tarefas_Service.verificaInspecao(widget.currentRow).then(
            function(Success) {},
                function(callback){
                    if(callback.data){
                        ScreenService.showMessage(callback.data.error);
                        //ScreenService.closeSwipe();
                        ScreenService.closePopup();
                        backOrCancel(args);
                    }
                }
            ); 
        
    };
    
    this.newInspecao = function(widget){
    
        widget.newRow();

        widget.currentRow.NRORG =  widget.parent.currentRow.NRORG;
        widget.currentRow.CDFILIAL =  widget.parent.currentRow.CDFILIAL;
        widget.currentRow.CDSETOR = widget.parent.currentRow.CDSETOR;
        widget.currentRow.CDPERIENTR = widget.parent.currentRow.CDPERIENTR;
        widget.currentRow.HRAGENTARE = widget.parent.currentRow.HRAGENTARE;
        widget.currentRow.IDORIGAGTARE = widget.parent.currentRow.IDORIGAGTARE;
        
    };
    
    function backOrCancel(args) {
		var deferred = ZHPromise.defer();
		if (args.row.__is_new) {
			args.owner.owner.widget.list(true);
			args.owner.owner.widget.dataSource.data.pop();
			args.owner.owner.widget.currentRow = {};
			deferred.resolve();
		} else if (args.owner.owner.widget.mode === 'edit') {
			args.owner.owner.widget.view();
			for (var i in args.owner.owner.widget.backupRow) {
				args.owner.owner.widget.currentRow[i] = args.owner.owner.widget.backupRow[i];
			}
			deferred.resolve();
			return deferred.promise;
		}
		ScreenService.goBack();
		return deferred.promise;
	}
    
}
Configuration(function(ContextRegister) {
    ContextRegister.register('cdp04000_agenda_de_tarefas_Controller', cdp04000_agenda_de_tarefas_Controller);
});


// FILE: ./assets/modules/producao/assets/js/controllers/cdp06100_tarefas_da_producao_Controller.js
function cdp06100_tarefas_da_producao_Controller (templateManager, restEngine, General, ScreenService, ZHPromise, cdp06100_tarefas_da_producao_Service){
    
    var self = this;
    var BKP_CurrentRow_Dados;
    
    this.changeDtfinrealaudReadOnlyOnFilter = function (widget){
        if(parseInt(widget.currentRow.IDSTATUSAUDI[0]) > 3)
            widget.getField('DTFINREALAUD').readOnly = false;
        else
            widget.getField('DTFINREALAUD').readOnly = true;
    };
    
    this.setFilter = function(widget){
        
        validateNrordprod(widget);
        
        validateCdsetexecaud(widget);
        
        validateIdstatusaudi(widget);
        
        validateDtinclaudit(widget);
        
        validateDtfinrealaud(widget);
        
        validateCdplanprodop(widget);
        
        validateTurno(widget);
        
        templateManager.container.getWidget('grid_dados').dataSourceFilter = [
                        {
                            "name": "P_PESQTURNO",
                            "operator": "=",
                            "value": widget.currentRow.P_PESQTURNO
                        },
                        {
                            "name": "P_CDFILIAL",
                            "operator": "=",
                            "value": getLocalVar('CDFILIAL')
                        },
                        {
                            "name": "P_NRORDPROD",
                            "operator": "=",
                            "value": widget.currentRow.P_NRORDPROD
                        },
                        {
                            "name": "P_TNRORDPROD",
                            "operator": "=",
                            "value": widget.currentRow.P_TNRORDPROD
                        },
                        {
                            "name": "P_CDSETEXECAUD",
                            "operator": "=",
                            "value": widget.currentRow.P_CDSETEXECAUD
                        },
                        {
                            "name": "P_TCDSETEXECAUD",
                            "operator": "=",
                            "value": widget.currentRow.P_TCDSETEXECAUD
                        },
                        {
                            "name": "P_IDSTATUSAUDI",
                            "operator": "=",
                            "value": widget.currentRow.P_IDSTATUSAUDI
                        },
                        {
                            "name": "P_DTINIC",
                            "operator": "=",
                            "value": widget.currentRow.P_DTINIC
                        },
                        {
                            "name": "P_DTFIMC",
                            "operator": "=",
                            "value": widget.currentRow.P_DTFIMC
                        },
                        {
                            "name": "P_TODOS",
                            "operator": "=",
                            "value": widget.currentRow.P_TODOS
                        },
                        {
                            "name": "P_DTINI",
                            "operator": "=",
                            "value": widget.currentRow.P_DTINI
                        },
                        {
                            "name": "P_DTFIM",
                            "operator": "=",
                            "value": widget.currentRow.P_DTFIM
                        },
                        {
                            "name": "P_ETODOS",
                            "operator": "=",
                            "value": widget.currentRow.P_ETODOS
                        },
                        {
                            "name": "P_CDPLANPRODOP",
                            "operator": "=",
                            "value": widget.currentRow.P_CDPLANPRODOP
                        },
                        {
                            "name": "P_LTURNOS",
                            "operator": "=",
                            "value": widget.currentRow.P_LTURNOS
                        },
                        {
                            "name": "P_TTURNOS",
                            "operator": "=",
                            "value": widget.currentRow.P_TTURNOS
                        },
                        {
                            "name": "NRORG",
                            "operator": "=",
                            "value": getLocalVar('NRORG')
                        }
                    ];
                    
    };
    
    function validateNrordprod (widget){
        var P_NRORDPROD = '', P_TNRORDPROD;
        if(!Util.isEmptyOrBlank(widget.currentRow.OP_SUBOP)){
            P_NRORDPROD = '_';
            widget.currentRow.OP_SUBOP.forEach(function (data){
                P_NRORDPROD = P_NRORDPROD.concat(data.concat('_')).replace(/\\/g, "/");
            });
            P_TNRORDPROD= null;
        }
        else {
            P_TNRORDPROD = 'T';
            P_NRORDPROD = null;
        }
        
        widget.currentRow.P_TNRORDPROD = P_TNRORDPROD;
        widget.currentRow.P_NRORDPROD = P_NRORDPROD;
    }
    
    function validateCdsetexecaud (widget){
        var P_CDSETEXECAUD = '', P_TCDSETEXECAUD;
        if(!Util.isEmptyOrBlank(widget.currentRow.NMSETOR)){
            widget.currentRow.NMSETOR.forEach(function (data){
                P_CDSETEXECAUD = P_CDSETEXECAUD.concat(data.concat('_'));
            });
            P_TCDSETEXECAUD= null;
        }
        else {
            P_TCDSETEXECAUD = 'T';
            P_CDSETEXECAUD = null;
        }
        
        widget.currentRow.P_TCDSETEXECAUD = P_TCDSETEXECAUD;
        widget.currentRow.P_CDSETEXECAUD = P_CDSETEXECAUD;
    }
    
    this.validateCdsetexecaudComplete =  function(widget){
        widget.dataSourceFilter = widget.dataSourceFilter.filter(function(element, index){
            return  ((element.name == "P_PESQTURNO") ||
            (element.name == "P_CDFILIAL") ||
            (element.name == "P_NRORDPROD") ||
            (element.name == "P_TNRORDPROD") ||
            (element.name == "P_CDSETEXECAUD") ||
            (element.name == "P_TCDSETEXECAUD") ||
            (element.name == "P_IDSTATUSAUDI") ||
            (element.name == "P_DTINIC") ||
            (element.name == "P_DTFIMC") ||
            (element.name == "P_TODOS") ||
            (element.name == "P_DTINI") ||
            (element.name == "P_DTFIM") || 
            (element.name == "P_ETODOS") || 
            (element.name == "P_CDPLANPRODOP") || 
            (element.name == "P_LTURNOS") || 
            (element.name == "P_TTURNOS") || 
            (element.name == "NRORG"));
        });
    };
    
    function validateIdstatusaudi (widget){
        var P_IDSTATUSAUDI = '_';
        if(!Util.isEmptyOrBlank(widget.currentRow.IDSTATUSAUDI)){
            widget.currentRow.IDSTATUSAUDI.forEach(function (data){
                P_IDSTATUSAUDI = P_IDSTATUSAUDI.concat(data.toString().concat('_'));
            });
        }
        else {
            P_IDSTATUSAUDI = '1_2_3_4_5';
        }
        widget.currentRow.P_IDSTATUSAUDI = P_IDSTATUSAUDI;
    }
    
    function validateDtinclaudit (widget){
        var P_DTINI = '', P_DTFIM, P_ETODOS;
        if(!Util.isEmptyOrBlank(widget.currentRow.DTINCLAUDIT)){
            if(!!widget.currentRow.DTINCLAUDIT.start && !!widget.currentRow.DTINCLAUDIT.end){
                P_DTINI = moment(widget.currentRow.DTINCLAUDIT.start+" 00:00:00", "DD/MM/YYYY HH:mm:ss").format("DD/MM/YYYY HH:mm:ss");
                P_DTFIM = moment(widget.currentRow.DTINCLAUDIT.end+" 23:59:59", "DD/MM/YYYY HH:mm:ss").format("DD/MM/YYYY HH:mm:ss");
                P_ETODOS = null;
            }
            else {
                P_DTINI = '30/12/1899';
                P_DTFIM = '30/12/1899';
                P_ETODOS = 'T';
            }
            
        } else {
            P_DTINI = '30/12/1899';
            P_DTFIM = '30/12/1899';
            P_ETODOS = 'T';
        }
            widget.currentRow.P_DTINI = P_DTINI;
            widget.currentRow.P_DTFIM = P_DTFIM;
            widget.currentRow.P_ETODOS = P_ETODOS;
    }
    
    function validateDtfinrealaud (widget){
        var P_DTINIC, P_DTFIMC, P_TODOS;
        if(!Util.isEmptyOrBlank(widget.currentRow.DTFINREALAUD)){
            if(!!widget.currentRow.DTFINREALAUD.start && !!widget.currentRow.DTFINREALAUD.end){
                P_DTINIC = moment(widget.currentRow.DTFINREALAUD.start+" 00:00:00", "DD/MM/YYYY HH:mm:ss").format("DD/MM/YYYY HH:mm:ss");
                P_DTFIMC = moment(widget.currentRow.DTFINREALAUD.end+" 23:59:59", "DD/MM/YYYY HH:mm:ss").format("DD/MM/YYYY HH:mm:ss");
                P_TODOS = null;
            }
            else {
                P_DTINIC = '30/12/1899';
                P_DTFIMC = '30/12/1899';
                P_TODOS = 'T';
            }
            
        } else {
            P_DTINIC = '30/12/1899';
            P_DTFIMC = '30/12/1899';
            P_TODOS = 'T';
        }
            widget.currentRow.P_DTINIC = P_DTINIC;
            widget.currentRow.P_DTFIMC = P_DTFIMC;
            widget.currentRow.P_TODOS = P_TODOS;
    }
    
    function validateCdplanprodop (widget) {
        var P_CDPLANPRODOP;
        if(!Util.isEmptyOrBlank(widget.currentRow.CDPLANPRODOP)){
            P_CDPLANPRODOP = widget.currentRow.CDPLANPRODOP;
        }
        else {
            P_CDPLANPRODOP = 'T';
        }
        widget.currentRow.P_CDPLANPRODOP = P_CDPLANPRODOP;
    }
    
    function validateTurno (widget) {
        var P_PESQTURNO = 'N', P_LTURNOS = null, P_TTURNOS = 'T';
        widget.currentRow.P_PESQTURNO = P_PESQTURNO;
        widget.currentRow.P_LTURNOS = P_LTURNOS;
        widget.currentRow.P_TTURNOS = P_TTURNOS;
    }
    
    this.alertCdplanprodopOnlyNull = function (widget){
        if (Util.isEmptyOrBlank(widget.dataSource.data)){
            ScreenService.showMessage("Não há Planos de Produção cadastrados");
        }
    };
    
    this.changeNmsetorIsVisible = function (widget){
        if (widget.currentRow.SETOR === 2){
            widget.getField('SETOR').class = 6;
            widget.getField('NMSETOR').isVisible = true;
        } else {
            widget.getField('SETOR').class = 12;
            widget.getField('NMSETOR').isVisible = false;
        }
    };
    
    this.changeOp_subopIsVisible = function (widget){
        if (widget.currentRow.NRORDPROD === 2){
            widget.getField('NRORDPROD').class = 6;
            widget.getField('OP_SUBOP').isVisible = true;
        } else {
            widget.getField('NRORDPROD').class = 12;
            widget.getField('OP_SUBOP').isVisible = false;
        }
    };
    
    this.formatText = function (widget){
        if (widget.currentRow.TXINSPECAUDI){
            var TXINSPECAUDI = widget.currentRow.TXINSPECAUDI;
            if ((TXINSPECAUDI.substr(TXINSPECAUDI.length - 9).split("}")[0]) === "\\par " ){
                TXINSPECAUDI = widget.currentRow.TXINSPECAUDI.split("}")[3];
                TXINSPECAUDI = TXINSPECAUDI.substr(TXINSPECAUDI.indexOf(" "));
                TXINSPECAUDI = TXINSPECAUDI.substr(0,TXINSPECAUDI.indexOf('\\par '));
            }
            widget.currentRow.TXINSPECAUDI = TXINSPECAUDI;
        }
    };
    
    this.validateIdrecuretaop = function (widget){
        clearVariables(widget);
        widget.redraw();
        self.validateOperador(widget);
        changeNmrecurso(widget);
        changeIdliberecuop(widget);
        changeNmgrupoequipa(widget);
    };
    
    function changeNmgrupoequipa (widget){
        if(widget.getField('IDRECURETAOP').value() === 'E'){
            widget.getField('NMGRUPOEQUIPA').readOnly = false;
            widget.getField('NMEQUIPPRO').readOnly = true;
        } else {
            
            widget.getField('NMGRUPOEQUIPA').readOnly = true;
        }
    }
    
    function changeIdliberecuop (widget){
        if(widget.getField('IDRECURETAOP').value() === 'E'){
            widget.getField('IDLIBERECUOP').readOnly = false;
        } else {
            widget.getField('IDLIBERECUOP').readOnly = true;
        }
    }
    
    function changeNmrecurso (widget){
        if(widget.getField('IDRECURETAOP').value() === 'E'){
            if(widget.getField('RECURSO')){
                widget.getField('RECURSO').name = "CDEQUIPPRO";
                widget.getField('NMRECURSO').name = "NMEQUIPPRO";
            }
            if (widget.getField('CDHABILIDADE')){
                widget.getField('CDHABILIDADE').name = "CDEQUIPPRO";
                widget.getField('NMHABILIDADE').name = "NMEQUIPPRO";
            }
            widget.getField('NMEQUIPPRO').descriptionField = "NMEQUIPPRO";
            widget.getField('NMEQUIPPRO').valueField = "CDEQUIPPRO";
            widget.getField('NMEQUIPPRO').order = "CDEQUIPPRO";
            widget.getField('NMEQUIPPRO').outData = {
                "NMEQUIPPRO":"NMEQUIPPRO",
                "CDEQUIPPRO":"CDEQUIPPRO"
            };
            widget.getField('NMEQUIPPRO').fields = [
                {
                    "sequenceInList":1,
                    "name":"CDEQUIPPRO",
                    "label": "Código",
                    "showOnList": true,
                    "isVisible":true,
                    "template":"field/text.html",
                    "mobile":{
                        "sequenceInList": 2
                    }
                },
                {
                    "sequenceInList":2,
                    "name":"NMEQUIPPRO",
                    "label":"Nome: ",
                    "align":"left",
                    "template":"field/text.html",
                    "isVisible":true,
                    "showOnList":true,
                    "showOnView":true,
                    "mobile":{
                        "sequenceInList": 1
                    }
                }
            ];
            widget.getField('NMEQUIPPRO').dataSource.name = "cdp#/crud/equipaprod";
            widget.getField('NMEQUIPPRO').readOnly = false;
        } else {
            if(widget.getField('RECURSO')){
                widget.getField('RECURSO').name = "CDHABILIDADE";
                widget.getField('NMRECURSO').name = "NMHABILIDADE";
            }
            if (widget.getField('CDEQUIPPRO')){
                widget.getField('CDEQUIPPRO').name = "CDHABILIDADE";
                widget.getField('NMEQUIPPRO').name = "NMHABILIDADE";
            }
            widget.getField('NMHABILIDADE').descriptionField = "NMHABILIDADE";
            widget.getField('NMHABILIDADE').valueField = "CDHABILIDADE";
            widget.getField('NMHABILIDADE').order = "CDHABILIDADE";
            widget.getField('NMHABILIDADE').outData = {
                "NMHABILIDADE":"NMHABILIDADE",
                "CDHABILIDADE":"CDHABILIDADE"
            };
            widget.getField('NMHABILIDADE').fields = [
                {
                    "sequenceInList":1,
                    "name":"CDHABILIDADE",
                    "label": "Código",
                    "showOnList": true,
                    "isVisible":true,
                    "template":"field/text.html",
                    "mobile":{
                        "sequenceInList": 2
                    }
                },
                {
                    "sequenceInList":2,
                    "name":"NMHABILIDADE",
                    "label":"Nome: ",
                    "align":"left",
                    "template":"field/text.html",
                    "isVisible":true,
                    "showOnList":true,
                    "showOnView":true,
                    "mobile":{
                        "sequenceInList": 1
                    }
                }
            ];
            widget.getField('NMHABILIDADE').dataSource.name = "cdp#/crud/habilidade";
            widget.getField('NMHABILIDADE').dataSourceFilter = [];
            widget.getField('NMHABILIDADE').readOnly = false;
            widget.getField('NMGRUPOEQUIPA').readOnly = true;
            widget.getField('NMGRUPOEQUIPA').setValue("");
        }
    }
    
    function clearVariables (widget){
        if(widget.getField('IDRECURETAOP').value() === 'E'){
            widget.currentRow.CDOPERADOR = "";
            widget.currentRow.NMOPERADOR = "";
            widget.currentRow.CDHABILIDADE = "";
            widget.currentRow.NMHABILIDADE = "";
        } else {
            widget.currentRow.CDGRUPOEQUIPA = "";
            widget.currentRow.NMGRUPOEQUIPA = "";
            widget.currentRow.CDEQUIPPRO = "";
            widget.currentRow.NMEQUIPPRO = "";
            widget.currentRow.IDLIBERECUOP = "";
        }
    }
    
    this.changeDataSourceFilterNmequippro = function (widget){
        widget.getField('NMEQUIPPRO').dataSourceFilter = [
            {
                "name": "CDGRUPOEQUIPA",
                "operator": "=",
                "value": General.getFieldValue('CDGRUPOEQUIPA', 'tabbed_liberacao')
            }
        ];
    };
    
    this.saveCrud = function(widget){
        if (widget.currentRow.__is_new){
            General.saveCrud(widget).then(function (){
                var widgetsToActivate = widget.parent.widgets;
    
    			General.changeWidgetAcessibility(
    				widgetsToActivate.filter(function (subwidget) {
    					return subwidget.name != widget.name;
    				}).concat(widget.parent), //retorna um array com a widget parent e suas widgets filhas, exceto aquela que será editada
    				true);
            });
        } else {
            General.widgetSave(widget).then(function (){
                var widgetsToActivate = widget.parent.widgets;
    
    			General.changeWidgetAcessibility(
    				widgetsToActivate.filter(function (subwidget) {
    					return subwidget.name != widget.name;
    				}).concat(widget.parent), //retorna um array com a widget parent e suas widgets filhas, exceto aquela que será editada
    				true);
            });
        }
    };
    
    this.backOrCancel = function(args){
        General.backOrCancel(args).then(function (){
            var widget = args.owner.widget;
            var widgetsToActivate = widget.parent.widgets;
    		General.changeWidgetAcessibility(
    		widgetsToActivate.filter(function (subwidget) {
    			return subwidget.name != widget.name;
    		}).concat(widget.parent), //retorna um array com a widget parent e suas widgets filhas, exceto aquela que será editada
    		true);
        });
    };
    
    this.cancelFormDados = function(args){
        General.backOrCancel(args).then(function (){
            var widget = args.owner.widget;
            var widgetsToActivate = widget.widgets;
    		General.changeWidgetAcessibility(
    		widgetsToActivate.filter(function (subwidget) {
    			return subwidget.name != widget.name;
    		}).concat(widget), //retorna um array com a widget parent e suas widgets filhas, exceto aquela que será editada
    		true);
        });
    };
    
    this.saveTabbedObservacoes = function (widget){
        if (Util.isEmptyOrBlank(widget.dataSource.data[0])){
            widget.currentRow.__is_new = true;
            widget.currentRow.CDFILIAL = General.getFieldValue('CDFILIAL', 'grid_dados');
            widget.currentRow.NRAUDITORIA = General.getFieldValue('NRAUDITORIA', 'grid_dados');
            widget.currentRow.NRINSPECAUDI = General.getFieldValue('NRINSPECAUDI', 'tabbed_tarefas');
        }
        var deferred = ZHPromise.defer();
        cdp06100_tarefas_da_producao_Service.salvarDescinsaudit(widget.currentRow).then(function(){
            if (General.formWidgetSwitchTemplate(widget) && widget.parent) {
                var widgetsToActivate = widget.parent.widgets;
        	
            	General.changeWidgetAcessibility(
            		widgetsToActivate.filter(function (subwidget) {
            			return subwidget.name != widget.parent.name;
            		}).concat(widget.parent), //retorna um array com a widget parent e suas widgets filhas, exceto aquela que será editada
            	true);
        		widget.list();
				deferred.resolve();
            }
        }, function (error){
            ScreenService.showMessage(error.data.error);
            deferred.reject();
        });
        return deferred.promise;
    };
    
    this.deleteTabbedObservacoes = function (widget){
        var deferred = ZHPromise.defer();
		ScreenService.confirmMessage(ScreenService.i18n('Delete Register?'), 'question', function (success) {
			widget.currentRow.TXINSPECAUDI = "";
			self.saveTabbedObservacoes(widget).then(function (){
			    General.formWidgetSwitchTemplate(widget);
			    widget.activate();
			    deferred.resolve();
			});
		}, function (error) {
			if (error.data && error.data.error.indexOf('ORA-02292') !== -1) {
				ScreenService.showMessage('Exclusão não permitida! O registro possui registros filhos.');
			} else {
				ScreenService.showMessage(error.data.error);
			}
			deferred.reject();
		});
		return deferred.promise;
    };
    
    this.redraw  = function (){
        if (templateManager.container.getWidget('tabbed_liberacao').getField('IDRECURETAOP').value()){
            if (templateManager.container.getWidget('tabbed_liberacao').getField('IDRECURETAOP').value() === 'E'){
                templateManager.container.getActiveWidget().dataSource.name = "cdp#/crud/equipaprod";
                if (templateManager.container.getActiveWidget().getField('CDHABILIDADE')){
                    templateManager.container.getActiveWidget().fields[0].name = "CDEQUIPPRO";
                    templateManager.container.getActiveWidget().fields[1].name = "NMEQUIPPRO";
                }
            }
            if (templateManager.container.getWidget('tabbed_liberacao').getField('IDRECURETAOP').value() === 'H'){
                templateManager.container.getActiveWidget().dataSource.name = "cdp#/crud/habilidade";
                if (templateManager.container.getActiveWidget().getField('NMEQUIPPRO')){
                    templateManager.container.getActiveWidget().fields[0].name = "CDHABILIDADE";
                    templateManager.container.getActiveWidget().fields[1].name = "NMHABILIDADE";
                }
            }
            templateManager.container.getActiveWidget().reload();
        }
    };
    
    function formatTempoGastoForSave (widget, nameDtInicial, nameDtFinal, nameTmpGasto){
        if (!Util.isEmptyOrBlank(General.getFieldValue(nameDtFinal, widget.name)) && !Util.isEmptyOrBlank(General.getFieldValue(nameDtInicial, widget.name))){
            var one_hour=1000*60*60;
            var dataInicial = calcTempo (General.getFieldValue(nameDtInicial, widget.name).split(" "));
            var dataFinal = calcTempo (General.getFieldValue(nameDtFinal, widget.name).split(" "));
            var diffInMs = dataFinal - dataInicial;
            widget.getField(nameTmpGasto).setValue(diffInMs/one_hour);
        } else{
             widget.getField(nameTmpGasto).setValue('');
         }
    }
    
    this.formatTempoGastoOnChange = function(widget, nameDtInicial, nameDtFinal, nameTmpGasto){
        if (!Util.isEmptyOrBlank(General.getFieldValue(nameDtFinal, widget.name)) && !Util.isEmptyOrBlank(General.getFieldValue(nameDtInicial, widget.name))){
            var one_hour=1000*60*60;
            var one_minute =1000*60;
            var dataInicial = calcTempo (General.getFieldValue(nameDtInicial, widget.name).split(" "));
            var dataFinal = calcTempo (General.getFieldValue(nameDtFinal, widget.name).split(" "));
            var diffInMs = dataFinal - dataInicial;
            widget.getField(nameTmpGasto).setValue(formatTimeText(parseInt(diffInMs/one_hour)).concat(':'.concat(formatTimeText((diffInMs%one_hour)/one_minute))));
        } else{
            widget.getField(nameTmpGasto).setValue('');
        }
        
    };
    
    this.formatTempoGasto = function (widget, nameDtInicial, nameDtFinal, nameTmpGasto){
        widget.dataSource.data.forEach(function(data){
            if (!Util.isEmptyOrBlank(data[nameDtFinal]) && !Util.isEmptyOrBlank(data[nameDtInicial])){
                var one_hour=1000*60*60;
                var one_minute =1000*60;
                var dataInicial = calcTempo (data[nameDtInicial].split(" "));
                var dataFinal = calcTempo (data[nameDtFinal].split(" "));
                var diffInMs = dataFinal - dataInicial;
                data[nameTmpGasto]= (formatTimeText(parseInt(diffInMs/one_hour)).concat(':'.concat(formatTimeText((diffInMs%one_hour)/one_minute))));
            } else {
                data[nameTmpGasto]= '';
            }
        });
    };
    
    function calcTempo (DATA){
        var time = new Date(parseInt(DATA[0].split('/')[2]), (parseInt(DATA[0].split('/')[1])- 1), parseInt(DATA[0].split('/')[0]), parseInt(DATA[1].split(':')[0]), parseInt(DATA[1].split(':')[1]));
        return time;
    }
    
    function formatTimeText (tempo){
        if (tempo < 10)
            return '0'.concat(tempo.toString());
        else
            return tempo.toString();
    }
    
    this.setNmrecursoReadOnlyOnEquipamento = function (widget){
        if (widget.getField('NMGRUPOEQUIPA').value())
            widget.getField('NMEQUIPPRO').readOnly = false;
        else{
            widget.getField('NMEQUIPPRO').readOnly = true;
            widget.getField('NMEQUIPPRO').setValue("");
        }
    };
    
    this.validateOperador = function (widget){
        if(widget.getField('CDHABILIDADE'))
            if (!Util.isEmptyOrBlank(General.getFieldValue('CDHABILIDADE', 'tabbed_liberacao'))){
                widget.getField('NMOPERADOR').readOnly = false;
                widget.getField('NMOPERADOR').validations = {'required': true};
            } else {
                widget.getField('NMOPERADOR').validations = {};
                widget.getField('NMOPERADOR').readOnly = true;
                widget.getField('NMOPERADOR').setValue('');
                widget.getField('CDOPERADOR').setValue('');
            }
    };
    
    this.editTabbedLiberacao = function (widget){
        self.validateIdrecuretaop(widget);
        if(widget.getField('IDRECURETAOP').value() === 'E')
            self.setNmrecursoReadOnlyOnEquipamento(widget);
        else
            self.validateOperador(widget);
        General.widgetEdit(widget);
    };
    
    this.validateIdstatusaudiOnChange = function(widget){
        if (parseInt(widget.currentRow.NRAUDITORIA) === parseInt(BKP_CurrentRow_Dados.NRAUDITORIA)){
            if (parseInt(widget.currentRow.IDSTATUSAUDI) < parseInt(BKP_CurrentRow_Dados.IDSTATUSAUDI)){
                ScreenService.showMessage("Situação não pode voltar para Pendente").then(function(){
                    widget.currentRow.IDSTATUSAUDI = BKP_CurrentRow_Dados.IDSTATUSAUDI;
                    widget.redraw();
                });
            }
        }
    };
    
    this.setBkp_Currentrow_Dados = function (widget){
        BKP_CurrentRow_Dados = Util.clone(widget.currentRow);
    };
    
    this.saveWithTimeFormat = function (widget, nameDtInicial, nameDtFinal, nameTmpGasto){
        formatTempoGastoForSave(widget, nameDtInicial, nameDtFinal, nameTmpGasto);
        ZHPromise.all(self.saveCrud(widget)).then(function(success){
            this.formatTempoGasto(widget, nameDtInicial, nameDtFinal, nameTmpGasto);
            widget.reload();
        }.bind(this));
    };
    
    this.validateDtFinal = function (widget, nameDtInicial, nameDtFinal, nameTmpGasto){
        if (!Util.isEmptyOrBlank(General.getFieldValue(nameDtFinal, widget.name)) && !Util.isEmptyOrBlank(General.getFieldValue(nameDtInicial, widget.name))){
            var dataInicial = calcTempo (General.getFieldValue(nameDtInicial, widget.name).split(" "));
            var dataFinal = calcTempo (General.getFieldValue(nameDtFinal, widget.name).split(" "));
            if(dataInicial > dataFinal){
                ScreenService.showMessage(widget.getField(nameDtFinal).label.concat(" maior que ").concat(widget.getField(nameDtInicial).label));
                widget.getField(nameDtFinal).setValue('');
                widget.getField(nameTmpGasto).setValue('');
            }
        }
    };
    
    this.validateFinalTarefa = function (widget) {
        if (widget.getField('IDINSPCONC').value() === 'S'){
            templateManager.container.getWidget('tabbed_liberacao').reload().then(function (response){
                if (!Util.isEmptyOrBlank(response.dataset.recuretapaop_grupoequipa_roteiroProducao)){
                    var isIncomplete;
                    response.dataset.recuretapaop_grupoequipa_roteiroProducao.forEach(function (data){
                        if (!Util.isEmptyOrBlank(data.DTFINUTRECOP) && !Util.isEmptyOrBlank(data.DTINIUTRECOP)){
                        } else {
                            ScreenService.showMessage('Tarefa não pode ser concluída com recurso em aberto');
                            isIncomplete = true;
                            return 0;

                        }
                    });
                    if (!isIncomplete){
                        widget.currentRow.DTFINRINSAUD = moment(widget.currentRow.DTFINRINSAUD, "DD/MM/YYYY HH:MM:SS").format("DD/MM/YYYY HH:MM:SS");
                        widget.currentRow.DTFINRINSAUD = moment().format("DD/MM/YYYY HH:MM:SS");
                        self.saveWithTimeFormat(widget, 'DTINIRINSAUD', 'DTFINRINSAUD', 'QTHRINSAUD');
                    }
                } else {
                    ScreenService.showMessage('Tarefa não pode ser concluída sem recurso cadastrado');
                }
            });
        } 
        else {
            General.saveCrud(widget);
            widget.widgets.forEach(function (element) {
                element.enabled = true;
            });
        }
    };
    
    this.editDadosRoteiro = function (widget){
        General.widgetEdit(widget);
        if (General.getFieldValue('IDSTATUSAUDI', 'grid_dados') === '3' || General.getFieldValue('IDSTATUSAUDI', 'grid_dados') === '4'){
            widget.fields.forEach(function (field){
                field.readOnly = true;
            });
        } else {
            widget.getField('IDSTATUSAUDI').readOnly = false;
            widget.getField('NMSETOR').readOnly = false;
            widget.getField('DTINCLAUDIT').readOnly = false;
            widget.getField('DSREFEAUDIT').readOnly = false;
        }
    };
    
    this.saveTarefasSubWidgetAndChangeSituationOfRoteiro = function (widget){
        if (General.getFieldValue('IDSTATUSAUDI', 'grid_dados') === '1'){
            if (widget.name === 'tabbed_observacao'){
                saveObservacaoAndDados(widget);
            }
            if (widget.name === 'tabbed_liberacao'){
                saveLiberacaoAndDados(widget);
            }
            if (widget.name === 'tabbed_ocorrencia'){
                saveOcorrenciaAndDados(widget);
            }
        } else {
            
        }
    };
    
    function saveObservacaoAndDados (widget){
        templateManager.container.getWidget('grid_dados').getField('IDSTATUSAUDI').setValue('2');
        var dataSet = [widget.currentRow, templateManager.container.getWidget('grid_dados').currentRow];
        cdp06100_tarefas_da_producao_Service.saveObservacaoAndDados(dataSet);
    }
    
    function saveLiberacaoAndDados (widget){
        templateManager.container.getWidget('grid_dados').getField('IDSTATUSAUDI').setValue('2');
        var dataSet = [widget.currentRow, templateManager.container.getWidget('grid_dados').currentRow];
        cdp06100_tarefas_da_producao_Service.saveLiberacaoAndDados(dataSet);
    }
    
    function saveOcorrenciaAndDados (widget){
        templateManager.container.getWidget('grid_dados').getField('IDSTATUSAUDI').setValue('2');
        var dataSet = [widget.currentRow, templateManager.container.getWidget('grid_dados').currentRow];
        cdp06100_tarefas_da_producao_Service.saveOcorrenciaAndDados(dataSet);
    }
    
    this.changeEditAction = function(widget){
        widget.actions.forEach(function(element){
            if(element.name == "editar"){
                if (widget.currentRow.IDINSPCONC == 'S'){
                   element.isVisible = false; 
                } else if (widget.currentRow.IDINSPCONC == 'P'){
                   element.isVisible = true; 
                }
            }
        });
    };
    
}
Configuration(function(ContextRegister) {
    ContextRegister.register('cdp06100_tarefas_da_producao_Controller', cdp06100_tarefas_da_producao_Controller);
});

// FILE: ./assets/modules/producao/assets/js/controllers/cdp06400_pontos_criticosController.js
function cdp06400_pontos_criticosController (ZHPromise, templateManager, restEngine, General, ScreenService, cdp06400_pontos_criticosService){
    
    this.newPonto = function(widget){
        widget.newRow();
        
        widget.widgets[0].enabled = false;
        widget.getField('CDARVINSPEC').readOnly= false;
        
        widget.currentRow.CDNVINSPECAO = '4';
        widget.currentRow.IDORIGINSPEC = 'PCC';
        	
		cdp06400_pontos_criticosService.incrementoCodigo(widget.currentRow).then(
		    function (success) {
		        widget.currentRow.CDINSPECAO = success.dataset.result[0].CDINSPECAO;
		    },
		    function (callback) {
			    if(callback.data){
                    ScreenService.showMessage(callback.data.error);
                }
		    }
		);
        
    };
    
    this.savePonto = function(widget){
        widget.widgets[0].enabled = true;
        
        General.saveCrud(widget);
    };
    
    this.editPonto = function(widget){
        widget.widgets[0].enabled = false;
        widget.getField('CDARVINSPEC').readOnly= true;
       
        General.edit(widget);
    };
    
    this.cancelPonto = function(widget){
        widget.widgets[0].enabled = true;
    };
    
    this.saveComplete = function(widget){
        widget.currentRow.CDINSPECAO = widget.parent.currentRow.CDINSPECAO;
        General.saveCrud(widget);
    };
    
}
Configuration(function(ContextRegister) {
    ContextRegister.register('cdp06400_pontos_criticosController', cdp06400_pontos_criticosController);
});


// FILE: ./assets/modules/producao/assets/js/controllers/cdp07700_calendario_de_producao_Controller.js
function cdp07700_calendario_de_producao_Controller (ZHPromise, templateManager, restEngine, General, ScreenService, cdp07700_calendario_de_producao_Service){
    
    this.filialCalendario = function(widget){
        if(widget.currentRow.NMFILIAL == ""){
            widget.getField('NMPERIPRODU').readOnly = true;
            widget.getField('NMPERIPRODU').value("");
            widget.getField('NMPERIPRODU').reload();
            widget.widgets[0].isVisible = false;
            this.escondeActions(widget);
            widget.widgets[0].reload();
        } else {
            widget.getField('NMPERIPRODU').readOnly = false;
        }
    };
    
    this.periCalendario = function(widget){
        if(widget.currentRow.NMPERIPRODU == ""){
            widget.widgets[0].isVisible = false;
            this.escondeActions(widget);
            widget.widgets[0].reload();
        } else {
            widget.widgets[0].isVisible = true;
            this.mostraActions(widget);
            widget.widgets[0].reload();
            this.coloreCalendario(widget.widgets[0]);
            widget.widgets[0].reload();
        }
    };
 
    this.escondeActions = function (widget){
        var tamanho = widget.widgets[0].actions.length;
        for(var i = 0; i<tamanho; i++){
            widget.widgets[0].actions[i].isVisible = false;
        }
    };
    
    this.mostraActions = function (widget){
        var tamanho = widget.widgets[0].actions.length;
        for(var i = 0; i<tamanho; i++){
            widget.widgets[0].actions[i].isVisible = true;
        }
    };
    
    this.anoAnteior = function(widget){
        
        if(widget.getYear() > moment().format().substring(0,4)){
            this.mostraActions(widget.parent);
            
        } else if(widget.getYear() < moment().format().substring(0,4)){
            this.escondeActions(widget.parent);
        } else if(widget.getYear() == moment().format().substring(0,4)){
            if((widget.getMonth() + 1).toString().length == 1){
                if((('0'+(widget.getMonth() + 1).toString()+'/'+widget.getYear().toString()) < (moment().format().substring(0,7).split("-").reverse().join("-").replace(/-/g, "/")))){
                    this.escondeActions(widget.parent);
                } else {
                    this.mostraActions(widget.parent);
                }
            } else if((widget.getMonth() + 1).toString().length == 2){
                if((((widget.getMonth() + 1).toString()+'/'+ widget.getYear().toString()) < (moment().format().substring(0,7).split("-").reverse().join("-").replace(/-/g, "/")))){
                    this.escondeActions(widget.parent);
                } else {
                    this.mostraActions(widget.parent);
                }
            }
        }
        
    };
    
    this.coloreCalendario = function(widget){
        
        //Tamanho do mes quem vem do dataSource
        var calendario_BD = widget.dataSource.data;
        var tamanho_mes_BD = widget.dataSource.data.length;
        if(tamanho_mes_BD > 0){
            var i = 0;
            var j = 0;
            widget.selectedDates = [];
            
            var mes = (widget.getMonth() + 1);
            
            if(mes.toString().length == 1){
                mes = widget.getYear().toString()+'-0'+(widget.getMonth() + 1).toString();
            } else if(mes.toString().length == 2){
                mes= widget.getYear().toString()+'-'+(widget.getMonth() + 1).toString();
            }
                
            for(i=0; i<tamanho_mes_BD; i++){
			    if(mes == calendario_BD[i].DTPRODUCAO.substring(0,10).replace(/\//g, "-").split("-").reverse().join("-").substring(0,7)){
			        widget.selectedDates[j] = calendario_BD[i].DTPRODUCAO.substring(0,10).replace(/\//g, "-").split("-").reverse().join("-").substring(0,10);
			        j++;
			    }
            }
            
        }
        
    };
   
    this.calcularProducaoAnual = function(widget){
        
        var tamanho_mes_BD = widget.dataSource.data.length;
        var i = 0;
        var existe = 0;
        
        for(i=0; i < tamanho_mes_BD; i++){
            if(widget.getYear().toString() === widget.dataSource.data[i].DTPRODUCAO.substring(6,10)){
        		existe++;
            }
        } 

        if(existe === 0){
            
            if(widget.getYear().toString() === moment().format().substring(0,4)){
            
                widget.parent.currentRow.DTINICIAL = '01/'+moment().format().substring(5,7)+'/'+widget.getYear().toString()+' 00:00:00';
                widget.parent.currentRow.NRMESES = (12 - parseInt(moment().format().substring(5,7))) + 1;
                widget.parent.currentRow.DTPROCESSA = moment().format().substring(0,10).split("-").reverse().join("-").replace(/-/g, "/")+' 00:00:00';
                
                cdp07700_calendario_de_producao_Service.calcularProdAnual(widget.parent.currentRow).then(
                    function(Success) {
                        ScreenService.closeSwipe().then(function () {
                            widget.activate();
                        });
                        ScreenService.closeSwipe();
                        ScreenService.closePopup();
                        ScreenService.goBack();
                        widget.reload().then( function(){
                            this.coloreCalendario(widget);
                        }.bind(this));
                    }.bind(this),
                    function(error){
                        if (error.data && error.data.error.indexOf('ORA-02292') !== -1) {
                            ScreenService.showMessage('Exclusão não permitida! O registro possui registros filhos.');
                        } else {
                            ScreenService.showMessage(error.message);
                        }
                    }
                );
                
            } else if(widget.getYear().toString() > moment().format().substring(0,4)){
                
                widget.parent.currentRow.DTINICIAL = '01/01/'+widget.getYear().toString()+' 00:00:00';
                widget.parent.currentRow.NRMESES = 12;
                widget.parent.currentRow.DTPROCESSA = moment().format().substring(0,10).split("-").reverse().join("-").replace(/-/g, "/")+' 00:00:00';
                
                cdp07700_calendario_de_producao_Service.calcularProdAnual(widget.parent.currentRow).then(
                    function(Success) {
                       ScreenService.closeSwipe().then(function () {
                            widget.activate();
                            ScreenService.closePopup();
                            ScreenService.goBack();
                        });
                        widget.reload().then( function(){
                            this.coloreCalendario(widget);
                        }.bind(this));
                    }.bind(this),
                    function(error){
                        if (error.data && error.data.error.indexOf('ORA-02292') !== -1) {
                            ScreenService.showMessage('Exclusão não permitida! O registro possui registros filhos.');
                        } else {
                            ScreenService.showMessage(error.message);
                        }
                    }
                );
                
                this.coloreCalendario(widget);

            }
       
        } else{
            
            if(widget.getYear().toString() === moment().format().substring(0,4)){
                
                widget.parent.currentRow.ANODELETA = widget.getYear();
                widget.selectedDates = [];
                
                cdp07700_calendario_de_producao_Service.deleteCalendario(widget.parent.currentRow).then(
                    function(Success) {
                        
                        widget.parent.currentRow.DTINICIAL = '01/'+moment().format().substring(5,7)+'/'+widget.getYear().toString()+' 00:00:00';
                        widget.parent.currentRow.NRMESES = (12 - parseInt(moment().format().substring(5,7))) + 1;
                        widget.parent.currentRow.DTPROCESSA = moment().format().substring(0,10).split("-").reverse().join("-").replace(/-/g, "/")+' 00:00:00';
                        
                        cdp07700_calendario_de_producao_Service.calcularProdAnual(widget.parent.currentRow).then(
                            function(Success) {
                                ScreenService.closeSwipe().then(function () {
                                    widget.activate();
                                });
                                widget.reload();
                            },
                            function(error){
                                if (error.data && error.data.error.indexOf('ORA-02292') !== -1) {
                                    ScreenService.showMessage('Exclusão não permitida! O registro possui registros filhos.');
                                } else {
                                    ScreenService.showMessage(error.message);
                                }
                            }
                        );
                        ScreenService.closeSwipe().then(function () {
                            widget.activate();
                        });
                        ScreenService.closeSwipe();
                        ScreenService.closePopup();
                        ScreenService.goBack();
                    },
                    function(error){
                        if (error.data && error.data.error.indexOf('ORA-02292') !== -1) {
                            ScreenService.showMessage('Exclusão não permitida! O registro possui registros filhos.');
                        } else {
                            ScreenService.showMessage(error.message);
                        }
                    }
                );
            
            } else {
                
                widget.parent.currentRow.ANODELETA = widget.getYear();
                widget.selectedDates = [];
                widget.parent.currentRow.DTINICIAL = '01/01/'+widget.getYear().toString()+' 00:00:00';
                widget.parent.currentRow.NRMESES = 12;
                widget.parent.currentRow.DTPROCESSA = moment().format().substring(0,10).split("-").reverse().join("-").replace(/-/g, "/")+' 00:00:00';
                
                cdp07700_calendario_de_producao_Service.deleteCalendario(widget.parent.currentRow).then(
                    function(Success) {
                        
                        cdp07700_calendario_de_producao_Service.calcularProdAnual(widget.parent.currentRow).then(
                            function(Success) {
                                ScreenService.closeSwipe().then(function () {
                                    widget.activate();
                                });
                                widget.reload();
                            },
                            function(error){
                                if (error.data && error.data.error.indexOf('ORA-02292') !== -1) {
                                    ScreenService.showMessage('Exclusão não permitida! O registro possui registros filhos.');
                                } else {
                                    ScreenService.showMessage(error.message);
                                }
                            }
                        );
                        ScreenService.closeSwipe().then(function () {
                            widget.activate();
                        });
                        ScreenService.closeSwipe();
                        ScreenService.closePopup();
                        ScreenService.goBack();
                    },
                    function(error){
                        if (error.data && error.data.error.indexOf('ORA-02292') !== -1) {
                            ScreenService.showMessage('Exclusão não permitida! O registro possui registros filhos.');
                        } else {
                            ScreenService.showMessage(error.message);
                        }
                    }
                );

            }
            
        } 
    };
    
    this.CalcularProduCaoMensal = function(widget){
        
        var calendario_BD = widget.dataSource.data;
        var tamanho_mes_BD = widget.dataSource.data.length;
        var data_mes = 0;
        var i = 0;
        var existe = 0;
        
        if(((widget.getMonth() + 1).toString().length == 1)){
            data_mes = '0'+(widget.getMonth() + 1).toString()+'/'+widget.getYear().toString();
        } else if(((widget.getMonth() + 1).toString().length == 2)){
            data_mes = (widget.getMonth() + 1).toString()+'/'+widget.getYear().toString();
        } 
        
        for(i=0; i < tamanho_mes_BD; i++){
            if(data_mes === widget.dataSource.data[i].DTPRODUCAO.substring(3,10)){
        		existe++;
            }
        } 

        if(existe === 0){
            
            if(data_mes.replace(/\//g, "-").split("-").reverse().join("-") === moment().format().substring(0,7)){
            
                widget.parent.currentRow.DTINICIAL = '01/'+moment().format().substring(5,7)+'/'+widget.getYear().toString()+' 00:00:00';
                widget.parent.currentRow.NRMESES = 1;
                widget.parent.currentRow.DTPROCESSA = moment().format().substring(0,10).split("-").reverse().join("-").replace(/-/g, "/")+' 00:00:00';
                
                cdp07700_calendario_de_producao_Service.calcularProdAnual(widget.parent.currentRow).then(
                    function(Success) {
                        ScreenService.closeSwipe().then(function () {
                            widget.activate();
                        });
                        ScreenService.closeSwipe();
                        ScreenService.closePopup();
                        ScreenService.goBack();
                        widget.reload().then( function(){
                            this.coloreCalendario(widget);
                        }.bind(this));
                    }.bind(this),
                    function(error){
                        if (error.data && error.data.error.indexOf('ORA-02292') !== -1) {
                            ScreenService.showMessage('Exclusão não permitida! O registro possui registros filhos.');
                        } else {
                            ScreenService.showMessage(error.message);
                        }
                    }
                );
              
            } else  if(data_mes.replace(/\//g, "-").split("-").reverse().join("-") > moment().format().substring(0,7)){
            
                widget.parent.currentRow.DTINICIAL = '01/'+data_mes+' 00:00:00';
                widget.parent.currentRow.NRMESES = 1;
                widget.parent.currentRow.DTPROCESSA = moment().format().substring(0,10).split("-").reverse().join("-").replace(/-/g, "/")+' 00:00:00';
                
                cdp07700_calendario_de_producao_Service.calcularProdAnual(widget.parent.currentRow).then(
                    function(Success) {
                       ScreenService.closeSwipe().then(function () {
                            widget.activate();
                        }); 
                        ScreenService.closeSwipe();
                        ScreenService.closePopup();
                        ScreenService.goBack();
                        widget.reload().then( function(){
                            this.coloreCalendario(widget);
                        }.bind(this));
                    }.bind(this),
                    function(error){
                        if (error.data && error.data.error.indexOf('ORA-02292') !== -1) {
                            ScreenService.showMessage('Exclusão não permitida! O registro possui registros filhos.');
                        } else {
                            ScreenService.showMessage(error.message);
                        }
                    }
                );
                
            }
       
        } else {
            
            if(data_mes.replace(/\//g, "-").split("-").reverse().join("-") === moment().format().substring(0,7)){
                
                
                if(widget.getMonth().toString().length == 1){
                    widget.parent.currentRow.ANODELETA = '0'+(widget.getMonth() + 1).toString()+'/'+widget.getYear().toString();
                } else if(widget.getMonth().toString().length == 2){
                    widget.parent.currentRow.ANODELETA = (widget.getMonth() + 1).toString()+'/'+widget.getYear().toString();
                } 
                widget.selectedDates = [];
                widget.parent.currentRow.DTINICIAL = '01/'+moment().format().substring(5,7)+'/'+widget.getYear().toString()+' 00:00:00';
                widget.parent.currentRow.NRMESES = 1;
                widget.parent.currentRow.DTPROCESSA = moment().format().substring(0,10).split("-").reverse().join("-").replace(/-/g, "/")+' 00:00:00';
                
                
                cdp07700_calendario_de_producao_Service.deleteCalendario(widget.parent.currentRow).then(
                    function(Success) {
                        
                        cdp07700_calendario_de_producao_Service.calcularProdAnual(widget.parent.currentRow).then(
                            function(Success) {
                                ScreenService.closeSwipe().then(function () {
                                    widget.activate();
                                });
                                widget.reload();
                            },
                            function(error){
                                if (error.data && error.data.error.indexOf('ORA-02292') !== -1) {
                                    ScreenService.showMessage('Exclusão não permitida! O registro possui registros filhos.');
                                } else {
                                    ScreenService.showMessage(error.message);
                                }
                            }
                        );
                        ScreenService.closeSwipe().then(function () {
                            widget.activate();
                        });
                        ScreenService.closeSwipe();
                        ScreenService.closePopup();
                        ScreenService.goBack();
                    },
                    function(error){
                        if (error.data && error.data.error.indexOf('ORA-02292') !== -1) {
                            ScreenService.showMessage('Exclusão não permitida! O registro possui registros filhos.');
                        } else {
                            ScreenService.showMessage(error.message);
                        }
                    }
                );
                
            } else {
                ScreenService.showMessage('Não é possivel calcular Produção Mensal. Produção Mensal já cadastrada.');
            }   
            
        }
    };
    
    this.deletarCalendario = function (widget) {
        ScreenService.showCustomDialog('Qual periodo deseja Excluir?', 'question', 'question', [{
            label: ScreenService.i18n("Ano"),
            code: function(){
                widget.parent.currentRow.ANODELETA = widget.getYear();
       
                ScreenService.confirmMessage(ScreenService.i18n('Delete Register?'), 'question', function (success) {
            
                    cdp07700_calendario_de_producao_Service.deleteCalendario(widget.parent.currentRow).then(
                        function(Success) {
                            widget.selectedDates = [];
                            ScreenService.closeSwipe().then(function () {
                                widget.activate();
                            });
                            widget.reload();
                        },
                        function(error){
                            if (error.data && error.data.error.indexOf('ORA-02292') !== -1) {
                                ScreenService.showMessage('Exclusão não permitida! O registro possui registros filhos.');
                            } else {
                                ScreenService.showMessage(error.message);
                            }
                        }
                    );
                });
            }.bind(this)
        },{
            label: ScreenService.i18n("Mês"),
            code: function(){
                
                if(((widget.getMonth() + 1).toString().length == 1)){
                    widget.parent.currentRow.ANODELETA = '0'+(widget.getMonth() + 1).toString()+'/'+widget.getYear().toString();
                } else if((widget.getMonth() + 1).toString().length == 2){
                    widget.parent.currentRow.ANODELETA = (widget.getMonth() + 1).toString()+'/'+widget.getYear().toString();
                } 
                
                ScreenService.confirmMessage(ScreenService.i18n('Delete Register?'), 'question', function (success) {
    
                    cdp07700_calendario_de_producao_Service.deleteCalendarioMes(widget.parent.currentRow).then(
                        function(Success) {
                            widget.selectedDates = [];
                            ScreenService.closeSwipe().then(function () {
                                widget.activate();
                            });
                            widget.reload();
                        },
                        function(error){
                            if (error.data && error.data.error.indexOf('ORA-02292') !== -1) {
                                ScreenService.showMessage('Exclusão não permitida! O registro possui registros filhos.');
                            } else {
                                ScreenService.showMessage(error.message);
                            }
                        }
                    );
                });
            }.bind(this)
        }]);
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('cdp07700_calendario_de_producao_Controller', cdp07700_calendario_de_producao_Controller);
});

// FILE: ./assets/modules/producao/assets/js/controllers/cdp26000_controle_prioridade_producaoController.js
function cdp26000_controle_prioridade_producaoController (templateManager, restEngine, General, ScreenService, ZHPromise, cdp26000_controle_prioridade_producaoService){
	
	this.widgetSave = function (widget) {
	    try{
    		var isNew; 
    		cdp26000_controle_prioridade_producaoService.checkNewRowPrioriproducao(widget.currentRow).then(function(success){
    		    isNew = success.dataset.checkNewRowPrioriproducao[0];
    		    widget.currentRow.__is_new = isNew;
                widgetSave(widget);
    		}, function (error) {
                var errorMessage = 'Timeout';
                if (error.data) {
                    errorMessage = error.data.error;
                }
                ScreenService.showMessage(errorMessage);
            });
	    } catch (e) {
	        ScreenService.showMessage(e);
	    }
	};
	
	function widgetSave(widget){
	   var deferred = ZHPromise.defer();

		if (widget.isValid()) {
			widget.currentRow.changed = true;

			if (!widget.currentRow.__is_new)
				widget.currentRow.__is_new = false;
			else if (widget.paramsNewCode && widget.paramsNewCode.__is_new_code) {
				widget.currentRow.__using_unit = widget.paramsNewCode.__using_unit || false;
				widget.currentRow.__new_code_pk = widget.paramsNewCode.__new_code_pk;
				widget.currentRow.__table_pk = widget.paramsNewCode.__table_pk;
				widget.currentRow.__new_code_length = widget.paramsNewCode.__new_code_length || 5;
				widget.currentRow.__cast_number = widget.paramsNewCode.__cast_number || false;
			}

			widget.saveRow().then(function (response) {
				widget.currentRow.changed = false;
				delete widget.backupRow;

				if (General.formWidgetSwitchTemplate(widget) && widget.parent) {
					widget.view();

					var widgets = widget.parent.widgets;
					General.changeWidgetAcessibility(widgets.concat(widget.parent), true);
				} else {
					if (widget.currentRow.__is_new) {
						widget.view();
					} else widget.view();

					General.changeWidgetAcessibility(widget.widgets, true);
				}

				if (widget.currentRow.__is_new) widget.currentRow.__is_new = false;
				else widget.reload();

				deferred.resolve(response);
			}, function (error) {
				var errorMessage = 'Timeout';

				if (error.data) errorMessage = error.data.error;

				ScreenService.showMessage(errorMessage);
				deferred.reject(errorMessage);
			});
		} else deferred.reject("Preencha todos os campos corretamente!");

		return deferred;
	}
}   

Configuration(function(ContextRegister) {
    ContextRegister.register('cdp26000_controle_prioridade_producaoController', cdp26000_controle_prioridade_producaoController);
});

// FILE: ./assets/modules/producao/assets/js/controllers/ger02500_nutrienteController.js
function ger02500_nutrienteController(ScreenService, ger02500_nutrienteService, localStorageEngine, templateManager, General, ZHPromise) {

	var self = this;

	this.abreDetalhesNutriente = function (nutrienteWidget, tabbedWidget, detalhesNutrienteWidget) {
		ScreenService.openSwipe(tabbedWidget);
		for (var i in nutrienteWidget.currentRow) {
			detalhesNutrienteWidget.currentRow[i] = nutrienteWidget.currentRow[i];
		}
	};

	this.editaNutriente = function (nutrienteWidget, tabbedWidget, detalhesNutrienteWidget) {
		self.abreDetalhesNutriente(nutrienteWidget, tabbedWidget, detalhesNutrienteWidget);
		detalhesNutrienteWidget.formTemplate = 'widget/form.html';
		detalhesNutrienteWidget.template = 'widget/form.html';
		detalhesNutrienteWidget.mode = 'edit';
		General.edit(detalhesNutrienteWidget);
	};

	this.cancelaEdicao = function (detalhesNutrienteWidget) {
		self.voltaModoView(detalhesNutrienteWidget);
		self.copiaRow(detalhesNutrienteWidget.backupRow, detalhesNutrienteWidget.currentRow);
	};

	this.salvaEdicao = function (nutrienteWidget, detalhesNutrienteWidget) {
		if (detalhesNutrienteWidget.isValid() && self.validaSigla(detalhesNutrienteWidget)) {
			detalhesNutrienteWidget.currentRow.__is_new = false;
			detalhesNutrienteWidget.currentRow.changed = true;
			detalhesNutrienteWidget.currentRow.DTULTATU = moment().format('L');
			detalhesNutrienteWidget.currentRow.NRORGULTATU = getLocalVar('NRORGTRAB');
			detalhesNutrienteWidget.currentRow.CDOPERULTATU = getLocalVar('CDOPERADOR');
			detalhesNutrienteWidget.dataSource.data = [];
			detalhesNutrienteWidget.saveRow().then(
				function success(success) {
					self.voltaModoView(detalhesNutrienteWidget);
					ScreenService.successNotification(ScreenService.i18n('Nutriente alterado com sucesso'));
					self.copiaRow(detalhesNutrienteWidget.currentRow, nutrienteWidget.currentRow);
				},
				function error(error) {
					var msg;
					if (error.data) {
						msg = ScreenService.i18n(error.data.error);
						ScreenService.showMessage(msg);
					} else {
						msg = ScreenService.i18n("Verifique sua conexão e tente novamente");
						ScreenService.showMessage(msg);
					}
				}
			);
		}
	};

	this.adicionaNutriente = function (nutrienteWidget) {
		newRowGeral(nutrienteWidget);
		ScreenService.openSwipe(nutrienteWidget);
		nutrienteWidget.currentRow.__is_new = true;
	};

	this.cancelaAdicao = function (nutrienteWidget) {
		nutrienteWidget.list(true);
		nutrienteWidget.dataSource.data.pop();
		nutrienteWidget.currentRow = {};
		ScreenService.closeSwipe();
		templateManager.updateTemplate();
	};

	this.validaAdicaoNutriente = function (nutrienteWidget) {
		if (nutrienteWidget.isValid()) {
			if (self.validaCodigoNutri(nutrienteWidget) && self.validaSigla(nutrienteWidget)) {
				var novoCdnutriente = nutrienteWidget.currentRow.CDNUTRIENTE;
				ger02500_nutrienteService.retornaNutriente().then(
					function success(success) {
						var nutriExistente = success.dataset.nutriente.filter(function (i) {
							return novoCdnutriente == i.CDNUTRIENTE;
						});
						if (nutriExistente.length) {
							var msg = ScreenService.i18n("Nutriente") + " '" + nutriExistente[0].CDNUTRIENTE + "' " + ScreenService.i18n("já cadastrado");
							ScreenService.showMessage(msg);
						} else {
							nutrienteWidget.currentRow.IDTIPONUTR = 'N';
							self.salvaAdicao(nutrienteWidget);
						}
					},
					function error(error) {
						var msg;
						if (error.data) {
							msg = ScreenService.i18n(error.data);
							ScreenService.showMessage(msg);
						} else {
							msg = ScreenService.i18n("Verifique sua conexão e tente novamente");
							ScreenService.showMessage(msg);
						}
					}
				);
			}
		}
	};

	this.salvaAdicao = function (nutrienteWidget) {
		$('CDNUTRIENTE').blur();
		return ger02500_nutrienteService.salvaNutriente(nutrienteWidget.currentRow).then(
			function success() {
				nutrienteWidget.list(true);
				nutrienteWidget.currentRow = {};
				ScreenService.closeSwipe();
				return nutrienteWidget.reload().then(function () {
					return ScreenService.successNotification(ScreenService.i18n('Nutriente adicionado com sucesso'));
				});
			},
			function error(error) {
				var msg;
				if (error.data) {
					msg = ScreenService.i18n(error.data);
					ScreenService.showMessage(msg);
				} else {
					msg = ScreenService.i18n("Verifique sua conexão e tente novamente");
					ScreenService.showMessage(msg);
				}
			}
		);
	};

	this.validaCodigoNutri = function (nutrienteWidget) {
		var validado = true;
		if (isNaN(parseFloat(nutrienteWidget.currentRow.CDNUTRIENTE))) {
			var msg = ScreenService.i18n("Código Inválido");
			ScreenService.showMessage(msg);
			validado = false;
		} else if (nutrienteWidget.currentRow.CDNUTRIENTE.length < 3) {
			var num = 3 - nutrienteWidget.currentRow.CDNUTRIENTE.length;
			for (num; num > 0; num--) {
				nutrienteWidget.currentRow.CDNUTRIENTE = '0' + nutrienteWidget.currentRow.CDNUTRIENTE;
			}
		} else if (nutrienteWidget.currentRow.CDNUTRIENTE.length > 3) {
			nutrienteWidget.currentRow.CDNUTRIENTE = nutrienteWidget.currentRow.CDNUTRIENTE.substr(0, 3);
		}
		return validado;
	};

	this.validaSigla = function (nutrienteWidget) {
		var validado = true;
		nutrienteWidget.currentRow.NMREDUZIDO = nutrienteWidget.currentRow.NMREDUZIDO.toUpperCase();
		if (nutrienteWidget.currentRow.NMREDUZIDO.length > 4) {
			nutrienteWidget.currentRow.NMREDUZIDO = nutrienteWidget.currentRow.NMREDUZIDO.substr(0, 4);
		}
		return validado;
	};

	this.excluiNutriente = function (nutrienteWidget) {
		var msg;
		
		if (nutrienteWidget.getCheckedRows().length == 0){
			msg = "Deseja excluir o nutriente " + nutrienteWidget.currentRow.NMNUTRIENTE + "?";
		}
		else if (nutrienteWidget.getCheckedRows().length > 1) {
			msg = "Deseja excluir o " + nutrienteWidget.getCheckedRows().length + " nutrientes selecionados?";
		} else {
			msg = "Deseja excluir o nutriente " + nutrienteWidget.getCheckedRows()[0].NMNUTRIENTE + "?";
		}
		
		if (nutrienteWidget.getCheckedRows().length > 0){
			ScreenService.confirmMessage(msg, 'question', function () {
				ger02500_nutrienteService.excluiNutriente(nutrienteWidget.getCheckedRows()).then(
					function success(argument) {
						nutrienteWidget.reload();
						nutrienteWidget.unSelectAll();
						templateManager.updateTemplate();
						return ScreenService.successNotification(ScreenService.i18n('Nutriente(s) excluído(s) com sucesso'));
					},
					function error(error) {
						var msg;
						if (error.data && error.data.error.indexOf('ORA-02292') !== -1) {
							msg = ScreenService.i18n('Exclusão não permitida. As informações da tabela NUTRIENTE são utilizadas na tabela NUTRPROD');
							ScreenService.showMessage(msg);
						} else if (error.data) {
							msg = ScreenService.i18n(error.data.error);
							ScreenService.showMessage(msg);
						} else {
							msg = ScreenService.i18n("Verifique sua conexão e tente novamente");
							ScreenService.showMessage(msg);
						}
					}
				);
			}, function(){
				nutrienteWidget.unSelectAll();
				templateManager.updateTemplate();
			});
		} else {
			ScreenService.confirmMessage(msg, 'question', function () {
				nutrienteWidget.removeRow().then(
					function success(argument) {
						ScreenService.closeSwipe().then(function(){
							nutrienteWidget.reload(); 	
						});
						return ScreenService.successNotification(ScreenService.i18n('Nutriente excluído com sucesso'));
					},
					function error(error) {
						var msg;
						if (error.data && error.data.error.indexOf('ORA-02292') !== -1) {
							msg = ScreenService.i18n('Exclusão não permitida. As informações da tabela NUTRIENTE são utilizadas na tabela NUTRPROD');
							ScreenService.showMessage(msg);
						} else if (error.data) {
							msg = ScreenService.i18n(error.data.error);
							ScreenService.showMessage(msg);
						} else {
							msg = ScreenService.i18n("Verifique sua conexão e tente novamente");
							ScreenService.showMessage(msg);
						}
					}
				);
			});
		}
	};

	this.voltaModoView = function (widget) {
		ScreenService.closeSwipe();
		widget.view();
		widget.template = "widget/form-view.html";
		templateManager.updateTemplate();
	};

	this.copiaRow = function (rowFonte, rowDestino) {
		for (var i in rowFonte) {
			rowDestino[i] = rowFonte[i];
		}
	};

	var newRowGeral = function (widget) {
		widget.newRow = function () {
			var event;
			if (this.beforeNewRow) {
				event = this.beforeNewRow();
			}
			if (!event || !event.isDefaultPrevented()) {

				var _oldValuesToRepeat = this.getRepeatOnNewValues();
				var row = {};
				if (this.dataSource) {
					this.dataSource.newRow();
					row = this.dataSource.data[this.dataSource.data.length - 1];
				}
				this.currentRow = row;
				this.applyDefaultValue();
				Util.extend(this.currentRow, _oldValuesToRepeat);
				this.edit();
				this.formTemplate = this.templateToForm;
				if (this.onNewRow) {
					this.onNewRow();
				}
			}
		};
		widget.newRow();
	};

}

Configuration(function (ContextRegister) {
	ContextRegister.register('ger02500_nutrienteController', ger02500_nutrienteController);
});

// FILE: ./assets/modules/producao/assets/js/controllers/ger04000_nutrientes_por_produto_Controller.js
function ger04000_nutrientes_por_produto_Controller(ScreenService, General, restEngine) {

	this.salvaProdutoNutrientes = function(widget){
		if(widget.currentRow.QTNUTRPROD < 0){
			ScreenService.showMessage("Quantidade não pode ser negativa.");
		}else {
			if (widget.currentRow.__is_new) {
				General.saveCrud(widget).then(function(){
					ScreenService.successNotification(ScreenService.i18n('Nutriente adicionado com sucesso!'));
				});
			} else {
				widget.saveRow().then(function () {
                    ScreenService.closeSwipe(); 
					widget.reload();
				});	
			}
		}
	};

	this.excluirNutrientes = function (widget) {
		var msg;
		
		if (widget.getCheckedRows().length == 0){
			msg = "Deseja excluir o nutriente " + widget.currentRow.NMNUTRIENTE + "?";
		} else if (widget.getCheckedRows().length > 1) {
			msg = "Deseja excluir os " + widget.getCheckedRows().length + " nutrientes selecionados?";
		} else {
			msg = "Deseja excluir o nutriente " + widget.getCheckedRows()[0].NMNUTRIENTE + "?";
		}
		
		ScreenService.confirmMessage(msg, "question", function () {
			
			if (widget.getCheckedRows().length > 0){
				widget.removeCheckedRows().then(
					function success(argument) {
						return widget.reload().then(function () {
							return ScreenService.successNotification(ScreenService.i18n('Nutriente excluído com sucesso!'));
						});
					},
					function error(error) {
						if (error.data && error.data.error.indexOf('ORA-02292') !== -1) {
							msg = ScreenService.i18n('Exclusão não permitida. As informações da tabela são utilizadas em outras tabelas!');
							ScreenService.showMessage(msg);
						} else if (error.data) {
							msg = ScreenService.i18n(error.data.error);
							ScreenService.showMessage(msg);
						} else {
							msg = ScreenService.i18n("Verifique sua conexão e tente novamente.");
							ScreenService.showMessage(msg);
						}
					}
				);
			} else{
				widget.removeRow().then(
					function success(argument) {
						return widget.reload().then(function () {
							ScreenService.closeSwipe();
							return ScreenService.successNotification(ScreenService.i18n('Nutriente excluído com sucesso!'));
						});
					},
					function error(error) {
						if (error.data && error.data.error.indexOf('ORA-02292') !== -1) {
							msg = ScreenService.i18n('Exclusão não permitida. As informações da tabela são utilizadas em outras tabelas!');
							ScreenService.showMessage(msg);
						} else if (error.data) {
							msg = ScreenService.i18n(error.data.error);
							ScreenService.showMessage(msg);
						} else {
							msg = ScreenService.i18n("Verifique sua conexão e tente novamente.");
							ScreenService.showMessage(msg);
						}
					}
				);
			}
			
		}, function () {
			widget.unSelectAll();
		});
	};

}

Configuration(function (ContextRegister) {
	ContextRegister.register('ger04000_nutrientes_por_produto_Controller', ger04000_nutrientes_por_produto_Controller);
});

// FILE: ./assets/modules/producao/assets/js/controllers/ger04800_equipamento_Controller.js
function ger04800_equipamento_Controller (ZHPromise, templateManager, General, ScreenService, ger04800_equipamento_Service){
    this.newRow = function(widget){
        widget.newRow();
        ger04800_equipamento_Service.newCdEquip().then(function(novoCodigoEquip){
            var newCode = novoCodigoEquip.dataset.newCdEquip[0].NEWCODE;
            widget.currentRow.CDEQUIPPRO = newCode;
        });
    };
}
Configuration(function(ContextRegister) {
    ContextRegister.register('ger04800_equipamento_Controller', ger04800_equipamento_Controller);
});


// FILE: ./assets/modules/producao/assets/js/controllers/ger08800_grupo_de_nutrientesController.js
function ger08800_grupo_de_nutrientesController(ScreenService, localStorageEngine, templateManager, General, ZHPromise) {

	this.salvaGrupoNutrientes = function(widget){
		
		if (widget.currentRow.__is_new) {
			General.saveCrud(widget).then(function (){
				General.changeWidgetAcessibility(widget.widgets, true);
				ScreenService.successNotification(ScreenService.i18n('Grupo de nutrientes adicionado com sucesso!'));
			});
		} else {
			widget.saveRow().then(
				function success() {
					var msg = ScreenService.i18n('Grupo de nutrientes alterado com sucesso');
					ScreenService.successNotification(msg);
					General.changeWidgetAcessibility(widget.widgets, true);
					widget.reload();
					ScreenService.closeSwipe();
				},
				function error(error) {
					var msg;
					if (error.data) {
						msg = ScreenService.i18n(error.data.error);
						ScreenService.showMessage(msg);
					} else {
						msg = ScreenService.i18n("Verifique sua conexão e tente novamente");
						ScreenService.showMessage(msg);
					}
				}				
			);	
		}
	};

	this.editaGrupoNutrientes = function (grupoNutrientesWidget) {
		General.edit(grupoNutrientesWidget);
		General.changeWidgetAcessibility(grupoNutrientesWidget.widgets, false	);
		ScreenService.openSwipe(grupoNutrientesWidget);
	};

	this.excluiGrupoNutriente = function (grupoNutrientesWidget) {
		var msg;
		
		if (grupoNutrientesWidget.getCheckedRows().length == 0){
			msg = "Deseja excluir o nutriente " + grupoNutrientesWidget.currentRow.NMGRUPNUTR + "?";
		} else if (grupoNutrientesWidget.getCheckedRows().length > 1) {
			msg = "Deseja excluir os " + grupoNutrientesWidget.getCheckedRows().length + " grupos selecionados?";
		} else {
			msg = "Deseja excluir o grupo " + grupoNutrientesWidget.getCheckedRows()[0].NMGRUPNUTR + "?";
		}
		
		ScreenService.confirmMessage(msg, 'INFORMATION', function () {
			
			if(grupoNutrientesWidget.getCheckedRows().length > 0){
				grupoNutrientesWidget.removeCheckedRows().then(
					function success() {
						grupoNutrientesWidget.reload().then(function(){
							ScreenService.successNotification(ScreenService.i18n('Grupo de Nutrientes excluído com sucesso'));
						});
					},
					function error(error) {
						if (error.data && error.data.error.indexOf('ORA-02292') !== -1) {
							msg = ScreenService.i18n('Exclusão não permitida. As informações da tabela GRUPNUTR são utilizadas na tabela NUTRIENTE');
							ScreenService.showMessage(msg);
						} else if (error.data) {
							msg = ScreenService.i18n(error.data.error);
							ScreenService.showMessage(msg);
						} else {
							msg = ScreenService.i18n("Verifique sua conexão e tente novamente");
							ScreenService.showMessage(msg);
						}
					}
				);	
			} else{
				grupoNutrientesWidget.removeRow().then(
					function success(argument) {
						return grupoNutrientesWidget.reload().then(function () {
							ScreenService.closeSwipe();
							return ScreenService.successNotification(ScreenService.i18n('Nutriente excluído com sucesso!'));
						});
					},
					function error(error) {
						if (error.data && error.data.error.indexOf('ORA-02292') !== -1) {
							msg = ScreenService.i18n('Exclusão não permitida. As informações da tabela são utilizadas em outras tabelas!');
							ScreenService.showMessage(msg);
						} else if (error.data) {
							msg = ScreenService.i18n(error.data.error);
							ScreenService.showMessage(msg);
						} else {
							msg = ScreenService.i18n("Verifique sua conexão e tente novamente.");
							ScreenService.showMessage(msg);
						}
					}
				);
			}
			
		}, function () {
			grupoNutrientesWidget.unSelectAll();
			templateManager.updateTemplate();
		});
	};

	this.salvaInclusaoNutrientes = function (nutrientesWidget) {
		var nutrienteNovo = nutrientesWidget.currentRow.NMNUTRIENTE;
		var cdgrupnutr = nutrientesWidget.currentRow.CDGRUPNUTR;
		var nmgrupnutr = nutrientesWidget.currentRow.nmgrupnutr;
		var nmgrupalvo = General.getFieldValue('NMGRUPNUTR','GrupoNutrientesWidget');
		var msg;
		
		if(cdgrupnutr == null){
			msg = 'Deseja incluir ' + nutrienteNovo + ' no grupo ' + nmgrupalvo + '?';
		} else if(cdgrupnutr == templateManager.container.getWidget('GrupoNutrientesWidget').fields[0].value()){
			ScreenService.showMessage(nutrienteNovo + ' já faz parte do grupo de ' + nmgrupalvo);
			return;
		} else{
			msg = nutrienteNovo + ' pertence ao grupo de nutrientes ' +  nmgrupnutr + '. Deseja deslocá-lo ao grupo ' + nmgrupalvo + '?';			
		}
		
		ScreenService.confirmMessage(msg, 'INFORMATION', function(){
			nutrientesWidget.currentRow.CDGRUPNUTR = templateManager.container.getWidget('GrupoNutrientesWidget').fields[0].value();
			nutrientesWidget.currentRow.__is_new = false;
			nutrientesWidget.currentRow.changed = true;
		
			nutrientesWidget.saveRow().then(
				function success() {
					nutrientesWidget.reload().then(function(){
						nutrientesWidget.fields[2].reload().then(function(){
							ScreenService.closeSwipe();
							var msg = ScreenService.i18n('Nutriente incluído com sucesso');
							ScreenService.successNotification(msg);	
						});
					});
				},
				function error(error) {
					var msg;
					if (error.data) {
						msg = ScreenService.i18n(error.data.error);
						ScreenService.showMessage(msg);
					} else {
						msg = ScreenService.i18n("Verifique sua conexão e tente novamente");
						ScreenService.showMessage(msg);
					}
				}
			);
		});
	};

	this.excluiNutriente = function (nutrientesWidget) {
		var nmgrupnutr = General.getFieldValue('NMGRUPNUTR', 'GrupoNutrientesWidget');
		var msg;
		
		if(nutrientesWidget.getCheckedRows().length == 0){
			msg = "Deseja excluir o nutriente " + nutrientesWidget.currentRow.NMNUTRIENTE + " do grupo " + nmgrupnutr + "?";
		}
		else if (nutrientesWidget.getCheckedRows().length > 1) {
			msg = "Deseja excluir os " + nutrientesWidget.getCheckedRows().length + " nutrientes selecionados do grupo " + nmgrupnutr + "?";
		} else {
			msg = "Deseja excluir o nutriente " + nutrientesWidget.getCheckedRows()[0].NMNUTRIENTE + " do grupo " + nmgrupnutr + "?";
		}
		
		ScreenService.confirmMessage(msg, 'INFORMATION', function () {
			
			if(nutrientesWidget.dataSource.getCheckedRows().length > 0){
				var excluidos = nutrientesWidget.dataSource.getCheckedRows();
				excluidos.forEach(function (nutriente) {
					nutriente.CDGRUPNUTR = null;
					nutriente.__is_new = false;
					nutriente.changed = true;
				});
				
				nutrientesWidget.dataSource.save().then(
				function success() {
					nutrientesWidget.reload().then(function(){
						nutrientesWidget.fields[2].reload().then(function(){
							nutrientesWidget.unSelectAll();
							msg = ScreenService.i18n('Nutriente(s) excluídos(s) com sucesso');
							ScreenService.successNotification(msg);
						});
					});
				},
				function error(error) {
					if (error.data) {
						msg = ScreenService.i18n(error.data.error);
						ScreenService.showMessage(msg);
					} else {
						msg = ScreenService.i18n("Verifique sua conexão e tente novamente");
						ScreenService.showMessage(msg);
					}
				}
			);
			}else{
				nutrientesWidget.currentRow.CDGRUPNUTR = null;
				nutrientesWidget.currentRow.__is_new = false;
				nutrientesWidget.changed = true;
				
				nutrientesWidget.saveRow().then(
					function success() {
							nutrientesWidget.fields[2].reload().then(function(){
								msg = ScreenService.i18n('Nutriente excluídos com sucesso');
								ScreenService.successNotification(msg);
								ScreenService.closeSwipe().then(function(){
									nutrientesWidget.reload();
								});
							});
					},
					function error(error) {
						if (error.data) {
							msg = ScreenService.i18n(error.data.error);
							ScreenService.showMessage(msg);
					    } else {
							msg = ScreenService.i18n("Verifique sua conexão e tente novamente");
							ScreenService.showMessage(msg);
					    }
					}
				);
			}
			
		}, function () {
			nutrientesWidget.unSelectAll();
			templateManager.updateTemplate();
		});
	};
}

Configuration(function (ContextRegister) {
	ContextRegister.register('ger08800_grupo_de_nutrientesController', ger08800_grupo_de_nutrientesController);
});

// FILE: ./assets/modules/producao/assets/js/controllers/ger10700_tipo_de_vistoController.js
function ger10700_tipo_de_vistoController (templateManager, ScreenService, General){
    
    this.reload = function(){
		var widget = templateManager.container.getActiveWidget();
		widget.reload();
	};
    
    this.salvarGrupoper = function(widget){
        widget.currentRow.CDTIPOVISTO = widget.parent.currentRow.CDTIPOVISTO ;
        General.saveCrud(widget);
    };
    
    this.ativaGrupoOper = function(){
        templateManager.container.getWidget('widgetTipoDeVisto').active = false;
        templateManager.container.getWidget('tabbedTipoDeVisto').reload();
        templateManager.container.getWidget('tabbedTipoDeVisto').activate();
    };
    
    this.salvarTpVisto = function(widget){
        if(widget.currentRow.IDTPRESPVIST){
            General.saveCrud(widget);
        } else {
            widget.currentRow.IDTPRESPVIST = "N";
            General.saveCrud(widget);
        }

		templateManager.updateTemplate();
    };

}
Configuration(function(ContextRegister) {
    ContextRegister.register('ger10700_tipo_de_vistoController', ger10700_tipo_de_vistoController);
});

// FILE: ./assets/modules/producao/assets/js/controllers/ger15600_setorController.js
function ger15600_setorController (ScreenService, templateManager, General){
	
	this.reload = function(){
		var widgetSetor = templateManager.container.getWidget('widgetSetor');
		widgetSetor.reload();
	};
	
	this.createSetor = function(widget) {
        widget.reload();
        widget.newRow();
        widget.currentRow.__is_new = true;
    };
    
    this.edit = function(widget){
        widget.backupRow = Util.clone(widget.currentRow);
        widget.edit();
    };
    
    this.cancel = function(widget){
        if(widget.currentRow.__is_new === true){
            widget.dataSource.data.pop();
            ScreenService.closeSwipe();
        } else {
            Util.extend(widget.currentRow, widget.backupRow);
            widget.view();
        }
        this.reload();
    };
    
    this.verificaCodigo = function(){
        var codigo = templateManager.container.getWidget('widgetSetor').getField('CDSETOR').value();
        if(isNaN(codigo)){
            ScreenService.showMessage("O campo 'Setor' deve conter apenas números");
            templateManager.container.getWidget('widgetSetor').getField('CDSETOR').setValue('');
        }
    };
    
    this.salvar = function(widget){
        var codigo = templateManager.container.getWidget('widgetSetor').getField('CDSETOR').value();
        if(isNaN(codigo)){
            ScreenService.showMessage("O campo 'Setor' deve conter apenas números");
            templateManager.container.getWidget('widgetSetor').getField('CDSETOR').setValue('');
        }else{
            if(widget.isValid() == true){
                if(widget.currentRow.__is_new === false) widget.currentRow.oldSigla = widget.backupRow.SGSETOR;
                General.callRestEngine('cdp_producao#/setor_departamento_centcust/save', 'Row', widget.currentRow).then(function(callback){
                    if (widget.currentRow.__is_new) {
    					widget.list(true);
    					ScreenService.goBack();
    					widget.reload();
    				} else {
    					widget.computeDescriptionOrder();
    					widget.view();
    				}
    				ScreenService.showMessage("Salvo com sucesso.");
                }).catch(function(callback){
                    if(callback.data.error.length > 0){
                        ScreenService.showMessage(callback.data.error);
                    }else{
                        ScreenService.showMessage("Sigla já cadastrada.");
                    }
                });
            }
        }
    };
      
}
Configuration(function(ContextRegister) {
    ContextRegister.register('ger15600_setorController', ger15600_setorController);
});

// FILE: ./assets/modules/producao/assets/js/controllers/ger20000_via_de_acesso_administracaoController.js
function ger20000_via_de_acesso_administracaoController (templateManager, ScreenService, General){
    
    this.reload = function(){
		var widgetViaDeAcessoAdiministracao = templateManager.container.getWidget('widgetViaDeAcessoAdiministracao');
		widgetViaDeAcessoAdiministracao.reload();
	};
	
	this.create = function(widget) {
        widget.reload();
        widget.newRow();
        widget.currentRow.__is_new = true;
    };
    
    this.edit = function(widget){
        widget.backupRow = Util.clone(widget.currentRow);
        widget.edit();
    };
    
    this.cancel = function(widget){
        if(widget.currentRow.__is_new === true){
            widget.dataSource.data.pop();
            ScreenService.closeSwipe();
        } else {
            Util.extend(widget.currentRow, widget.backupRow);
            widget.view();
        }
        this.reload();
    };
    
    this.verificaCodigo = function(){
        var codigo = templateManager.container.getWidget('widgetViaDeAcessoAdiministracao').getField('CDVIACESDIET').value();
        if(isNaN(codigo)){
            ScreenService.showMessage("O campo 'Código' deve conter apenas números");
            templateManager.container.getWidget('widgetViaDeAcessoAdiministracao').getField('CDVIACESDIET').setValue('');
        }
    };
    
    this.salvar = function(widget){
        var codigo = templateManager.container.getWidget('widgetViaDeAcessoAdiministracao').getField('CDVIACESDIET').value();
        if(isNaN(codigo)){
            ScreenService.showMessage("O campo 'Código' deve conter apenas números");
            templateManager.container.getWidget('widgetViaDeAcessoAdiministracao').getField('CDVIACESDIET').setValue('');
        }
        else{
            General.saveCrud(widget);
        }
    };
}
Configuration(function(ContextRegister) {
    ContextRegister.register('ger20000_via_de_acesso_administracaoController', ger20000_via_de_acesso_administracaoController);
});

// FILE: ./assets/modules/producao/assets/js/controllers/ger21000_formas_de_apresentacaoController.js
function ger21000_formas_de_apresentacaoController(ScreenService, templateManager, General, ZHPromise) {

	this.excluir = function (widget) {
		var msg;
		
		if (widget.getCheckedRows().length == 0){
			msg = "Deseja excluir a forma " + widget.currentRow.NMAPRERECE + "?";
		}else if (widget.getCheckedRows().length > 1) {
			msg = "Deseja excluir as " + widget.getCheckedRows().length + " formas selecionadas?";
		} else {
			msg = "Deseja excluir a forma " + widget.getCheckedRows()[0].NMAPRERECE + "?";
		}
		
		return ScreenService.confirmMessage(msg, 'INFORMATION', function () {
			
			if(widget.getCheckedRows().length > 0){
				widget.removeCheckedRows().then(
					function success() {
						widget.reload().then(function(){
							ScreenService.closeSwipe();
							msg = ScreenService.i18n('Forma de apresentação excluída com sucesso');
							return ScreenService.successNotification(msg);
						});
					},
					function error(error) {
						if (error.data && error.data.error.indexOf('ORA-02292') !== -1) {
							ScreenService.showMessage(ScreenService.i18n('Exclusão não permitida. As informações da tabela APRERECE são utilizadas em outras tabelas'));
						} else if (error.data) {
							msg = ScreenService.i18n(error.data.error);
							ScreenService.showMessage(msg);
						} else {
							msg = ScreenService.i18n("Verifique sua conexão e tente novamente");
							ScreenService.showMessage(msg);
						}
					}
				);
			} else{
				widget.removeRow().then(
					function success() {
						widget.reload().then(function(){
							ScreenService.closeSwipe();
							msg = ScreenService.i18n('Forma de apresentação excluída com sucesso');
							return ScreenService.successNotification(msg);
						});
					},
					function error(error) {
						if (error.data && error.data.error.indexOf('ORA-02292') !== -1) {
							ScreenService.showMessage(ScreenService.i18n('Exclusão não permitida. As informações da tabela APRERECE são utilizadas em outras tabelas'));
						} else if (error.data) {
							msg = ScreenService.i18n(error.data.error);
							ScreenService.showMessage(msg);
						} else {
							msg = ScreenService.i18n("Verifique sua conexão e tente novamente");
							ScreenService.showMessage(msg);
						}
					}
				);
			}
		}, function () {
			widget.unSelectAll();
			templateManager.updateTemplate();
		});
	};

	this.salvar = function (widget) {
		if (widget.isValid()) {
			$("#CDAPRERECE").blur();
			if (widget.currentRow.__is_new) {
				widget.currentRow.DTULTATU = moment().format('L');
				widget.currentRow.NRORG = getLocalVar('NRORGTRAB');
				widget.currentRow.NRORGULTATU = getLocalVar('NRORGTRAB');
				widget.currentRow.CDOPERULTATU = getLocalVar('CDOPERADOR');
			}
			widget.saveRow().then(
				function success(success) {
					widget.list();
					ScreenService.closeSwipe();
					widget.reload();
					ScreenService.successNotification(ScreenService.i18n('Forma de apresentação salva com sucesso'));
				},
				function error(error) {
					var msg;
					if (error.data && error.data.error.indexOf('ORA-00001') !== -1) {
						msg = ScreenService.i18n('Código existente');
						ScreenService.showMessage(msg);
					} else if (error.data) {
						msg = ScreenService.i18n(error.data.error);
						ScreenService.showMessage(msg);
					} else {
						msg = ScreenService.i18n("Verifique sua conexão e tente novamente");
						ScreenService.showMessage(msg);
					}
				}
			);
		}
	};
}

Configuration(function (ContextRegister) {
	ContextRegister.register('ger21000_formas_de_apresentacaoController', ger21000_formas_de_apresentacaoController);
});

// FILE: ./assets/modules/producao/assets/js/controllers/ger24000_habilidadeController.js
function ger24000_habilidadeController (templateManager, restEngine, General, ScreenService, ZHPromise, ger24000_habilidadeService){
	
	var self = this;
	
	this.backOrCancel = function(args){
	    General.backOrCancel(args).then (function (){
	        if (args.owner.widget.name === 'grid_habilidade'){
	           General.changeWidgetAcessibility(args.owner.widget.widgets, true);
	        } 
	        if (args.owner.widget.name === 'grid_operador'){
	            args.owner.widget.getField('NMOPERADOR').readOnly = false;
	        }
	    });
	};
	
	this.activateTabs = function(args){
	    General.formWidgetSwitchTemplate(args.owner.widget);
	        var widgetsToActivate = args.owner.widget.widgets;

			General.changeWidgetAcessibility(
				widgetsToActivate.filter(function (subwidget) {
					return subwidget.name != args.owner.widget.name;
				}).concat(args.owner.widget), //retorna um array com a widget parent e suas widgets filhas, exceto aquela que será editada
				true);
				args.owner.widget.view();
	};
    
    this.validateFilterPopup = function(widget){
        var popup = widget.__filterPopup;
        var IDSITUACAOHABIL = popup.currentRow.IDSITUACAOHABIL;
        
        var IDGRUPHABILIDAD = popup.currentRow.IDGRUPHABILIDAD;

        if(!(IDSITUACAOHABIL)){
            widget.dataSourceFilter[1].value = 'T';
        }
        else{
            widget.dataSourceFilter[1].value = IDSITUACAOHABIL;
        }
        if(!(IDSITUACAOHABIL && IDGRUPHABILIDAD)){
            widget.dataSourceFilter[0].value = 'T';
        }
        else{
            widget.dataSourceFilter[0].value = IDGRUPHABILIDAD;
        }
            
    };
    
    this.saveCrud = function(widget){
        if(widget.currentRow.__is_new)
            General.saveCrud(widget).then(function(){
                General.changeWidgetAcessibility(widget.widgets, true);
            });
        else
            General.widgetSave(widget);
        if (widget.name === 'grid_operador'){
	        widget.getField('NMOPERADOR').readOnly = false;
	    }    
        
    };
    
    this.validateCusto = function(field){
        var VRCUSHRHABIL = field.value();
        
        if(VRCUSHRHABIL){
            if(parseFloat(VRCUSHRHABIL) > 999999999999999999999999999999999999999999999999999999999999999999999999999999999999999999999999999999999999999999999999999999 || parseFloat(VRCUSHRHABIL) < 0){
                ScreenService.errorNotification("Custo/Hora deve ter até 3 digitos e ser positivo");
                field.setValue('');
            }
        }
            
    };
    
    this.widgetEdit = function(widget){
        widget.getField('NMOPERADOR').readOnly = true;
        General.widgetEdit(widget);
    };
    
    this.saveCustohab = function(widget){
        
        var deferred = ZHPromise.defer();
        
        ScreenService.confirmMessage(ScreenService.i18n('Custo/Hora será alterado.\n Deseja Continuar?'), 'question', function (success) {
    		if (widget.isValid()) {
    			widget.currentRow.changed = true;
    
    			if (!widget.currentRow.__is_new)
    				widget.currentRow.__is_new = false;
    			else if (widget.paramsNewCode && widget.paramsNewCode.__is_new_code) {
    				widget.currentRow.__using_unit = widget.paramsNewCode.__using_unit || false;
    				widget.currentRow.__new_code_pk = widget.paramsNewCode.__new_code_pk;
    				widget.currentRow.__table_pk = widget.paramsNewCode.__table_pk;
    				widget.currentRow.__new_code_length = widget.paramsNewCode.__new_code_length || 5;
    				widget.currentRow.__cast_number = widget.paramsNewCode.__cast_number || false;
    			}
        
                var oldVRCUSHRHAB = Util.clone(widget.parent.currentRow.VRCUSHRHABIL);
                updateVRCUSHRHABIL(widget);
                var dataset = [];
                dataset.push(widget.currentRow, widget.parent.currentRow);
                ger24000_habilidadeService.saveCustohab(dataset).then(function (response) {
    				widget.currentRow.changed = false;
    				delete widget.backupRow;
    
    				if (General.formWidgetSwitchTemplate(widget) && widget.parent) {
    					widget.view();
    
    					var widgets = widget.parent.widgets;
    					General.changeWidgetAcessibility(widgets.concat(widget.parent), true);
    				} else {
    					if (widget.currentRow.__is_new) {
    						ScreenService.closeSwipe();
    						widget.list();
    						widget.reload();
    					} else widget.view();
    
    					General.changeWidgetAcessibility(widget.widgets, true);
    				}
    
    				if (widget.currentRow.__is_new) widget.currentRow.__is_new = false;
    				else widget.reload();
    
    				deferred.resolve(response);
    			}, function (error) {
    			    oldVRCUSHRHAB = widget.parent.currentRow.VRCUSHRHABIL;
    			    
    				var errorMessage = 'Timeout';
    
    				if (error.data) errorMessage = error.data.error;
    
    				ScreenService.showMessage(errorMessage);
    				deferred.reject(errorMessage);
    			});
    		} else deferred.reject("Preencha todos os campos corretamente!");
        });


		return deferred;
    };
    
    function updateVRCUSHRHABIL(widget){
        var deferred = ZHPromise.defer();
        var VRCUSHRHABIL = 0;
        widget.dataSource.data.forEach(function(data){
            VRCUSHRHABIL = parseFloat(VRCUSHRHABIL) + parseFloat(data.VRCUSTOHAB);
        });
        widget.parent.currentRow.VRCUSHRHABIL = VRCUSHRHABIL;
        return deferred.promise;
    }
    
}
Configuration(function(ContextRegister) {
    ContextRegister.register('ger24000_habilidadeController', ger24000_habilidadeController);
});

// FILE: ./assets/modules/producao/assets/js/controllers/ger55000_informacoes_adicionais_Controller.js
function ger55000_informacoes_adicionais_Controller (templateManager, restEngine, General, ScreenService, ZHPromise, ger55000_informacoes_adicionais_Service){
	
	var self = this;
	
	this.widgetEdit = function(widget){
		
	    if(widget.currentRow == undefined || Object.keys(widget.currentRow).length == 0){
	        
	        widget.currentRow = {};
	        General.widgetNewRow(widget);
	        widget.currentRow.CDPRODUTO = General.getFieldValue('CDPRODUTO', 'grid_produtos');
	        General.formWidgetSwitchTemplate(widget);

	    } else {
	        General.widgetEdit(widget);
	    }
	};
	
	this.widgetSave = function (args) {
        General.widgetSave(args.owner.widget).then(function (response){
                args.owner.widget.list();
        });
	};
	this.atualizaCurrentRow = function() {
		var meuWidget = templateManager.container.getActiveWidget();
        if(meuWidget.dataSource.data[0] == undefined){
        	meuWidget.currentRow = {};
        }
        else {
        	meuWidget.currentRow = meuWidget.dataSource.data[0];
        }
    };
	
	this.backOrCancel = function(args){
	    General.backOrCancel(args).then (function (){
	        self.activateTabs(args);
	    });
	};
	
	this.activateTabs = function(args){
	    General.formWidgetSwitchTemplate(args.owner.widget);
	        var widgetsToActivate = args.owner.widget.parent.widgets;

			General.changeWidgetAcessibility(
				widgetsToActivate.filter(function (subwidget) {
					return subwidget.name != args.owner.widget.name;
				}).concat(args.owner.widget.parent), //retorna um array com a widget parent e suas widgets filhas, exceto aquela que será editada
				true);
				args.owner.widget.list();
	};
	
	this.valida_ProdutoAte = function(widget) {
	    var limite;
	    var popup = widget.__filterPopup;
        // Variável booleana que é setada como true caso alguma empresa tenha sido selecionada.
        var CDARVPRODINI_IsSelected = !!popup.currentRow.CDARVPRODINI;
        
        var Nmarvprodfinfield = popup.getField('NMARVPRODFIN');
        var Nmarvprodinifield = popup.getField('NMARVPRODINI');
        
        Nmarvprodinifield.dataSource.data.forEach(function(obj){
            if(obj.CDARVPROD === popup.currentRow.CDARVPRODINI){
                limite = obj.ROWNUM;
            }
        });

        // Altera as propriedades do field 'Lote__Ate' e reseta seu valor.
        if(CDARVPRODINI_IsSelected)
            Nmarvprodfinfield.validations.required = CDARVPRODINI_IsSelected;
        else
            delete(Nmarvprodfinfield.validations.required);
        Nmarvprodfinfield.readOnly = !CDARVPRODINI_IsSelected;
        Nmarvprodfinfield.setValue(null);
        Nmarvprodfinfield.needReload = true;
        popup.currentRow.limite = limite;
    };    
    
    this.prodFin = function(widget){
	    var popup = widget.__filterPopup;
        var limite = popup.currentRow.limite;
        var dataArrayProdFin = popup.getField('NMARVPRODFIN').dataSource.data;
        
        dataArrayProdFin.splice(0, limite);
        
    };
    
    this.validateFilterPopup = function(widget){
        var popup = widget.__filterPopup;
        // Variável booleana que é setada como true caso alguma empresa tenha sido selecionada.
        var CDARVPRODINI = popup.currentRow.CDARVPRODINI;
        
        var CDARVPRODFIN = popup.currentRow.CDARVPRODFIN;
        var Nmarvprodfinfield = popup.getField('NMARVPRODFIN');

        // Altera as propriedades do field 'Lote__Ate' e reseta seu valor.
        if((!(CDARVPRODINI && CDARVPRODFIN)) || (CDARVPRODINI === CDARVPRODFIN)){
            widget.dataSourceFilter[3].value = 'T';
            widget.dataSourceFilter[0].value = '';
            widget.dataSourceFilter[1].value = '';
        }
        else{
            widget.dataSourceFilter[3].value = '';
            widget.dataSourceFilter[0].value = CDARVPRODINI;
            widget.dataSourceFilter[1].value = CDARVPRODFIN;
            delete(Nmarvprodfinfield.validations.required);
        }
            
    };
    
    this.saveInfo = function(args){
        var widget = args.owner.widget;
        try{
            self.save(widget).then(function(){
                General.modEdit(widget);
                General.cancelModEdit(args);
            });
        } catch (e) {
			ScreenService.showMessage(e);
		}
    };
    
    this.save = function(widget){
    		var deferred = ZHPromise.defer();
    
    		if (widget.isValid()) {
    			widget.currentRow.changed = true;
    
    			if (!widget.currentRow.__is_new)
    				widget.currentRow.__is_new = false;
    			else if (widget.paramsNewCode && widget.paramsNewCode.__is_new_code) {
    				widget.currentRow.__using_unit = widget.paramsNewCode.__using_unit || false;
    				widget.currentRow.__new_code_pk = widget.paramsNewCode.__new_code_pk;
    				widget.currentRow.__table_pk = widget.paramsNewCode.__table_pk;
    				widget.currentRow.__new_code_length = widget.paramsNewCode.__new_code_length || 5;
    				widget.currentRow.__cast_number = widget.paramsNewCode.__cast_number || false;
    			}
    
    			ger55000_informacoes_adicionais_Service.saveInfo(widget).then(function (response) {
    				widget.currentRow.changed = false;
    				delete widget.backupRow;
    
    				if (General.formWidgetSwitchTemplate(widget) && widget.parent) {
    					widget.view();
    
    					var widgets = widget.parent.widgets;
    					General.changeWidgetAcessibility(widgets.concat(widget.parent), true);
    				} else {
    					if (widget.currentRow.__is_new) {
    						ScreenService.closeSwipe();
    						widget.view();
    					} else widget.view();
    
    					General.changeWidgetAcessibility(widget.widgets, true);
    				}
    
    				if (widget.currentRow.__is_new) widget.currentRow.__is_new = false;
    				deferred.resolve(response);
    			}, function (error) {
    				var errorMessage = 'Timeout';
    
    				if (error.data) errorMessage = error.data.error;
    
    				ScreenService.showMessage(errorMessage);
    				deferred.reject(errorMessage);
    			});
    		} else deferred.reject("Preencha todos os campos corretamente!");
    
    		return deferred;
    };
    
    this.deleteRefBibOrCondArm = function(widget){
        var deferred = ZHPromise.defer();
		ScreenService.confirmMessage(ScreenService.i18n('Delete Register?'), 'question', function (success) {
		    var field = widget.fields[1];
		    field.setValue('');
			General.widgetSave(widget).then(function () {
			    General.formWidgetSwitchTemplate(widget);
				widget.list();
				widget.activate();
				deferred.resolve();
			}, function (error) {
				if (error.data && error.data.error.indexOf('ORA-02292') !== -1) {
					ScreenService.showMessage('Exclusão não permitida! O registro possui registros filhos.');
				} else {
					ScreenService.showMessage(error.data.error);
				}
				deferred.reject();
			});
		});
		return deferred.promise;
    };
    
    this.deleteDadosQuimicos = function(widget){
        var deferred = ZHPromise.defer();
		ScreenService.confirmMessage(ScreenService.i18n('Delete Register?'), 'question', function (success) {
		    var formula = widget.getField('DSFORMULAMOL');
		    var peso = widget.getField('VRPESOMOL');
		    formula.setValue('');
		    peso.setValue('');
			General.widgetSave(widget).then(function () {
			    General.formWidgetSwitchTemplate(widget);
				widget.list();
				widget.activate();
				deferred.resolve();
			}, function (error) {
				if (error.data && error.data.error.indexOf('ORA-02292') !== -1) {
					ScreenService.showMessage('Exclusão não permitida! O registro possui registros filhos.');
				} else {
					ScreenService.showMessage(error.data.error);
				}
				deferred.reject();
			});
		});
		return deferred.promise;
    };
    
    this.saveTextBlob = function(args){
        var widget = args.owner.widget;
        try{
        	switch(widget.name){
        		case "tabbed_DCB":
        			saveDCB(widget).then(function(){
		                widget.formTemplate = widget.templateToView;
		            });
        			break;
        		case "tabbed_CAS":
        			saveCAS(widget).then(function(){
		                widget.formTemplate = widget.templateToView;
		            });
        			break;
        		case "tabbed_INCI":
        			saveINCI(widget).then(function(){
		                widget.formTemplate = widget.templateToView;
		            });
        			break;
        		case "tabbed_DCI":
        			saveDCI(widget).then(function(){
		                widget.formTemplate = widget.templateToView;
		            });
        			break;
        		
        	}
        } catch (e) {
			ScreenService.showMessage(e);
		}
    };
    
    function saveDCB(widget){
    		var deferred = ZHPromise.defer();
    
    		if (widget.isValid()) {
    			widget.currentRow.changed = true;
    
    			if (!widget.currentRow.__is_new)
    				widget.currentRow.__is_new = false;
    			else if (widget.paramsNewCode && widget.paramsNewCode.__is_new_code) {
    				widget.currentRow.__using_unit = widget.paramsNewCode.__using_unit || false;
    				widget.currentRow.__new_code_pk = widget.paramsNewCode.__new_code_pk;
    				widget.currentRow.__table_pk = widget.paramsNewCode.__table_pk;
    				widget.currentRow.__new_code_length = widget.paramsNewCode.__new_code_length || 5;
    				widget.currentRow.__cast_number = widget.paramsNewCode.__cast_number || false;
    			}
    
    			ger55000_informacoes_adicionais_Service.saveDCB(widget).then(function (response) {
    				widget.currentRow.changed = false;
    				delete widget.backupRow;
    
    				if (General.formWidgetSwitchTemplate(widget) && widget.parent) {
    					widget.list();
    
    					var widgets = widget.parent.widgets;
    					General.changeWidgetAcessibility(widgets.concat(widget.parent), true);
    				} else {
    					if (widget.currentRow.__is_new) {
    						ScreenService.closeSwipe();
    						widget.list();
    					} else widget.list();
    
    					General.changeWidgetAcessibility(widget.widgets, true);
    				}
    
    				if (widget.currentRow.__is_new) widget.currentRow.__is_new = false;
    				deferred.resolve(response);
    			}, function (error) {
    				var errorMessage = 'Timeout';
    
    				if (error.data) errorMessage = error.data.error;
    
    				ScreenService.showMessage(errorMessage);
    				widget.formTemplate = widget.templateToView;
    				deferred.reject(errorMessage);
    			});
    		} else deferred.reject("Preencha todos os campos corretamente!");
    
    		return deferred;
    }
    
    function saveCAS(widget){
    		var deferred = ZHPromise.defer();
    
    		if (widget.isValid()) {
    			widget.currentRow.changed = true;
    
    			if (!widget.currentRow.__is_new)
    				widget.currentRow.__is_new = false;
    			else if (widget.paramsNewCode && widget.paramsNewCode.__is_new_code) {
    				widget.currentRow.__using_unit = widget.paramsNewCode.__using_unit || false;
    				widget.currentRow.__new_code_pk = widget.paramsNewCode.__new_code_pk;
    				widget.currentRow.__table_pk = widget.paramsNewCode.__table_pk;
    				widget.currentRow.__new_code_length = widget.paramsNewCode.__new_code_length || 5;
    				widget.currentRow.__cast_number = widget.paramsNewCode.__cast_number || false;
    			}
    
    			ger55000_informacoes_adicionais_Service.saveCAS(widget).then(function (response) {
    				widget.currentRow.changed = false;
    				delete widget.backupRow;
    
    				if (General.formWidgetSwitchTemplate(widget) && widget.parent) {
    					widget.list();
    
    					var widgets = widget.parent.widgets;
    					General.changeWidgetAcessibility(widgets.concat(widget.parent), true);
    				} else {
    					if (widget.currentRow.__is_new) {
    						ScreenService.closeSwipe();
    						widget.list();
    					} else widget.list();
    
    					General.changeWidgetAcessibility(widget.widgets, true);
    				}
    
    				if (widget.currentRow.__is_new) widget.currentRow.__is_new = false;
    				deferred.resolve(response);
    			}, function (error) {
    				var errorMessage = 'Timeout';
    
    				if (error.data) errorMessage = error.data.error;
    
    				ScreenService.showMessage(errorMessage);
    				deferred.reject(errorMessage);
    			});
    		} else deferred.reject("Preencha todos os campos corretamente!");
    
    		return deferred;
    }
    
    function saveINCI(widget){
    		var deferred = ZHPromise.defer();
    
    		if (widget.isValid()) {
    			widget.currentRow.changed = true;
    
    			if (!widget.currentRow.__is_new)
    				widget.currentRow.__is_new = false;
    			else if (widget.paramsNewCode && widget.paramsNewCode.__is_new_code) {
    				widget.currentRow.__using_unit = widget.paramsNewCode.__using_unit || false;
    				widget.currentRow.__new_code_pk = widget.paramsNewCode.__new_code_pk;
    				widget.currentRow.__table_pk = widget.paramsNewCode.__table_pk;
    				widget.currentRow.__new_code_length = widget.paramsNewCode.__new_code_length || 5;
    				widget.currentRow.__cast_number = widget.paramsNewCode.__cast_number || false;
    			}
    
    			ger55000_informacoes_adicionais_Service.saveINCI(widget).then(function (response) {
    				widget.currentRow.changed = false;
    				delete widget.backupRow;
    
    				if (General.formWidgetSwitchTemplate(widget) && widget.parent) {
    					widget.list();
    
    					var widgets = widget.parent.widgets;
    					General.changeWidgetAcessibility(widgets.concat(widget.parent), true);
    				} else {
    					if (widget.currentRow.__is_new) {
    						ScreenService.closeSwipe();
    						widget.list();
    					} else widget.list();
    
    					General.changeWidgetAcessibility(widget.widgets, true);
    				}
    
    				if (widget.currentRow.__is_new) widget.currentRow.__is_new = false;
    				deferred.resolve(response);
    			}, function (error) {
    				var errorMessage = 'Timeout';
    
    				if (error.data) errorMessage = error.data.error;
    
    				ScreenService.showMessage(errorMessage);
    				deferred.reject(errorMessage);
    			});
    		} else deferred.reject("Preencha todos os campos corretamente!");
    
    		return deferred;
    }
    
    function saveDCI(widget){
    		var deferred = ZHPromise.defer();
    
    		if (widget.isValid()) {
    			widget.currentRow.changed = true;
    
    			if (!widget.currentRow.__is_new)
    				widget.currentRow.__is_new = false;
    			else if (widget.paramsNewCode && widget.paramsNewCode.__is_new_code) {
    				widget.currentRow.__using_unit = widget.paramsNewCode.__using_unit || false;
    				widget.currentRow.__new_code_pk = widget.paramsNewCode.__new_code_pk;
    				widget.currentRow.__table_pk = widget.paramsNewCode.__table_pk;
    				widget.currentRow.__new_code_length = widget.paramsNewCode.__new_code_length || 5;
    				widget.currentRow.__cast_number = widget.paramsNewCode.__cast_number || false;
    			}
    
    			ger55000_informacoes_adicionais_Service.saveDCI(widget).then(function (response) {
    				widget.currentRow.changed = false;
    				delete widget.backupRow;
    
    				if (General.formWidgetSwitchTemplate(widget) && widget.parent) {
    					widget.list();
    
    					var widgets = widget.parent.widgets;
    					General.changeWidgetAcessibility(widgets.concat(widget.parent), true);
    				} else {
    					if (widget.currentRow.__is_new) {
    						ScreenService.closeSwipe();
    						widget.list();
    					} else widget.list();
    
    					General.changeWidgetAcessibility(widget.widgets, true);
    				}
    
    				if (widget.currentRow.__is_new) widget.currentRow.__is_new = false;
    				deferred.resolve(response);
    			}, function (error) {
    				var errorMessage = 'Timeout';
    
    				if (error.data) errorMessage = error.data.error;
    
    				ScreenService.showMessage(errorMessage);
    				deferred.reject(errorMessage);
    			});
    		} else deferred.reject("Preencha todos os campos corretamente!");
    
    		return deferred;
    }
      
}
Configuration(function(ContextRegister) {
    ContextRegister.register('ger55000_informacoes_adicionais_Controller', ger55000_informacoes_adicionais_Controller);
});

// FILE: ./assets/modules/producao/assets/js/controllers/cdp00800_tipo_de_material_controller.js
function cdp00800_tipo_de_material_controller (templateManager, restEngine, General, ScreenService, ZHPromise){
    
    this.widgetSave = function (widget) {
		var deferred = ZHPromise.defer();

		if (widget.isValid()) {
			widget.currentRow.changed = true;

			if (!widget.currentRow.__is_new)
				widget.currentRow.__is_new = false;
			else if (widget.paramsNewCode && widget.paramsNewCode.__is_new_code) {
				widget.currentRow.__using_unit = widget.paramsNewCode.__using_unit || false;
				widget.currentRow.__new_code_pk = widget.paramsNewCode.__new_code_pk;
				widget.currentRow.__table_pk = widget.paramsNewCode.__table_pk;
				widget.currentRow.__new_code_length = widget.paramsNewCode.__new_code_length || 5;
				widget.currentRow.__cast_number = widget.paramsNewCode.__cast_number || false;
			}

			widget.saveRow().then(function (response) {
				widget.currentRow.changed = false;
				delete widget.backupRow;

				if (General.formWidgetSwitchTemplate(widget) && widget.parent) {
					widget.view();

					var widgets = widget.parent.widgets;
					General.changeWidgetAcessibility(widgets.concat(widget.parent), true);
				} else {
					if (widget.currentRow.__is_new) {
						ScreenService.closeSwipe();
						widget.list();
					} else widget.view();

					General.changeWidgetAcessibility(widget.widgets, true);
				}

				if (widget.currentRow.__is_new) widget.currentRow.__is_new = false;
				else widget.reload();

				deferred.resolve(response);
				widget.reload();
			}.bind(this), function (error) {
				var errorMessage = 'Timeout';

				if (error.data) errorMessage = error.data.error;

				ScreenService.showMessage(errorMessage);
				deferred.reject(errorMessage);
			});
		} else deferred.reject("Preencha todos os campos corretamente!");

		return deferred;
	};
      
}
Configuration(function(ContextRegister) {
    ContextRegister.register('cdp00800_tipo_de_material_controller', cdp00800_tipo_de_material_controller);
});

// FILE: ./assets/modules/qualidade/assets/js/controllers/QPR01000_Parametros_Qualidade_Producao_Controller.js
function QPR01000_Parametros_Qualidade_Producao_Controller (QPR01000_Parametros_Qualidade_Producao_Service, templateManager, restEngine, General, ScreenService,ZHPromise){

	this.setDefaultFilial = function(widget) {
        var filter = [
            {
                "name": "CDOPERADOR",
                "operator": "=",
                "value": "OPERADOR_LOGADO"
            }
        ];

        General.callRestEngine('cdp#/crud/operador', 'FilterData', filter).then(function(response) {
            widget.currentRow.CDFILIAL = response.dataset.operador[0].CDFILIALSELECIONADA;
            widget.currentRow.NMFILIAL = response.dataset.operador[0].CDFILIALSELECIONADA;
            this.filtroParametrosFilial(widget.getField('NMFILIAL'));
            this.setFilial(widget.getField('NMFILIAL'));
        }.bind(this));
    };

    this.widgetEdit = function (widget) {
    	if(!Util.isEmptyOrBlank(widget.dataSource.data)){
			if (!widget.editing) {
				//Trata a edição de uma widget filha do tipo form
				if (General.formWidgetSwitchTemplate(widget) && widget.parent) {
				    
				    this.changeBarAcessibility(widget.parent, false);
					
				} else //trata a edição dos demais casos
					General.changeWidgetAcessibility(widget.widgets, false);
	
				//propriedades a serem ignoradas na criação do backup
				var ignoredKeys = ["__rightActions", "__leftActions", "_children", "_parent", "__groupHeaders", "__index", "__isSelected", "__notSelectable", "$$hashKey"];
	
				//faz backup da currentRow para permitir a recuperação dos dados
				widget.backupRow = Util.clone(widget.currentRow, ignoredKeys);
				widget.edit();
				return true;
			} else return false;
    	} else{
    		this.NewRow(widget);
    	}
	};
    
    this.backOrCancel = function (args) {
		
		General.formWidgetSwitchTemplate(args.owner.widget);
		
		this.changeBarAcessibility(args.owner.widget.parent ,true);
		
		if (args.row.__is_new) {
			args.owner.widget.list(true);
			args.owner.widget.dataSource.data.pop();
			args.owner.widget.currentRow = {};
		} else if (args.owner.widget.mode === 'edit') {
			args.owner.widget.list();
			for (var i in args.owner.widget.backupRow) {
				args.owner.widget.currentRow[i] = args.owner.widget.backupRow[i];
			}
		}
		ScreenService.goBack();
	};
	
	this.filtroParametrosFilial =  function(field){
    	var filial = field.getParent().fields[1].value();
    	var allTabbeds =field.getParent().getParent().widgets; 
       	allTabbeds.forEach(function(widget){
       		this.activateAction(widget, !filial);
       	}.bind(this));
    };
    
    this.activateAction = function(widget, state){
    	widget.widgets.forEach(function(widget){
    		widget.actions.forEach(function(action){
    			action.readOnly = state;
    		});
    	});
    };
    
    this.recarregarField = function(nomeWidget,nomeField){
        var field =  templateManager.container.getWidget(nomeWidget).getField(nomeField);
        field.reload();
    };
    
    this.WidgetOnEnter = function(args){
        args.owner.currentRow = args.owner.dataSource.data[0];
    };
    
    this.changeBarAcessibility = function(widget, status){
        var widgetsToChange = widget.parent.widgets;

		General.changeWidgetAcessibility(
			widgetsToChange.filter(function (subwidget) {
				return subwidget.name != widget.name;
			}).concat(widget.parent), //retorna um array com a widget parent e suas widgets filhas, exceto aquela que será editada
		status);
    };
    
    this.changeLocalEstoqAcessibility = function (grid){
        var gridParametrosControleQualidade =  templateManager.container.getWidget(grid);
        if (gridParametrosControleQualidade.currentRow === undefined){
        	gridParametrosControleQualidade.currentRow = {};
        }
        var almoxarifado = gridParametrosControleQualidade.getField('CDALMOXARIFE').value();
        if(almoxarifado){
            gridParametrosControleQualidade.getField('DSLOCALESTOQ').readOnly = false;
        }else{
            gridParametrosControleQualidade.getField('DSLOCALESTOQ').readOnly = true;}
            gridParametrosControleQualidade.getField('DSLOCALESTOQ').reload();
    };
    
    
    this.getProxConsulta = function (args){
    
    QPR01000_Parametros_Qualidade_Producao_Service.findProxConsulta(args.owner).then(function(success) {
        var gridReanalise = templateManager.container.getWidget('grid_reanalise');
        if(success.dataset.parametroqpr_param_qualidade_prox_consulta[0] || (success.dataset.parametroqpr_param_qualidade_prox_consulta[1])){
            if(success.dataset.parametroqpr_param_qualidade_prox_consulta[0]){
	            gridReanalise.getField('DTHRPROXIMACONSULTA').setValue(success.dataset.parametroqpr_param_qualidade_prox_consulta[0].DTHRPROXIMACONSULTA);
            }
            if(success.dataset.parametroqpr_param_qualidade_prox_consulta[1]){
            	gridReanalise.getField('DTHRULTIMACONSULTA').setValue(success.dataset.parametroqpr_param_qualidade_prox_consulta[1].DTULTCONSULTA);
            }
            gridReanalise.getField('SITUACAOCONSUL').setValue('ATIVO');
        } else {
            gridReanalise.getField('SITUACAOCONSUL').setValue('INATIVO');
        }
        
    });  
    };
    
    this.widgetSave = function (widget, afterValid) {
		
		var deferred = ZHPromise.defer();

		if (widget.isValid()) {
			widget.currentRow.changed = true;

			if (!widget.currentRow.__is_new)
				widget.currentRow.__is_new = false;
			else if (widget.paramsNewCode && widget.paramsNewCode.__is_new_code) {
				widget.currentRow.__using_unit = widget.paramsNewCode.__using_unit || false;
				widget.currentRow.__new_code_pk = widget.paramsNewCode.__new_code_pk;
				widget.currentRow.__table_pk = widget.paramsNewCode.__table_pk;
				widget.currentRow.__new_code_length = widget.paramsNewCode.__new_code_length || 5;
				widget.currentRow.__cast_number = widget.paramsNewCode.__cast_number || false;
			}

			widget.saveRow().then(function (response) {
				widget.currentRow.changed = false;
				delete widget.backupRow;

				if (General.formWidgetSwitchTemplate(widget) && widget.parent) {
					widget.list();

					var widgets = widget.parent.widgets;
					General.changeWidgetAcessibility(widgets.concat(widget.parent), true);
					this.changeBarAcessibility(widget.parent ,true);
				} else {
					if (widget.currentRow.__is_new) {
						ScreenService.closeSwipe();
						widget.list();
					} else widget.list();

					General.changeWidgetAcessibility(widget.widgets, true);
				}

				if (widget.currentRow.__is_new) widget.currentRow.__is_new = false;
				else widget.reload();

				deferred.resolve(response);
			}.bind(this), function (error) {
				var errorMessage = 'Timeout';

				if (error.data) errorMessage = error.data.error;

				ScreenService.showMessage(errorMessage);
				deferred.reject(errorMessage);
			});
		} else deferred.reject("Preencha todos os campos corretamente!");

		return deferred;	
	};
	
	this.setFilial = function(field){
		var gridMain = templateManager.container.getWidget('tabbed_main');
            gridMain.widgets[0].getField('CDFILIAL').setValue(field.getParent().fields[1].value());
            gridMain.widgets[0].getField('NMFILIAL').setValue(field.value());
            gridMain.widgets[1].getField('CDFILIAL').setValue(field.getParent().fields[1].value());
            gridMain.widgets[1].getField('NMFILIAL').setValue(field.value());
            gridMain.widgets[2].getField('CDFILIAL').setValue(field.getParent().fields[1].value());
            gridMain.widgets[2].getField('NMFILIAL').setValue(field.value());
            gridMain.widgets[0].widgets[0].reload();
            gridMain.widgets[1].widgets[0].reload();
            gridMain.widgets[2].widgets[0].reload();
	};
	
	this.NewRow = function(widget){
		this.changeBarAcessibility(widget.parent, false);
		General.formWidgetSwitchTemplate(widget);
		templateManager.container.getWidget(widget.name).setCurrentRow({});
		widget.newRow();
		widget.currentRow.CDFILIAL = widget.parent.fields[1].value();
	};
	
	this.setFieldsOnAutorizacaoReadOnly = function(widget, state){
		widget.getField('IDAUTGRUPOP').readOnly = state;
		widget.getField('DSGRUPOPER').readOnly = state;
	};
    
}

Configuration(function(ContextRegister) {
    ContextRegister.register('QPR01000_Parametros_Qualidade_Producao_Controller', QPR01000_Parametros_Qualidade_Producao_Controller);
});

// FILE: ./assets/modules/qualidade/assets/js/controllers/QPR01900_Inspecao_Digital_Controller.js
function QPR01900_Inspecao_Digital_Controller (localStorageEngine, templateManager, restEngine, General, ScreenService, QPR01900_Inspecao_Digital_Service){
    
    var cdChecklist;
    var nrOrdProd;
    var nrSubOrdProd;
    
    var mensagens = [];
    mensagens.filtroIncompleto = "É necessário preencher todos os campos do Filtro.";
    
    var currentQuest;
    var currentQuestPosDataSource;
    var currentQuestPosInterface;
    var currentCadQuest;
    var currentCadQuestNewCode;
    var originalRow;
    var cadRowsToDelete = [];
    
    this.openFilter = function(args) {
        ScreenService.openPopup(templateManager.container.getWidget('TarefaFilter'));
        templateManager.container.getWidget('TarefaFilter').isVisible = true;
    };
    
    this.checkFilter = function(args) {
        var row = args.owner.field.widget.currentRow;
        
        args.owner.field.widget.getField('LANCAMENTOFIN').setValue(null);
        args.owner.field.widget.getField('LANCAMENTOFIN').readOnly = !row.LANCAMENTOINI;
        if (row.LANCAMENTOINI) {
            args.owner.field.widget.getField('LANCAMENTOFIN').minDate = args.owner.field.widget.getField('LANCAMENTOINI').value();
        }
    };
    
    this.retornaOperadorLogado = function() {
        var filter = [
            {
                "name": "CDOPERADOR",
                "operator": "=",
                "value": "OPERADOR_LOGADO"
            }
        ];
        return localStorageEngine.download("ger#/crud/operador", filter);
    };    
        
    this.getLocalData = function() {
        var mainWidget = templateManager.container.getWidget('inspecao_digital');
        var filterWidget = templateManager.container.getWidget('TarefaFilter');
        
        if (filterWidget.currentRow.LANCAMENTOINI && filterWidget.currentRow.LANCAMENTOFIN) {
            var minDate = filterWidget.currentRow.LANCAMENTOINI;
            var maxDate = filterWidget.currentRow.LANCAMENTOFIN;
            var params = [];
            
            this.retornaOperadorLogado().then(function(callback){
                params.push(callback[0].CDOPERADOR);
                params.push(minDate);
                params.push(maxDate);
                QPR01900_Inspecao_Digital_Service.searchTarefaQuestao(params).then(function(success){
                    
                    localStorageEngine.setDataSource('inspecaoTarefa', success.dataset.resultados.tarefa);
                    localStorageEngine.setDataSource('inspecaoQuestao', success.dataset.resultados.questao);
                    localStorageEngine.setDataSource('respostaVal', success.dataset.resultados.respostaVal);
                    localStorageEngine.setDataSource('respostaBool', success.dataset.resultados.respostaBool);
                    localStorageEngine.setDataSource('respostaCad', success.dataset.resultados.respostaCad);
                    localStorageEngine.setDataSource('respQuestVisBoo', success.dataset.resultados.respQuestVisBoo);
                    localStorageEngine.setDataSource('respQuestVar', success.dataset.resultados.respQuestVar);
                    localStorageEngine.setDataSource('respQuestCad', success.dataset.resultados.respQuestCad);
                    
                    localStorageEngine.getDataSource('inspecaoTarefa', []).then(function(inspecaoTarefa) {
                        mainWidget.dataSource.data = inspecaoTarefa;
                        ScreenService.closePopup();
                        ScreenService.closePopup();
                    });
                }.bind(this));
            });
        } else {
            ScreenService.showMessage(mensagens.filtroIncompleto);
        }
    };
    
    this.questionApplyFilter = function(widget) {
        
        var filter = [{
            "name": "CDCHECKLIST",
            "operator": "=",
            "value": cdChecklist
        }, {
            "name": "NRORDPROD",
            "operator": "=",
            "value": nrOrdProd
        }, {
            "name": "NRSUBORDPROD",
            "operator": "=",
            "value": nrSubOrdProd
        }];
        
        localStorageEngine.getDataSource('inspecaoQuestao', filter).then(function(inspecaoQuestao) {
            templateManager.container.getWidget('WidgetQuestoes').dataSource.data = inspecaoQuestao;
         });
    }.bind(this);
    
    this.openRespWidget = function(widget) {
        localStorageEngine.getDataSource('inspecaoQuestao').then(function(inspecaoQuestao) {
            var found = false;
            for(var i=0; i<inspecaoQuestao.length && found==false; i++) {
                if (inspecaoQuestao[i].NRQUESTCHECK == widget.currentRow.NRQUESTCHECK && inspecaoQuestao[i].CDCHECKLIST == widget.currentRow.CDCHECKLIST && inspecaoQuestao[i].NRORDPROD == widget.currentRow.NRORDPROD && inspecaoQuestao[i].NRSUBORDPROD == widget.currentRow.NRSUBORDPROD) {
                    for(var j=0; j<widget.dataSource.data.length && found==false; j++) {
                    	if (widget.dataSource.data[j] == widget.currentRow) {
                    	    found = true;
                	        this.currentQuest = inspecaoQuestao[i];
                	        this.currentQuestPosDataSource = i;
                	        this.currentQuestPosInterface = j;
                            if (widget.currentRow.TPQUESTCHECK == 'BOO') {
                                this.openBoolResp();
                            }
                            if (widget.currentRow.TPQUESTCHECK == 'VAL') {
                                this.openValResp();
                            }
                            if (widget.currentRow.TPQUESTCHECK == 'VIS') {
                                this.openVisResp();
                            }
                            if (widget.currentRow.TPQUESTCHECK == 'CAD') {
                                this.openCadResp();
                            }
                        }
                    }
                }
            }
        }.bind(this));
    };
    
    this.openVisResp = function() {
        var filter = [{
            "name": "CDCHECKLIST",
            "operator": "=",
            "value": cdChecklist
        }, {
            "name": "NRQUESTCHECK",
            "operator": "=",
            "value": this.currentQuest.NRQUESTCHECK
        }];
       localStorageEngine.getDataSource('respostaBool', filter).then(function(respostaBool) {
           localStorageEngine.getDataSource('respQuestVisBoo').then(function(respQuestVisBoo) {
               localStorageEngine.getDataSource('inspecaoQuestao').then(function(inspecaoQuestao) {
        		if (this.currentQuest.IDSITQUESTAROP == 3) {
        		    this.currentQuest.IDSITQUESTAROP = 1;
        		} else {
        		    this.currentQuest.IDSITQUESTAROP = 3;
        		}
        		
        		var found = false;
        		for (var i=0; i<respQuestVisBoo.length && found == false; i++) {
        		    if (respQuestVisBoo[i].NRORDPROD == this.currentQuest.NRORDPROD && respQuestVisBoo[i].NRQUESTCHECK == this.currentQuest.NRQUESTCHECK) {
        		        found = true;
        		        if (this.currentQuest.IDSITQUESTAROP == 1) {
        		            respQuestVisBoo[i].IDRESPVISTO = 'NOK';   
        		        } else respQuestVisBoo[i].IDRESPVISTO = 'SOK';    
        		    }
        		}
        		if (found == false) {
        		    respQuestVisBoo.push(this.makeVisBooResp('Vis', this.currentQuest.IDSITQUESTAROP));
        		}
        		
                inspecaoQuestao[this.currentQuestPosDataSource] = this.currentQuest;
                localStorageEngine.setDataSource('inspecaoQuestao', inspecaoQuestao);
                localStorageEngine.setDataSource('respQuestVisBoo', respQuestVisBoo);
        	    templateManager.container.getWidget('WidgetQuestoes').dataSource.data[this.currentQuestPosInterface].IDSITQUESTAROP = inspecaoQuestao[this.currentQuestPosDataSource].IDSITQUESTAROP;
        		
    		    if (respostaBool[0].DSRESPVISTO) {
    		        ScreenService.showMessage(respostaBool[0].DSRESPVISTO);
    		    }
                this.colorizeQuestion();
               }.bind(this));
           }.bind(this));
       }.bind(this));
    
    };
    
    this.openBoolResp = function() {
        var boolRespWidget = templateManager.container.getWidget('WidgetBoolResp');
        localStorageEngine.getDataSource('respostaBool').then(function(respostaBool) {
            var found = false;
            ScreenService.openPopup(boolRespWidget);
            
            for (var i=0; i<respostaBool.length && found == false; i++) {
                if (respostaBool[i].NRQUESTCHECK == this.currentQuest.NRQUESTCHECK) {
                    found = true;
                    boolRespWidget.fields[0].dataSource.data[0].NMRESPBOOL = respostaBool[i].DSRESPFALSO;
                    boolRespWidget.fields[0].dataSource.data[1].NMRESPBOOL = respostaBool[i].DSRESPVERD;
                }
            }
        }.bind(this));
    };
    
    this.openValResp = function() {
        var valRespWidget = templateManager.container.getWidget('WidgetValResp');
        ScreenService.openPopup(valRespWidget);
    };
    
    this.confirmBoolResp = function(widget) {
        var Value = widget.currentRow.IDRESPBOOL;
        
        var filter = [{
            "name": "CDCHECKLIST",
            "operator": "=",
            "value": cdChecklist
        }, {
            "name": "NRQUESTCHECK",
            "operator": "=",
            "value": this.currentQuest.NRQUESTCHECK
        }];
        
        localStorageEngine.getDataSource('respostaBool', filter).then(function(respostaBool) {
            localStorageEngine.getDataSource('respQuestVisBoo').then(function(respQuestVisBoo) {
                if (respostaBool) {
                    localStorageEngine.getDataSource('inspecaoQuestao').then(function(inspecaoQuestao) {
                        if (Value == 'F') {
                            this.currentQuest.IDSITQUESTAROP = '2';
                            inspecaoQuestao[this.currentQuestPosDataSource] = this.currentQuest;
                            localStorageEngine.setDataSource('inspecaoQuestao', inspecaoQuestao);
                        } else if (Value == 'V') {
                            this.currentQuest.IDSITQUESTAROP = '3';
                            inspecaoQuestao[this.currentQuestPosDataSource] = Util.clone(this.currentQuest);
                            localStorageEngine.setDataSource('inspecaoQuestao', inspecaoQuestao);
                        }
                        
                        var found = false;
                		for (var i=0; i<respQuestVisBoo.length && found == false; i++) {
                		    if (respQuestVisBoo[i].NRORDPROD == this.currentQuest.NRORDPROD && respQuestVisBoo[i].NRQUESTCHECK == this.currentQuest.NRQUESTCHECK) {
                		        found = true;
                		        if (this.currentQuest.IDSITQUESTAROP == 2) {
                		            respQuestVisBoo[i].IDVERDFALSO = 'N';   
                		        } else if (this.currentQuest.IDSITQUESTAROP == 3) respQuestVisBoo[i].IDVERDFALSO = 'S';    
                		    }
                		}
                		if (found == false) {
                		    respQuestVisBoo.push(this.makeVisBooResp('Bool', this.currentQuest.IDSITQUESTAROP));
                		}
                        
                        localStorageEngine.setDataSource('respQuestVisBoo', respQuestVisBoo);
                        templateManager.container.getWidget('WidgetQuestoes').dataSource.data[this.currentQuestPosInterface].IDSITQUESTAROP = inspecaoQuestao[this.currentQuestPosDataSource].IDSITQUESTAROP;
                        ScreenService.closePopup();
                        this.colorizeQuestion();
                    }.bind(this));
                } else {
                    ScreenService.showMessage('Não existe este tipo de resposta.');
                }
                this.colorizeQuestion(); 
            }.bind(this));
         }.bind(this));
    };
    
    this.confirmValResp = function(widget) {
        var Value = widget.currentRow.RESPVAL;
        
        var filter = [{
            "name": "CDCHECKLIST",
            "operator": "=",
            "value": cdChecklist
        }, {
            "name": "NRQUESTCHECK",
            "operator": "=",
            "value": this.currentQuest.NRQUESTCHECK
        }];
        
        localStorageEngine.getDataSource('respostaVal', filter).then(function(respostaVal) {
            
            var found = false;
            var response;
            var responseValue;
            
            for(var i=0; i<respostaVal.length && found==false; i++) {
                if (respostaVal[i].TPFXVR == '<') {
                    if (Value < respostaVal[i].FXINICIAL) {
                        found = true;
                    }
                } else if (respostaVal[i].TPFXVR == '>') {
                    if (Value > respostaVal[i].FXINICIAL) {
                        found = true;
                    }
                } else if (respostaVal[i].TPFXVR == 'E') {
                    if (Value >= respostaVal[i].FXINICIAL && Value <= respostaVal[i].FXFINAL) {
                        found = true;
                    }
                }
                if (found) {
                    response = respostaVal[i].DSRESPVR;
                    responseValue = respostaVal[i].PONTVRCHECK;
                }
            }
            
            if (found) {
                ScreenService.showMessage(response);
                localStorageEngine.getDataSource('inspecaoQuestao').then(function(inspecaoQuestao) {
                    localStorageEngine.getDataSource('respQuestVar').then(function(respQuestVar) {
                        if (responseValue == 'I') {
                            this.currentQuest.IDSITQUESTAROP = '2';
                            inspecaoQuestao[this.currentQuestPosDataSource] = this.currentQuest;
                            localStorageEngine.setDataSource('inspecaoQuestao', inspecaoQuestao);
                        } else if (responseValue == 'C' || responseValue == 'A') {
                            this.currentQuest.IDSITQUESTAROP = '3';
                            inspecaoQuestao[this.currentQuestPosDataSource] = Util.clone(this.currentQuest);
                            localStorageEngine.setDataSource('inspecaoQuestao', inspecaoQuestao);
                        }
                        
                        var found = false;
                		for (var i=0; i<respQuestVar.length && found == false; i++) {
                		    if (respQuestVar[i].NRORDPROD == this.currentQuest.NRORDPROD && respQuestVar[i].NRQUESTCHECK == this.currentQuest.NRQUESTCHECK) {
                		        found = true;
                		        respQuestVar[i].VRRESPTAR = Value;   
                		    }
                		}
                		if (found == false) {
                		    respQuestVar.push(this.makeVarResp(Value));
                		}
                        
                        localStorageEngine.setDataSource('respQuestVar', respQuestVar);
                        templateManager.container.getWidget('WidgetQuestoes').dataSource.data[this.currentQuestPosInterface].IDSITQUESTAROP = inspecaoQuestao[this.currentQuestPosDataSource].IDSITQUESTAROP;
                        ScreenService.closePopup();
                        this.colorizeQuestion();
                    }.bind(this));
                }.bind(this));
            } else {
                ScreenService.showMessage('Não existe este tipo de resposta.');
            }
            this.colorizeQuestion();
         }.bind(this));
    };
    
    this.colorizeQuestion = function() {
        var list = document.querySelector('body > span > section > section > div.default-window.ng-scope > section.zh-swipe-container.zh-swipe-right.ng-scope.open > div > div:nth-child(3) > section > section > div > section > div > div.container.zh-list-container.ng-scope.ng-isolate-scope.nonbounce > ul');
        list = list.querySelectorAll('li.zh-list-item-label');

        if (this.currentQuest.IDSITQUESTAROP == '3'){
            list[this.currentQuestPosInterface].childNodes[7].querySelectorAll('div.row')[1].style.color = 'green';   
        } else if (this.currentQuest.IDSITQUESTAROP == '2'){
            list[this.currentQuestPosInterface].childNodes[7].querySelectorAll('div.row')[1].style.color = 'red';   
        } else if (this.currentQuest.IDSITQUESTAROP == '1'){
            list[this.currentQuestPosInterface].childNodes[7].querySelectorAll('div.row')[1].style.color = 'black';   
        } 
    };
    
    this.colorizeAllQuestions = function() {
        var list = document.querySelector('body > span > section > section > div.default-window.ng-scope > section.zh-swipe-container.zh-swipe-right.ng-scope.open > div > div:nth-child(3) > section > section > div > section > div > div.container.zh-list-container.ng-scope.ng-isolate-scope.nonbounce > ul');
        list = list.querySelectorAll('li.zh-list-item-label');
        
        for(var i=0; i<list.length; i++) {
            var span = list[i].childNodes[7].querySelectorAll('div.row')[1].childNodes[1].childNodes[3].innerHTML;
            
            if (span == 'Pendente.') {
                list[i].childNodes[7].querySelectorAll('div.row')[1].style.color = 'black';   
            } else if (span == 'Correta.') {
                list[i].childNodes[7].querySelectorAll('div.row')[1].style.color = 'green';
            } else if (span == 'Incorreta.') {
                list[i].childNodes[7].querySelectorAll('div.row')[1].style.color = 'red';
            }
        }
        
    };
    
    this.openCadResp = function() {
        var cadHolderRespWidget = templateManager.container.getWidget('WidgetCadRespHolder');
        var cadRespWidget = templateManager.container.getWidget('WidgetCadResp');
        var CadRespView =   templateManager.container.getWidget('WidgetCadRespView');
        localStorageEngine.getDataSource('respQuestCad').then(function(respQuestCad) {
            var currentResp = [];
            for (var i=0; i<respQuestCad.length; i++) {
                if (respQuestCad[i].NRQUESTCHECK == this.currentQuest.NRQUESTCHECK) {
                    currentResp.push(respQuestCad[i]);
                }
            }
            
            for (i=0; i<cadRespWidget.actions.length; i++) {
                cadRespWidget.actions[i].isVisible = true;
            }
            
            cadRespWidget.dataSource.data = currentResp;
            
            localStorageEngine.getDataSource('respostaCad').then(function(respostaCad) {
                var found = false;
                for (var i=0; i<respostaCad.length && found == false; i++) {
                    if (respostaCad[i].NRQUESTCHECK == this.currentQuest.NRQUESTCHECK) {
                        found = true;
                        
                        this.currentCadQuest = respostaCad[i];
                        
                        if(respostaCad[i].IDPRODUTO == 'S') {
                            cadRespWidget.fields[1].isVisible = true;
                            CadRespView.fields[0].isVisible = true;
                            if(respostaCad[i].IDLOTE == 'S') {
                                cadRespWidget.fields[3].readOnly = true;
                                CadRespView.fields[2].readOnly = true;
                            }
                        }
                        if(respostaCad[i].IDEQUIPA == 'S') {
                            cadRespWidget.fields[2].isVisible = true;
                            CadRespView.fields[1].isVisible = true;
                        }
                        if(respostaCad[i].IDLOTE == 'S') {
                            cadRespWidget.fields[3].isVisible = true;
                            CadRespView.fields[2].isVisible = true;
                        }
                        if(respostaCad[i].IDOPERADOR == 'S') {
                            cadRespWidget.fields[4].isVisible = true;
                            CadRespView.fields[3].isVisible = true;
                        }
                        
                        if(respostaCad[i].DSCOLUNA1) {
                            CadRespView.fields[4].isVisible = true;
                            CadRespView.fields[4].label = respostaCad[i].DSCOLUNA1;
                        }
                        if(respostaCad[i].DSCOLUNA2) {
                            CadRespView.fields[5].isVisible = true;
                            CadRespView.fields[5].label = respostaCad[i].DSCOLUNA2;
                        }
                        if(respostaCad[i].DSCOLUNA3) {
                            CadRespView.fields[6].isVisible = true;
                            CadRespView.fields[6].label = respostaCad[i].DSCOLUNA3;
                        }
                        if(respostaCad[i].DSCOLUNA4) {
                            CadRespView.fields[7].isVisible = true;
                            CadRespView.fields[7].label = respostaCad[i].DSCOLUNA4;
                        }
                        if(respostaCad[i].DSCOLUNA5) {
                            CadRespView.fields[8].isVisible = true;
                            CadRespView.fields[8].label = respostaCad[i].DSCOLUNA5;
                        }
                        if(respostaCad[i].DSCOLUNA6) {
                            CadRespView.fields[9].isVisible = true;
                            CadRespView.fields[9].label = respostaCad[i].DSCOLUNA6;
                        }
                        if(respostaCad[i].DSCOLUNA7) {
                            CadRespView.fields[10].isVisible = true;
                            CadRespView.fields[10].label = respostaCad[i].DSCOLUNA7;
                        }
                        if(respostaCad[i].DSCOLUNA8) {
                            CadRespView.fields[11].isVisible = true;
                            CadRespView.fields[11].label = respostaCad[i].DSCOLUNA8;
                        }
                        if(respostaCad[i].DSCOLUNA9) {
                            CadRespView.fields[12].isVisible = true;
                            CadRespView.fields[12].label = respostaCad[i].DSCOLUNA9;
                        }
                        
                        ScreenService.openSwipe(cadHolderRespWidget);
                    }
                }
            }.bind(this));
        }.bind(this));
    };
    
    this.openCadRespView = function(widget) {
        var CadRespView = templateManager.container.getWidget('WidgetCadRespView');
        
        if (CadRespView.actions[0].isVisible == false) {
           for (var i=0; i<3; i++) {
               CadRespView.actions[i].isVisible = true;
           }
            
            CadRespView.currentRow = widget.currentRow;
            ScreenService.openSwipe(CadRespView);
            CadRespView.list();
        }
    };
        
    
    this.returnCadResp = function() {
        var cadRespViewWidget = templateManager.container.getWidget('WidgetCadRespView');
        var cadRespWidget = templateManager.container.getWidget('WidgetCadResp');
        var questWidget = templateManager.container.getWidget('WidgetQuestoes');
        ScreenService.closeSwipe();
        
        cadRespViewWidget.fields.forEach(function(item){ 
            item.isVisible = false;
        });
        
        cadRespWidget.fields.forEach(function(item){ 
            item.isVisible = false;
        });
        
        cadRespWidget.actions.forEach(function(item){ 
            item.isVisible = false;
        });
        
        questWidget.actions.forEach(function(item){ 
            item.isVisible = true;
        });
        
        questWidget.activate();
    };
    
    this.returnCadRespView = function() {
        var cadRespViewWidget = templateManager.container.getWidget('WidgetCadRespView');
        var cadRespWidget = templateManager.container.getWidget('WidgetCadResp');
        
        cadRespViewWidget.actions.forEach(function(item){ 
            item.isVisible = false;
        });
        this.currentCadQuestNewCode = null;
        ScreenService.closeSwipe();
        cadRespWidget.activate();
    };
    
    this.checkQueStstate = function() {
        var questWidget = templateManager.container.getWidget('WidgetQuestoes');
        var filter = [{
            "name": "NRORDPROD",
            "operator": "=",
            "value": nrOrdProd
        }];
        
        localStorageEngine.getDataSource('inspecaoQuestao', filter).then(function(inspecaoQuestao) {
            localStorageEngine.getDataSource('respQuestCad', filter).then(function(respQuestCad) {
                for(var i=0; i<inspecaoQuestao.length; i++) {
                    if (inspecaoQuestao[i].TPQUESTCHECK == 'CAD') {
                        var found = false;
                        for(var j=0; j<respQuestCad.length && found == false; j++) {
                            if (respQuestCad[j].NRQUESTCHECK == inspecaoQuestao[i].NRQUESTCHECK) {
                                found = true;
                                inspecaoQuestao[i].IDSITQUESTAROP = 3;
                            }
                        }
                        if (found == false) {
                            inspecaoQuestao[i].IDSITQUESTAROP = 1;
                        }
                    }
                }
                localStorageEngine.setDataSource('inspecaoQuestao', inspecaoQuestao);
                templateManager.container.getWidget('WidgetQuestoes').dataSource.data = inspecaoQuestao;
            }.bind(this));    
        }.bind(this));
    };
    
    this.openWidgetCadNew = function() {
        var cadRespViewWidget = templateManager.container.getWidget('WidgetCadRespView');
        
        cadRespViewWidget.actions[4].isVisible = true;
        cadRespViewWidget.actions[6].isVisible = true;
        
        cadRespViewWidget.currentRow = [];
        cadRespViewWidget.currentRow.__is_new = true;
        ScreenService.openSwipe(cadRespViewWidget);
        cadRespViewWidget.edit();
    };
    
    this.lockLote = function(args) {
        var row = args.owner.field.widget.currentRow;
        var cadRespViewWidget = templateManager.container.getWidget('WidgetCadRespView');
        
        if(this.currentCadQuest.IDLOTE == 'S') {
            if (args.owner.field.widget.getField('NMPRODUTO')) {
                var filter = {
                    "name": "CDPRODUTO",
                    "operator": "=",
                    "value": args.owner.field.widget.currentRow.CDPRODUTO
                };
                
                cadRespViewWidget.fields[2].dataSourceFilter[1] = filter;
            }
            
            cadRespViewWidget.fields[2].readOnly = !row.NMPRODUTO;
            cadRespViewWidget.fields[2].clearValue();
        }
    };
    
    this.editCadResp = function(widget) {
        var cadRespViewWidget = templateManager.container.getWidget('WidgetCadRespView');
        widget.edit();
        cadRespViewWidget.currentRow.__is_new = false;
        this.originalRow = Util.clone(widget.currentRow);
        
        if (cadRespViewWidget.currentRow.NMPRODUTO && cadRespViewWidget.currentRow.NRLOTEESTQ) {
            cadRespViewWidget.fields[2].readOnly = true;
        } else {
            cadRespViewWidget.fields[2].readOnly = false;
        }
        
        cadRespViewWidget.actions[3].isVisible = true;
        cadRespViewWidget.actions[5].isVisible = true;
    };
  
    this.cancelCadRespEdit = function(widget) {
        var cadRespViewWidget = templateManager.container.getWidget('WidgetCadRespView');
        if (widget.currentRow.__is_new) {
          widget.dataSource.data.pop();
          widget.reload();
        } else { 
          Util.extend(widget.currentRow, this.originalRow);
        }
        
        cadRespViewWidget.actions[3].isVisible = false;
        cadRespViewWidget.actions[5].isVisible = false;
        widget.list();
    };
    
    this.saveCadRespEdit = function(widget) {
        var cadRespWidget = templateManager.container.getWidget('WidgetCadResp');
        var cadRespViewWidget = templateManager.container.getWidget('WidgetCadRespView');
        var filter = [{
            "name": "CDRESPCAD",
            "operator": "=",
            "value": widget.currentRow.CDRESPCAD
        }, {
            "name": "NRQUESTCHECK",
            "operator": "=",
            "value": this.currentQuest.NRQUESTCHECK
        }, {
            "name": "CDCHECKLIST",
            "operator": "=",
            "value": this.currentQuest.CDCHECKLIST
        }, {
            "name": "NRORDPROD",
            "operator": "=",
            "value": this.currentQuest.NRORDPROD
        }, {
            "name": "NRSUBORDPROD",
            "operator": "=",
            "value": this.currentQuest.NRSUBORDPROD
        }];
        
        if (this.currentCadQuestNewCode != null) {
            filter[0] = {
                "name": "CDRESPCAD",
                "operator": "=",
                "value": this.currentCadQuestNewCode
            };
        }
        
        localStorageEngine.getDataSource('respQuestCad', filter).then(function(respQuestCad) {
            localStorageEngine.getDataSource('respQuestCad').then(function(respQuestCadAll) {
                var found = false;
                var currentResp = [];
                for (var i=0; i<respQuestCadAll.length && found==false; i++) {
                    if (this.currentCadQuestNewCode != null) {
                        if (respQuestCadAll[i].CDRESPCAD == this.currentCadQuestNewCode && respQuestCadAll[i].NRQUESTCHECK == this.currentQuest.NRQUESTCHECK) {
                            found = true;
                            respQuestCadAll[i] = this.makeCadResp(widget, this.currentCadQuestNewCode);
                            localStorageEngine.setDataSource('respQuestCad', respQuestCadAll);
                        }
                    } else { 
                        if (respQuestCadAll[i].CDRESPCAD == widget.currentRow.CDRESPCAD && respQuestCadAll[i].NRQUESTCHECK == widget.currentRow.NRQUESTCHECK) {
                            found = true;
                            respQuestCadAll[i] = widget.currentRow;
                            localStorageEngine.setDataSource('respQuestCad', respQuestCadAll);
                        }
                    }
                }
                widget.reload();
                for (i=0; i<respQuestCadAll.length; i++) {
                    if (respQuestCadAll[i].NRQUESTCHECK == this.currentQuest.NRQUESTCHECK) {
                        currentResp.push(respQuestCadAll[i]);
                    }
                }
                cadRespWidget.dataSource.data = currentResp;
                widget.list();
                
                cadRespViewWidget.actions[3].isVisible = false;
                cadRespViewWidget.actions[5].isVisible = false;
            }.bind(this));
        }.bind(this));
        
    };
    
    this.saveNewCadResp = function(widget) {
        var cadRespViewWidget = templateManager.container.getWidget('WidgetCadRespView');
        var cadRespWidget = templateManager.container.getWidget('WidgetCadResp');
        var filter = [{
            "name": "NRQUESTCHECK",
            "operator": "=",
            "value": this.currentQuest.NRQUESTCHECK
        }, {
            "name": "CDCHECKLIST",
            "operator": "=",
            "value": this.currentQuest.CDCHECKLIST
        }, {
            "name": "NRORDPROD",
            "operator": "=",
            "value": this.currentQuest.NRORDPROD
        }, {
            "name": "NRSUBORDPROD",
            "operator": "=",
            "value": this.currentQuest.NRSUBORDPROD
        }];
        
        localStorageEngine.getDataSource('respQuestCad', filter).then(function(respQuestCad) {
            localStorageEngine.getDataSource('respQuestCad').then(function(respQuestCadAll) {
                var currentResp = [];
                
                var maxCode = 0;
                for(var i=0; i<respQuestCad.length; i++) {
                    if (maxCode < parseInt(respQuestCad[i].CDRESPCAD)) {
                        maxCode = parseInt(respQuestCad[i].CDRESPCAD);
                    }
                }
                
                var newResp = this.makeCadResp(widget, this.zeroFill(maxCode+1));
                respQuestCadAll.push(newResp);
                localStorageEngine.setDataSource('respQuestCad', respQuestCadAll);
                
                for (i=0; i<respQuestCadAll.length; i++) {
                    if (respQuestCadAll[i].NRQUESTCHECK == this.currentQuest.NRQUESTCHECK) {
                        currentResp.push(respQuestCadAll[i]);
                    }
                }
                cadRespWidget.dataSource.data = currentResp;
                cadRespWidget.reload();
                
                cadRespViewWidget.actions.forEach(function(item){ 
                    item.isVisible = false;
                });
                this.currentCadQuestNewCode = newResp.CDRESPCAD;
                this.openCadRespView(widget);
                this.checkQueStstate();
            }.bind(this));
        }.bind(this));
    };
    
    this.removeCadResp = function(widget) {
        var cadRespWidget = templateManager.container.getWidget('WidgetCadResp');
        var filter = [{
            "name": "CDRESPCAD",
            "operator": "=",
            "value": widget.currentRow.CDRESPCAD
        }, {
            "name": "NRQUESTCHECK",
            "operator": "=",
            "value": widget.currentRow.NRQUESTCHECK
        }, {
            "name": "CDCHECKLIST",
            "operator": "=",
            "value": this.currentQuest.CDCHECKLIST
        }, {
            "name": "NRORDPROD",
            "operator": "=",
            "value": this.currentQuest.NRORDPROD
        }, {
            "name": "NRSUBORDPROD",
            "operator": "=",
            "value": this.currentQuest.NRSUBORDPROD
        }];
        ScreenService.confirmMessage(ScreenService.i18n('Delete Register?'), 'question', function (success) {
            localStorageEngine.getDataSource('respQuestCad').then(function(respQuestCadAll) {
                var found = false;
                var currentResp = [];
                for (var i=0; i<respQuestCadAll.length && found==false; i++) {
                    if (respQuestCadAll[i].CDRESPCAD == widget.currentRow.CDRESPCAD && respQuestCadAll[i].NRQUESTCHECK == widget.currentRow.NRQUESTCHECK) {
                        found = true;
                        cadRowsToDelete.push(respQuestCadAll[i]);
                        respQuestCadAll.splice(i, 1);
                        localStorageEngine.setDataSource('respQuestCad', respQuestCadAll);
                    }
                }
                widget.reload();
                for (i=0; i<respQuestCadAll.length; i++) {
                    if (respQuestCadAll[i].NRQUESTCHECK == this.currentQuest.NRQUESTCHECK) {
                        currentResp.push(respQuestCadAll[i]);
                    }
                }
                cadRespWidget.dataSource.data = currentResp;
                cadRespWidget.reload();
                ScreenService.closeSwipe();
                this.checkQueStstate();
            }.bind(this));
		}.bind(this));
    };
    
    //função responsável por colocar "0" atrás do número
    this.zeroFill = function(number) {
    	if (number<10) {
    		return "00" + number;
        } else if (number<100) {
            return "0" + number;
        } return number;
    };
    
    this.getFilterData = function(widget) {
       cdChecklist =  widget.currentRow.CDCHECKLIST;
       nrOrdProd = widget.currentRow.NRORDPROD;
       nrSubOrdProd = widget.currentRow.NRSUBORDPROD;
       this.checkQueStstate();
    };
    
    this.sendChanges = function() {
        localStorageEngine.getDataSource('inspecaoQuestao', []).then(function(inspecaoQuestao) {
            localStorageEngine.getDataSource('respQuestVisBoo', []).then(function(respQuestVisBoo) {
                localStorageEngine.getDataSource('respQuestVar', []).then(function(respQuestVar) {
                    localStorageEngine.getDataSource('respQuestCad', []).then(function(respQuestCad) {

                        var rows = {};
                        rows[0] = inspecaoQuestao;
                        rows[1] = respQuestVisBoo;
                        rows[2] = respQuestVar;
                        rows[3] = respQuestCad;
                        rows[4] = cadRowsToDelete;
                        
                        for(var i=0; i < rows[0].length; i++) {
                            delete rows[0][i].TPQUESTCHECK;
                            delete rows[0][i].DSQUESTCHECK;
                        }
                        
                        QPR01900_Inspecao_Digital_Service.sendChanges(rows).then(function(success){
                            ScreenService.showMessage('Mudanças salvas com sucesso.');
                            
                            for(var i=0; i < rows.length; i++) {
                                for(var j=0; i < rows[i].length; j++) {
                                    rows[i][j].__is_new = false;
                                }
                            }
                            
                        });
                    }.bind(this));
                }.bind(this));
            }.bind(this));
        });
    };
    
    this.makeVisBooResp = function(type, idresp) {
        var newResp = {
            CDFILIAL: this.currentQuest.CDFILIAL,
            CDCHECKLIST: this.currentQuest.CDCHECKLIST,
            NRORDPROD: this.currentQuest.NRORDPROD,
            NRSUBORDPROD: this.currentQuest.NRSUBORDPROD,
            NRQUESTCHECK: this.currentQuest.NRQUESTCHECK,
            CDETAPAPROD: this.currentQuest.CDETAPAPROD,
            CDINSPECAO: this.currentQuest.CDINSPECAO,
            CDHABILIDADE: this.currentQuest.CDHABILIDADE,
            NRAUDITORIA: this.currentQuest.NRAUDITORIA,
            NRINSPECAUDI: this.currentQuest.NRINSPECAUDI,
            IDATIVO: this.currentQuest.IDATIVO,
            NRORG: this.currentQuest.NRORG,
            NRORGULTATU: this.currentQuest.NRORGULTATU,
            CDOPERULTATU: this.currentQuest.CDOPERULTATU,
            __is_new: true
        };
        
        if (type == 'Vis') {
            if (idresp == 1) {
                newResp.IDRESPVISTO = 'NOK';
            } else {
                newResp.IDRESPVISTO = 'SOK';
            }
        } else {
            if (idresp == 2) {
                newResp.IDVERDFALSO = 'N';
            } else {
                newResp.IDVERDFALSO = 'S';
            }
        }
        
        return newResp;
    };
    
    this.makeVarResp = function(valresp) {
        var newResp = {
            CDFILIAL: this.currentQuest.CDFILIAL,
            CDCHECKLIST: this.currentQuest.CDCHECKLIST,
            NRORDPROD: this.currentQuest.NRORDPROD,
            NRSUBORDPROD: this.currentQuest.NRSUBORDPROD,
            NRQUESTCHECK: this.currentQuest.NRQUESTCHECK,
            CDETAPAPROD: this.currentQuest.CDETAPAPROD,
            CDINSPECAO: this.currentQuest.CDINSPECAO,
            CDHABILIDADE: this.currentQuest.CDHABILIDADE,
            NRAUDITORIA: this.currentQuest.NRAUDITORIA,
            NRINSPECAUDI: this.currentQuest.NRINSPECAUDI,
            IDATIVO: this.currentQuest.IDATIVO,
            NRORG: this.currentQuest.NRORG,
            NRORGULTATU: this.currentQuest.NRORGULTATU,
            CDOPERULTATU: this.currentQuest.CDOPERULTATU,
            __is_new: true,
            VRRESPTAR: valresp
        };
        
        return newResp;
    };
    
    this.makeCadResp = function(widget, code) {
        var newResp = {
            CDFILIAL: this.currentQuest.CDFILIAL,
            CDCHECKLIST: this.currentQuest.CDCHECKLIST,
            NRORDPROD: this.currentQuest.NRORDPROD,
            NRSUBORDPROD: this.currentQuest.NRSUBORDPROD,
            NRQUESTCHECK: this.currentQuest.NRQUESTCHECK,
            CDETAPAPROD: this.currentQuest.CDETAPAPROD,
            NRINSPECAUDI: this.currentQuest.NRINSPECAUDI,
            CDHABILIDADE: this.currentQuest.CDHABILIDADE,
            CDINSPECAO: this.currentQuest.CDINSPECAO,
            NRAUDITORIA: this.currentQuest.NRAUDITORIA,
            CDRESPCAD: code,
            CDPRODUTO: widget.currentRow.CDPRODUTO,
            NMPRODUTO: widget.currentRow.NMPRODUTO,
            CDEQUIPPRO: widget.currentRow.CDEQUIPPRO,
            NMEQUIPPRO: widget.currentRow.NMEQUIPPRO,
            NRLOTEESTQ: widget.currentRow.NRLOTEESTQ,
            CDOPERADOR: widget.currentRow.CDOPERADOR,
            NMOPERADOR: widget.currentRow.NMOPERADOR,
            COL1: widget.currentRow.COL1,
            COL2: widget.currentRow.COL2,
            COL3: widget.currentRow.COL3,
            COL4: widget.currentRow.COL4,
            COL5: widget.currentRow.COL5,
            COL6: widget.currentRow.COL6,
            COL7: widget.currentRow.COL7,
            COL8: widget.currentRow.COL8,
            COL9: widget.currentRow.COL9,
            __is_new: true
        };
        
        return newResp;
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('QPR01900_Inspecao_Digital_Controller', QPR01900_Inspecao_Digital_Controller);
});
